/*
Copyright (c) 2014, The WebRTC project authors. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

  * Neither the name of Google nor the names of its contributors may
    be used to endorse or promote products derived from this software
    without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
 * Spreed WebRTC.
 * Copyright (C) 2013-2015 struktur AG
 *
 * This file is part of Spreed WebRTC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/**
 * UAParser.js v0.7.9
 * Lightweight JavaScript-based User-Agent string parser
 * https://github.com/faisalman/ua-parser-js
 *
 * Copyright © 2012-2015 Faisal Salman <fyzlman@gmail.com>
 * Dual licensed under GPLv2 & MIT
 */

/*
 * Spreed WebRTC.
 * Copyright (C) 2013-2015 struktur AG
 *
 * This file is part of Spreed WebRTC.
 *
 * This file is a AMD wrapped version of the sdputils.js from the
 * WebRTC apprtc example. https://github.com/webrtc/apprtc/blob/master/src
 *
 * Copyright (c) 2014 The WebRTC project authors. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 *  * Neither the name of Google nor the names of its contributors may
 *    be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

/*
 * Toastr
 * Copyright 2012-2014
 * Authors: John Papa, Hans Fjällemark, and Tim Ferrell.
 * All Rights Reserved.
 * Use, reproduction, distribution, and modification of this code is subject to the terms and
 * conditions of the MIT license, available at http://www.opensource.org/licenses/mit-license.php
 *
 * ARIA Support: Greta Krafsig
 *
 * Project: https://github.com/CodeSeven/toastr
 */

/*
 * Spreed WebRTC.
 * Copyright (C) 2013-2015 struktur AG
 *
 * This file is part of Spreed WebRTC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The AngularJS fastscroll service is based on \
 * 60fps-scroll by Ryan Seddon https://github.com/ryanseddon/60fps-scroll
 * which is is released under the MIT license.
 *
 * Copyright (c) 2013 Ryan Seddon
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

/*
 * jquery.injectCSS.js - jquery css injection plugin
 * Copyright (C) 2013, Robert Kajic (robert@kajic.com)
 * http://kajic.com
 *
 * https://github.com/kajic/jquery-injectCSS
 * Allows for injection of CSS defined as javascript JSS objects.
 *
 * Based on JSS (http://jss-lang.org/).
 *
 * Licensed under the MIT License.
 *
 * Date: 2013-01-08
 * Version: 0.1
 */

// PersistentStorage (c)2015 struktur AG. MIT license.

/*
 AngularJS v1.2.27
 (c) 2010-2014 Google, Inc. http://angularjs.org
 License: MIT
*/

/*
 * @license angular-humanize
 * Copyright 2013-2015 struktur AG, http://www.struktur.de
 * License: MIT
 */

/*!
 * jQuery Mobile Events
 * by Ben Major (www.ben-major.co.uk)
 *
 * Copyright 2011, Ben Major
 * Licensed under the MIT License:
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 */

function requestUserMedia(e){return new Promise(function(t,n){getUserMedia(e,t,n)})}var getUserMedia=null,attachMediaStream=null,reattachMediaStream=null,webrtcDetectedBrowser=null,webrtcDetectedVersion=null,webrtcMinimumVersion=null,webrtcUtils={log:function(){"undefined"==typeof module&&"function"!=typeof require&&"function"==typeof define&&console.log.apply(console,arguments)}};if("undefined"!=typeof window&&window.navigator)if(navigator.mozGetUserMedia){if(webrtcUtils.log("This appears to be Firefox"),webrtcDetectedBrowser="firefox",webrtcDetectedVersion=parseInt(navigator.userAgent.match(/Firefox\/([0-9]+)\./)[1],10),webrtcMinimumVersion=31,window.RTCPeerConnection=function(e,t){if(38>webrtcDetectedVersion&&e&&e.iceServers){for(var n=[],i=0;i<e.iceServers.length;i++){var o=e.iceServers[i];if(o.hasOwnProperty("urls"))for(var a=0;a<o.urls.length;a++){var r={url:o.urls[a]};0===o.urls[a].indexOf("turn")&&(r.username=o.username,r.credential=o.credential),n.push(r)}else n.push(e.iceServers[i])}e.iceServers=n}return new mozRTCPeerConnection(e,t)},window.RTCSessionDescription=mozRTCSessionDescription,window.RTCIceCandidate=mozRTCIceCandidate,getUserMedia=function(e,t,n){var i=function(e){if("object"!=typeof e||e.require)return e;var t=[];return Object.keys(e).forEach(function(n){if("require"!==n&&"advanced"!==n&&"mediaSource"!==n){var i=e[n]="object"==typeof e[n]?e[n]:{ideal:e[n]};if((void 0!==i.min||void 0!==i.max||void 0!==i.exact)&&t.push(n),void 0!==i.exact&&("number"==typeof i.exact?i.min=i.max=i.exact:e[n]=i.exact,delete i.exact),void 0!==i.ideal){e.advanced=e.advanced||[];var o={};o[n]="number"==typeof i.ideal?{min:i.ideal,max:i.ideal}:i.ideal,e.advanced.push(o),delete i.ideal,Object.keys(i).length||delete e[n]}}}),t.length&&(e.require=t),e};return 38>webrtcDetectedVersion&&(webrtcUtils.log("spec: "+JSON.stringify(e)),e.audio&&(e.audio=i(e.audio)),e.video&&(e.video=i(e.video)),webrtcUtils.log("ff37: "+JSON.stringify(e))),navigator.mozGetUserMedia(e,t,n)},navigator.getUserMedia=getUserMedia,navigator.mediaDevices||(navigator.mediaDevices={getUserMedia:requestUserMedia,addEventListener:function(){},removeEventListener:function(){}}),navigator.mediaDevices.enumerateDevices=navigator.mediaDevices.enumerateDevices||function(){return new Promise(function(e){var t=[{kind:"audioinput",deviceId:"default",label:"",groupId:""},{kind:"videoinput",deviceId:"default",label:"",groupId:""}];e(t)})},41>webrtcDetectedVersion){var orgEnumerateDevices=navigator.mediaDevices.enumerateDevices.bind(navigator.mediaDevices);navigator.mediaDevices.enumerateDevices=function(){return orgEnumerateDevices().catch(function(e){if("NotFoundError"===e.name)return[];throw e})}}attachMediaStream=function(e,t){e.mozSrcObject=t},reattachMediaStream=function(e,t){e.mozSrcObject=t.mozSrcObject}}else if(navigator.webkitGetUserMedia){webrtcUtils.log("This appears to be Chrome"),webrtcDetectedBrowser="chrome",webrtcDetectedVersion=parseInt(navigator.userAgent.match(/Chrom(e|ium)\/([0-9]+)\./)[2],10),webrtcMinimumVersion=38,window.RTCPeerConnection=function(e,t){var n=new webkitRTCPeerConnection(e,t),i=n.getStats.bind(n);return n.getStats=function(e,t){var n=this,o=arguments;if(arguments.length>0&&"function"==typeof e)return i(e,t);var a=function(e){var t={},n=e.result();return n.forEach(function(e){var n={id:e.id,timestamp:e.timestamp,type:e.type};e.names().forEach(function(t){n[t]=e.stat(t)}),t[n.id]=n}),t};if(arguments.length>=2){var r=function(e){o[1](a(e))};return i.apply(this,[r,arguments[0]])}return new Promise(function(e,t){i.apply(n,[e,t])})},n},["createOffer","createAnswer"].forEach(function(e){var t=webkitRTCPeerConnection.prototype[e];webkitRTCPeerConnection.prototype[e]=function(){var e=this;if(arguments.length<1||1===arguments.length&&"object"==typeof arguments[0]){var n=1===arguments.length?arguments[0]:void 0;return new Promise(function(i,o){t.apply(e,[i,o,n])})}return t.apply(this,arguments)}}),["setLocalDescription","setRemoteDescription","addIceCandidate"].forEach(function(e){var t=webkitRTCPeerConnection.prototype[e];webkitRTCPeerConnection.prototype[e]=function(){var e=arguments,n=this;return new Promise(function(i,o){t.apply(n,[e[0],function(){i(),e.length>=2&&e[1].apply(null,[])},function(t){o(t),e.length>=3&&e[2].apply(null,[t])}])})}});var constraintsToChrome=function(e){if("object"!=typeof e||e.mandatory||e.optional)return e;var t={};return Object.keys(e).forEach(function(n){if("require"!==n&&"advanced"!==n&&"mediaSource"!==n){var i="object"==typeof e[n]?e[n]:{ideal:e[n]};void 0!==i.exact&&"number"==typeof i.exact&&(i.min=i.max=i.exact);var o=function(e,t){return e?e+t.charAt(0).toUpperCase()+t.slice(1):"deviceId"===t?"sourceId":t};if(void 0!==i.ideal){t.optional=t.optional||[];var a={};"number"==typeof i.ideal?(a[o("min",n)]=i.ideal,t.optional.push(a),a={},a[o("max",n)]=i.ideal,t.optional.push(a)):(a[o("",n)]=i.ideal,t.optional.push(a))}void 0!==i.exact&&"number"!=typeof i.exact?(t.mandatory=t.mandatory||{},t.mandatory[o("",n)]=i.exact):["min","max"].forEach(function(e){void 0!==i[e]&&(t.mandatory=t.mandatory||{},t.mandatory[o(e,n)]=i[e])})}}),e.advanced&&(t.optional=(t.optional||[]).concat(e.advanced)),t};if(getUserMedia=function(e,t,n){return e.audio&&(e.audio=constraintsToChrome(e.audio)),e.video&&(e.video=constraintsToChrome(e.video)),webrtcUtils.log("chrome: "+JSON.stringify(e)),navigator.webkitGetUserMedia(e,t,n)},navigator.getUserMedia=getUserMedia,navigator.mediaDevices||(navigator.mediaDevices={getUserMedia:requestUserMedia,enumerateDevices:function(){return new Promise(function(e){var t={audio:"audioinput",video:"videoinput"};return MediaStreamTrack.getSources(function(n){e(n.map(function(e){return{label:e.label,kind:t[e.kind],deviceId:e.id,groupId:""}}))})})}}),navigator.mediaDevices.getUserMedia){var origGetUserMedia=navigator.mediaDevices.getUserMedia.bind(navigator.mediaDevices);navigator.mediaDevices.getUserMedia=function(e){return webrtcUtils.log("spec:   "+JSON.stringify(e)),e.audio=constraintsToChrome(e.audio),e.video=constraintsToChrome(e.video),webrtcUtils.log("chrome: "+JSON.stringify(e)),origGetUserMedia(e)}}else navigator.mediaDevices.getUserMedia=function(e){return requestUserMedia(e)};"undefined"==typeof navigator.mediaDevices.addEventListener&&(navigator.mediaDevices.addEventListener=function(){webrtcUtils.log("Dummy mediaDevices.addEventListener called.")}),"undefined"==typeof navigator.mediaDevices.removeEventListener&&(navigator.mediaDevices.removeEventListener=function(){webrtcUtils.log("Dummy mediaDevices.removeEventListener called.")}),attachMediaStream=function(e,t){"undefined"!=typeof e.srcObject?e.srcObject=t:"undefined"!=typeof e.src?e.src=URL.createObjectURL(t):webrtcUtils.log("Error attaching stream to element.")},reattachMediaStream=function(e,t){e.src=t.src}}else navigator.mediaDevices&&navigator.userAgent.match(/Edge\/(\d+).(\d+)$/)?(webrtcUtils.log("This appears to be Edge"),webrtcDetectedBrowser="edge",webrtcDetectedVersion=parseInt(navigator.userAgent.match(/Edge\/(\d+).(\d+)$/)[2],10),webrtcMinimumVersion=12,getUserMedia=navigator.getUserMedia,attachMediaStream=function(e,t){e.srcObject=t},reattachMediaStream=function(e,t){e.srcObject=t.srcObject}):webrtcUtils.log("Browser does not appear to be WebRTC-capable");else webrtcUtils.log("This does not appear to be a browser"),webrtcDetectedBrowser="not a browser";var webrtcTesting={};if(Object.defineProperty(webrtcTesting,"version",{set:function(e){webrtcDetectedVersion=e}}),"undefined"!=typeof module){var RTCPeerConnection;"undefined"!=typeof window&&(RTCPeerConnection=window.RTCPeerConnection),module.exports={RTCPeerConnection:RTCPeerConnection,getUserMedia:getUserMedia,attachMediaStream:attachMediaStream,reattachMediaStream:reattachMediaStream,webrtcDetectedBrowser:webrtcDetectedBrowser,webrtcDetectedVersion:webrtcDetectedVersion,webrtcMinimumVersion:webrtcMinimumVersion,webrtcTesting:webrtcTesting}}else"function"==typeof require&&"function"==typeof define&&define("webrtc.adapter",[],function(){return{RTCPeerConnection:window.RTCPeerConnection,getUserMedia:getUserMedia,attachMediaStream:attachMediaStream,reattachMediaStream:reattachMediaStream,webrtcDetectedBrowser:webrtcDetectedBrowser,webrtcDetectedVersion:webrtcDetectedVersion,webrtcMinimumVersion:webrtcMinimumVersion,webrtcTesting:webrtcTesting}});define("services/desktopnotify",["jquery","underscore","desktop-notify","webrtc.adapter"],function(e,t,n){return["$window",function(i){var o=function(){var t=e("<span>").addClass("desktopnotify-icon hidden");t.appendTo("body");var n=t.css("background-image");return n=/^url\((['"]?)(.*)\1\)$/.exec(n),n=n?n[2]:"",t.remove(),n}(),a=n,r=function(){this.asked=!1,this.windowHasFocus=!0,this.dummy={close:function(){}},this.refresh(),this.enabled(),e(i).on("focus blur",t.bind(function(e){this.windowHasFocus="focus"===e.type?!0:!1},this))};return r.prototype.enabled=function(){return this.supported&&"default"===this.level&&(this.asked=!0,this.requestPermission()),this.supported&&"granted"===this.level},r.prototype.refresh=function(){var e=this.level=a.permissionLevel();this.supported=function(){if(a.isSupported){if(i.Notification&&i.Notification.requestPermission)if("granted"!==e)try{new i.Notification("")}catch(t){if("TypeError"==t.name)return!1}else if(i.webrtcDetectedAndroid)return!1;return!0}return!1}()},r.prototype.requestPermission=function(e){return a.requestPermission(t.bind(function(){this.refresh(),e&&e.apply(a,arguments)},this))},r.prototype.createNotification=function(e,t){return a.createNotification(e,t)},r.prototype.notify=function(t,n,a){if(!this.enabled())return this.dummy;var r={body:n,icon:o,timeout:7e3};e.extend(r,a);var s=r.timeout;delete r.timeout;var c=this.createNotification(t,r);return s&&i.setTimeout(function(){c.close()},s),c},new r}]}),define("services/playsound",["underscore","Howler","require"],function(e,t,n){var i={},o={};return window.PLAYSOUND=i,[function(){var a=function(e,t,n){this.sound=e,this.id=t,this.interval=null,this.time=n};a.prototype.start=function(){if(null===this.interval){var t=this.id,n=e.bind(function(){return this.sound.play(t)},this);n(),this.interval=setInterval(n,this.time)}},a.prototype.stop=function(){clearInterval(this.interval),this.interval=null,delete this.sound.intervals[this.id]};var r=function(e,t){this.sound=null,this.intervals={},e&&this.initialize(e,t)};return r.prototype.initialize=function(i,o){this.sound&&this.sound.stop(),e.each(this.intervals,function(e){e.stop()}),this.intervals={};var a=i.onloaderror;i.onloaderror=function(e){console.error("Failed to load sounds",e),a&&a.apply(this,arguments)};var r=i.urls;if(r){var s=[];e.each(r,function(e){e=n.toUrl(e),s.push(e)}),i.urls=s}return this.players={},this.aliases=e.extend({},o),this.sound=new t.Howl(i),this},r.prototype.getId=function(e){return this.aliases.hasOwnProperty(e)?this.aliases[e]:e},r.prototype.play=function(t,n,i){if(!this.sound)return console.log("Play sound but not initialized.",t),null;if(n){if(this.intervals.hasOwnProperty(t))return this.intervals[t];var o=this.intervals[t]=new a(this,t,n);return i&&o.start(),o}var r=this.getId(t);if(this.shouldPlaySound(t)&&this.shouldPlaySound(r)){var s=this.players[r],c=this.sound;s||(s=this.players[r]=function(t){var n={},i=function(e){n.soundId=e},o=e.debounce(function(){n.soundId&&(c.stop(n.soundId),n.soundId=null),c.play(t,i)},10);return o}(r)),s()}},r.prototype.shouldPlaySound=function(e){return o.all||o.hasOwnProperty(e)?!1:!0},{initialize:function(e,t,n){t||(t=null);var o=i[t]=new r(e,n);return o},play:function(e,t){t||(t=null);var n=i[t];return n?n.play(e):(console.log("Play sound with unknown player",t),null)},interval:function(e,t,n){t||(t=null);var o=i[t];return o?(n||(n=1500),o.play(e,n)):(console.log("Play sound with unknown player",t),null)},disable:function(e,t){t!==!1?o[e]=!0:delete o[e]}}}]}),define("services/safeapply",[],function(){return["$rootScope",function(){return function(e,t){var n=e.$root.$$phase;"$apply"==n||"$digest"==n?t&&e.$eval(t):t?e.$apply(t):e.$apply()}}]}),define("mediastream/connector",["jquery","underscore"],function(e,t){var n=5e3,i=2e4,o=function(){this.e=e({}),this.error=!1,this.connected=!1,this.connecting=null,this.connecting_timeout=n,this.disabled=!1,this.token=null,this.queue=[]};return o.prototype.connect=function(e){if(!this.disabled){if(null!==this.connecting)return void console.warn("Refusing to connect while already connecting");this.error=!1,this.e.triggerHandler("connecting",[e]),this.url=e,this.token&&(e+="?t="+this.token);var o=this,a=this.conn=new WebSocket(e);a.onopen=function(e){e.target===o.conn&&o.onopen(e)},a.onerror=function(e){e.target===o.conn&&o.onerror(e)},a.onclose=function(e){e.target===o.conn&&o.onclose(e)},a.onmessage=function(e){e.target===o.conn&&o.onmessage(e)},this.connecting=window.setTimeout(t.bind(function(){console.warn("Connection timeout out after",this.connecting_timeout),this.connecting_timeout<i&&(this.connecting_timeout+=n),this.e.triggerHandler("error"),this.reconnect()},this),this.connecting_timeout)}},o.prototype.disconnect=function(e){e?this.onerror(null):this.conn.close()},o.prototype.reconnect=function(){if(this.url){this.close();var e=this.url;this.url=null,setTimeout(t.bind(function(){this.connect(e)},this),200)}},o.prototype.close=function(){if(window.clearTimeout(this.connecting),this.connecting=null,this.connected=!1,this.conn){var e=this.conn;this.conn=null,e.close()}},o.prototype.forgetAndReconnect=function(){this.token=null,this.conn&&this.connected&&this.conn.close()},o.prototype.onopen=function(e){window.clearTimeout(this.connecting),this.connecting=null,this.connecting_timeout=n,console.info("Connector on connection open."),this.connected=!0,this.e.triggerHandler("open",[null,e]);for(var t;this.queue.length>0&&this.connected;)t=this.queue.shift(),this.send(t)},o.prototype.onerror=function(e){window.clearTimeout(this.connecting),this.connecting=null,this.connecting_timeout=n,console.warn("Connector on connection error."),this.error=!0,this.close(),this.e.triggerHandler("error",[null,e])},o.prototype.onclose=function(e){window.clearTimeout(this.connecting),this.connecting=null,this.connecting_timeout=n,console.info("Connector on connection close.",e,this.error),this.close(),this.error||this.e.triggerHandler("close",[null,e])},o.prototype.onmessage=function(e){var t=JSON.parse(e.data);this.e.triggerHandler("received",[t])},o.prototype.send=function(e,t){return this.connected||t?void this.conn.send(JSON.stringify(e)):(this.queue.push(e),void console.warn("Queuing sending data because of not connected.",e))},o.prototype.ready=function(e){this.e.on("open",e),this.connected&&e()},o}),define("services/connector",["mediastream/connector"],function(e){return[function(){return new e}]}),function(e,t){var n="0.7.9",i="",o="?",a="function",r="undefined",s="object",c="string",l="major",d="model",u="name",p="type",f="vendor",h="version",g="architecture",m="console",v="mobile",b="tablet",y="smarttv",w="wearable",k="embedded",x={extend:function(e,t){for(var n in t)-1!=="browser cpu device engine os".indexOf(n)&&t[n].length%2===0&&(e[n]=t[n].concat(e[n]));return e},has:function(e,t){return"string"==typeof e?-1!==t.toLowerCase().indexOf(e.toLowerCase()):!1},lowerize:function(e){return e.toLowerCase()},major:function(e){return typeof e===c?e.split(".")[0]:t}},$={rgx:function(){for(var e,n,i,o,c,l,d,u=0,p=arguments;u<p.length&&!l;){var f=p[u],h=p[u+1];if(typeof e===r){e={};for(o in h)c=h[o],typeof c===s?e[c[0]]=t:e[c]=t}for(n=i=0;n<f.length&&!l;)if(l=f[n++].exec(this.getUA()))for(o=0;o<h.length;o++)d=l[++i],c=h[o],typeof c===s&&c.length>0?2==c.length?e[c[0]]=typeof c[1]==a?c[1].call(this,d):c[1]:3==c.length?e[c[0]]=typeof c[1]!==a||c[1].exec&&c[1].test?d?d.replace(c[1],c[2]):t:d?c[1].call(this,d,c[2]):t:4==c.length&&(e[c[0]]=d?c[3].call(this,d.replace(c[1],c[2])):t):e[c]=d?d:t;u+=2}return e},str:function(e,n){for(var i in n)if(typeof n[i]===s&&n[i].length>0){for(var a=0;a<n[i].length;a++)if(x.has(n[i][a],e))return i===o?t:i}else if(x.has(n[i],e))return i===o?t:i;return e}},C={browser:{oldsafari:{version:{"1.0":"/8",1.2:"/1",1.3:"/3","2.0":"/412","2.0.2":"/416","2.0.3":"/417","2.0.4":"/419","?":"/"}}},device:{amazon:{model:{"Fire Phone":["SD","KF"]}},sprint:{model:{"Evo Shift 4G":"7373KT"},vendor:{HTC:"APA",Sprint:"Sprint"}}},os:{windows:{version:{ME:"4.90","NT 3.11":"NT3.51","NT 4.0":"NT4.0",2000:"NT 5.0",XP:["NT 5.1","NT 5.2"],Vista:"NT 6.0",7:"NT 6.1",8:"NT 6.2",8.1:"NT 6.3",10:["NT 6.4","NT 10.0"],RT:"ARM"}}}},S={browser:[[/(opera\smini)\/([\w\.-]+)/i,/(opera\s[mobiletab]+).+version\/([\w\.-]+)/i,/(opera).+version\/([\w\.]+)/i,/(opera)[\/\s]+([\w\.]+)/i],[u,h],[/\s(opr)\/([\w\.]+)/i],[[u,"Opera"],h],[/(kindle)\/([\w\.]+)/i,/(lunascape|maxthon|netfront|jasmine|blazer)[\/\s]?([\w\.]+)*/i,/(avant\s|iemobile|slim|baidu)(?:browser)?[\/\s]?([\w\.]*)/i,/(?:ms|\()(ie)\s([\w\.]+)/i,/(rekonq)\/([\w\.]+)*/i,/(chromium|flock|rockmelt|midori|epiphany|silk|skyfire|ovibrowser|bolt|iron|vivaldi|iridium)\/([\w\.-]+)/i],[u,h],[/(trident).+rv[:\s]([\w\.]+).+like\sgecko/i],[[u,"IE"],h],[/(edge)\/((\d+)?[\w\.]+)/i],[u,h],[/(yabrowser)\/([\w\.]+)/i],[[u,"Yandex"],h],[/(comodo_dragon)\/([\w\.]+)/i],[[u,/_/g," "],h],[/(chrome|omniweb|arora|[tizenoka]{5}\s?browser)\/v?([\w\.]+)/i,/(uc\s?browser|qqbrowser)[\/\s]?([\w\.]+)/i],[u,h],[/(dolfin)\/([\w\.]+)/i],[[u,"Dolphin"],h],[/((?:android.+)crmo|crios)\/([\w\.]+)/i],[[u,"Chrome"],h],[/XiaoMi\/MiuiBrowser\/([\w\.]+)/i],[h,[u,"MIUI Browser"]],[/android.+version\/([\w\.]+)\s+(?:mobile\s?safari|safari)/i],[h,[u,"Android Browser"]],[/FBAV\/([\w\.]+);/i],[h,[u,"Facebook"]],[/version\/([\w\.]+).+?mobile\/\w+\s(safari)/i],[h,[u,"Mobile Safari"]],[/version\/([\w\.]+).+?(mobile\s?safari|safari)/i],[h,u],[/webkit.+?(mobile\s?safari|safari)(\/[\w\.]+)/i],[u,[h,$.str,C.browser.oldsafari.version]],[/(konqueror)\/([\w\.]+)/i,/(webkit|khtml)\/([\w\.]+)/i],[u,h],[/(navigator|netscape)\/([\w\.-]+)/i],[[u,"Netscape"],h],[/fxios\/([\w\.-]+)/i],[h,[u,"Firefox"]],[/(swiftfox)/i,/(icedragon|iceweasel|camino|chimera|fennec|maemo\sbrowser|minimo|conkeror)[\/\s]?([\w\.\+]+)/i,/(firefox|seamonkey|k-meleon|icecat|iceape|firebird|phoenix)\/([\w\.-]+)/i,/(mozilla)\/([\w\.]+).+rv\:.+gecko\/\d+/i,/(polaris|lynx|dillo|icab|doris|amaya|w3m|netsurf)[\/\s]?([\w\.]+)/i,/(links)\s\(([\w\.]+)/i,/(gobrowser)\/?([\w\.]+)*/i,/(ice\s?browser)\/v?([\w\._]+)/i,/(mosaic)[\/\s]([\w\.]+)/i],[u,h]],cpu:[[/(?:(amd|x(?:(?:86|64)[_-])?|wow|win)64)[;\)]/i],[[g,"amd64"]],[/(ia32(?=;))/i],[[g,x.lowerize]],[/((?:i[346]|x)86)[;\)]/i],[[g,"ia32"]],[/windows\s(ce|mobile);\sppc;/i],[[g,"arm"]],[/((?:ppc|powerpc)(?:64)?)(?:\smac|;|\))/i],[[g,/ower/,"",x.lowerize]],[/(sun4\w)[;\)]/i],[[g,"sparc"]],[/((?:avr32|ia64(?=;))|68k(?=\))|arm(?:64|(?=v\d+;))|(?=atmel\s)avr|(?:irix|mips|sparc)(?:64)?(?=;)|pa-risc)/i],[[g,x.lowerize]]],device:[[/\((ipad|playbook);[\w\s\);-]+(rim|apple)/i],[d,f,[p,b]],[/applecoremedia\/[\w\.]+ \((ipad)/],[d,[f,"Apple"],[p,b]],[/(apple\s{0,1}tv)/i],[[d,"Apple TV"],[f,"Apple"]],[/(archos)\s(gamepad2?)/i,/(hp).+(touchpad)/i,/(kindle)\/([\w\.]+)/i,/\s(nook)[\w\s]+build\/(\w+)/i,/(dell)\s(strea[kpr\s\d]*[\dko])/i],[f,d,[p,b]],[/(kf[A-z]+)\sbuild\/[\w\.]+.*silk\//i],[d,[f,"Amazon"],[p,b]],[/(sd|kf)[0349hijorstuw]+\sbuild\/[\w\.]+.*silk\//i],[[d,$.str,C.device.amazon.model],[f,"Amazon"],[p,v]],[/\((ip[honed|\s\w*]+);.+(apple)/i],[d,f,[p,v]],[/\((ip[honed|\s\w*]+);/i],[d,[f,"Apple"],[p,v]],[/(blackberry)[\s-]?(\w+)/i,/(blackberry|benq|palm(?=\-)|sonyericsson|acer|asus|dell|huawei|meizu|motorola|polytron)[\s_-]?([\w-]+)*/i,/(hp)\s([\w\s]+\w)/i,/(asus)-?(\w+)/i],[f,d,[p,v]],[/\(bb10;\s(\w+)/i],[d,[f,"BlackBerry"],[p,v]],[/android.+(transfo[prime\s]{4,10}\s\w+|eeepc|slider\s\w+|nexus 7)/i],[d,[f,"Asus"],[p,b]],[/(sony)\s(tablet\s[ps])\sbuild\//i,/(sony)?(?:sgp.+)\sbuild\//i],[[f,"Sony"],[d,"Xperia Tablet"],[p,b]],[/(?:sony)?(?:(?:(?:c|d)\d{4})|(?:so[-l].+))\sbuild\//i],[[f,"Sony"],[d,"Xperia Phone"],[p,v]],[/\s(ouya)\s/i,/(nintendo)\s([wids3u]+)/i],[f,d,[p,m]],[/android.+;\s(shield)\sbuild/i],[d,[f,"Nvidia"],[p,m]],[/(playstation\s[3portablevi]+)/i],[d,[f,"Sony"],[p,m]],[/(sprint\s(\w+))/i],[[f,$.str,C.device.sprint.vendor],[d,$.str,C.device.sprint.model],[p,v]],[/(lenovo)\s?(S(?:5000|6000)+(?:[-][\w+]))/i],[f,d,[p,b]],[/(htc)[;_\s-]+([\w\s]+(?=\))|\w+)*/i,/(zte)-(\w+)*/i,/(alcatel|geeksphone|huawei|lenovo|nexian|panasonic|(?=;\s)sony)[_\s-]?([\w-]+)*/i],[f,[d,/_/g," "],[p,v]],[/(nexus\s9)/i],[d,[f,"HTC"],[p,b]],[/[\s\(;](xbox(?:\sone)?)[\s\);]/i],[d,[f,"Microsoft"],[p,m]],[/(kin\.[onetw]{3})/i],[[d,/\./g," "],[f,"Microsoft"],[p,v]],[/\s(milestone|droid(?:[2-4x]|\s(?:bionic|x2|pro|razr))?(:?\s4g)?)[\w\s]+build\//i,/mot[\s-]?(\w+)*/i,/(XT\d{3,4}) build\//i],[d,[f,"Motorola"],[p,v]],[/android.+\s(mz60\d|xoom[\s2]{0,2})\sbuild\//i],[d,[f,"Motorola"],[p,b]],[/android.+((sch-i[89]0\d|shw-m380s|gt-p\d{4}|gt-n8000|sgh-t8[56]9|nexus 10))/i,/((SM-T\w+))/i],[[f,"Samsung"],d,[p,b]],[/((s[cgp]h-\w+|gt-\w+|galaxy\snexus|sm-n900))/i,/(sam[sung]*)[\s-]*(\w+-?[\w-]*)*/i,/sec-((sgh\w+))/i],[[f,"Samsung"],d,[p,v]],[/(samsung);smarttv/i],[f,d,[p,y]],[/\(dtv[\);].+(aquos)/i],[d,[f,"Sharp"],[p,y]],[/sie-(\w+)*/i],[d,[f,"Siemens"],[p,v]],[/(maemo|nokia).*(n900|lumia\s\d+)/i,/(nokia)[\s_-]?([\w-]+)*/i],[[f,"Nokia"],d,[p,v]],[/android\s3\.[\s\w;-]{10}(a\d{3})/i],[d,[f,"Acer"],[p,b]],[/android\s3\.[\s\w;-]{10}(lg?)-([06cv9]{3,4})/i],[[f,"LG"],d,[p,b]],[/(lg) netcast\.tv/i],[f,d,[p,y]],[/(nexus\s[45])/i,/lg[e;\s\/-]+(\w+)*/i],[d,[f,"LG"],[p,v]],[/android.+(ideatab[a-z0-9\-\s]+)/i],[d,[f,"Lenovo"],[p,b]],[/linux;.+((jolla));/i],[f,d,[p,v]],[/((pebble))app\/[\d\.]+\s/i],[f,d,[p,w]],[/android.+;\s(glass)\s\d/i],[d,[f,"Google"],[p,w]],[/android.+(\w+)\s+build\/hm\1/i,/android.+(hm[\s\-_]*note?[\s_]*(?:\d\w)?)\s+build/i,/android.+(mi[\s\-_]*(?:one|one[\s_]plus)?[\s_]*(?:\d\w)?)\s+build/i],[[d,/_/g," "],[f,"Xiaomi"],[p,v]],[/(mobile|tablet);.+rv\:.+gecko\//i],[[p,x.lowerize],f,d]],engine:[[/windows.+\sedge\/([\w\.]+)/i],[h,[u,"EdgeHTML"]],[/(presto)\/([\w\.]+)/i,/(webkit|trident|netfront|netsurf|amaya|lynx|w3m)\/([\w\.]+)/i,/(khtml|tasman|links)[\/\s]\(?([\w\.]+)/i,/(icab)[\/\s]([23]\.[\d\.]+)/i],[u,h],[/rv\:([\w\.]+).*(gecko)/i],[h,u]],os:[[/microsoft\s(windows)\s(vista|xp)/i],[u,h],[/(windows)\snt\s6\.2;\s(arm)/i,/(windows\sphone(?:\sos)*|windows\smobile|windows)[\s\/]?([ntce\d\.\s]+\w)/i],[u,[h,$.str,C.os.windows.version]],[/(win(?=3|9|n)|win\s9x\s)([nt\d\.]+)/i],[[u,"Windows"],[h,$.str,C.os.windows.version]],[/\((bb)(10);/i],[[u,"BlackBerry"],h],[/(blackberry)\w*\/?([\w\.]+)*/i,/(tizen)[\/\s]([\w\.]+)/i,/(android|webos|palm\sos|qnx|bada|rim\stablet\sos|meego|contiki)[\/\s-]?([\w\.]+)*/i,/linux;.+(sailfish);/i],[u,h],[/(symbian\s?os|symbos|s60(?=;))[\/\s-]?([\w\.]+)*/i],[[u,"Symbian"],h],[/\((series40);/i],[u],[/mozilla.+\(mobile;.+gecko.+firefox/i],[[u,"Firefox OS"],h],[/(nintendo|playstation)\s([wids3portablevu]+)/i,/(mint)[\/\s\(]?(\w+)*/i,/(mageia|vectorlinux)[;\s]/i,/(joli|[kxln]?ubuntu|debian|[open]*suse|gentoo|arch|slackware|fedora|mandriva|centos|pclinuxos|redhat|zenwalk|linpus)[\/\s-]?([\w\.-]+)*/i,/(hurd|linux)\s?([\w\.]+)*/i,/(gnu)\s?([\w\.]+)*/i],[u,h],[/(cros)\s[\w]+\s([\w\.]+\w)/i],[[u,"Chromium OS"],h],[/(sunos)\s?([\w\.]+\d)*/i],[[u,"Solaris"],h],[/\s([frentopc-]{0,4}bsd|dragonfly)\s?([\w\.]+)*/i],[u,h],[/(ip[honead]+)(?:.*os\s*([\w]+)*\slike\smac|;\sopera)/i],[[u,"iOS"],[h,/_/g,"."]],[/(mac\sos\sx)\s?([\w\s\.]+\w)*/i,/(macintosh|mac(?=_powerpc)\s)/i],[[u,"Mac OS"],[h,/_/g,"."]],[/((?:open)?solaris)[\/\s-]?([\w\.]+)*/i,/(haiku)\s(\w+)/i,/(aix)\s((\d)(?=\.|\)|\s)[\w\.]*)*/i,/(plan\s9|minix|beos|os\/2|amigaos|morphos|risc\sos|openvms)/i,/(unix)\s?([\w\.]+)*/i],[u,h]]},P=function(t,n){if(!(this instanceof P))return new P(t,n).getResult();var o=t||(e&&e.navigator&&e.navigator.userAgent?e.navigator.userAgent:i),a=n?x.extend(S,n):S;return this.getBrowser=function(){var e=$.rgx.apply(this,a.browser);return e.major=x.major(e.version),e},this.getCPU=function(){return $.rgx.apply(this,a.cpu)},this.getDevice=function(){return $.rgx.apply(this,a.device)},this.getEngine=function(){return $.rgx.apply(this,a.engine)},this.getOS=function(){return $.rgx.apply(this,a.os)},this.getResult=function(){return{ua:this.getUA(),browser:this.getBrowser(),engine:this.getEngine(),os:this.getOS(),device:this.getDevice(),cpu:this.getCPU()}},this.getUA=function(){return o},this.setUA=function(e){return o=e,this},this.setUA(o),this};P.VERSION=n,P.BROWSER={NAME:u,MAJOR:l,VERSION:h},P.CPU={ARCHITECTURE:g},P.DEVICE={MODEL:d,VENDOR:f,TYPE:p,CONSOLE:m,MOBILE:v,SMARTTV:y,TABLET:b,WEARABLE:w,EMBEDDED:k},P.ENGINE={NAME:u,VERSION:h},P.OS={NAME:u,VERSION:h},typeof exports!==r?(typeof module!==r&&module.exports&&(exports=module.exports=P),exports.UAParser=P):typeof define===a&&define.amd?define("ua-parser",[],function(){return P}):e.UAParser=P;var T=e.jQuery||e.Zepto;if(typeof T!==r){var _=new P;T.ua=_.getResult(),T.ua.get=function(){return _.getUA()},T.ua.set=function(e){_.setUA(e);var t=_.getResult();for(var n in t)T.ua[n]=t[n]}}}("object"==typeof window?window:this),define("mediastream/api",["jquery","underscore","ua-parser"],function(e,t,n){var i=function(i,o){this.version=i,this.id=null,this.sid=null,this.session={},this.connector=o,this.iids=0,this.e=e({});var a=n();this.userAgent=a.os.name&&/Spreed Desktop Caller/i.test(a.ua)?a.ua.match(/Spreed Desktop Caller\/([\d.]+)/i)[1]+" ("+a.os.name+")":a.browser.name?a.browser.name+" "+a.browser.major:a.ua,o.e.on("received",t.bind(function(e,t){this.received(t)},this)),this.last_receive=null,this.last_receive_overdue=!1};return i.prototype.heartbeat=function(e,t){var n=this.last_receive;if(this.connector.connected){if(null!==n){var i=(new Date).getTime();this.last_receive_overdue?i>n+t&&(console.log("Reconnecting because alive timeout was reached."),this.last_receive_overdue=!1,this.last_receive=null,this.connector.disconnect(!0)):i>n+e&&(this.last_receive_overdue=!0,this.sendAlive(i))}}else this.last_receive=null,this.last_receive_overdue=!1},i.prototype.send=function(e,t,n){var i={Type:e};i[e]=t,this.connector.send(i,n)},i.prototype.send2=function(e,n){var i={send:t.bind(function(e,t){n&&n(e,t),this.send(e,t)},this)};return this.apply(e,i)},i.prototype.request=function(e,t,n,i){var o={Type:e};if(o[e]=t,n){var a=""+this.iids++;o.Iid=a,this.e.one(a+".request",n)}this.connector.send(o,i)},i.prototype.apply=function(e,n){var i=this[e];return t.bind(i,n)},i.prototype.received=function(e){var t=(new Date).getTime();this.last_receive=t,this.last_receive_overdue=!1;var n=e.A,i=e.Iid,o=e.Data,a=o.Type;if(n&&e.From&&this.e.triggerHandler("received.attestation",[e.From,n]),i)return void this.e.triggerHandler(i+".request",[a,o]);switch(a){case"Self":o.Token&&(this.connector.token=o.Token),this.id=o.Id,this.sid=o.Sid,this.e.triggerHandler("received.self",[o]);break;case"Offer":this.e.triggerHandler("received.offer",[o.To,o.Offer,o.Type,e.To,e.From]);break;case"Candidate":this.e.triggerHandler("received.candidate",[o.To,o.Candidate,o.Type,e.To,e.From]);break;case"Answer":this.e.triggerHandler("received.answer",[o.To,o.Answer,o.Type,e.To,e.From]);break;case"Users":this.e.triggerHandler("received.users",[o.Users]);break;case"Bye":console.log("Bye received",o.To,o.Bye),this.e.triggerHandler("received.bye",[o.To,o.Bye,o.Type,e.To,e.From]);break;case"Joined":case"Left":this.e.triggerHandler("received.userleftorjoined",[a,o]);break;case"Status":this.e.triggerHandler("received.status",[o]);break;case"Chat":this.e.triggerHandler("received.chat",[o.To,e.From,o.Chat,e.p2p]);break;case"Conference":this.e.triggerHandler("received.conference",[o.Id,o.Conference,o.Type,e.To,e.From]);break;case"Talking":this.e.triggerHandler("received.talking",[e.To,e.From,o.Talking]);break;case"Screenshare":this.e.triggerHandler("received.screenshare",[e.To,e.From,o.Screenshare,e.p2p]);break;case"Presentation":this.e.triggerHandler("received.presentation",[e.To,e.From,o.Presentation,e.p2p]);break;case"YouTubeVideo":this.e.triggerHandler("received.youtubevideo",[e.To,e.From,o.YouTubeVideo,e.p2p]);break;case"Alive":break;case"Room":this.e.triggerHandler("received.room",[o]);break;default:console.log("Unhandled type received:",a,o)}},i.prototype.sendSelf=function(){var e={Type:"Self",Self:{}};return this.send("Self",e,!0)},i.prototype.sendHello=function(e,t,n,i){var o={Version:this.version,Ua:this.userAgent,Name:e,Type:""};t&&(o.Credentials={PIN:t});var a=this,r=function(e,t,o){"Welcome"===t?(n&&n(o.Room),a.e.triggerHandler("received.room",[o.Room]),a.e.triggerHandler("received.users",[o.Users])):i&&i(o)};this.request("Hello",o,r,!0)},i.prototype.sendOffer=function(e,t){var n={To:e,Type:"Offer",Offer:t};return this.send("Offer",n)},i.prototype.sendCandidate=function(e,t){var n={To:e,Type:"Candidate",Candidate:t};return this.send("Candidate",n)},i.prototype.sendAnswer=function(e,t){var n={To:e,Type:"Answer",Answer:t};return this.send("Answer",n)},i.prototype.requestRoomUpdate=function(e,t,n){var i=function(e,i,o){"Room"===i?t&&t(o):n&&n(o)};this.request("Room",e,i,!0)},i.prototype.requestUsers=function(){var e={Type:"Users",Users:{}};return this.send("Users",e)},i.prototype.requestAuthentication=function(e,t){var n={Type:"Authentication",Authentication:{Userid:e,Nonce:t}};return this.send("Authentication",n)},i.prototype.updateStatus=function(e){var t={Type:"Status",Status:e};return this.send("Status",t)},i.prototype.sendBye=function(e,t){var n={To:e,Type:"Bye",Bye:{Reason:t}};return this.send("Bye",n)},i.prototype.sendChat=function(e,t,n,i){var o={To:e,Type:"Chat",Chat:{Mid:i,Message:t,Status:n,NoEcho:!0}};return this.send("Chat",o)},i.prototype.sendConference=function(e,t){var n={Id:e,Type:"Conference",Conference:t};return this.send("Conference",n)},i.prototype.sendScreenshare=function(e,t){var n={Id:e,Type:"Screenshare",Screenshare:{id:t}};return this.send("Screenshare",n)},i.prototype.sendPresentation=function(e,n,i){var o={Id:e,Type:"Presentation",Presentation:{id:n}};return i&&(o.Presentation=t.extend(o.Presentation,i)),this.send("Presentation",o)},i.prototype.sendYouTubeVideo=function(e,n,i){var o={Id:e,Type:"YouTubeVideo",YouTubeVideo:{id:n}};return i&&(o.YouTubeVideo=t.extend(o.YouTubeVideo,i)),this.send("YouTubeVideo",o)},i.prototype.sendAlive=function(e){var t={Type:"Alive",Alive:e};return this.send("Alive",t)},i.prototype.sendSessions=function(e,t,n){var i={Type:"Sessions",Sessions:{Type:t,Token:e}};return this.request("Sessions",i,n)},i}),define("services/api",["mediastream/api"],function(e){return["globalContext","connector",function(t,n){return new e(t.Cfg.Version,n)}]}),define("mediastream/utils",[],function(){function e(){}function t(e,t){if(!e||!t)return e||t;var n=e;for(var i in t.mandatory)t.mandatory.hasOwnProperty(i)&&(n.mandatory[i]=t.mandatory[i]);return n.optional=n.optional.concat(t.optional),n}function n(e,t){return"true"===t.opusStereo?e=h(e,"opus/48000","stereo","1"):"false"===t.opusStereo&&(e=g(e,"opus/48000","stereo")),"true"===t.opusFec?e=h(e,"opus/48000","useinbandfec","1"):"false"===t.opusFec&&(e=g(e,"opus/48000","useinbandfec")),"true"===t.opusDtx?e=h(e,"opus/48000","usedtx","1"):"false"===t.opusDtx&&(e=g(e,"opus/48000","usedtx")),t.opusMaxPbr&&(e=h(e,"opus/48000","maxplaybackrate",t.opusMaxPbr)),e}function i(t,n){return n.audioSendBitrate?(e("Prefer audio send bitrate: "+n.audioSendBitrate),s(t,n.audioSendBitrate,"audio")):t}function o(t,n){return n.audioRecvBitrate?(e("Prefer audio receive bitrate: "+n.audioRecvBitrate),s(t,n.audioRecvBitrate,"audio")):t}function a(t,n){return n.videoSendBitrate?(e("Prefer video send bitrate: "+n.videoSendBitrate),s(t,n.videoSendBitrate,"video")):t}function r(t,n){return n.videoRecvBitrate?(e("Prefer video receive bitrate: "+n.videoRecvBitrate),s(t,n.videoRecvBitrate,"video")):t}function s(t,n,i){var o=t.split("\r\n"),a=y(o,"m=",i);if(null===a)return e("Failed to add bandwidth line to sdp, as no m-line found"),t;var r=w(o,a+1,-1,"m=");null===r&&(r=o.length);var s=w(o,a+1,r,"c=");
if(null===s)return e("Failed to add bandwidth line to sdp, as no c-line found"),t;var c=w(o,s+1,r,"b=AS");c&&o.splice(c,1);var l="b=AS:"+n;return o.splice(s+1,0,l),t=o.join("\r\n")}function c(t,n){var i=n.videoSendInitialBitrate;if(!i)return t;var o=i,a=n.videoSendBitrate;a&&(i>a&&(e("Clamping initial bitrate to max bitrate of "+a+" kbps."),i=a,n.videoSendInitialBitrate=i),o=a);var r=t.split("\r\n"),s=y(r,"m=","video");return null===s?(e("Failed to find video m-line"),t):(t=h(t,"VP8/90000","x-google-min-bitrate",n.videoSendInitialBitrate.toString()),t=h(t,"VP8/90000","x-google-max-bitrate",o.toString()))}function l(e,t){return f(e,"audio","send",t.audioSendCodec)}function d(e,t){return f(e,"audio","receive",t.audioRecvCodec)}function u(e,t){return f(e,"video","send",t.videoSendCodec)}function p(e,t){return f(e,"video","receive",t.videoRecvCodec)}function f(t,n,i,o){var a=n+" "+i+" codec";if(""===o)return e("No preference on "+a+"."),t;e("Prefer "+a+": "+o);var r=t.split("\r\n"),s=y(r,"m=",n);if(null===s)return t;var c=k(r,o);return c&&(r[s]=$(r[s],c)),t=r.join("\r\n")}function h(e,t,n,i){var o=e.split("\r\n"),a=b(o,t),r={};if(null===a){var s=y(o,"a=rtpmap",t);if(null===s)return e;var c=x(o[s]);r.pt=c.toString(),r.params={},r.params[n]=i,o.splice(s+1,0,v(r))}else r=m(o[a]),r.params[n]=i,o[a]=v(r);return e=o.join("\r\n")}function g(e,t,n){var i=e.split("\r\n"),o=b(i,t);if(null===o)return e;var a=m(i[o]);delete a.params[n];var r=v(a);return null===r?i.splice(o,1):i[o]=r,e=i.join("\r\n")}function m(e){var t={},n=e.indexOf(" "),i=e.substring(n+1).split("; "),o=new RegExp("a=fmtp:(\\d+)"),a=e.match(o);if(!a||2!==a.length)return null;t.pt=a[1];for(var r={},s=0;s<i.length;++s){var c=i[s].split("=");2===c.length&&(r[c[0]]=c[1])}return t.params=r,t}function v(e){if(!e.hasOwnProperty("pt")||!e.hasOwnProperty("params"))return null;var t=e.pt,n=e.params,i=[],o=0;for(var a in n)n.hasOwnProperty(a)&&(i[o]=a+"="+n[a],++o);return 0===o?null:"a=fmtp:"+t.toString()+" "+i.join("; ")}function b(e,t){var n=k(e,t);return n?y(e,"a=fmtp:"+n.toString()):null}function y(e,t,n){return w(e,0,-1,t,n)}function w(e,t,n,i,o){for(var a=-1!==n?n:e.length,r=t;a>r;++r)if(0===e[r].indexOf(i)&&(!o||-1!==e[r].toLowerCase().indexOf(o.toLowerCase())))return r;return null}function k(e,t){var n=y(e,"a=rtpmap",t);return n?x(e[n]):null}function x(e){var t=new RegExp("a=rtpmap:(\\d+) \\w+\\/\\d+"),n=e.match(t);return n&&2===n.length?n[1]:null}function $(e,t){var n=e.split(" "),i=n.slice(0,3);i.push(t);for(var o=3;o<n.length;o++)n[o]!==t&&i.push(n[o]);return i.join(" ")}return{mergeConstraints:t,maybeSetOpusOptions:n,maybeSetAudioSendBitRate:i,maybeSetAudioReceiveBitRate:o,maybeSetVideoSendBitRate:a,maybeSetVideoReceiveBitRate:r,maybeSetVideoSendInitialBitRate:c,maybePreferAudioSendCodec:l,maybePreferAudioReceiveCodec:d,maybePreferVideoSendCodec:u,maybePreferVideoReceiveCodec:p,fixLocal:function(e){return"chrome"===window.webrtcDetectedBrowser&&(e=e.replace(/a=rtpmap:\d+ rtx\/\d+\r\n/i,""),e=e.replace(/a=fmtp:\d+ apt=\d+\r\n/i,"")),e},fixRemote:function(e){return e}}}),define("mediastream/peerconnection",["jquery","underscore","webrtc.adapter"],function(e,t){var n=0,i="default",o=function(e,t){this.webrtc=e,this.id=n++,this.currentcall=null,this.pc=null,this.datachannel=null,this.datachannelReady=!1,t&&this.createPeerConnection(t)};return o.prototype.createPeerConnection=function(e){var n;e?this.currentcall=e:e=this.currentcall;try{console.log("Creating RTCPeerConnnection with:\n  config: '"+JSON.stringify(e.pcConfig)+"';\n  constraints: '"+JSON.stringify(e.pcConstraints)+"'."),n=this.pc=new window.RTCPeerConnection(e.pcConfig,e.pcConstraints)}catch(o){console.error("Failed to create PeerConnection, exception: "+o.message),n=this.pc=null}return n&&(n.onicecandidate=t.bind(e.onIceCandidate,e),n.oniceconnectionstatechange=t.bind(this.onIceConnectionStateChange,this),n.onaddstream=t.bind(this.onRemoteStreamAdded,this),n.onremovestream=t.bind(this.onRemoteStreamRemoved,this),"firefox"===window.webrtcDetectedBrowser?this.negotiationNeeded=t.bind(function(){this.currentcall.initiate&&(console.log("Negotiation needed."),this.onNegotiationNeeded({target:this.pc}))},this):n.onnegotiationneeded=t.bind(this.onNegotiationNeeded,this),n.ondatachannel=t.bind(this.onDatachannel,this),n.onsignalingstatechange=t.bind(this.onSignalingStateChange,this),n.onicechange=t.bind(function(e){console.warn("Old style onicechange event",arguments),this.onIceConnectionStateChange({target:{iceConnectionState:e}})},this),e.initiate&&("chrome"!==window.webrtcDetectedBrowser||!window.webrtcDetectedAndroid||"chrome"===window.webrtcDetectedBrowser&&window.webrtcDetectedVersion>=33)&&this.createDatachannel(i,{ordered:!0})),n},o.prototype.negotiationNeeded=function(){},o.prototype.createDatachannel=function(t,n){if(!t)return void console.error("Refusing to create a datachannel without a label.",t,n);var o=e.extend({},n);console.debug("Creating datachannel:",t,o,this);var a;try{a=this.pc.createDataChannel(t,o),this.onDatachannel({channel:a})}catch(r){console.error("Failed to create DataChannel, exception: "+r.message),t===i&&(this.datachannel=null,this.datachannelReady=!1)}return a},o.prototype.onDatachannel=function(e){var n=e.channel;if(n)if(n.label===i){n.binaryType="arraybuffer",console.debug("Got default datachannel",n.label,this.id,n,this),this.datachannel=n;var o=t.bind(this.currentcall.onDatachannelDefault,this.currentcall);n.onmessage=t.bind(this.currentcall.onMessage,this.currentcall),n.onopen=t.bind(function(e){console.log("Datachannel opened",n.label,this.id,e),this.datachannelReady=!0,o("open",n)},this),n.onclose=t.bind(function(e){console.log("Datachannel closed",n.label,this.id,e),this.datachannelReady=!1,o("close",n)},this),n.onerror=t.bind(function(e){console.warn("Datachannel error",n.label,this.id,e),this.datachannelReady=!1,o("error",n)},this)}else console.debug("Got datachannel",n.label,this.id,n),t.defer(t.bind(this.currentcall.onDatachannel,this.currentcall),n)},o.prototype.send=function(e){if(!this.datachannelReady)return void console.error("Unable to send message by datachannel because datachannel is not ready.",e);if(e instanceof Blob)this.datachannel.send(e);else if(e instanceof ArrayBuffer)this.datachannel.send(e);else try{this.datachannel.send(JSON.stringify(e))}catch(t){console.warn("Data channel failed to send string -> closing.",t),this.datachannelReady=!1,this.datachannel.close()}},o.prototype.onSignalingStateChange=function(e){var t=e.target.signalingState;console.debug("Connection signaling state change",t,this.currentcall.id),this.currentcall.onSignalingStateChange(t)},o.prototype.onIceConnectionStateChange=function(e){var t=e.target.iceConnectionState;console.debug("ICE connection state change",t,this.currentcall.id),this.currentcall.onIceConnectionStateChange(t)},o.prototype.onRemoteStreamAdded=function(e){var t=e.stream;console.info("Remote stream added.",t),this.currentcall.onRemoteStreamAdded(t)},o.prototype.onRemoteStreamRemoved=function(e){var t=e.stream;console.info("Remote stream removed.",t),this.currentcall.onRemoteStreamRemoved(t)},o.prototype.onNegotiationNeeded=function(e){var t=e.target;t===this.pc&&this.currentcall.onNegotiationNeeded()},o.prototype.close=function(){this.datachannel&&this.datachannel.close(),this.pc&&this.pc.close(),this.datachannel=null,this.pc=null},o.prototype.hasRemoteDescription=function(){return this.pc&&this.pc.remoteDescription&&this.pc.remoteDescription.sdp?!0:!1},o.prototype.setRemoteDescription=function(){return this.pc.setRemoteDescription.apply(this.pc,arguments)},o.prototype.setLocalDescription=function(){return this.pc.setLocalDescription.apply(this.pc,arguments)},o.prototype.addIceCandidate=function(){return this.pc.addIceCandidate.apply(this.pc,arguments)},o.prototype.addStream=function(){return t.defer(this.negotiationNeeded),this.pc.addStream.apply(this.pc,arguments)},o.prototype.removeStream=function(){return t.defer(this.negotiationNeeded),this.pc.removeStream.apply(this.pc,arguments)},o.prototype.createAnswer=function(){return this.pc.createAnswer.apply(this.pc,arguments)},o.prototype.createOffer=function(){return this.pc.createOffer.apply(this.pc,arguments)},o.prototype.getRemoteStreams=function(){return this.pc?this.pc.getRemoteStreams.apply(this.pc,arguments):[]},o.prototype.getLocalStreams=function(){return this.pc?this.pc.getRemoteStreams.apply(this.pc,arguments):[]},o.prototype.getStreamById=function(){return this.pc.getStreamById.apply(this.pc,arguments)},o}),define("mediastream/peercall",["jquery","underscore","mediastream/utils","mediastream/peerconnection"],function(e,t,n,i){var o=function(t,n,i,o){this.webrtc=t,this.id=n,this.from=i,this.to=o,this.e=e({}),this.mediaConstraints=e.extend(!0,{},this.webrtc.settings.mediaConstraints),this.pcConfig=e.extend(!0,{},this.webrtc.settings.pcConfig),this.pcConstraints=e.extend(!0,{},this.webrtc.settings.pcConstraints),this.sdpConstraints=e.extend(!0,{},this.webrtc.settings.sdpConstraints),this.offerConstraints=e.extend(!0,{},this.webrtc.settings.offerConstraints),this.sdpParams=e.extend(!0,{},this.webrtc.settings.sdpParams),this.peerconnection=null,this.datachannels={},this.streams={},this.negotiationNeeded=!1,this.initiate=!1,this.closed=!1};return o.prototype.setInitiate=function(e){this.initiate=!!e},o.prototype.createPeerConnection=function(e,t){var n=this.peerconnection=new i(this.webrtc,this);return e&&n.pc&&e(n),t&&!n.pc&&t(n),n},o.prototype.createOffer=function(e){var i=n.mergeConstraints(this.offerConstraints,this.sdpConstraints);console.log("Creating offer with constraints: \n  '"+JSON.stringify(i,null,"	")+"'.",this.negotiationNeeded),this.peerconnection.createOffer(t.bind(this.onCreateAnswerOffer,this,e),t.bind(this.onErrorAnswerOffer,this),i)},o.prototype.createAnswer=function(e){console.log("Creating answer.",this.negotiationNeeded),this.peerconnection.createAnswer(t.bind(this.onCreateAnswerOffer,this,e),t.bind(this.onErrorAnswerOffer,this),this.peerconnection.sdpConstraints)},o.prototype.onCreateAnswerOffer=function(e,n){this.setLocalSdp(n);var i=n;i.toJSON&&(i=JSON.parse(JSON.stringify(i))),console.log("Created offer/answer",JSON.stringify(i,null,"	")),this.e.triggerHandler("sessiondescription",[i,this]),this.peerconnection.setLocalDescription(n,t.bind(function(){console.log("Set local session description.",n,this),e&&e(i,this)},this),t.bind(function(e){console.error("Set local session description failed",e),this.close(),this.e.triggerHandler("error","failed_peerconnection_setup")},this)),this.negotiationNeeded&&(this.negotiationNeeded=!1,console.log("Negotiation complete.",this))},o.prototype.onErrorAnswerOffer=function(e){console.error("Failed to create answer/offer",e)},o.prototype.setRemoteDescription=function(e,n){var i=this.peerconnection;return i?(this.setRemoteSdp(e),void i.setRemoteDescription(e,t.bind(function(){console.log("Set remote session description.",e,this),n&&n(e,this),t.defer(t.bind(function(){var e=0;t.each(i.getRemoteStreams(),t.bind(function(t){!this.streams.hasOwnProperty(t.id)&&(t.getAudioTracks().length>0||t.getVideoTracks().length>0)&&(console.log("Adding stream after remote SDP success.",t),this.onRemoteStreamAdded(t),e++)},this)),0===e&&this.sdpConstraints.mandatory&&(this.sdpConstraints.mandatory.OfferToReceiveAudio||this.sdpConstraints.mandatory.OfferToReceiveVideo)&&this.e.triggerHandler("remoteStreamAdded",[null,this])},this))},this),t.bind(function(e){console.error("Set remote session description failed",e),this.close(),this.e.triggerHandler("error","failed_peerconnection_setup")},this))):void console.log("Got a remote description but not connected -> ignored.")},o.prototype.setLocalSdp=function(e){var t=this.sdpParams;e.sdp=n.maybePreferAudioReceiveCodec(e.sdp,t),e.sdp=n.maybePreferVideoReceiveCodec(e.sdp,t),e.sdp=n.maybeSetAudioReceiveBitRate(e.sdp,t),e.sdp=n.maybeSetVideoReceiveBitRate(e.sdp,t),e.sdp=n.fixLocal(e.sdp,t)},o.prototype.setRemoteSdp=function(e){var t=this.sdpParams;e.sdp=n.maybeSetOpusOptions(e.sdp,t),e.sdp=n.maybePreferAudioSendCodec(e.sdp,t),e.sdp=n.maybePreferVideoSendCodec(e.sdp,t),e.sdp=n.maybeSetAudioSendBitRate(e.sdp,t),e.sdp=n.maybeSetVideoSendBitRate(e.sdp,t),e.sdp=n.maybeSetVideoSendInitialBitRate(e.sdp,t),e.sdp=n.fixRemote(e.sdp,t)},o.prototype.onIceCandidate=function(e){if(e.candidate){var t={type:"candidate",sdpMLineIndex:e.candidate.sdpMLineIndex,sdpMid:e.candidate.sdpMid,candidate:e.candidate.candidate};this.e.triggerHandler("icecandidate",[t,this]),this.webrtc.api.sendCandidate(this.to,t)}else console.log("End of candidates.")},o.prototype.onSignalingStateChange=function(e){this.e.triggerHandler("signalingStateChange",[e,this])},o.prototype.onIceConnectionStateChange=function(e){this.e.triggerHandler("connectionStateChange",[e,this])},o.prototype.onRemoteStreamAdded=function(e){var t=e.id;this.streams.hasOwnProperty(t)||(this.streams[t]=e,this.e.triggerHandler("remoteStreamAdded",[e,this]))},o.prototype.onRemoteStreamRemoved=function(e){this.e.triggerHandler("remoteStreamRemoved",[e,this]),e&&delete this.streams[e.id]},o.prototype.onNegotiationNeeded=function(){this.negotiationNeeded||(this.negotiationNeeded=!0,console.log("Negotiation needed.",this),this.e.triggerHandler("negotiationNeeded",[this]))},o.prototype.addIceCandidate=function(e){this.closed||this.peerconnection.addIceCandidate(e,function(){},function(t){console.warn("Failed to add remote candidate:",t,e)})},o.prototype.onDatachannel=function(e){var t=e.label;return this.datachannels.hasOwnProperty(t)?void console.warn("Received duplicated datachannel label",t,e,this.datachannels):(this.datachannels[t]=e,void this.e.triggerHandler("datachannel",["new",e,this]))},o.prototype.onDatachannelDefault=function(e,n){"open"===e&&t.defer(t.bind(function(){this.e.triggerHandler("dataReady",[this])},this)),this.e.triggerHandler("datachannel.default",[e,n,this])},o.prototype.onMessage=function(e){var t=e.data;if(t instanceof Blob)console.warn("Blob data received - not implemented.",t);else if(t instanceof ArrayBuffer)console.warn("ArrayBuffer data received - not implemented.",t);else if("string"==typeof t){if(2===t.charCodeAt(0))return;var n=JSON.parse(e.data);this.webrtc.api.received({Type:n.Type,Data:n,To:this.webrtc.api.id,From:this.id,p2p:!0})}else console.warn("Unknow data type received -> igored",typeof t,[t])},o.prototype.getDatachannel=function(e,t,n){var i=this.datachannels[e];return i||(console.log("Creating new datachannel",e,t),i=this.peerconnection.createDatachannel(e,t),n&&n(i)),i},o.prototype.close=function(){this.closed||(this.closed=!0,t.each(this.datachannels,function(e){e.close()}),this.datachannels={},this.peerconnection&&(this.peerconnection.close(),this.peerconnection=null),t.each(this.streams,t.bind(function(e){this.e.triggerHandler("remoteStreamRemoved",[e,this])},this)),this.streams={},console.log("Peercall close",this),this.e.triggerHandler("closed",[this]))},o}),define("mediastream/peerconference",["jquery","underscore","mediastream/peercall"],function(e,t,n){var i=0,o=function(n,o,a){this.webrtc=n,this.currentcall=o,this.calls={},this.callsIn={},this.e=e({}),this.id=a?a:n.api.id+"_"+ ++i,this.usermedia=n.usermedia,n.e.on("usermedia",t.bind(function(e,t){console.log("Conference user media changed",t),this.usermedia=t},this)),console.log("Created conference",this.id)};return o.prototype.createCall=function(e,i,o){var a=new n(this.webrtc,e,i,o);return a.e.on("closed",t.bind(function(){delete this.calls[e],this.callsIn.hasOwnProperty(e)&&delete this.callsIn[e],console.log("Cleaned up conference call",e),t.isEmpty(this.calls)&&(console.log("Conference is now empty -> cleaning up."),this.e.triggerHandler("finished"))},this)),a.e.on("connectionStateChange",t.bind(function(e,t,n){this.onConnectionStateChange(t,n)},this)),a.e.on("remoteStreamAdded",t.bind(function(e,t,n){this.webrtc.onRemoteStreamAdded(t,n)},this)),a.e.on("remoteStreamRemoved",t.bind(function(e,t,n){this.webrtc.onRemoteStreamRemoved(t,n)},this)),a},o.prototype.doCall=function(e,n){if(e!==this.currentcall.id&&!this.calls.hasOwnProperty(e)){var i=this.calls[e]=this.createCall(e,null,e);i.setInitiate(!0),i.e.on("sessiondescription",t.bind(function(e,t){console.log("Injected conference id into sessionDescription",this.id),t._conference=this.id},this)),n||this.webrtc.e.triggerHandler("connecting",[i]),console.log("Creating PeerConnection",i),i.createPeerConnection(t.bind(function(e){this.usermedia&&this.usermedia.addToPeerConnection(e),i.e.on("negotiationNeeded",t.bind(function(e,t){this.webrtc.sendOfferWhenNegotiationNeeded(t)},this))},this),t.bind(function(){console.error("Failed to create peer connection for conference call.")},this))}},o.prototype.handOver=function(){var e=t.keys(this.callsIn);if(e.length){var n=e[0],i=this.currentcall=this.calls[n];return delete this.calls[n],delete this.callsIn[n],console.log("Handed over conference to",n,i),t.isEmpty(this.calls)&&(console.log("Conference is now empty -> cleaning up."),this.e.triggerHandler("finished")),i}return null},o.prototype.autoAnswer=function(e,n){if(e===this.currentcall.id||this.calls.hasOwnProperty(e))return void console.warn("Already got a call to this id (autoAnswer)",e,this.calls);var i=this.calls[e]=this.createCall(e,this.webrtc.api.id,e);console.log("Creating PeerConnection",i),i.createPeerConnection(t.bind(function(e){i.setRemoteDescription(n,t.bind(function(){this.usermedia&&this.usermedia.addToPeerConnection(e),i.e.on("negotiationNeeded",t.bind(function(e,t){this.webrtc.sendOfferWhenNegotiationNeeded(t)},this)),i.createAnswer(t.bind(function(e,t){console.log("Sending answer",e,t.id),this.webrtc.api.sendAnswer(t.id,e)},this))},this))},this),t.bind(function(){console.error("Failed to create peer connection for auto answer.")},this))},o.prototype.getCall=function(e){var t=this.calls[e];return t||(t=null),t},o.prototype.close=function(){this.currentcall=null;var e=this.webrtc.api;t.each(this.calls,function(t){t.close();var n=t.id;n&&e.sendBye(n)}),this.calls={}},o.prototype.onConnectionStateChange=function(e,t){switch(console.log("Conference peer connection state changed",e,t),e){case"completed":case"connected":this.callsIn.hasOwnProperty(t.id)||(this.callsIn[t.id]=!0,this.pushUpdate());break;case"failed":console.warn("Conference peer connection state failed",t)}this.webrtc.onConnectionStateChange(e,t)},o.prototype.pushUpdate=function(){var e=t.keys(this.callsIn);e&&this.currentcall&&(e.push(this.currentcall.id),e.push(this.webrtc.api.id)),console.log("Calls in conference: ",e),this.webrtc.api.sendConference(this.id,e)},o.prototype.applyUpdate=function(e){console.log("Applying conference update",this.id,e);var n=this.webrtc.api.id;t.each(e,t.bind(function(e){var t=e>n?-1:n>e?1:0;console.log("Considering conference peers to call",t,e),-1===t&&this.doCall(e,!0)},this))},o.prototype.peerIds=function(){return t.keys(this.calls)},o}),define("mediastream/tokens",["jquery","underscore"],function(e,t){var n=function(t){this.e=e({}),this.count=0,this.trigger=null,this.handlers={},this.handlerKey=t};n.prototype.on=function(e,t){return this.count++,this.e.on(e,t)},n.prototype.off=function(e,t,n){this.e.off(e,t),n||this.count--},n.prototype.addHandler=function(e,t,n){return n||(n=e.id),this.handlers[o.makeId(t,n)]=e,e},n.prototype.getHandler=function(e){return this.handlers[e]};var i=function(){this.tokens={},this.handlers={},this.e=e({})};i.prototype.registerHandler=function(e,t){this.handlers[e]=t},i.prototype.makeId=function(){var e=Array.prototype.slice.call(arguments);return e.join("_")},i.prototype.valid=function(e){return this.tokens.hasOwnProperty(e)},i.prototype.get=function(e){return this.tokens[e]},i.prototype.bind=function(e,t,i,o){var a=this.tokens[t];return a||(a=this.tokens[t]=new n(o),console.log("Created token",t,a)),a.on(e,i)},i.prototype.on=function(e,t,n){return this.bind("message",e,t,n)},i.prototype.create=function(e,t,n){return this.bind("created",e,t,n)},i.prototype.off=function(e,t){var n=this.tokens[e];n&&(n.off("message",t),n.off("created",t,!0),n.count<=0&&(delete this.tokens[e],console.log("Removed token",e,n)))},i.prototype.processReceivedMessage=function(e,n,i,o,a,r,s,c){if(!this.valid(n))return void console.warn("Received token request for unknown token -> ignore.",n);var l=this.get(n);l&&!l.trigger&&(l.trigger=function(e,n,i,o,a){return t.bind(function(e,t){this.e.triggerHandler("message",[n,i,e,null,o,a,t])},l)}(e,n,o,s,c));var d=l.getHandler(this.makeId(c,i));switch(r){case"Offer":if(!d){var u=this.handlers[l.handlerKey];if(!u)return void console.warn("Incoming offer for unknown handler",l.handlerKey);d=u(e,i,n,c),l.addHandler(d,c,i),d.createPeerConnection(function(){l.e.triggerHandler("created",[n,o,a,r,s,c,d])}),d.messageHandler=t.bind(l.trigger,l)}d.setRemoteDescription(new window.RTCSessionDescription(a),t.bind(function(){d.createAnswer(t.bind(function(t){e.api.sendAnswer(c,t)},this))},this));break;case"Answer":console.log("Token answer process."),d.messageHandler||(d.messageHandler=t.bind(l.trigger,l)),d.setRemoteDescription(new window.RTCSessionDescription(a));break;case"Candidate":var p=new window.RTCIceCandidate({sdpMLineIndex:a.sdpMLineIndex,sdpMid:a.sdpMid,candidate:a.candidate});d.addIceCandidate(p);break;default:l.e.triggerHandler("message",[n,o,a,r,s,c,d])}};var o=new i;return o}),define("mediastream/peerxfer",["jquery","underscore","mediastream/peercall","mediastream/tokens","webrtc.adapter"],function(e,t,n,i){var o=0;i.registerHandler("xfer",function(e,t,n,i){console.log("Creating new xfer for incoming offer from",i,t);var o=new a(e,t,n,i);return o});var a=function(e,i,a,r){null===i&&(i=o++),n.call(this,e,i,null,r),this.token=a,this.messageHandler=null,this.mediaConstraints={audio:!1,video:!1},this.sdpConstraints={mandatory:{},optional:[]},this.pcConstraints={mandatory:{},optional:[]},this.e.on("sessiondescription icecandidate",t.bind(function(e,t){t._token=this.token,t._id=this.id},this))};return a.prototype=Object.create(n.prototype),a.prototype.constructor=a,a.prototype.close=function(){n.prototype.close.call(this)},a.prototype.cancel=function(){this.e.triggerHandler("cancel",[this]),this.close()},a.prototype.onMessage=function(e){this.messageHandler?this.messageHandler(e.data,this):console.warn("No messageHandler for message",e,this)},a.prototype.send=function(e){return this.peerconnection?this.peerconnection.send(e):void console.warn("Xfer cannot send because not connected.")},a}),define("mediastream/peerscreenshare",["jquery","underscore","mediastream/peercall","mediastream/tokens"],function(e,t,n,i){var o=0;i.registerHandler("screenshare",function(e,t,n,i){console.log("Creating new screenshare for incoming offer from",i,t);var o=new a(e,t,n,i);return o});var a=function(e,i,a,r){null===i&&(i=o++),n.call(this,e,i,null,r),this.token=a,this.messageHandler=null,this.mediaConstraints={audio:!1,video:!1},this.sdpConstraints.mandatory.OfferToReceiveAudio=!1,this.sdpConstraints.mandatory.OfferToReceiveVideo=!0,this.pcConstraints={mandatory:{},optional:[]},this.e.on("sessiondescription icecandidate",t.bind(function(e,t){t._token=this.token,t._id=this.id},this))};return a.getCaptureMediaConstraints=function(t,n){var i=window.screen.width,o=window.screen.height,a=e.extend(!0,{},{maxWidth:i,maxHeight:o,minWidth:1,minHeight:1},t.settings.screensharing.mediaConstraints.video.mandatory,n),r=e.extend(!0,{},t.settings.screensharing.mediaConstraints,{audio:!1});return r.video.mandatory=a,console.log("Setting screen sharing media constraints",r),r},a.prototype=Object.create(n.prototype),a.prototype.constructor=a,a.prototype.close=function(){n.prototype.close.call(this)},a.prototype.onMessage=function(e){this.messageHandler?this.messageHandler(e.data,this):console.warn("No messageHandler for message",e,this)},a.prototype.send=function(e){return this.peerconnection?this.peerconnection.send(e):void console.warn("Screenshare cannot send because not connected.")},a}),define("mediastream/dummystream",[],function(){var e=function(e){this.id=e?e:"defaultDummyStream"};return e.prototype.stop=function(){},e.prototype.getAudioTracks=function(){return[]},e.prototype.getVideoTracks=function(){return[]},e.not=function(t){return!t||t.stop!==e.prototype.stop},e.is=function(t){return t&&t.stop===e.prototype.stop},e}),define("mediastream/usermedia",["jquery","underscore","audiocontext","mediastream/dummystream","webrtc.adapter"],function(e,t,n,i){var o=n?new n:null,a=function(e,t,n,i){var o=t.substring(0,3);switch(o){case"min":case"max":var a=t[3].toLowerCase()+t.substring(4);e.hasOwnProperty(a)||(e[a]={}),i&&"min"===o&&e[a].hasOwnProperty(o)&&(e[a].ideal=e[a].min),e[a][o]=n;break;default:e[t]=n}},r=function(e){if(!e)return!1;if(!e.hasOwnProperty("optional")&&!e.hasOwnProperty("mandatory"))return e;var n={};return e.optional&&t.each(e.optional,function(e){t.each(e,function(e,t){a(n,t,e)})}),e.mandatory&&t.each(e.mandatory,function(e,t){a(n,t,e,!0)}),t.isEmpty(n)?!0:(t.each(n,function(e,i){if(t.isObject(e)){var o=t.values(e);1===o.length&&(n[i]={ideal:o[0]})}}),n)},s=function(){return window.navigator.mediaDevices?(console.info("Enabled mediaDevices adapter ..."),function(e,t,n){var i={audio:r(e.audio),video:r(e.video)};console.log("Constraints for mediaDevices",i),window.navigator.mediaDevices.getUserMedia(i).then(t).catch(n)}):window.getUserMedia}(),c=function(){return function(e){if(e&&e.getTracks){var n=e.getTracks();t.each(n,function(e){e.stop()}),"firefox"===window.webrtcDetectedBrowser&&e.stop&&e.stop()}else e.stop()}}(),l=function(n){this.options=e.extend({},n),this.e=e({}),this.localStream=null,this.started=!1,this.peerconnections={},this.renegotiation=n.renegotiation&&!0,this.renegotiation&&console.info("User media with renegotiation created ..."),this.audioMute=n.audioMute&&!0,this.videoMute=n.videoMute&&!0,this.mediaConstraints=null,this.audioLevel=0,!this.options.noAudio&&o&&o.createScriptProcessor&&(this.audioSource=null,this.audioProcessor=o.createScriptProcessor(2048,1,1),this.audioProcessor.onaudioprocess=t.bind(function(e){if(this.audioSource){for(var t=e.inputBuffer.getChannelData(0),n=t.length,i=0,o=0;n>o;)i+=Math.abs(t[o++]);var a=Math.sqrt(i/n);this.audioLevel=a}},this),o.createMediaStreamSource&&this.e.on("localstream",t.bind(function(e,t){this.audioSource&&this.audioSource.disconnect();var n=t.getAudioTracks();return n.length<1?void(this.audioSource=null):(this.audioSource=o.createMediaStreamSource(t),this.audioSource.connect(this.audioProcessor),void this.audioProcessor.connect(o.destination))},this))),this.e.on("localstream",t.bind(function(e,n,o){o&&t.each(this.peerconnections,function(e){i.not(o)&&e.removeStream(o),i.not(n)&&e.addStream(n),console.log("Updated usermedia stream at peer connection",e,n)})},this))};return l.testGetUserMedia=function(e,t){console.log("Requesting testGetUserMedia"),function(n){var i=null,o=function(t){if(i&&(clearTimeout(i),i=null),c(t),!n.done){n.done=!0;var o=Array.prototype.slice.call(arguments,1);e.apply(this,o)}},a=function(){if(i&&(clearTimeout(i),i=null),!n.done){n.done=!0;var e=Array.prototype.slice.call(arguments,1);t.apply(this,e)}};try{s({video:!0,audio:!0},o,a)}catch(r){console.error("getUserMedia failed with exception: "+r.message),a(r)}i=setTimeout(function(){var e=new Error("Timeout while waiting for getUserMedia");console.error("getUserMedia timed out"),a(e)},1e4)}({})},l.getUserMedia=s,l.stopUserMediaStream=c,l.prototype.doGetUserMedia=function(e,t){return t||(t=e.mediaConstraints),this.doGetUserMediaWithConstraints(t)},l.prototype.doGetUserMediaWithConstraints=function(n){n?(this.mediaConstraints=n,this.localStream&&this.replaceStream(null)):n=this.mediaConstraints;var o=e.extend(!0,{},n);if(this.renegotiation){if(this.audioMute&&this.videoMute)return t.defer(t.bind(function(){this.onUserMediaSuccess(new i)},this)),this.started=!0,!0;this.audioMute&&(o.audio=!1),this.videoMute&&(o.video=!1)}try{return console.log("Requesting access to local media with mediaConstraints:\n  '"+JSON.stringify(o)+"'",o),s(o,t.bind(this.onUserMediaSuccess,this),t.bind(this.onUserMediaError,this)),this.started=!0,!0}catch(a){return console.error("getUserMedia failed with exception: "+a.message),!1}},l.prototype.onUserMediaSuccess=function(e){return console.log("User has granted access to local media."),this.started?void this.onLocalStream(e):void c(e)},l.prototype.onUserMediaError=function(e){console.error("Failed to get access to local media. Error was "+e.name,e),this.started&&this.e.triggerHandler("mediaerror",[this,e])},l.prototype.replaceStream=function(e){var n=this.localStream;if(n&&n.active){var i=function(){console.log("Silently ended replaced user media stream.")};n.getTracks?t.each(e.getTracks(),function(e){e.onended=i}):n.onended=i,c(n)}if(e){var o=t.bind(function(e){this.started&&(console.log("Stopping user media as a stream has ended.",e),this.stop())},this);e.getTracks?t.each(e.getTracks(),function(e){e.onended=o}):e.onended=o,this.localStream=e,this.e.triggerHandler("localstream",[e,n,this])}return n&&e},l.prototype.onLocalStream=function(e){this.replaceStream(e)?setTimeout(t.bind(function(){this.e.triggerHandler("mediachanged",[this])},this),0):setTimeout(t.bind(function(){this.e.triggerHandler("mediasuccess",[this])},this),0),this.renegotiation||(this.applyAudioMute(this.audioMute),this.applyVideoMute(this.videoMute))},l.prototype.stop=function(){this.started=!1,this.audioSource&&(this.audioSource.disconnect(),this.audioSource=null),this.localStream&&(c(this.localStream),this.localStream=null),this.audioProcessor&&this.audioProcessor.disconnect(),this.audioLevel=0,this.audioMute=!1,this.videoMute=!1,this.mediaConstraints=null,console.log("Stopped user media."),this.e.triggerHandler("stopped",[this]),this.e.off()},l.prototype.applyAudioMute=function(e){var t=!!e;if(this.renegotiation)this.started?this.audioMute!==t&&(this.audioMute=t,this.doGetUserMediaWithConstraints()):this.audioMute=t;else if(this.localStream){var n=this.localStream.getAudioTracks();if(0===n.length)return;for(var i=0;i<n.length;i++)n[i].enabled=!e;console.log(e?"Local audio muted by disabling audio tracks.":"Local audio unmuted by enabling audio tracks.")}return t},l.prototype.applyVideoMute=function(e){var t=!!e;if(this.renegotiation)this.started?this.videoMute!==t&&(this.videoMute=t,this.doGetUserMediaWithConstraints()):this.videoMute=t;else if(this.localStream){var n=this.localStream.getVideoTracks();if(0===n.length)return;for(var i=0;i<n.length;i++)n[i].enabled=!e;console.log(e?"Local video muted by disabling video tracks.":"Local video unmuted by enabling video tracks.")}return t},l.prototype.addToPeerConnection=function(e){if(console.log("Add usermedia stream to peer connection",e,this.localStream),this.localStream){i.not(this.localStream)&&e.addStream(this.localStream);var n=e.id;this.peerconnections.hasOwnProperty(n)||(this.peerconnections[n]=e,e.currentcall.e.one("closed",t.bind(function(){delete this.peerconnections[n]},this)))}else t.defer(e.negotiationNeeded)},l.prototype.removeFromPeerConnection=function(e){console.log("Remove usermedia stream from peer connection",e,this.localStream),this.localStream&&(i.not(this.localStream)&&e.removeStream(this.localStream),this.peerconnections.hasOwnProperty(e.id)&&delete this.peerconnections[e.id])},l.prototype.attachMediaStream=function(e){this.localStream&&i.not(this.localStream)&&window.attachMediaStream(e,this.localStream)},l});var webrtcDetectedAndroid=null!==(window.navigator||{}).userAgent.match(/android (\d+)/i);define("mediastream/webrtc",["jquery","underscore","mediastream/peercall","mediastream/peerconference","mediastream/peerxfer","mediastream/peerscreenshare","mediastream/usermedia","mediastream/utils","mediastream/tokens","webrtc.adapter"],function(e,t,n,i,o,a,r,s,c){webrtcDetectedAndroid&&console.log("This seems to be Android");var l=function(n){this.api=n,this.e=e({}),this.currentcall=null,this.currentconference=null,this.msgQueue=[],this.started=!1,this.initiator=null,this.usermedia=null,this.audioMute=!1,this.videoMute=!1,this.settings={mediaConstraints:{audio:!0,video:{optional:[],mandatory:{maxWidth:640,maxHeight:480}}},pcConfig:{iceServers:[{url:"stun:stun.l.google.com:19302"}]},pcConstraints:{mandatory:{},optional:[]},sdpConstraints:{mandatory:{OfferToReceiveAudio:!0,OfferToReceiveVideo:!0},optional:[]},offerConstraints:{mandatory:{},optional:[]},screensharing:{mediaConstraints:{audio:!1,video:{optional:[],mandatory:{}}}},sdpParams:{audioSendCodec:"opus/48000",opusStereo:"true",videoSendCodec:"VP8/90000"},renegotiation:!0},this.screensharingSettings={},this.api.e.bind("received.offer received.candidate received.answer received.bye received.conference",t.bind(this.processReceived,this))
};return l.prototype.processReceived=function(e,t,n,i,o,a){if(n&&n._token){var r=n._token,s=n._id;return delete n._token,delete n._id,void c.processReceivedMessage(this,r,s,t,n,i,o,a)}if(this.initiator||this.started)this.processReceivedMessage(t,n,i,o,a);else switch(i){case"Offer":if(this.currentcall)return console.warn("Received Offer while not started and with current call -> busy.",a),this.api.sendBye(a,"busy"),void this.e.triggerHandler("busy",[a,o,t]);this.msgQueue.unshift([t,n,i,o,a]),this.currentcall=this.createCall(a,a,a),this.e.triggerHandler("offer",[a,o,t]);break;case"Bye":if(!this.currentcall)return void console.warn("Received Bye while without currentcall -> ignore.",a);if(this.currentcall.from!==a)return void console.warn("Received Bye from another id -> ignore.",a);console.log("Bye process (started false)"),this.doHangup("receivedbye",a),this.e.triggerHandler("bye",[n.Reason,a,t,o]);break;default:this.msgQueue.push([t,n,i,o,a])}},l.prototype.findTargetCall=function(e){var t=null;if(this.currentcall)do{if(this.initiator&&this.currentcall.to===e){t=this.currentcall;break}if(!this.initiator&&this.currentcall.from===e){t=this.currentcall;break}if(this.currentcall.id===e){t=this.currentcall;break}this.currentconference&&(t=this.currentconference.getCall(e))}while(!1);return t},l.prototype.callForEachCall=function(e){var n=0;return this.currentcall&&(e(this.currentcall,n),n++,this.currentconference&&t.each(this.currentconference.calls,function(t,n){e(t),n++})),n},l.prototype.processReceivedMessage=function(e,n,o,a,r){if(!this.started)return void console.log("PeerConnection has not been created yet!");var s;switch(o){case"Offer":if(console.log("Offer process."),s=this.findTargetCall(r)){if(!this.settings.renegotiation&&s.peerconnection&&s.peerconnection.hasRemoteDescription())return this.doHangup("unsupported",r),void console.error("Processing new offers is not implemented without renegotiation.");s.setRemoteDescription(new window.RTCSessionDescription(n),t.bind(function(e,n){n===this.currentcall&&this.e.triggerHandler("peercall",[this.currentcall]),n.createAnswer(t.bind(function(e,t){console.log("Sending answer",e,t.id),this.api.sendAnswer(t.id,e)},this))},this))}else{if(this.currentconference&&this.currentconference.id===n._conference){console.log("Received conference Offer -> auto.",r,n._conference),delete n._conference,this.currentconference.autoAnswer(r,new window.RTCSessionDescription(n));break}console.log("Received Offer from unknown id -> busy.",r),this.api.sendBye(r,"busy"),this.e.triggerHandler("busy",[r,a,e])}break;case"Candidate":if(s=this.findTargetCall(r),!s)return void console.warn("Received Candidate for unknown id -> ignore.",r);var c=new window.RTCIceCandidate({sdpMLineIndex:n.sdpMLineIndex,sdpMid:n.sdpMid,candidate:n.candidate});s.addIceCandidate(c);break;case"Answer":if(s=this.findTargetCall(r),!s)return void console.warn("Received Answer from unknown id -> ignore",r);console.log("Answer process."),s.setRemoteDescription(new window.RTCSessionDescription(n),function(){console.log("Received answer after we sent offer",n)});break;case"Bye":if(s=this.findTargetCall(r),!s)return void console.warn("Received Bye from unknown id -> ignore.",r);if(console.log("Bye process."),s===this.currentcall){var l;this.currentconference&&(l=this.currentconference.handOver()),l?(this.currentcall=l,s.close(),this.e.triggerHandler("peercall",[l]),this.e.triggerHandler("peerconference",[this.currentconference])):(this.doHangup("receivedbye",s.id),this.e.triggerHandler("bye",[n.Reason,r,e,a]))}else this.doHangup("receivedbye",s.id),this.e.triggerHandler("bye",[n.Reason,r,e,a]);break;case"Conference":if(!this.currentcall||-1===n.indexOf(this.currentcall.id))return void console.warn("Received Conference for unknown call -> ignore.",e,n);var d=this.currentconference;if(d){if(d.id!==e)return void console.warn("Received Conference for wrong id -> ignore.",e,d)}else d=this.currentconference=new i(this,this.currentcall,e),d.e.one("finished",t.bind(function(){this.currentconference=null,this.e.triggerHandler("peerconference",[null])},this));d.applyUpdate(n),this.e.triggerHandler("peerconference",[d]);break;default:console.log("Unhandled message type",o,n)}},l.prototype.testMediaAccess=function(e){var t=function(){console.info("testMediaAccess success"),e(!0)},n=function(){console.info("testMediaAccess failed"),e(!1)};r.testGetUserMedia(t,n)},l.prototype.createCall=function(e,i,o){var a=new n(this,e,i,o);return a.e.on("connectionStateChange",t.bind(function(e,t,n){this.onConnectionStateChange(t,n)},this)),a.e.on("remoteStreamAdded",t.bind(function(e,t,n){this.onRemoteStreamAdded(t,n)},this)),a.e.on("remoteStreamRemoved",t.bind(function(e,t,n){this.onRemoteStreamRemoved(t,n)},this)),a.e.on("error",t.bind(function(e,n,i){n||(n="failed_peerconnection"),this.e.triggerHandler("error",[i,n]),t.defer(t.bind(this.doHangup,this),"error",a.id)},this)),a},l.prototype.doUserMedia=function(e){var n=new r({renegotiation:this.settings.renegotiation,audioMute:this.audioMute,videoMute:this.videoMute});return n.e.on("mediasuccess mediaerror",t.bind(function(e,t){this.e.triggerHandler("usermedia",[t]),this.maybeStart(t)},this)),n.e.on("mediachanged",t.bind(function(e,t){this.e.triggerHandler("usermedia",[t])},this)),n.e.on("stopped",t.bind(function(e,t){t===this.usermedia&&(this.e.triggerHandler("usermedia",[null]),this.usermedia=null)},this)),this.e.one("stop",function(){n.stop()}),this.usermedia=n,this.e.triggerHandler("usermedia",[n]),n.doGetUserMedia(e)},l.prototype.doCall=function(e){if(this.currentcall){var n=this.currentconference;n||(n=this.currentconference=new i(this,this.currentcall),n.e.one("finished",t.bind(function(){this.currentconference=null,this.e.triggerHandler("peerconference",[null])},this))),n.doCall(e),this.e.triggerHandler("peerconference",[n])}else{var o=this.currentcall=this.createCall(e,null,e);this.e.triggerHandler("peercall",[o]);var a=this.doUserMedia(o);if(!a)return this.e.triggerHandler("error",["Failed to access camera/microphone.","failed_getusermedia"]),this.doHangup();this.e.triggerHandler("waitforusermedia",[o]),this.initiator=!0}},l.prototype.doAccept=function(){var e=this.currentcall;if(!e)return void console.warn("Trying to accept without a call.",e);var t=this.doUserMedia(e);return t?void this.e.triggerHandler("waitforusermedia",[e]):(this.e.triggerHandler("error",["Failed to access camera/microphone.","failed_getusermedia"]),this.doHangup())},l.prototype.doXfer=function(n,i,a){var r=c.get(i);if(!r)return void console.warn("Cannot start xfer for unknown token",i);var s=new o(this,null,i,n),l=e.extend({created:function(){},connected:function(){},error:function(){},closed:function(){}},a);r.addHandler(s,n),s.e.on("connectionStateChange",t.bind(function(e,t,n){switch(console.log("Xfer state changed",t),t){case"completed":case"connected":break;case"disconnected":l.error(n);break;case"closed":l.closed(n)}},this)),s.e.on("dataReady",t.bind(function(e,t){l.connected(t)},this)),l.created(s),s.setInitiate(!0),s.createPeerConnection(t.bind(function(e){s.e.on("negotiationNeeded",t.bind(function(e,t){this.sendOfferWhenNegotiationNeeded(t,n)},this)),t.defer(e.negotiationNeeded)},this))},l.prototype.doScreenshare=function(e){var t=new r({noAudio:!0}),n=t.doGetUserMedia(null,a.getCaptureMediaConstraints(this,e));return n?(this.e.one("done",function(){t.stop()}),t):null},l.prototype.doSubscribeScreenshare=function(n,i,o){var r=c.get(i);if(!r)return void console.warn("Cannot subscribe screen share for unknown token",i);var s=new a(this,null,i,n),l=e.extend({created:function(){},connected:function(){},error:function(){},closed:function(){}},o);this.e.one("done",function(){s.close()}),r.addHandler(s,n),s.e.on("connectionStateChange",t.bind(function(e,t,n){switch(console.log("Screen share state changed",t),t){case"completed":case"connected":l.connected(n);break;case"disconnected":l.error(n);break;case"closed":l.closed(n)}},this)),l.created(s),s.setInitiate(!0),s.createPeerConnection(t.bind(function(e){s.e.on("negotiationNeeded",t.bind(function(e,t){this.sendOfferWhenNegotiationNeeded(t,n)},this)),t.defer(e.negotiationNeeded)},this))},l.prototype.stop=function(){this.currentconference&&(this.currentconference.close(),this.currentconference=null),this.currentcall&&(this.currentcall.close(),this.currentcall=null),this.e.triggerHandler("peerconference",[null]),this.e.triggerHandler("peercall",[null]),this.e.triggerHandler("stop"),this.msgQueue.length=0,this.initiator=null,this.started=!1},l.prototype.doHangup=function(e,n){if(console.log("Hanging up.",n),n){var i=this.findTargetCall(n);if(!i)return void console.warn("Tried to hangup unknown call.",e,n);if(i!==this.currentcall)return i.close(),"receivedbye"!==e&&this.api.sendBye(n,e),void t.defer(t.bind(function(){this.currentcall&&i?this.e.triggerHandler("statechange",["connected",this.currentcall]):this.e.triggerHandler("done",[e])},this))}this.currentcall&&(n=this.currentcall.id,t.defer(t.bind(function(){this.e.triggerHandler("done",[e])},this))),this.stop(),n&&"receivedbye"!==e&&this.api.sendBye(n,e)},l.prototype.maybeStart=function(e){if(!this.started){var n=this.currentcall;n.setInitiate(this.initiator),this.e.triggerHandler("connecting",[n]),console.log("Creating PeerConnection.",n),n.createPeerConnection(t.bind(function(i){e.addToPeerConnection(i),this.started=!0,this.initiator||this.calleeStart(),n.e.on("negotiationNeeded",t.bind(function(e,t){this.sendOfferWhenNegotiationNeeded(t)},this))},this),t.bind(function(){this.e.triggerHandler("error",["Failed to create peer connection. See log for details."]),this.doHangup()},this))}},l.prototype.calleeStart=function(){for(var e;this.msgQueue.length>0;)e=this.msgQueue.shift(),this.processReceivedMessage.apply(this,e)},l.prototype.sendOfferWhenNegotiationNeeded=function(e,n){"stable"===e.peerconnection.pc.signalingState&&(n||(n=e.id),e.createOffer(t.bind(function(e,t){console.log("Sending offer with sessionDescription",e,n,t),this.api.sendOffer(n,e)},this)))},l.prototype.onConnectionStateChange=function(e,n){t.defer(t.bind(function(){this.e.triggerHandler("statechange",[e,n])},this))},l.prototype.onRemoteStreamAdded=function(e,t){this.e.triggerHandler("streamadded",[e,t])},l.prototype.onRemoteStreamRemoved=function(e,t){this.e.triggerHandler("streamremoved",[e,t])},l.prototype.setVideoMute=function(e){this.videoMute=!!e,this.usermedia&&this.usermedia.applyVideoMute(this.videoMute)},l.prototype.setAudioMute=function(e){this.audioMute=!!e,this.usermedia&&this.usermedia.applyAudioMute(this.audioMute)},l}),define("services/webrtc",["mediastream/webrtc"],function(e){return["api",function(t){return new e(t)}]}),define("services/mediastream",["jquery","underscore","ua-parser","sjcl","modernizr","mediastream/tokens","webrtc.adapter"],function(e,t,n,i,o,a){return["globalContext","connector","api","webrtc","appData","$route","$location","$window","visibility","alertify","$http","safeApply","$timeout","$sce","localStorage","continueConnector","restURL",function(r,s,c,l,d,u,p,f,h,g,m,v,b,y,w,k,x){var $=(r.Ssl?"wss":"ws")+"://"+r.Host+(r.Cfg.B||"/")+"ws",C=r.Cfg.Version;console.log("Service version: "+C),console.log("Ws URL: "+$),console.log("Secure Contextual Escaping: "+y.isEnabled());var S=null,P=i.codec.base64.fromBits(i.hash.sha256.hash(r.Cfg.Token+n().browser.name));l.settings.renegotiation=r.Cfg.Renegotiation&&!0,l.settings.renegotiation&&"chrome"!==f.webrtcDetectedBrowser&&(console.warn("Disable renegotiation in anything but Chrome for now."),l.settings.renegotiation=!1);var T={version:C,ws:$,config:r.Cfg,webrtc:l,connector:s,api:c,tokens:a,users:{register:function(t,n,i){var o=x.api("users");if(t){e(t).attr("action",o).attr("method","POST");var a=e('<input name="id" type="hidden">');a.val(T.api.id);var r=e('<input name="sid" type="hidden">');r.val(T.api.sid),e(t).append(a),e(t).append(r);{e(t).find("iframe")}t.submit(),b(function(){a.remove(),r.remove(),a=null,r=null},0);var s=0,c=function(){T.users.authorize({count:s},n,function(e,t){s++,10>=s?b(c,2e3):(console.error("Failed to authorize session",t,e),i&&i(e,t))})};b(c,1500)}else{var l={id:T.api.id,sid:T.api.sid};m({method:"POST",url:o,data:JSON.stringify(l),headers:{"Content-Type":"application/json"}}).success(function(e,t){""!==e.userid&&e.success?n(e,t):i&&i(e,t)}).error(function(e,t){i&&i(e,t)})}},authorize:function(e,n,i){d.authorizing(!0);var o=x.api("sessions")+"/"+T.api.id+"/",a=t.clone(e);a.id=T.api.id,a.sid=T.api.sid,m({method:"PATCH",url:o,data:JSON.stringify(a),headers:{"Content-Type":"application/json"}}).success(function(e,t){""!==e.nonce&&e.success?n(e,t):(d.authorizing(!1),i&&i(e,t))}).error(function(e,t){d.authorizing(!1),i&&i(e,t)})},store:function(e){var n=t.clone(e);n.v=42;var o=i.encrypt(P,JSON.stringify(n));return w.setItem("mediastream-login-"+r.Cfg.UsersMode,o),o},load:function(){var e=w.getItem("mediastream-login-"+r.Cfg.UsersMode);if(e){try{e=i.decrypt(P,e),e=JSON.parse(e)}catch(t){console.error("Failed to parse stored login data",t),e={}}switch(e.v){case 42:return e;default:console.warn("Unknown stored credentials",e.v)}}return null},forget:function(){w.removeItem("mediastream-login-"+r.Cfg.UsersMode)}},connect:function(){var e={};S=e,k.then(function(){S===e&&(console.log("Connecting ..."),s.connect($))})},reconnect:function(){var e={};S=e,k.then(function(){S===e&&(console.log("Reconnecting ..."),s.reconnect())})},initialize:function(n,i){var a=!1,s=!1;n.version=C,n.connect=!1;var c=function(){return o.websockets?void(s&&a&&(console.log("Ready to connect ..."),T.connect(),v(n,function(e){e.connect=!0}))):void console.error("This browser has no support for websockets. Connect aborted.")};n.$on("rooms.ready",function(){console.info("Initial room path set, continuing to connect ..."),s=!0,c()}),h.afterPrerendering(function(){var n=e("#loader");if(n.addClass("done"),t.delay(function(){n.remove()},1e3),r.Cfg.Tokens){var o=w.getItem("mediastream-access-code"),s=function(){g.dialog.prompt(i._("Access code required"),function(e){return e?void d(e):void s()},s)},l=x.api("tokens"),d=function(t){m({method:"POST",url:l,data:e.param({a:t}),headers:{"Content-Type":"application/x-www-form-urlencoded"}}).success(function(e){""!==e.token&&e.success?(w.setItem("mediastream-access-code",t),a=!0,c()):g.dialog.error(i._("Access denied"),i._("Please provide a valid access code."),function(){s()})}).error(function(e,t){403!=t&&413!=t||e.success!==!1?g.dialog.error(i._("Error"),i._("Failed to verify access code. Check your Internet connection and try again."),function(){s()}):g.dialog.error(i._("Access denied"),i._("Please provide a valid access code."),function(){s()})})};o?d(o):s()}else a=!0,c()})}};return T}]}),define("services/appdata",["jquery"],function(e){return["randomGen","$window",function(t,n){var i=this;return i.e=e({}),i.data=null,i.flags={authorizing:!1,resurrect:null},i.language=n.document.getElementsByTagName("html")[0].getAttribute("lang"),i.id=t.id(),i.get=function(){return i.data},i.set=function(e){return i.data=e,e},i.authorizing=function(e,t){if("undefined"!=typeof e){var n=!!e;n!==i.flags.authorizing&&(i.flags.authorizing=n,i.e.triggerHandler("authorizing",n,t))}return i.flags.authorizing},console.info("App runtime id: "+i.id),i}]}),define("services/buddydata",["underscore"],function(e){return["appData","contactData","mediaStream","$rootScope",function(t,n,i,o){var a={},r={},s={},c={},l={},d=0,u={clear:function(){e.each(a,function(e,t){e.$destroy(),r[t]=e}),a={}},push:function(e){var t=s[e];if(t)t.count++;else{var n=a[e];if(!n)return 0;t=s[e]={count:1,scope:a[e]}}return t.count},pop:function(e){var t=s[e];return t?(t.count--,t.count<=0&&delete s[e],t.count):0},get:function(e,t,i,o){if(a.hasOwnProperty(e))return a[e];if(!t&&s.hasOwnProperty(e))return s[e].scope;var r;return o&&a.hasOwnProperty(o)?(r=a[o],t&&(a[e]=r),r):t?(r=a[e]=t.$new(),o&&(a[o]=r),r.buddyIndex=++d,r.contact=o?n.get(o):null,r.buddyIndexSortable=("0000000"+r.buddyIndex).slice(-7),s.hasOwnProperty(e)&&(s[e].scope=r),i&&i(r),r):null},lookup:function(e,t,n){if(e){if(a.hasOwnProperty(e))return a[e];if(!t){if(r.hasOwnProperty(e))return r[e];if(s.hasOwnProperty(e))return s[e].scope;if(n){var d=l[e];if(d){if(d.display)return d}else if(c.hasOwnProperty(e)){d=l[e]={};var u=c[e].a;i.api.sendSessions(u,"session",function(e,t,n){if(n.Users&&n.Users.length>0){var i=n.Users[0];d.display={displayName:i.Status.displayName},o.$digest()}})}}}return null}},del:function(e,t){var n=a[e];return n?(t||(r[e]=n),delete a[e],n):null},set:function(e,t){a[e]=t},attestation:function(e){var t=c[e];return t?t.a:null}};return function(){i.api.e.on("received.attestation",function(e,n,i){var o=t.get();if(!o||o.id!==n){var a=c[n],r=!1;a?a.a!==i&&(r=!0):r=!0,r&&(c[n]={a:i,t:(new Date).getTime()})}});var n=function(){var t=(new Date).getTime()-24e4;e.each(c,function(e,n){e.t<t&&delete c[n]}),setTimeout(n,12e4)};n()}(),u}]}),define("text!partials/buddy.html",[],function(){return'<div class="buddy" ng-class="{\'contact\': contact, \'withSubline\': display.subline || session.Userid, \'isself\': session.Userid === myuserid}">\n    <div class="buddyPicture"><i class="fa fa-user"/><img ng-show="display.buddyPicture" alt ng-src="{{display.buddyPicture}}"/></div>\n    <div class="buddy1">{{session.Id|displayName}}</div>\n    <div class="buddy2"><span ng-show="session.Userid"><i class="fa contact visible-with-contacts-inline" data-action="contact"></i><span ng-show="session.count"> ({{session.count}})</span></span> <span title="{{display.sublineFull}}">{{display.subline}}</span></div>\n</div>\n'}),define("text!partials/buddyactions.html",[],function(){return'<div class="buddyhover">\n	<div class="buddyactions active">\n		<div class="btn-group">\n			<a class="btn btn-primary" data-action="call" title="{{_(\'Start video call\')}}"><i class="fa fa-phone"></i></a>\n			<a class="btn btn-primary" data-action="chat" title="{{_(\'Start chat\')}}"><i class="fa fa-comments-o"></i></a>\n		</div>\n	</div>\n	<div class="buddysessions" ng-if="session.count>1">\n		<ul>\n			<li ng-repeat="(id, s) in session.sessions" ng-class="{currentsession: s.Id === session.Id}">\n				<span>\n					<div class="buddyPicture buddyPictureSmall"><i class="fa fa-user"/><img ng-show="s.Status.buddyPicture" alt ng-src="{{s.Id|buddyImageSrc:s.Status}}"/></div>\n					<div class="buddy3" title="{{s.Status.message}}">{{s.Status.displayName|displayNameForSession:s.Id}}<span ng-show="s.Status.message">, {{s.Status.message}}</span></div>\n					<div class="btn-group">\n						<a class="btn btn-sm btn-primary" title="{{_(\'Start video call\')}}" ng-click="doCall(s.Id); $event.stopPropagation()"><i class="fa fa-phone"></i></a>\n						<a class="btn btn-sm btn-primary" title="{{_(\'Start chat\')}}" ng-click="doChat(s.Id); $event.stopPropagation()"><i class="fa fa-comments-o"></i></a>\n					</div>\n				</span>\n			</li>\n		</ul>\n	</div>\n</div>\n'}),define("text!partials/buddyactionsforaudiomixer.html",[],function(){return'<div class="buddyactions active">\n    <a class="btn btn-info" title="{{_(\'Start audio conference\')}}" ng-click="doAudioConference(session.Id); ; $event.stopPropagation()"><i class="fa fa-users"></i></a>\n</div>\n'}),define("services/buddylist",["jquery","angular","underscore","modernizr","avltree","text!partials/buddy.html","text!partials/buddyactions.html","text!partials/buddyactionsforaudiomixer.html"],function(e,t,n,i,o,a,r,s){var c=function(){this.data={},this.tree=new o(function(e,t){return e.sort.localeCompare(t.sort)})};return c.prototype.create=function(e,t){var n=t.display||{},i=n.displayName?n.displayName:"session "+t.buddyIndexSortable+" "+e,o={id:e,sort:i+"z"+e};return o},c.prototype.add=function(e,t){var n=this.create(e,t);return this._add(e,n),this.position(e)},c.prototype._add=function(e,t){this.tree.add(t)&&(this.data[e]=t)},c.prototype.remove=function(e){this.data.hasOwnProperty(e)&&(this.tree.remove(this.data[e]),delete this.data[e])},c.prototype.check=function(e){return this.data.hasOwnProperty(e)},c.prototype.update=function(e,t){var n=this.data[e];if(!n)return this.add(e,t);var i=this.create(e,t);return i.sort!==n.sort?(this.tree.remove(n),this._add(e,i),this.position(e)):void 0},c.prototype.position=function(e){var t=null;return this.tree.inOrderTraverse(function(n){return n.id!==e?(t=n.id,!0):void 0},this.data[e]),t},c.prototype.traverse=function(e){return this.tree.inOrderTraverse(e)},c.prototype.keys=function(){return n.keys(this.data)},c.prototype.clear=function(){this.tree.clear(),this.data={}},["$window","$compile","playSound","buddyData","buddySession","buddyPicture","fastScroll","mediaStream","animationFrame","$q",function(i,o,l,d,u,p,f,h,g,m){var v=o(a),b=o(r),y=(o(s),i.document,0),w=function(o,a,r){this.$scope=a,this.$element=o.find(".buddycontainer > div"),this.options=t.extend({},r),this.$element.empty(),this.actionElements={},this.tree=new c,this.queue=[],this.lefts={},this.playSoundLeft=!1,this.playSoundJoined=!1,f.apply(o,this.$element),o.on("mouseenter mouseleave",".buddy",n.bind(function(t){var n=e(t.currentTarget);this.hover(n,"mouseenter"===t.type?!0:!1)},this)),o.on("click",".buddy",n.bind(function(t){var n=e(t.currentTarget);this.click(n,t.target)},this)),o.attr("data-xthreshold","10"),o.on("swipeleft",".buddy",n.bind(function(t){t.preventDefault();var n=e(t.currentTarget);this.hover(n,!n.hasClass("hovered"))},this)),i.setInterval(n.bind(this.soundLoop,this),500);var s=n.bind(function(){this.refreshBuddies()},this);g.register(s)};return w.prototype.addBuddyElementToScope=function(e,t,n){n||(n=this.$element[0]),v(e,function(e,i){if(t){var o=d.get(t);o&&o.element?n.insertBefore(e[0],o.element[0]):n.appendChild(e[0])}else n.appendChild(e[0]);i.element=e})},w.prototype.onBuddyScopeCreated=function(e,t){e.element=null,e.contact=null,e.display={},e.session=u.create(t),e.$on("$destroy",function(){e.element=null,e.killed=!0})},w.prototype.onBuddySessionUserid=function(e,t){var n=t.Userid,i=d.get(n);if(!i)return void d.set(n,e);var o=i.session;if(t!==o){o.merge(t);var a=t.Id;return this.tree.remove(a),i!==e?(e.element&&(this.lefts[a]=e.element,e.$destroy()),d.set(a,i),delete this.actionElements[a],i):void 0}},w.prototype.soundLoop=function(){this.playSoundLeft&&(l.play("left"),this.playSoundLeft=!1),this.playSoundJoined&&(l.play("joined"),this.playSoundJoined=!1)},w.prototype.refreshBuddies=function(){var e,t,i,o,a,r,s=0,c=this.lefts;n.isEmpty(c)||(n.each(c,function(e){e&&e.remove()}),this.lefts={});var l=!1,u=this.queue;if(u.length)for(var p=this.$element[0];;){if(e=u.shift(),!e)break;if(i=e[1],t=null,!i||(t=d.lookup(i,!1),t&&!t.killed)){if(a=e[0],o=e[2],r=t.element?!1:!0)this.addBuddyElementToScope(t,o,p);else if("undefined"==typeof o);else if(o){var f=d.get(o);f&&f.element?p.insertBefore(t.element[0],f.element[0]):p.appendChild(t.element[0])}else p.appendChild(t.element[0]);if(s++,l=!0,s>10)break}}t=this.$scope;var h=l,g=t.loading;l?g||(t.loading=!0):t.loading&&(t.loading=!1,h=!0);var m=0===y;m!=t.empty&&(t.empty=m,h=!0),h&&t.$apply()},w.prototype.setDisplay=function(e,t,n,i){var o=n.Status;o||(o={});var a=t.display;if(a.displayName=o.displayName,p.update(a,o.buddyPicture),this.updateSubline(a,o.message),!t.element){var r=this.tree.add(e,t);this.queue.push([i,e,r]),this.playSoundJoined=!0}},w.prototype.updateDisplay=function(e,t,n,i){var o=n.Status;if(o){var a=t.display,r=t.contact&&t.contact.Status,s=a.displayName;if(a.displayName=r?r.displayName:o.displayName?o.displayName:null,s!==o.displayName){var c=this.tree.update(e,t);this.queue.push([i,e,c])}o.message&&this.updateSubline(a,o.message),r?p.update(a,r.buddyPicture||o.buddyPicture||null):o.buddyPicture&&p.update(a,o.buddyPicture||null)}},w.prototype.updateSubline=function(e,t){return t&&"__e"!==t?(e.sublineFull=t,t.length>100&&(t=t.substr(0,100)),void(e.subline=t)):void(e.subline="")},w.prototype.onContactUpdated=function(e){var n=d.get(e.Userid);n&&n.contact&&(n.contact.Status=t.extend(n.contact.Status,e.Status)),this.updateDisplay(e.Id,n,e,"status")},w.prototype.onStatus=function(e){var t=e.Id,i=d.get(t,this.$scope,n.bind(function(t){this.onBuddyScopeCreated(t,e)},this),e.Userid),o=i.session.update(t,e,n.bind(function(e){var t=this.onBuddySessionUserid(i,e);t&&(i=t)},this));return o&&this.updateDisplay(t,i,o,"status"),i.$apply(),i},w.prototype.onJoined=function(e,t){var i=e.Id,o=d.get(i,this.$scope,n.bind(function(t){this.onBuddyScopeCreated(t,e)},this),e.Userid);y++;var a=o.session.update(i,e,n.bind(function(e){var t=this.onBuddySessionUserid(o,e);t&&(o=t)},this));return a?this.setDisplay(i,o,a,"joined"):t||o.$apply(),o},w.prototype.onLeft=function(e,t,n){var i=e.Id,o=d.get(i);if(o){this.tree.remove(i),d.del(i);var a=o.session;if(a.remove(i)&&null===o.contact||t)o.element&&(this.lefts[i]=o.element,this.playSoundLeft=!0),a.Userid&&d.del(a.Userid,!0),delete this.actionElements[i],o.$destroy(),y>0&&y--;else{var r=a.get();if(r)this.updateDisplay(r.Id,o,r,"status");else if(o.contact){var s=o.contact;this.tree.check(s.Userid)||(this.tree.add(s.Userid,o),y++),null===s.Status||s.Status.message||(s.Status.message="__e"),this.updateDisplay(s.Userid,o,s,"status")}n||o.$apply()}return o}},w.prototype.onClosed=function(){this.queue=[];var e={},t=u.sessions();for(var n in t)t.hasOwnProperty(n)&&(e.Id=n,this.onLeft(e,!1,!0))},w.prototype.onContactAdded=function(e){var t=e.Userid,i=d.get(t);if(i){i.contact=e;var o=i.session.get();if(o){if(null===e.Status&&o.Status){var a=e.Status=n.extend({},o.Status);if(delete a.message,a.buddyPicture){var r=p.toString(i.element.find(".buddyPicture img")[0]);r?a.buddyPicture=r:delete a.buddyPicture}console.log("Injected status into contact",e)}this.updateDisplay(o.Id,i,e,"status"),i.$apply()}}else i=this.onJoined({Id:e.Userid,Userid:e.Userid,Status:n.extend({},e.Status)}),i.contact=e},w.prototype.onContactRemoved=function(e){var t=e.Userid,n=d.get(t);if(n){n.contact=null;var i=n.session.get();i||this.onLeft({Id:t},!0)}},w.prototype.click=function(t,n){var i,o=t[0];do i=e(n).data("action"),n=e(n).parent()[0];while(!i&&n&&n!==o);i||(i="chat");var a=t.scope(),r=a.session,s=a.contact,c=function(){var e=m.defer(),t=r.get();return t?e.resolve(t.Id):s&&s.Token&&h.api.sendSessions(s.Token,"contact",function(n,i,o){var s=null;o.Users&&o.Users.length>0&&(s=o.Users[0]),t=r.get(),!t&&s&&(d.set(s.Id,a),t=s),t&&e.resolve(t.Id)}),e.promise}();switch(i){case"call":c.then(function(e){a.doCall(e)});break;case"chat":c.then(function(e){a.doChat(e)});break;case"contact":s?a.doContactRemove(s.Userid):c.then(function(e){a.doContactRequest(e)})}},w.prototype.hover=function(t,i){var o,a=t.scope(),r=a.session.Id,s=e(t),c=this.actionElements;if(i)if(o=c[r])s.addClass("hovered");else{var l=b;l(a,n.bind(function(e){c[r]=e,s.append(e),n.defer(function(){s.addClass("hovered")})},this)),a.$apply()}else s.removeClass("hovered"),setTimeout(n.bind(function(){s.hasClass("hovered")||(o=c[r],o&&(delete c[r],o.remove()))},this),1e3)},{buddylist:function(e,t,n){return new w(e,t,n)}}}]}),define("services/buddypicture",[],function(){return["$window","restURL",function(e,t){var n={update:function(e,n){"undefined"!=typeof n?e.buddyPicture=n:n=e.buddyPicture,n&&0===n.indexOf("img:")&&(e.buddyPicture=e.buddyPictureLocalUrl=t.buddy(n.substr(4)))},toString:function(t,n){if(t){"undefined"==typeof n&&(n="image/jpeg");var i=e.document.createElement("canvas");i.width=t.naturalWidth,i.height=t.naturalHeight;var o=i.getContext("2d");return o.drawImage(t,0,0),i.toDataURL(n)}return null},toBlob:function(e,t,i){t&&(e=n.toString(t,i));for(var o=atob(e.split(",")[1]),a=e.split(",")[0].split(":")[1].split(";")[0],r=new ArrayBuffer(o.length),s=new Uint8Array(r),c=0;c<o.length;c++)s[c]=o.charCodeAt(c);return new Blob([r],{type:a})}};return n}]}),define("services/enrichmessage",[],function(){return["$filter",function(e){var t=e("linky"),n={url:function(e){return e=t(e),e=e.replace(/<a/g,'<a rel="external"')},multiline:function(e){return e=e.replace(/\r\n/g,"<br/>"),e=e.replace(/\n/g,"<br/>"),e=e.replace(/&#10;/g,"<br/>")},all:function(e){return e=n.url(e),e=n.multiline(e)}};return n}]}),define("services/safemessage",[],function(){return["$sanitize","enrichMessage",function(e,t){return function(n){return e(t.all(n))}}]}),define("services/alertify",["angular"],function(e){var t=["$scope","$modalInstance","data",function(t,n,i){t.input={text:""},t.id=i.id,t.header=i.header||"",t.msg=i.message||"",t.okButtonLabel=i.okButtonLabel||"Ok",t.cancelButtonLabel=i.cancelButtonLabel||"Cancel",t.cancel=function(){n.dismiss("Canceled")},t.save=function(){n.close(t.input.text)},t.hitEnter=function(n){!e.equals(n.keyCode,13)||e.equals(t.input.text,null)||e.equals(t.input.text,"")||t.save()},t.ok=function(){n.close("Ok")},t.close=function(){n.close("Close")}}];return["$window","$modal","$templateCache","translation",function(n,i,o,a){o.put("/dialogs/error.html",'<div class="modal-header dialog-header-error"><button type="button" class="close" ng-click="close()">&times;</button><h3 class="modal-title text-danger"><span ng-bind-html="header"></span></h3></div><div class="modal-body text-danger h4" ng-bind-html="msg"></div><div class="modal-footer"><button type="button" class="btn btn-default" ng-click="close()">{{_("Close")}}</button></div>'),o.put("/dialogs/wait.html",'<div class="modal-header dialog-header-wait"><h3 class="modal-title">Please Wait</h3></div><div class="modal-body"><p ng-bind-html="msg"></p><div class="progress progress-striped active"><div class="progress-bar progress-bar-info" ng-style="getProgress()"></div><span class="sr-only">{{progress}}% Complete</span></div></div>'),o.put("/dialogs/notify.html",'<div class="modal-header dialog-header-notify"><button type="button" class="close" ng-click="close()" class="pull-right">&times;</button><h3 class="modal-title">{{header}}</h3></div><div class="modal-body h4" ng-bind-html="msg"></div><div class="modal-footer"><button type="button" class="btn btn-primary" ng-click="close()">{{_("Ok")}}</button></div>'),o.put("/dialogs/confirm.html",'<div class="modal-header dialog-header-confirm"><button type="button" class="close" ng-click="cancel()">&times;</button><h3 class="modal-title">{{header}}</h3></div><div class="modal-body h4" ng-bind-html="msg"></div><div class="modal-footer"><button type="button" class="btn btn-default" ng-click="ok()">{{_("Ok")}}</button><button type="button" class="btn btn-primary" ng-click="cancel()">{{_("Cancel")}}</button></div>'),o.put("/dialogs/prompt.html",'<div class="modal-header"><h3 class="modal-title"><span ng-bind-html="header"></span></h3></div><div class="modal-body"><ng-form name="promptDialog" novalidate role="form"><div class="form-group input-group-lg" ng-class="{true: \'has-error\'}[promptDialog.text.$dirty && promptDialog.text.$invalid]"><label class="control-label"></label><input type="text" id="{{id}}" class="form-control" name="text" ng-model="input.text" ng-keyup="hitEnter($event)" required></div></ng-form></div><div class="modal-footer"><button type="button" class="btn btn-default" ng-click="cancel()">{{cancelButtonLabel}}</button><button type="button" class="btn btn-primary" ng-click="save()" ng-disabled="(promptDialog.$dirty && promptDialog.$invalid) || promptDialog.$pristine">{{okButtonLabel}}</button></div>');var r={error:a._("Error"),notify:a._("Hint"),confirm:a._("Please confirm"),prompt:a._("More information required"),okButtonLabel:a._("Ok"),cancelButtonLabel:a._("Cancel"),closeButtonLabel:a._("Close")},s=0,c={defaultMessages:r},l=function(e,n){return i.open({templateUrl:"/dialogs/"+n+".html",controller:t,resolve:{data:function(){return e}}})},d=[],u={registerCustom:function(t){var n=e.extend({},t);if(!n||n&&!n.type||n&&!n.baseType)throw Error("Custom template not configured correctly.");var i="/dialogs/"+n.type+".html";n.template?o.put(i,n.template):o.put(i,o.get("/dialogs/"+n.baseType+".html")),n.title||(n.title=c.defaultMessages[n.baseType]),d[n.type]=n},exec:function(e,t,n,i,o){!n&&t&&(n=t,t=null),t||(t=c.defaultMessages[e]||e);
var a=l({header:t,message:n},e);return i&&a.result.then(i,o),a},custom:function(e){var t=d[e];if(!t)throw new Error('The custom dialog type "'+e+'" is not registered.');return u.exec(t.type,t.title,t.message,t.ok_cb,t.err_cb)},error:function(e,t,n,i){return u.exec("error",e,t,n,i)},notify:function(e,t,n,i){return u.exec("notify",e,t,n,i)},alert:function(e,t,n){return u.notify(n,e,t)},confirm:function(e,t,n){return u.exec("confirm",null,e,t,n)},prompt:function(e,t,i){var o="allertifyPrompt"+s++,a={okButtonLabel:c.defaultMessages.okButtonLabel||"Ok",cancelButtonLabel:c.defaultMessages.cancelButtonLabel||"Cancel",header:e,id:o},r=l(a,"prompt");r.result.then(function(e){t&&t(e)},function(){i&&i()}),r.opened.then(function(){n.setTimeout(function(){var e=n.document.getElementById(o);e&&e.focus()},100)})}};return c.dialog=u,c}]}),function(e){e("toastr",["jquery"],function(e){return function(){function t(e,t,n){return h({type:k.error,iconClass:g().iconClasses.error,message:e,optionsOverride:n,title:t})}function n(t,n){return t||(t=g()),v=e("#"+t.containerId),v.length?v:(n&&(v=u(t)),v)}function i(e,t,n){return h({type:k.info,iconClass:g().iconClasses.info,message:e,optionsOverride:n,title:t})}function o(e){b=e}function a(e,t,n){return h({type:k.success,iconClass:g().iconClasses.success,message:e,optionsOverride:n,title:t})}function r(e,t,n){return h({type:k.warning,iconClass:g().iconClasses.warning,message:e,optionsOverride:n,title:t})}function s(e){var t=g();v||n(t),d(e,t)||l(t)}function c(t){var i=g();return v||n(i),t&&0===e(":focus",t).length?void m(t):void(v.children().length&&v.remove())}function l(t){for(var n=v.children(),i=n.length-1;i>=0;i--)d(e(n[i]),t)}function d(t,n){return t&&0===e(":focus",t).length?(t[n.hideMethod]({duration:n.hideDuration,easing:n.hideEasing,complete:function(){m(t)}}),!0):!1}function u(t){return v=e("<div/>").attr("id",t.containerId).addClass(t.positionClass).attr("aria-live","polite").attr("role","alert"),v.appendTo(e(t.target)),v}function p(){return{tapToDismiss:!0,toastClass:"toast",containerId:"toast-container",debug:!1,showMethod:"fadeIn",showDuration:300,showEasing:"swing",onShown:void 0,hideMethod:"fadeOut",hideDuration:1e3,hideEasing:"swing",onHidden:void 0,extendedTimeOut:1e3,iconClasses:{error:"toast-error",info:"toast-info",success:"toast-success",warning:"toast-warning"},iconClass:"toast-info",positionClass:"toast-top-right",timeOut:5e3,titleClass:"toast-title",messageClass:"toast-message",target:"body",closeHtml:"<button>&times;</button>",newestOnTop:!0,preventDuplicates:!1,progressBar:!1}}function f(e){b&&b(e)}function h(t){function i(t){return!e(":focus",d).length||t?(clearTimeout(k.intervalId),d[s.hideMethod]({duration:s.hideDuration,easing:s.hideEasing,complete:function(){m(d),s.onHidden&&"hidden"!==x.state&&s.onHidden(),x.state="hidden",x.endTime=new Date,f(x)}})):void 0}function o(){(s.timeOut>0||s.extendedTimeOut>0)&&(l=setTimeout(i,s.extendedTimeOut),k.maxHideTime=parseFloat(s.extendedTimeOut),k.hideEta=(new Date).getTime()+k.maxHideTime)}function a(){clearTimeout(l),k.hideEta=0}function r(){var e=(k.hideEta-(new Date).getTime())/k.maxHideTime*100;h.width(e+"%")}var s=g(),c=t.iconClass||s.iconClass;if(s.preventDuplicates){if(t.message===y)return;y=t.message}"undefined"!=typeof t.optionsOverride&&(s=e.extend(s,t.optionsOverride),c=t.optionsOverride.iconClass||c),w++,v=n(s,!0);var l=null,d=e("<div/>"),u=e("<div/>"),p=e("<div/>"),h=e("<div/>"),b=e(s.closeHtml),k={intervalId:null,hideEta:null,maxHideTime:null},x={toastId:w,state:"visible",startTime:new Date,options:s,map:t};return t.iconClass&&d.addClass(s.toastClass).addClass(c),t.title&&(u.append(t.title).addClass(s.titleClass),d.append(u)),t.message&&(p.append(t.message).addClass(s.messageClass),d.append(p)),s.closeButton&&(b.addClass("toast-close-button").attr("role","button"),d.prepend(b)),s.progressBar&&(h.addClass("toast-progress"),d.prepend(h)),d.hide(),s.newestOnTop?v.prepend(d):v.append(d),d[s.showMethod]({duration:s.showDuration,easing:s.showEasing,complete:s.onShown}),s.timeOut>0&&(l=setTimeout(i,s.timeOut),k.maxHideTime=parseFloat(s.timeOut),k.hideEta=(new Date).getTime()+k.maxHideTime,s.progressBar&&(k.intervalId=setInterval(r,10))),d.hover(a,o),!s.onclick&&s.tapToDismiss&&d.click(i),s.closeButton&&b&&b.click(function(e){e.stopPropagation?e.stopPropagation():void 0!==e.cancelBubble&&e.cancelBubble!==!0&&(e.cancelBubble=!0),i(!0)}),s.onclick&&d.click(function(){s.onclick(),i()}),f(x),s.debug&&console&&console.log(x),d}function g(){return e.extend({},p(),x.options)}function m(e){v||(v=n()),e.is(":visible")||(e.remove(),e=null,0===v.children().length&&v.remove())}var v,b,y,w=0,k={error:"error",info:"info",success:"success",warning:"warning"},x={clear:s,remove:c,error:t,getContainer:n,info:i,options:{},subscribe:o,success:a,version:"2.1.0",warning:r};return x}()})}("function"==typeof define&&define.amd?define:function(e,t){"undefined"!=typeof module&&module.exports?module.exports=t(require("jquery")):window.toastr=t(window.jQuery)}),define("services/toastr",["toastr"],function(e){return[function(){return e.options={debug:!1,positionClass:"toast-bottom-right",onclick:null,showMethod:"show",hideMethod:"hide",timeOut:0,extendedTimeOut:0,closeButton:!0},e}]}),define("services/visibility",["visibly"],function(e){return[function(){var t=e.isSupported();return{onVisible:e.onVisible,onHidden:e.onHidden,hidden:e.hidden,visibilityState:e.visibilityState,visibilitychange:e.visibilitychange,afterPrerendering:function(n){if(!t||"prerender"!==e.visibilityState())return n(),!1;var i=!1;return e.visibilitychange(function(e){i||"prerender"!==e&&(i=!0,n())}),!0}}}]}),define("services/translation",["jed","underscore"],function(e,t){var n=function(e,n,i){var o=e.i18n;this._=t.bind(function(){return i&&n?t.bind(function(e){var t=Array.prototype.slice.call(arguments,1),a=o.translate(e).onDomain(i).withContext(n);return a.fetch.apply(a,t)},this):i?t.bind(function(e){var t=Array.prototype.slice.call(arguments,1),n=o.translate(e).onDomain(i);return n.fetch.apply(n,t)},this):n?t.bind(function(e){var t=Array.prototype.slice.call(arguments,1),i=o.translate(e).withContext(n);return i.fetch.apply(i,t)},this):t.bind(function(e){var t=Array.prototype.slice.call(arguments,1),n=o.translate(e);return n.fetch.apply(n,t)},this)},this)(),this._n=t.bind(function(){return t.bind(i&&n?function(e,t){var a=Array.prototype.slice.call(arguments,2),r=o.translate(e).onDomain(i).withContext(n).ifPlural(a[0],t);return r.fetch.apply(r,a)}:i?function(e,t){var n=Array.prototype.slice.call(arguments,2),a=o.translate(e).onDomain(i).ifPlural(n[0],t);return a.fetch.apply(a,n)}:n?function(e,t){var i=Array.prototype.slice.call(arguments,2),a=o.translate(e).withContext(n).ifPlural(i[0],t);return a.fetch.apply(a,i)}:function(e,t){var n=Array.prototype.slice.call(arguments,2),i=o.translate(e).ifPlural(n[0],t);return i.fetch.apply(i,n)})},this)()},i=function(i){this.i18n=new e(i);var o=new n(this);this._=t.bind(o._,o),this._n=t.bind(o._n,o)};return i.prototype.inject=function(e,i,o){var a=new n(this,i,o);return e._=t.bind(a._,a),e._n=t.bind(a._n,a),e},["translationData",function(e){var t=new i(e);return t}]}),define("services/mediasources",["jquery","underscore"],function(e,t){return["$window",function(e){var n=function(){this.supported=e.MediaStreamTrack&&e.MediaStreamTrack.getSources,this.audio=[],this.video=[]};return n.prototype.refresh=function(e){if(!this.supported)return void(e&&e([],[]));try{this._refresh(e)}catch(t){console.error("Failed to get media sources: "+t.message),this.supported=!1,e&&e([],[])}},n.prototype._refresh=function(n){e.MediaStreamTrack.getSources(t.bind(function(e){var i=this.audio=[],o=this.video=[];t.each(e,function(e){var t={id:e.id,facing:e.facing};"audio"===e.kind?(t.label=e.label?e.label:"Microphone "+(i.length+1),i.push(t)):"video"===e.kind&&(t.label=e.label?e.label:"Camera "+(o.length+1),o.push(t))}),n&&n(i,o)},this))},n.prototype.hasAudioId=function(e){var t;for(t=0;t<this.audio.length;t++)if(this.audio[t].id===e)return!0;return!1},n.prototype.hasVideoId=function(e){var t;for(t=0;t<this.video.length;t++)if(this.video[t].id===e)return!0;return!1},n.prototype.hasVideo=function(){return!this.supported||this.video.length>0},n.prototype.hasAudio=function(){return!this.supported||this.audio.length>0},new n}]}),define("services/fileupload",["jquery","underscore","webrtc.adapter"],function(e,t){return["fileData","fileTransfer","safeApply","alertify","translation",function(n,i,o,a,r){var s=function(e,n){this.token=e,this.scope=n,this.running=!0,this.connections={};var i=n.$on("cancelUpload",t.bind(function(e){i(),e.stopPropagation(),this.running=!1,t.each(this.connections,function(e){e.cancel()}),this.connections={},this.scope=null},this))};s.prototype.handleRequest=function(e,t,n){if("string"==typeof n){if(2===n.charCodeAt(0))return;var i;try{i=JSON.parse(n)}catch(o){return console.warn("Invalid JSON received from file download request.",n),t.cancel(),void delete this.connections[t.id]}this.processRequest(e,t,i)}else console.warn("Unkown data type received -> ignored",typeof n,[n]),t.cancel(),delete this.connections[t]},s.prototype.processRequest=function(e,a,r){if(!this.running)return void a.cancel();this.connections.hasOwnProperty(a.id)||(console.log("New incoming download connection:",a),this.connections[a.id]=a,a.e.on("closed",t.bind(function(){console.log("Incoming download connection closed:",a),delete this.connections[a.id]},this)));var s=this.scope.info;switch(r.m){case"r":var c=parseInt(r.i||0,10),l=n.getFile(s.id);l.getChunk(c,t.bind(function(e){if(this.running){var t=i.makeChunk(c,e);a.send(t.raw()),o(this.scope,function(t){t.$emit("uploadedChunk",c,e.byteLength)})}},this));break;case"bye":a.cancel();break;default:console.log("Unknown xfer control request",r.m,r)}};var c=function(){this.supported=i.supported};c.prototype.bindClick=function(i,o,s){var c={namespace:function(){return i}};return e(o).on("click",t.bind(function(t){if(t.preventDefault(),!this.supported)return void a.dialog.alert(r._("Your browser does not support file transfer."));var i=e('<input type="file" multiple>');i.css({visibility:"hidden",position:"absolute",left:"0px",top:"0px",height:"0px",width:"0px"}),i.change(function(e){var t,i=e.target,o=[];for(t=0;t<i.files.length;t++)o.push(n.createFile(c.namespace(),i.files[t]));s&&s(o)}),i.click()},this)),c},c.prototype.bindDrop=function(i,o,s){var c={namespace:function(){return i}};return e(o).on("dragover dragenter",function(e){e.preventDefault()}),e(o).on("drop",t.bind(function(e){if(e.preventDefault(),!this.supported)return void a.dialog.alert(r._("Your browser does not support file transfer."));var t,i=e.originalEvent.dataTransfer,o=[];for(t=0;t<i.files.length;t++)o.push(n.createFile(c.namespace(),i.files[t]));s&&s(o)},this)),c},c.prototype.createSession=function(e,t){var n=new s(t,e);return n},c.prototype.startUpload=function(e,t){var n=this.createSession(e,t);return n};var l=new c;return l}]}),define("services/filedownload",["jquery","underscore"],function(e,t){return["fileData","fileTransfer","$window","mediaStream","safeApply","$timeout",function(e,n,i,o,a,r){var s=0,c=function(e,t,n){this.id=e,this.token=t,this.scope=n,this.file=null,this.interval=null,this.running=!1,this.known_peer_id=null,this.chunk=0,this.end=n.info.chunks-1,this.fragments=100,this.concurrent=5,this.downloadedBytes=0,this.totalBytes=n.info.size,this.jobs=[],this.xfer_all=[],this.xfer_connected=[]};c.makeId=function(e,t){return[e,t].join("_")},c.prototype.cancel=function(){this.running=!1,i.clearInterval(this.interval),this.interval=null,t.each(this.xfer_all,function(e){e.send({m:"bye"}),r(function(){e.cancel()},0)}),t.each(this.jobs,function(e){e.stop=!0}),this.xfer_all=[],this.xfer_connected=[],this.jobs=[],this.file=null},c.prototype.run=function(n){this.known_peer_id=n,this.running=!0;var o=this.file=e.generateFile(""+s++ +".file",this.scope.info);o.e.bind("complete",t.bind(function(){a(this.scope,function(e){var t=o.toURL();console.log("Generated URL",t),e.$emit("writeComplete",t,o)})},this)),o.e.bind("error writerror failed",t.bind(function(e,t){console.log("Error occured.",e,t),this.cancel(),a(this.scope,function(e){e.error=!0})},this)),o.e.bind("written",t.bind(function(e,n,i){a(this.scope,t.bind(function(e){e.$emit("downloadedWritten",n,i)},this))},this));var r=this.scope,c=r.$on("cancelDownload",t.bind(function(t){t.stopPropagation(),c(),e.purgeFile(o.id),this.cancel()},this));this.addXfer(n,t.bind(function(){this.process()},this)),this.interval=i.setInterval(t.bind(function(){this.process(),this.running&&this.xfer_all.length<this.concurrent&&this.chunk<=this.end&&(this.end+1)/this.fragments>=this.xfer_all.length-2&&this.addXfer(this.known_peer_id)},this),1e3)},c.prototype.process=function(){if(this.running){if(!this.xfer_all.length&&null!==this.known_peer_id)return void this.addXfer(this.known_peer_id);if(!(this.chunk>this.end)){var e=this.xfer_connected.shift();if(e){var n=this,i={};this.jobs.push(i),i.chunk=this.chunk,i.end=i.chunk+this.fragments,i.end>this.end&&(i.end=this.end),this.chunk=i.end+1,i.next=t.bind(function(){return this.stop?void(this.next=null):this.chunk>this.end?(e.e.off("sessionData"),n.xfer_connected.push(e),this.next=null,void n.done(this)):void d.sendRequest(e,this.chunk++)},i),e.e.on("sessionData",t.bind(this.handleData,this,i)),i.next()}}}},c.prototype.done=function(e){console.log("Job done",e,this.end,this.chunk);var n=this.jobs.indexOf(e);~n&&this.jobs.splice(n,1),this.chunk>=this.end&&0===this.jobs.length&&(a(this.scope,t.bind(function(e){e.$emit("downloadComplete")},this)),this.file.fileFinished(),this.cancel())},c.prototype.handleData=function(e,i,o){n.parseChunk(o,t.bind(function(n,i,o){var r=this.file;r.scope.chunk_size||(r.scope.chunk_size=o);var s=r.scope.chunk_size*n;r.setChunk(n,s,i),a(this.scope,t.bind(function(t){this.downloadedBytes+=i.byteLength,t.$emit("downloadedChunk",n,i.byteLength,this.downloadedBytes,this.totalBytes),e.next()},this))},this))},c.prototype.rmXfer=function(e){var t=this.xfer_connected.indexOf(e);~t&&this.xfer_connected.splice(t,1),t=this.xfer_all.indexOf(e),~t&&this.xfer_all.splice(t,1)},c.prototype.addXfer=function(e,n){o.webrtc.doXfer(e,this.token,{created:t.bind(function(e){this.xfer_all.push(e)},this),connected:t.bind(function(e){this.xfer_connected.push(e),n&&n(e)},this),error:t.bind(function(e){this.rmXfer(e)},this),closed:t.bind(function(e){this.rmXfer(e)},this)})};var l=function(){this.supported=n.supported,this.downloads=0,this.sessions={}};l.prototype.sendRequest=function(e,t){var n={m:"r",i:t};e.send(n)},l.prototype.createSession=function(e,t){var n=c.makeId(t,this.downloads++),i=this.sessions[n]=new c(n,t,e);return i},l.prototype.getSession=function(e,t){var n=c.makeId(e,t),i=this.sessions[n];return i?i:(console.warn("Get unknown file download session",n),null)},l.prototype.startDownload=function(e,t,n){var i=this.createSession(e,n);return i.run(t),i},l.prototype.handleRequest=function(e,t,n){n instanceof ArrayBuffer?t.e.triggerHandler("sessionData",[n]):console.warn("Unkown data type received -> ignored",typeof n,[n])};var d=new l;return d}]}),define("services/filedata",["jquery","underscore","sha","webrtc.adapter"],function(e,t,n){var i=window.requestFileSystem||window.webkitRequestFileSystem||null;i||console.warn("Browser support for filesystem API not found.");var o="chrome"===window.webrtcDetectedBrowser?6e4:16e3,a=function(e){this.owner=e,this.file=null};a.prototype.flush=function(){var e=this.owner.writeBuffer.length;if(this.owner.e.trigger("written",e,0),this.owner.complete&&!this.file){var t=this.owner.writeBuffer.slice();t.sort(function(e,t){return e[0]-t[0]});var n=t.map(function(e){return e[1]}),i=new Blob(n,{type:this.owner.info.type||"application/octet-stream"}),o=null;this.file={toURL:function(){return o||(o=URL.createObjectURL(i)),o},remove:function(e){o&&(URL.revokeObjectURL(o),o=null),e&&e()}},this.owner.file=this.file,this.owner.e.triggerHandler("complete",[this])}},a.prototype.stop=function(){this.file=null,this.owner=null};var r=function(e){this.owner=e,this.file=null,this.writing=!1,this.written=0,this.writing_written=0,this.writer=null,this.create()};r.prototype.supported=!!i,r.prototype.filesystem=null,r.prototype.create=function(){var e=t.bind(function(){r.prototype.filesystem.root.getFile(this.owner.id,{create:!0,exclusive:!0},t.bind(function(e){console.log("Generate file",this.owner,e),this.setup(e),this.flush()},this),t.bind(function(e){console.warn("Fileystem failed to create file.",e),this.owner.e.triggerHandler("failed",[e,this.owner])},this))},this);r.prototype.filesystem?e():this.requestFileSystem(null,t.bind(function(){e()},this),t.bind(function(e){this.owner.e.triggerHandler("error",[e,this.owner])},this))},r.prototype.requestFileSystem=function(e,n,o){e||(e=5242880),i(window.TEMPORARY,e,t.bind(function(e){console.info("Opened file system.",e.name),r.prototype.filesystem=e,n&&n(e)},this),t.bind(function(e){console.warn("Failed to open file system.",e),o&&o(e)},this))},r.prototype.setup=function(e){this.file=e,this.file.createWriter(t.bind(function(e){this.owner.stopped||(e.onerror=t.bind(function(e){console.warn("File write failed: "+e.toString()),this.owner&&this.owner.e.triggerHandler("writeerror",[e,this])},this),e.onwriteend=t.bind(function(){this.written+=this.writing_written,this.writing_written=0,this.writing=!1,this.owner&&(this.owner.e.trigger("written",this.written,this.owner.writeBuffer.length),this.flush())},this),this.writing=!0,this.writer=e,this.written=0,this.writing_written=0,e.truncate(this.owner.info.size||0))},this))},r.prototype.flush=function(){if(!this.writing&&!this.owner.stopped&&this.writer){var e=this.owner.writeBuffer,t=e.length;if(t){this.writing=!0;var n=e.splice(0,t);n.sort(function(e,t){return e[0]-t[0]});for(var i,o,a,r,s,c=null;;){if(i=n.shift(),i&&(r=i[0],a=i[1],null===c&&(c=o=r,s=[])),o!==r||!i){this.writer.position!==c&&this.writer.seek(c),this.writing_written=s.length,this.writer.write(new Blob(s,{type:this.owner.info.type||"application/octet-stream"})),s=null,i&&(n.length&&e.unshift.apply(e,n),e.unshift(i));break}s.push(a),o+=a.length}}this.owner.complete&&!t&&(this.owner.file=this.file,this.owner.e.triggerHandler("complete",[this]))}},r.prototype.stop=function(){this.owner=null,this.writer=null,this.file=null};var s=r.prototype.supported?r:a,c=function(t,n,i){this.id=t,this.file=n,this.e=e({}),this.scope={},n?(this.info={chunks:this.chunks=Math.ceil(n.size/o),size:n.size,name:n.name,type:n.type},this.complete=!0):(this.info=i?i:{},this.complete=!1),this.stopped=!1,this.writer=null,this.writeBuffer=[]};return c.prototype.getChunk=function(e,t){var n=o*e,i=o*(e+1);if(i>this.info.size&&(i=this.info.size),n>=i)return void console.warn("Requested file chunk which is out of bound",e,n,i,this.info);var a=new FileReader,r=this.file.slice(n,i);a.onload=function(e){a.readyState==FileReader.DONE&&t(e.target.result)},a.readAsArrayBuffer(r)},c.prototype.setChunk=function(e,t,n){this.stopped||(this.writeBuffer.push([t,n]),this.writer&&this.writer.flush())},c.prototype.fileFinished=function(){this.complete||(this.complete=!0,this.flushToFilesystem())},c.prototype.createWriter=function(){var e=this.writer=new s(this);return e},c.prototype.flushToFilesystem=function(e){this.stopped||(this.writer?this.writer.flush():this.createWriter(e))},c.prototype.toURL=function(){return this.file.toURL()},c.prototype.stop=function(){if(this.e.triggerHandler("stop",[this]),this.file&&this.file.remove){var e=this.file;this.file.remove(t.bind(function(){console.log("File removed",e)},this)),this.file=null}this.writer&&(this.writer.stop(),this.writer=null),this.writeBuffer=[],this.stopped=!0},["randomGen",function(e){var t=e.random(),i=0,o=e.id(),a={},r={generateFile:function(e,t){e=o+e;var n=a[e]=new c(e,null,t);return n.createWriter(),n},createFile:function(e,o){var r=e+"_"+i++,s=new n(r,"TEXT"),l=s.getHMAC(t,"TEXT","SHA-384","HEX"),d=a[l]=new c(l,o);return d},purgeFile:function(e){var t=a[e];t&&(t.stop(),delete a[e])},getFile:function(e){return a[e]}};return r}]}),define("services/filetransfer",["mediastream/webrtc","webrtc.adapter"],function(){var e=function(e,t){var n=new Uint8Array(e.byteLength+t.byteLength);return n.set(new Uint8Array(e),0),n.set(new Uint8Array(t),e.byteLength),n.buffer},t=function(){for(var e,t=[],n=0;256>n;n++){e=n;for(var i=0;8>i;i++)e=1&e?3988292384^e>>>1:e>>>1;t[n]=e}return t},n=t(),i=function(e){for(var t=-1,i=0;i<e.length;i++)t=t>>>8^n[255&(t^e[i])];return(-1^t)>>>0},o=function(e,t,n){this.version=0,e?this._open(e):"undefined"!=typeof t&&n&&this._set(t,n)};return o.prototype._open=function(e,t){if(this._v=new Uint8Array(e,0,1),this._c=new Uint32Array(e,4,1),this._crc32=new Uint32Array(e,8,1),this._buffer=e,this._data=new Uint8Array(this._buffer,12,this._buffer.byteLength-12),!t){if(this._v[0]!==this.version)throw new TypeError("Data version mismatch.");var n=i(this._data);if(this._crc32[0]!==n)throw console.warn("Data crc32 error.",this._c[0],n,this._crc32[0]),new TypeError("Data crc32 error.",this._c[0],n,this._crc32[0])}},o.prototype._set=function(t,n){var o=new ArrayBuffer(12);this._open(e(o,n),!0),this._v[0]=this.version,this._c[0]=t,this._crc32[0]=i(new Uint8Array(n))},o.prototype.data=function(){return this._data},o.prototype.index=function(){return this._c[0]},o.prototype.raw=function(){return this._buffer},o.prototype.size=function(){return this._data.length},["$window",function(t){var n="chrome"===t.webrtcDetectedBrowser&&t.webrtcDetectedVersion>=32&&!t.webrtcDetectedAndroid||"firefox"===t.webrtcDetectedBrowser&&t.webrtcDetectedVersion>=28&&!t.webrtcDetectedAndroid;return n||console.warn("Browser support for binary file transfers not found."),{supported:n,arrayBufferJoin:e,crc32:i,parseChunk:function(e,t){var n=new Uint8Array(e,0,1)[0];switch(n){case 0:var i=new o(e);return t&&t(i.index(),i.data(),i.size()),i;default:console.warn("Unknow data version.")}},makeChunk:function(e,t){return new o(null,e,t)}}}]}),define("services/safedisplayname",[],function(){return["safeMessage","$filter",function(e,t){var n=t("displayName");return function(){var t=n.apply(this,arguments);return e(t)}}]}),define("services/randomgen",["underscore"],function(e){return["$window",function(t){var n;t.crypto&&t.crypto.getRandomValues&&(n=e.bind(t.crypto.getRandomValues,t.crypto));var i=function(){return(Math.random()+1).toString(36).substr(2,7)},o=function(e){for(var t,n="",i=0,o=e.length;o>i;++i)t=e.charCodeAt(i),n+=(t>>4).toString(16),n+=(15&t).toString(16);return n},a={id:i,random:function(){return n?function(t){var i=e.extend({},t),a=new Uint8Array(16);n(a);var r=String.fromCharCode.apply(null,a);return i.hex?o(r):r}:i}(),binStringToHex:o};return a}]}),define("services/fastscroll",["jquery"],function(e){var t=function(e){var t=document.createEvent("MouseEvent"),n=document.elementFromPoint(e.x,e.y);t.initMouseEvent("click",!0,!0,window,null,e.x,e.y,0,0,!1,!1,!1,!1,0,null),t.synthetic=!0,n.dispatchEvent(t)};return["$window",function(n){var i={apply:function(i,o){o||(o=i);var a,r=n.document.createElement("div"),s=r.style,c=!1,l=!1,d={x:0,y:0};s.cssText=["-webkit-transform: translate3d(0,0,0);","transform: translate3d(0,0,0);","position: absolute;","top: 0;","right: 0;","left: 0;","bottom: 0;","opacity: 0;","z-index: 9;","pointer-events: none"].join(""),o.append(r),i.on("scroll",function(){c||(s.pointerEvents="auto",c=!0),n.clearTimeout(a),a=n.setTimeout(function(){s.pointerEvents="none",c=!1,l&&(t(d),l=!1)},500)}),e(r).on("click",function(e){e.target!==r||e.synthetic||(d.x=e.clientX,d.y=e.clientY,l=!0)})}};return i}]}),define("services/videowaiter",["underscore"],function(e){return["$window",function(t){var n=function(){this.stop=!1,this.count=0,this.retries=100};return n.prototype.start=function(n,i,o,a){if(this.stop)return void(a&&a(n,i));var r=i&&i.getVideoTracks()||[];0===r.length&&this.count>=10?o(!1,n,i):n.currentTime>0&&n.videoHeight>0?o(!0,n,i):(this.count++,this.count<this.retries?t.setTimeout(e.bind(this.start,this,n,i,o,a),100):a&&a(n,i))},n.prototype.stop=function(){this.stop=!0},{wait:function(t,i,o,a){var r=new n;return e.defer(function(){r.start(t,i,o,a)}),r}}}]}),function(jQuery){function toCSS(jss,options){function jsonToCSS(e,t){e&&!result[e]&&(result[e]={});for(var n in t){var i=t[n];if(i instanceof Array)for(var o=i,a=0;a<o.length;a++)addProperty(e,n,o[a]);else switch(typeof i){case"number":case"string":addProperty(e,n,i);break;case"object":var r=n.charAt(n.length-1);if(!e||"_"!==r&&"-"!==r)jsonToCSS(makeSelectorName(e,n),i);else{var s=i;for(var c in s)for(var l=c.split(/\s*,\s*/),d=0;d<l.length;d++){var u=s[c];if(u instanceof Array)for(var p=u,f=0;f<p.length;f++)addProperty(e,n+l[d],p[f]);else addProperty(e,n+l[d],s[c])}}}}}function makePropertyName(e){return e.replace(/_/g,"-")}function makeSelectorName(e,t){for(var n=[],i=t.split(/\s*,\s*/),o=e.split(/\s*,\s*/),a=0;a<o.length;a++)for(var r=o[a],s=0;s<i.length;s++){var c=i[s];n.push("&"===c.charAt(0)?r+c.substr(1):r?r+" "+c:c)}return n.join(", ")}function addProperty(e,t,n){"number"!=typeof n||options.useRawValues||(n+="px");for(var i=t.split(/\s*,\s*/),o=0;o<i.length;o++){var a=makePropertyName(i[o]);result[e][a]?result[e][a].push(n):result[e][a]=[n]}}var result={};if("string"==typeof jss)try{eval("var jss = {"+jss+"}")}catch(e){return"/*\nUnable to parse JSS: "+e+"\n*/"}jsonToCSS("",jss);var ret="";for(var a in result){var css=result[a];ret+=a+" {\n";for(var i in css)for(var values=css[i],j=0;j<values.length;j++)ret+="	"+i+": "+values[j]+";\n";ret+="}\n"}return ret}var defaults={truncateFirst:!1,container:null,containerName:"injectCSSContainer",useRawValues:!1};jQuery.injectCSS=function(e,t){t=jQuery.extend({},defaults,t),t.media=t.media||"all";var n=t.container&&jQuery(t.container)||jQuery("#"+t.containerName);n.length||(n=jQuery("<style></style>").appendTo("head").attr({media:t.media,id:t.containerName,type:"text/css"}));var i="";t.truncateFirst||(i+=n.text()),i+=toCSS(e,t);var o=n[0];return void 0!==o.styleSheet&&void 0!==o.styleSheet.cssText?o.styleSheet.cssText=i:n.text(i),n}}(jQuery),define("injectCSS",["jquery"],function(e){return function(){var t;return t||e.$}}(this)),define("services/videolayout",["jquery","underscore","modernizr","injectCSS"],function(e,t,n){{var i={},o={width:640,height:360},a=o.width/o.height,r=function(e,t){var n={width:o.width,height:o.height};if(e.length&&1===e.length){var i=t[e[0]].element.find("video")[0];i&&(n.width=i.videoWidth,n.height=i.videoHeight,console.log("Remote video size: ",n))}return n},s="audiovideo-dynamic",c=function(t){e.injectCSS(t,{containerName:s,truncateFirst:!0,useRawValues:!0})};n["object-fit"]&&!0}return["$window",function(){var n=function(){};n.prototype.name="invisible",n.prototype.render=function(){},n.prototype.close=function(){};var s=function(){};s.prototype.name="onepeople",s.prototype.render=function(t,n,i,s,l){if(!this.closed){var d,u;if(s.length){var p=r(s,l);d=p.width,u=p.height}if(d||"1"===i.localVideo.style.opacity&&(d=i.localVideo.videoWidth,u=i.localVideo.videoHeight,s=[null]),s.length){d||(d=o.width),u||(u=o.height),this.countSelfAsRemote&&s.unshift(null);var f=n.height,h=n.width,g=a,m={};m[".renderer-"+this.name+" .miniVideo"]={width:e(i.mini).height()*a+"px"};var v=f*h,b=v/s.length,y=Math.pow(b*g,.5),w=Math.ceil(h/y);w>s.length&&(w=s.length);var k=Math.ceil(h/w),x=Math.ceil(k/g),$=w*k,C=Math.ceil(s.length/w)*x;if(C>f){var S=(C-f)/Math.ceil(s.length/w);x-=S,k=x*g}t.style.width=$+"px",t.style.left=(h-$)/2+"px",m[".renderer-"+this.name+" .remoteVideos"]={">div":{width:k+"px",height:x+"px"}},c(m)}}},s.prototype.close=function(){this.closed=!0};var l=function(e,t,n){s.call(this,e,t,n)};l.prototype=Object.create(s.prototype),l.prototype.constructor=l,l.prototype.name="smally";var d=function(t,n,i){s.call(this,t,n,i);var o=e(n.mini);this.miniParent=o.parent(),o.prependTo(n.remoteVideos),o.find("video")[0].play(),this.countSelfAsRemote=!0};d.prototype=Object.create(s.prototype),d.prototype.constructor=d,d.prototype.name="democrazy",d.prototype.close=function(t,n,i){s.prototype.close.call(this,t,n,i);var o=e(n.mini);o.appendTo(this.miniParent),o.find("video")[0].play(),this.miniParent=null};var u=function(n){this.remoteVideos=e(n).find(".remoteVideos"),this.bigVideo=e("<div>").addClass("bigVideo")[0],this.remoteVideos.before(this.bigVideo),this.big=null,this.remoteVideos.on("click",".remoteVideo",t.bind(function(t){e(t.currentTarget).hasClass("remoteVideo")&&(t.stopPropagation(),this.makeBig(e(t.currentTarget)))},this))};u.prototype.name="conferencekiosk",u.prototype.makeBig=function(e){this.big!==e&&(this.big&&(this.big.insertAfter(e),this.big.find("video")[0].play()),this.big=e,e.appendTo(this.bigVideo),e.find("video")[0].play())},u.prototype.render=function(e,t,n,i,o){var r=this.big;if(r){var s=this.big.data("peerid");o[s]||(console.log("Current big peer is no longer there",s),this.big=r=null)}r||i.length&&(this.makeBig(o[i[0]].element),this.bigVideo.style.opacity=1);var l=t.height-110,d=t.width,u={},p=a,f=p*l>d?d:p*l,h=d/p>l?l:d/p;(t.width-192*(i.length-1))/2<192&&(u[".renderer-"+this.name+" .remoteVideos"]={"margin-right":"192px","overflow-x":"auto","overflow-y":"hidden"}),u[".renderer-"+this.name+" .bigVideo .remoteVideo"]={height:h+"px",width:f+"px",margin:"auto",display:"block"},c(u)},u.prototype.close=function(){this.closed=!0,this.big&&(this.remoteVideos.append(this.big),this.big.find("video")[0].play()),this.big=null,this.bigVideo.remove(),this.bigVideo=null,this.remoteVideos=null};var p=function(e,t,n){u.call(this,e,t,n)};p.prototype=Object.create(u.prototype),p.prototype.constructor=p,p.prototype.name="auditorium",p.prototype.render=function(t,n,i,o,r){var s=this.big;if(s){var l=this.big.data("peerid");r[l]||(console.log("Current big peer is no longer there",l),this.big=s=null)}s||o.length&&(this.makeBig(r[o[0]].element),this.bigVideo.style.opacity=1);var d={};d[".renderer-"+this.name+" .miniVideo"]={width:e(i.mini).height()*a+"px"},c(d)},i[n.prototype.name]=n,i[s.prototype.name]=s,i[l.prototype.name]=l,i[d.prototype.name]=d,i[u.prototype.name]=u,i[p.prototype.name]=p;var f=function(e,t,n){var i=e;return i=n?i+t.charAt(0).toUpperCase()+t.slice(1):i+"-"+t},h=null,g=e("body");return{update:function(n,o,a,r){var s=t.keys(r.streams),c=r.streams,l=a.container,d=a.layoutparent;return h?h&&h.name!==n?(h.close(l,a,r),e(l).removeAttr("style"),e(d).removeClass(f("renderer",h.name)),g.removeClass(f("videolayout",h.name,!0)),h=new i[n](l,a,r),e(d).addClass(f("renderer",n)),g.addClass(f("videolayout",n,!0)),console.log("Switched to new video layout renderer",n,h),!0):h.render(l,o,a,s,c):(h=new i[n](l,a,r),console.log("Created new video layout renderer",n,h),e(d).addClass(f("renderer",n)),g.addClass(f("videolayout",n,!0)),!0)},register:function(e,t){i[e]=t},layouts:function(){return t.keys(i)}}}]}),define("services/contactdata",["underscore","jquery"],function(e){return[function(){var t={},n={},i=0,o={clear:function(o){e.each(n,e.bind(function(e,n){var i=t[e];o&&i&&o(i),this.remove(n)},this)),i=0},addByRequest:function(e){var o,a=e.Userid,r=e.Token;n.hasOwnProperty(a)?o=n[a]:(o=String(i++),n[a]=o);var s=t[o]={Id:"contact-"+o,Userid:a,Token:r,Status:null};return s},addByData:function(e){var o,a=e.Userid;n.hasOwnProperty(a)?o=n[a]:(o=String(i++),n[a]=o);var r=t[o]=e;return r.Id=o,r},get:function(e){if(n.hasOwnProperty(e)){var i=n[e];return t[i]}return null},remove:function(e){if(n.hasOwnProperty(e)){var i=n[e];delete t[i]}delete n[e]},getById:function(e){return 0===e.indexOf("contact-")&&(e=e.substr(8)),t.hasOwnProperty(e)?t[e]:null},getAll:function(){return e.values(t)}};return o}]}),define("text!partials/contactsmanager.html",[],function(){return'<div default-dialog>\n  <div class="row head">\n    <div class="col-xs-12">\n      <p ng-if="contacts.length === 0">\n        {{_(\'You have no contacts.\')}}\n      </p>\n      <p>{{_(\'To add new contacts, join a room and create a contact add request by clicking on the star icon next to a user entry.\')}}</p>\n    </div>\n  </div>\n  <div class="row" ng-if="contacts.length > 0">\n    <div class="col-xs-12">\n      <div class="editlist nicescroll row">\n        <table class="table table-hover table-condensed">\n          <tbody>\n            <tr ng-repeat="contact in contacts">\n              <td class="picture buddy">\n                <div class="buddyPicture"><i class="fa fa-user"/><img ng-show="contact.Status.buddyPicture" alt ng-src="{{contact.Status.buddyPicture}}"/></div>\n              </td>\n              <td class="name">\n                <span>{{contact.Userid|displayName}}</span>\n              </td>\n              <td class="action">\n                <div class="btn-group buddyactions">\n                    <button class="btn btn-primary" ng-click="doCall(contact)" title="{{_(\'Start video call\')}}"><i class="fa fa-phone"></i></button>\n                    <button class="btn btn-primary" ng-click="startChat(contact)" title="{{_(\'Start chat\')}}"><i class="fa fa-comments-o"></i></button>\n                </div>\n                <button class="btn btn-primary" ng-click="openContactsManagerEdit(contact)" title="{{_(\'Edit contact\')}}">{{_(\'Edit\')}}</button>\n              </td>\n            </tr>\n          </tbody>\n        </table>\n      </div>\n    </div>\n  </div>\n</div>\n'
}),define("text!partials/contactsmanageredit.html",[],function(){return'<div>\n  <div class="modal-header">\n    <button type="button" class="close" ng-click="$close()">×</button>\n    <h3 class="modal-title" ng-bind-html="header"></h3>\n  </div>\n  <div  class="modal-body">\n    <div class="form-horizontal">\n        <div class="form-group">\n          <label for="contact-name" class="col-xs-4 control-label">{{_(\'Picture\')}}</label>\n          <div class="col-xs-6">\n            <div class="picture buddy">\n              <div class="buddyPicture"><i class="fa fa-user"/><img ng-show="contact.Status.buddyPicture" alt ng-src="{{contact.Status.buddyPicture}}"/></div>    \n            </div>\n          </div>\n        </div>\n        <div class="form-group">\n          <label for="contact-name" class="col-xs-4 control-label">{{_(\'Name\')}}</label>\n          <div class="col-xs-6">\n            <input id="contact-name" class="form-control" type="text" ng-model="contact.Status.displayName">\n          </div>\n        </div>\n    </div>\n  </div>\n  <div class="modal-footer">\n    <div class="pull-left">\n        <button class="btn btn-danger" ng-click="removeContact()">{{_(\'Remove\')}}</button>\n        <button id="contact-sync" class="btn btn-success" ng-if="buddySyncable" ng-click="syncContactInfo()"><span class="fa fa-rotate-right"></span> {{_(\'Refresh\')}}</button>\n    </div>\n    <div class="pull-right">\n      <button class="btn btn-default" ng-click="cancel()">{{_(\'Cancel\')}}</button>\n      <button class="btn btn-primary" ng-click="save()">{{_(\'Save\')}}</button>\n    </div>\n  </div>\n</div>\n'}),define("services/contacts",["underscore","jquery","modernizr","sjcl","text!partials/contactsmanager.html","text!partials/contactsmanageredit.html"],function(e,t,n,i,o,a){var r=function(n){this.version=3,this.ready=!1,this.db=null,this.name=n,this.e=t({});var i=window.indexedDB.open(this.name,this.version),o=this;i.onupgradeneeded=function(t){var n=t.target.result,i=t.target.transaction;i.onerror=e.bind(o.onerror,o),o.init(n),console.info("Created contacts database.")},i.onsuccess=e.bind(o.onsuccess,o),i.onerror=e.bind(o.onerror,o)};return r.prototype.init=function(e){var t=function(t,n){e.objectStoreNames.contains(t)&&e.deleteObjectStore(t),e.createObjectStore(t,n)};t("contacts",{keyPath:"id"})},r.prototype.onerror=function(e){console.log("IndexDB database error",e)},r.prototype.onsuccess=function(e){this.db=e.target.result,this.ready=!0,this.e.triggerHandler("ready")},r.prototype.put=function(t,n,i,o){var a=this.db.transaction(t,"readwrite"),r=a.objectStore(t),s=r.put(n);return o||(o=e.bind(this.onerror,this)),a.onerror=s.onerror=o,i&&(s.onsuccess=i),s},r.prototype.delete=function(t,n,i,o){var a=this.db.transaction(t,"readwrite"),r=a.objectStore(t),s=r.delete(n);return o||(o=e.bind(this.onerror,this)),a.onerror=s.onerror=o,i&&(s.onsuccess=i),s},r.prototype.all=function(t,n,i){var o=this.db.transaction(t),a=o.objectStore(t),r=window.IDBKeyRange.lowerBound(0),s=a.openCursor(r);return s.onsuccess=function(e){var t=e.target.result;t&&(n(t.value),t.continue())},i||(i=e.bind(this.onerror,this)),o.onerror=s.onerror=i,s},r.prototype.close=function(){this.e.off(),this.db&&(this.db.close(),this.db=null,this.ready=!1),e.defer(e.bind(function(){this.e.triggerHandler("closed")},this))},["appData","contactData","mediaStream","$templateCache","modules",function(s,c,l,d,u){var p=u.withModule("contacts");p&&(d.put("/contactsmanager/main.html",o),d.put("/contactsmanager/edit.html",a));var f=function(){this.e=t({}),this.userid=null,this.key=null,this.database=null,this.enabled=p,s.e.on("authenticationChanged",e.bind(function(t,n,i){var o=this.open(n,i);o&&n&&(o.ready?e.defer(e.bind(function(){this.database===o&&this.load()},this)):o.e.one("ready",e.bind(function(){this.database===o&&this.load()},this)))},this))};return f.prototype.put=function(e){return this.database?void this.database.put("contacts",{id:this.id(e.Userid),contact:this.encrypt(e)}):void console.warn("Unable to put contact as no database is loaded.")},f.prototype.open=function(e,t){if(!this.enabled)return null;if(!this.database||e&&this.userid===e||(this.unload(),this.database.close(),this.database=null),e){if(!n.indexeddb)return;this.key=i.codec.base64.fromBits(i.hash.sha256.hash(t+l.config.Token));var o="mediastream-"+this.id(e),a=this.database=new r(o);return a}return this.database=null,null},f.prototype.id=function(e){var t=new i.misc.hmac(this.key);return i.codec.base64.fromBits(t.encrypt(e))},f.prototype.encrypt=function(e){return i.encrypt(this.key,JSON.stringify(e))},f.prototype.decrypt=function(e){var t;try{var n=i.decrypt(this.key,e);t=JSON.parse(n)}catch(o){console.error("Failed to decrypt contact data",o)}return t},f.prototype.load=function(){if(this.database){var t=[];this.database.all("contacts",e.bind(function(e){var n=this.decrypt(e.contact);if(n){{c.addByData(n)}this.e.triggerHandler("contactadded",n)}else t.push(e.id)},this)),t.length&&e.each(t,e.bind(function(e){this.database.delete("contacts",e)},this))}},f.prototype.unload=function(){c.clear(e.bind(function(e){this.e.triggerHandler("contactremoved",e)},this))},f.prototype.add=function(e,t){var n=c.addByRequest(e,t);this.e.triggerHandler("contactadded",n),this.database&&this.put(n)},f.prototype.remove=function(e){var t=c.get(e);t&&(c.remove(e),this.database&&this.database.delete("contacts",this.id(e)),this.e.triggerHandler("contactremoved",t))},f.prototype.update=function(e){this.put(e),this.e.triggerHandler("contactupdated",e)},new f}]}),define("services/buddysession",["underscore"],function(e){return[function(){var t={},n=0,i=function(e){this.serial=n++,this.sessions={},this.count=0;var t=e.Id;if(e.Id){var i=e.Userid||null;if(t===i)this.use(i,e);else{var o=this.add(t,e);i&&this.auth(i,o)}}else this.use(null,{})};return i.prototype.add=function(e,n){return this.sessions[e]=n,0===this.count&&this.use(e,n),this.count++,t[e]=this,n},i.prototype.rm=function(e){this.sessions.hasOwnProperty(e)&&(delete this.sessions[e],this.count--),delete t[e]},i.prototype.get=function(e){return e||(e=this.Id),this.sessions[e]},i.prototype.use=function(e){this.Id=e?e:null},i.prototype.remove=function(e){if(this.rm(e),e===this.Id){var t,n=this.sessions;for(var i in n)if(n.hasOwnProperty(i)){t=n[i];break}if(!t)return this.use(this.Userid?this.Userid:null),!0;this.use(t.Id,t)}return!1},i.prototype.update=function(e,t,n){var i,o=t.Userid;return e===o?i=t:(i=this.get(e),i||(i=this.add(e,t))),o&&this.auth(o,i,n),t!==i&&(t.Rev&&(i.Rev=t.Rev),t.Status&&(i.Status=t.Status)),e===this.Id?i:null},i.prototype.auth=function(e,t,n){this.Userid||(this.Userid=e),n&&!t.auth&&(n(this),t.auth=!0)},i.prototype.merge=function(t){return this.Userid?t.Userid!==this.Userid?void console.error("Refusing to merge other session with different userid",t,this):void e.each(t.sessions,e.bind(function(e,t){this.sessions.hasOwnProperty(t)||this.add(t,e)},this)):void console.error("Refusing to merge into session as we have no userid",this,t)},{create:function(e){return new i(e)},sessions:function(){return t}}}]}),define("services/localstorage",["modernizr"],function(e){return["$window",function(t){var n=function(e){this.prefix=e?e:"ps",this.isPersistentStorage=!0};n.prototype.setItem=function(e,n){var i=this.prefix+"_"+e;t.document.cookie=i+"="+n+"; path=/"},n.prototype.getItem=function(e){for(var n=this.prefix+"_"+e+"=",i=t.document.cookie.split(";"),o=0;o<i.length;o++){var a=i[o].trim();if(0===a.indexOf(n))return a.substring(n.length,a.length)}return null},n.prototype.removeItem=function(e){var n=this.prefix+"_"+e;t.document.cookie=n+"=; expires=Thu, 01 Jan 1970 00:00:01 GMT; path=/"};var i;return i=e.localstorage?t.localStorage:new n,{setItem:function(e,t){return i.setItem(e,t)},getItem:function(e){return i.getItem(e)},removeItem:function(e){return i.removeItem(e)}}}]}),define("services/animationframe",["underscore","rAF"],function(e){return["$window",function(t){var n=t.requestAnimationFrame,i=[],o=function(e){e()},a=function(){i.forEach(o),n(s)},r=t.setTimeout,s=function(){r(a,100)},c={register:function(e){i.push(e)}};return e.defer(s),c}]}),define("services/dialogs",["angular"],function(){return["$window","$modal","$templateCache","translation",function(e,t){return{create:function(e,n,i,o){return t.open({templateUrl:e,controller:n,keyboard:void 0===o.kb?!0:o.kb,backdrop:void 0===o.bd?!0:o.bd,windowClass:o.wc,size:o.ws,resolve:{data:function(){return i}}})}}}]}),define("services/geolocation",["underscore","modernizr"],function(e,t){var n=t.geolocation;return[function(){var t={enableHighAccuracy:!0,timeout:5e3,maximumAge:0};return{getCurrentPosition:function(i,o,a){if(!n)return void(o&&o(new Error("geolocation api is not supported")));var r=e.extend({},t,a);navigator.geolocation.getCurrentPosition(i,o,r)}}}]}),define("text!partials/screensharedialogff.html",[],function(){return'<div>\n	<div class="modal-header"><button type="button" class="close" ng-click="$close()">×</button><h3 class="modal-title">{{_("Share screen")}}</h3></div>\n	<div class="modal-body">\n		<ng-form name="promptDialog" novalidate role="form">\n			<h4>{{_("Please select what to share.")}}</h4>\n			<div class="btn-group">\n				<label class="btn btn-default" ng-model="data.selection" btn-radio="\'screen\'">{{_("Screen")}}</label>\n				<label class="btn btn-default" ng-model="data.selection" btn-radio="\'window\'">{{_("Window")}}</label>\n				<label class="btn btn-default" ng-model="data.selection" btn-radio="\'application\'">{{_("Application")}}</label>\n			</div>\n			<div ng-switch="data.selection">\n				<span class="help-block" ng-switch-when="screen">{{_("Share the whole screen. Click share to select the screen.")}}</span>\n				<span class="help-block" ng-switch-when="window">{{_("Share a single window. Click share to select the window.")}}</span>\n				<span class="help-block" ng-switch-when="application">{{_("Share all windows of a application. This can leak content behind windows when windows get moved. Click share to select the application.")}}</span>\n			</div>\n		</ng-form>\n	</div>\n	<div class="modal-footer">\n		<button type="button" class="btn btn-default" ng-click="cancel()">{{_("Cancel")}}</button>\n		<button type="button" class="btn btn-primary" ng-click="ok()" ng-disabled="(promptDialog.$dirty && promptDialog.$invalid) || !data.selection">{{_("Share")}}</button>\n	</div>\n</div>'}),define("services/screensharing",["underscore","text!partials/screensharedialogff.html","webrtc.adapter"],function(e,t){var n=["$scope","$modalInstance","data",function(e,t,n){e.data=n,e.cancel=function(){t.close(null)},e.ok=function(){t.close(e.data.selection)}}];return["$window","$q","$timeout","chromeExtension","dialogs","$templateCache",function(i,o,a,r,s,c){c.put("/dialogs/screensharedialogff.html",t);var l=function(){this.autoinstall=!1,this.initialize(),r.e.on("available",e.bind(function(){this.initialize()},this))};l.prototype.initialize=function(){if(this.supported=!1,this.prepare=null,this.cancel=null,"chrome"===i.webrtcDetectedBrowser)if(i.webrtcDetectedVersion>=32&&i.webrtcDetectedVersion<37?(this.supported=!0,this.prepare=function(t){var n=o.defer(),i=e.extend({chromeMediaSource:"screen"},t);return n.resolve(i),n.promise}):i.webrtcDetectedVersion>=37,r.available){this.supported=!0;var t=null;this.prepare=function(n){var i=r.call({Type:"Action",Action:"chooseDesktopMedia"}),a=o.defer();return i.then(function(i){if(t=null,i){var o=e.extend({chromeMediaSource:"desktop",chromeMediaSourceId:i},n);a.resolve(o)}else a.resolve(null)},function(e){t=null,console.log("Failed to prepare screensharing",e),a.reject(e)},function(e){t=e}),a.promise},this.cancel=function(){null!==t&&(r.call({Type:"Action",Action:"cancelChooseDesktopMedia",Args:t}),t=null)}}else r.autoinstall.force&&(this.supported=!1);else"firefox"===i.webrtcDetectedBrowser&&i.webrtcDetectedVersion>=36&&(this.supported=!0,this.prepare=function(t){var i=o.defer(),a=s.create("/dialogs/screensharedialogff.html",n,{selection:"screen"},{});return a.result.then(function(n){if(n){var o=e.extend({mediaSource:n},t);i.resolve(o)}else i.resolve(null)},function(){i.resolve(null)}),i.promise});if(!this.supported&&r.autoinstall.install){this.supported=this.autoinstall=!0;var c=this,l=!1,d=this.prepare;this.prepare=function(e){var t=o.defer(),n=r.autoinstall.install();return n.then(function(){console.log("Auto install success"),l=!0,a(function(){var n=function(){l=!1;var n=c.prepare(e);n.then(function(e){t.resolve(e)},function(e){t.reject(e)})};!c.autoinstall&&c.supported?n():r.e.one("available",function(){a(function(){l&&!c.autoinstall&&c.supported&&n()},0)})},100),a(function(){l&&(l=!1,t.reject("Timeout while waiting for extension to become available"))},3e4)},function(n){if(console.log("Auto install of extension failed.",n),d){var i=d(e);i.then(function(e){t.resolve(e)},function(){t.reject(n)})}else t.reject(n)}),t.promise},this.cancel=function(){r.autoinstall.cancel&&r.autoinstall.cancel(),l=!1}}else this.autoinstall=!1;console.log("Screensharing support",this.supported,this.autoinstall?"autoinstall":"")},l.prototype.getScreen=function(e){if(this.prepare)return this.prepare(e);var t=o.defer();return t.reject("No implementation to get screen."),t.promise},l.prototype.cancelGetScreen=function(){this.cancel&&this.cancel()};var d=new l;return d}]}),define("services/continueconnector",["underscore"],function(e){var t=function(e){this.ref=e};return t.prototype.disable=function(){this.ref=null},t.prototype.resolve=function(t){this.ref&&e.bind(this.ref.resolve,this.ref)(t)},t.prototype.reject=function(t){this.ref&&e.bind(this.ref.reject,this.ref)(t)},t.prototype.notify=function(t){this.ref&&e.bind(this.ref.notify,this.ref)(t)},["$q",function(n){var i=function(){this.deferred=n.defer(),this.promises=[],this.thens=[],this.current=null};return i.prototype.add=function(e){this.promises.push(e),this.refresh()},i.prototype.remove=function(t){this.promises=e.without(this.promises,t),this.refresh()},i.prototype.refresh=function(){this.current&&this.current.disable();var i=this.current=new t(this),o=n.all(this.promises);o.then(e.bind(i.resolve,i),e.bind(i.reject,i),e.bind(i.notify,i))},i.prototype.defer=function(){var e=n.defer();return this.add(e.promise),e},i.prototype.resolve=function(e){this.deferred.resolve(e)},i.prototype.reject=function(e){this.deferred.reject(e)},i.prototype.notify=function(e){this.deferred.notify(e)},i.prototype.then=function(e,t,n){return this.thens.push(arguments),this.deferred.promise.then(e,t,n)},i.prototype.reset=function(){this.deferred=n.defer();var t=this.deferred.promise;e.each(this.thens,function(e){t.then.apply(t,e)}),this.refresh()},new i}]}),define("services/chromeextension",["underscore","jquery","webrtc.adapter"],function(e,t){return["$window","$q","alertify","translation",function(e,n,i,o){var a=function(){this.available=!1,this.registry={},this.count=0,this.e=t({}),this.autoinstall={},this.initialize()};a.prototype.initialize=function(){var t=e.document.getElementById("chromeextension-available");t?(this.available=!0,console.log("Chrome extension is available."),this.e.triggerHandler("available",!0)):!t&&this.available&&(this.available=!1,console.log("Chrome extension is no longer available."),this.e.triggerHandler("available",!1))},a.prototype.call=function(t){var i=n.defer(),o=this.count++;this.registry[o]=i;var a={Type:"Call",Call:t,n:o};return e.postMessage(a,e.document.URL),i.promise},a.prototype.onMessage=function(e){var t=e.data;switch(t.Type){case"Call":var n=this.registry[t.n];if(n){var i=t.Call;switch(i.Type){case"Result":delete this.registry[t.n],n.resolve(i.Result);break;case"Notify":n.notify(i.Notify);break;case"Error":delete this.registry[t.n],n.reject(i.Error)}}else console.warn("Unknown call reference received",t,this.registry,this);break;case"Upgrade":console.log("Extension installed or upgraded",t),this.initialize();break;default:console.log("Unknown message type",t.Type,t)}},a.prototype.registerAutoInstall=function(e,t,n){this.autoinstall.install=e,this.autoinstall.cancel=t,this.autoinstall.force=!!n,!this.available&&e&&this.e.triggerHandler("available",!0)};var r=new a;return e.addEventListener("message",function(e){e.source===window&&e.data.answer&&r.onMessage(e)}),"chrome"===e.webrtcDetectedBrowser&&e.webrtcDetectedVersion>=37&&r.registerAutoInstall(function(){var e=n.defer();return i.dialog.alert(o._("Screen sharing requires a browser extension. Please add the Spreed WebRTC screen sharing extension to Chrome and try again.")),e.reject("Manual extension installation required"),e.promise}),r}]}),define("services/usersettingsdata",["sjcl"],function(e){return["localStorage","mediaStream","appData",function(t,n,i){var o=function(e){this.prefix=e,this.suffix="",this.key=null};o.prototype.getId=function(){var e=this.prefix;return this.suffix&&(e=e+"_"+this.suffix),e},o.prototype.setEncryption=function(t,i){if(t){this.key=e.codec.base64.fromBits(e.hash.sha256.hash(i+n.config.Token));var o=new e.misc.hmac(this.key);this.suffix=e.codec.base64.fromBits(o.encrypt(t+this.prefix))}else this.suffix="",this.key=null},o.prototype.load=function(){var n=t.getItem(this.getId());if(n)try{return this.key&&(n=e.decrypt(this.key,n)),JSON.parse(n)}catch(i){console.warn("Failed to load stored user data:",i)}return null},o.prototype.save=function(n){var i=JSON.stringify(n);this.key&&(i=e.encrypt(this.key,i)),t.setItem(this.getId(),i)},o.prototype.clear=function(){t.removeItem(this.getId())};var a=new o("mediastream-user");return i.e.on("authenticationChanged",function(e,t,n){a.setEncryption(t,n)}),{load:function(){return a.load()},save:function(e){return a.save(e)},clear:function(){return a.clear()}}}]}),define("services/localstatus",["angular","underscore"],function(e,t){return["mediaStream","$window",function(n,i){var o=null,a=!1,r={update:function(n){o&&t.isEqual(n,o)||(o=e.copy(n),a||(a=!0,i.setTimeout(r.commit,1e3)))},commit:function(){a&&(a=!1,n.api.updateStatus(o))},clear:function(){o=null},get:function(){return o}};return r}]}),define("services/rooms",["angular","jquery","underscore"],function(e,t,n){return["$window","$location","$timeout","$q","$route","$rootScope","$http","globalContext","safeApply","connector","api","restURL","roompin","appData","alertify","translation","mediaStream",function(i,o,a,r,s,c,l,d,u,p,f,h,g,m,v,b,y){var w=h.api("rooms"),k="",x=null,$=null,C=null,S=null,P=!y.config.AuthorizeRoomJoin,T=P?!y.config.AuthorizeRoomCreation:!1,_=function(e){switch(R(null),e.Code){case"default_room_disabled":x=null,U.randomRoom();break;case"invalid_credentials":g.clear(k);case"authorization_required":g.requestInteractively(k).then(D,function(){console.log("Authentication cancelled, try a different room."),U.joinPriorOrDefault(!0)});break;case"authorization_not_required":g.clear(k),D();break;case"room_join_requires_account":console.log("Room join requires a logged in user."),v.dialog.notify("",b._("Please sign in to create rooms.")),U.joinPriorOrDefault(!0);break;default:console.log("Unknown error",e,"while joining room ",k)}},D=function(){if(p.connected&&!m.authorizing()&&(!C||k!==C.Name)&&(k=k?k:"",$!==k)){$=k;var e=$;n.defer(function(){$===e&&($=null)}),console.log("Joining room",[k]),f.sendHello(k,g.get(k),function(e){R(e)},function(e){_(e)})}},R=function(e){if(e!==C){var t=C;C=e,t&&(x=t.Name,console.log("Left room",[t.Name]),c.$broadcast("room.left",t.Name)),C&&(console.log("Joined room",[C.Name]),c.$broadcast("room.joined",C.Name))}},M=function(e){var t=r.defer();return f.requestRoomUpdate(e,t.resolve,t.reject),t.promise.then(A)},A=function(e){return e.Credentials&&(g.update(C.Name,e.Credentials.PIN),delete e.Credentials),C=e,c.$broadcast("room.updated",C),e};p.e.on("close error",function(){R(null)}),f.e.on("received.room",function(e,t){A(t)}),m.e.on("authorizing",function(e,t){t||n.defer(D)}),m.e.on("selfReceived",function(){n.defer(D),P=!y.config.AuthorizeRoomJoin||c.myuserid?!0:!1,T=P&&(!y.config.AuthorizeRoomCreation||c.myuserid)?!0:!1}),c.$on("$locationChangeSuccess",function(){var e;s.current?(e=s.current.params.room,e=i.decodeURIComponent(e)):e="",k=e,p.connected?n.defer(D):c.$broadcast("rooms.ready")});var U={inDefaultRoom:function(){return""===(null!==C?C.Name:k)},randomRoom:function(){return T?void l({method:"POST",url:w,data:t.param({}),headers:{"Content-Type":"application/x-www-form-urlencoded"}}).success(function(e){console.info("Retrieved random room data",e),e.name||(e.name=""),S={name:e.name},c.$broadcast("room.random",S)}).error(function(){console.error("Failed to retrieve random room data."),S={},c.$broadcast("room.random",S)}):void a(function(){c.$broadcast("room.random",{})})},getRandomRoom:function(){return S},canCreateRooms:function(){return T},canJoinRooms:function(){return P},joinByName:function(e,t){var n=h.encodeRoomURL(e,"",function(e){u(c,function(){o.path(e),t&&o.replace()})});return n},joinDefault:function(e){return U.joinByName("",e)},joinPriorOrDefault:function(e){x&&k!==x?U.joinByName(x,e):U.joinDefault(e)},link:function(e){var t=e?e.Name:null;return t||(t=""),h.room(t)},setPIN:function(t){t=""+t;var n=e.copy(C);return n.Credentials={PIN:t},M(n).then(null,function(e){return console.log("Failed to set room PIN",e),r.reject(e)})}};return i.setRoomPIN=U.setPIN,U}]}),define("services/resturl",["underscore"],function(e){return["globalContext","$window",function(t,n){var i=function(){};return i.prototype.room=function(e){var i=this.encodeRoomURL(e);return n.location.protocol+"//"+n.location.host+t.Cfg.B+i},i.prototype.buddy=function(e){return n.location.protocol+"//"+n.location.host+t.Cfg.B+"static/img/buddy/s46/"+e},i.prototype.api=function(e){return(t.Cfg.B||"/")+"api/v1/"+e},i.prototype.sandbox=function(e){return(t.Cfg.B||"/")+"sandbox/"+n.location.protocol+"/"+n.location.host+"/"+e+".html"},i.prototype.encodeRoomURL=function(t,i,o){var a=t.split("/"),r=[],s=[];return"undefined"!=typeof i&&r.push(i),e.each(a,function(e){""!==e&&(s.push(e),e=n.encodeURIComponent(e),e=e.replace(/^%40/,"@"),e=e.replace(/^%24/,"$"),e=e.replace(/^%2B/,"+"),r.push(e))}),o?(o(r.join("/")),s.join("/")):r.join("/")},i.prototype.createAbsoluteUrl=function(e){var t=n.document.createElement("a");return t.href=e,t.href},new i}]}),define("services/roompin",[],function(){return["$window","$q","alertify","translation",function(e,t,n,i){var o={},a={get:function(e){var t=o[e];return t?t:null},clear:function(e){delete o[e],console.log("Cleared PIN for",e)},update:function(e,t){t?(o[e]=t,n.dialog.alert(i._("PIN for room %s is now '%s'.",e,t))):(a.clear(e),n.dialog.alert(i._("PIN lock has been removed from room %s.",e)))},requestInteractively:function(e){var a=t.defer();return n.dialog.prompt(i._("Enter the PIN for room %s",e),function(t){t?(o[e]=t,a.resolve()):a.reject()},function(){a.reject()}),a.promise}};return a}]}),define("services/constraints",["jquery","underscore","webrtc.adapter"],function(e,t){return["webrtc","$window","$q",function(n,i,o){var a=this,r=function(e){this.settings=t.clone(e,!0),this.pc=[],this.audio=[],this.video=[],this.videoMandatory={},this.screensharing=[],this.disabled={},this.promises=[],this.defer().resolve()};return r.prototype.defer=function(){var e=o.defer();return this.promises.push(e.promise),e},r.prototype.wait=function(e){return this.promises.push(e),e},r.prototype.add=function(e,n,i,o){if(t.isArray(e))return void t.forEach(e,function(e){this.add(e,n,i,o)},this);var a;if(o&&(e+="Mandatory"),a=this[e])if(o)a[n]=i;else{var r={};r[n]=i,a.push(r)}else console.warn("Pushed to unknown constraint",e,n,i,o)},r.prototype.set=function(e,t,n){n&&(e+="Mandatory"),this[e]?this[e]=t:console.warn("Set to unknown constraint",e,t,n)},r.prototype.disable=function(e){this.disabled[e]=!0},a.e=e({}),a.stun=[],a.turn={},a.mediaConstraints=function(e){n.settings.mediaConstraints.audio=e.disabled.audio?!1:{optional:e.audio},n.settings.mediaConstraints.video=e.disabled.video?!1:{optional:e.video,mandatory:e.videoMandatory},n.settings.screensharing.mediaConstraints.video.optional=e.screensharing},a.pcConstraints=function(e){n.settings.pcConstraints.optional=e.pc},a.iceServers=function(){var e=function(e,t,n){var i={urls:e};return t&&(i.username=t,i.credential=n),i},t=[];a.stun&&a.stun.length&&t.push(e(a.stun)),a.turn&&a.turn.urls&&a.turn.urls.length&&t.push(e(a.turn.urls,a.turn.username,a.turn.password)),n.settings.pcConfig.iceServers=t},a.e.on("refresh",function(e,t){"chrome"===i.webrtcDetectedBrowser&&(i.webrtcDetectedVersion>=32||(console.warn("Turning on SCTP combatibility - please update your Chrome."),t.add("pc","DtlsSrtpKeyAgreement",!0)))}),{e:a.e,refresh:function(e){var t=new r(e);return a.e.triggerHandler("refresh",[t]),o.all(t.promises).then(function(){a.mediaConstraints(t),a.pcConstraints(t),a.iceServers(t)})},turn:function(e){a.turn=e},stun:function(e){a.stun=e},supported:function(){var e="chrome"===i.webrtcDetectedBrowser,t="firefox"===i.webrtcDetectedBrowser,n="edge"===i.webrtcDetectedBrowser,o=i.webrtcDetectedVersion;return{audioVideo:e||t&&o>=38,hdVideo:e||t&&o>=38,renderToAssociatedSink:e&&0===i.navigator.platform.indexOf("Win"),chrome:e,firefox:t,edge:n}}()}}]}),define("services/modules",[],function(){return["mediaStream",function(e){var t=e.config.Modules||[];return{withModule:function(e){return-1!==t.indexOf(e)}}}]}),define("services/mediadevices",["webrtc.adapter"],function(){return["$window",function(e){var t=e.navigator.mediaDevices||{},n=function(){return t.getUserMedia?t.getUserMedia.bind(t):function(t){return new Promise(function(n,i){var o=function(e){n(e)},a=function(e){i(e)};try{e.getUserMedia(t,o,a)}catch(r){a(r)}})}}();return{shim:t.getUserMedia?!1:!0,getUserMedia:n}}]}),define("services/sandbox",["jquery","underscore"],function(e,t){return["$window",function(n){var i=function(e,t,i,o,a,r){if(this.container=e,this.sandbox=o?o:"",this.className=a,this.attrs=r,t){var s=new n.Blob([t],{type:"text/html;charset=utf-8"});this.url=this.blobUrl=n.URL.createObjectURL(s)}else i&&(this.url=i);this.url&&this.create()};return i.prototype.create=function(){if(this.url){var i,o=e(this.container);o.is("iframe")?(this.className&&o.addClass(this.className),this.attrs&&o.attr(this.attrs),i=o[0],i.src=this.url,this.created=!1):(i=n.document.createElement("iframe"),i.sandbox=this.sandbox,this.className&&(i.className=this.className),this.attrs&&e(i).attr(this.attrs),i.src=this.url,o.append(i),this.created=!0),this.iframe=i,this.target=this.iframe.contentWindow,this.e=e({}),this.handler=t.bind(this.onPostMessageReceived,this),this.ready=!1,this.pending_messages=[],this.origin=n.location.protocol+"//"+n.location.host,n.addEventListener("message",this.handler,!1)}},i.prototype.destroy=function(){this.handler&&(n.removeEventListener("message",this.handler,!1),this.handler=null),this.blobUrl&&(n.URL.revokeObjectURL(this.blobUrl),this.blobUrl=null),this.url=null,this.container=null,this.attrs=null,this.created&&e(this.iframe).remove()},i.prototype.onPostMessageReceived=function(e){"null"!==e.origin&&e.origin!==this.origin||e.source!==this.target||("ready"===e.data.type&&(this.ready=!0,this._sendPendingMessages()),this.e.triggerHandler("message",[e]))},i.prototype._sendPendingMessages=function(){var e;for(e=0;e<this.pending_messages.length;e++){var t=this.pending_messages[e];this.postMessage(t[0],t[1])}this.pending_messages=[]},i.prototype.postMessage=function(e,t){if(!this.ready)return void this.pending_messages.push([e,t]);var n={type:e};n[e]=t,this.target.postMessage(n,"*")},{createSandbox:function(e,t,n,o,a){return n||(n=""),new i(e,t,n,o,a)}}}]}),define("services/dummystream",["mediastream/dummystream"],function(e){return[function(){return e}]}),define("services/usermedia",["mediastream/usermedia"],function(e){return[function(){return{getUserMedia:e.getUserMedia,stopUserMediaStream:e.stopUserMediaStream}}]}),define("services/services",["underscore","services/desktopnotify","services/playsound","services/safeapply","services/connector","services/api","services/webrtc","services/mediastream","services/appdata","services/buddydata","services/buddylist","services/buddypicture","services/enrichmessage","services/safemessage","services/alertify","services/toastr","services/visibility","services/translation","services/mediasources","services/fileupload","services/filedownload","services/filedata","services/filetransfer","services/safedisplayname","services/randomgen","services/fastscroll","services/videowaiter","services/videolayout","services/contactdata","services/contacts","services/buddysession","services/localstorage","services/animationframe","services/dialogs","services/geolocation","services/screensharing","services/continueconnector","services/chromeextension","services/usersettingsdata","services/localstatus","services/rooms","services/resturl","services/roompin","services/constraints","services/modules","services/mediadevices","services/sandbox","services/dummystream","services/usermedia"],function(e,t,n,i,o,a,r,s,c,l,d,u,p,f,h,g,m,v,b,y,w,k,x,$,C,S,P,T,_,D,R,M,A,U,E,I,N,O,H,V,F,q,j,L,B,z,Y,X,W){var G={desktopNotify:t,playSound:n,safeApply:i,connector:o,api:a,webrtc:r,mediaStream:s,appData:c,buddyData:l,buddyList:d,buddyPicture:u,enrichMessage:p,safeMessage:f,alertify:h,toastr:g,visibility:m,translation:v,mediaSources:b,fileUpload:y,fileDownload:w,fileData:k,fileTransfer:x,safeDisplayName:$,randomGen:C,fastScroll:S,videoWaiter:P,videoLayout:T,contactData:_,contacts:D,buddySession:R,localStorage:M,animationFrame:A,dialogs:U,geolocation:E,screensharing:I,continueConnector:N,chromeExtension:O,userSettingsData:H,localStatus:V,rooms:F,restURL:q,roompin:j,constraints:L,modules:B,mediaDevices:z,sandbox:Y,dummyStream:X,userMedia:W},J=function(t){e.each(G,function(e,n){t.factory(n,e)})};return{initialize:J}}),define("directives/onenter",[],function(){return[function(){return{restrict:"A",link:function(e,t,n){var i=n.onEnter;t.bind("keydown keypress",function(t){13!==t.which||t.shiftKey||t.ctrlKey||(t.preventDefault(),e.$eval(i),e.$apply())})}}}]}),define("directives/onescape",[],function(){return[function(){return{restrict:"A",link:function(e,t,n){var i=n.onEscape;t.bind("keydown keypress",function(t){27===t.which&&(t.preventDefault(),e.$eval(i),e.$apply())})}}}]}),define("text!partials/statusmessage.html",[],function(){return'<span class="status-{{status}}" ng-switch on="status">\n  <span ng-switch-when="initializing">{{_("Initializing")}} <i class="fa fa-circle-o-notch fa-spin"></i></span>\n  <span ng-switch-when="waiting" ng-controller="UsersettingsController as usersettings"><span class="status-indicator"><i style="color:rgb(132,184,25)" class="fa fa-dot-circle-o" title="{{_(\'Online\')}}"></i> {{id|displayName}}</span> <img class="userpicture" ng-show="master.buddyPicture" ng-src="{{master.buddyPicture}}" alt="" /><button ng-if="!authorizing && !myuserid && usersettings.loginUserid" type="button" class="btn btn-default" ng-click="usersettings.loginUserid()">{{_("Sign in")}}</button></span>\n  <span ng-switch-when="connecting"><span class="msg">{{_("Calling")}} {{dialing|displayName}}</span> <a class="btn btn-small btn-danger" ng-click="doAbort()"><i class="fa fa-circle-o-notch fa-spin"></i> {{_("Hangup")}}</a></span>\n  <span ng-switch-when="connected"><span class="msg">{{_("In call with")}} {{peer|displayName}}</span> <a class="btn btn-small btn-danger" ng-click="doHangup()"><i class="fa fa-sign-out"></i> {{_("Hangup")}}</a></span>\n  <span ng-switch-when="conference"><span class="msg">{{_("Conference with")}} {{peer|displayName}}<span>{{conferencePeers|displayConference}}</span></span> <a class="btn btn-small btn-danger" ng-click="doHangup()"><i class="fa fa-sign-out"></i> {{_("Hangup")}}</a></span>\n  <span ng-switch-when="closed"><span class="msg">{{_("Your are offline")}}</span> <a class="btn btn-small btn-success" ng-click="doReconnect()"><i class="fa fa-sign-in"></i> {{_("Go online")}}</a></span>\n  <span ng-switch-when="reconnecting">{{_("Connection interrupted")}} <i class="text-warning fa fa-circle-o-notch fa-spin"></i></span>\n  <span ng-switch-when="error"><span class="msg">{{_("An error occured")}}</span> <a class="btn btn-small btn-success" ng-click="doReconnect()"><i class="fa fa-refresh"></i> {{_("Retry")}}</a></span>\n  <span ng-switch-when="ringing"><span class="msg long">{{_("Incoming call")}} {{_("from")}} {{incoming|displayName}}</span> <span class="actions"><a class="btn btn-small btn-success btn-shakeityeah" ng-click="doAccept()"><i class="fa fa-phone"></i> {{_("Accept call")}}</a> <a class="btn btn-small btn-danger" ng-click="doReject()"><i class="fa fa-sign-out"></i> {{_("Reject")}}</a></span></span>\n  <span ng-switch-when="waitforusermedia"><span class="msg">{{_("Waiting for camera/microphone access")}}</span> <a class="btn btn-small btn-danger" ng-click="doHangup()"><i class="fa fa-circle-o-notch fa-spin"></i> {{_("Hangup")}}</a></span>\n</span>\n'
}),define("directives/statusmessage",["text!partials/statusmessage.html"],function(e){return[function(){return{restrict:"E",replace:!0,template:e,controller:"StatusmessageController"}}]}),define("text!partials/buddylist.html",[],function(){return'<div class="buddylist nicescroll" ng-class="{loading: loading, empty: empty}">\n  <div class="buddycontainer">\n    <div>\n    </div>\n  </div>\n  <div class="buddylistloading"><i class="fa fa-circle-o-notch fa-spin"></i></div>\n  <div class="buddylistempty">{{_("No one else here")}}</div>\n</div>\n'}),define("directives/buddylist",["underscore","text!partials/buddylist.html"],function(e,t){return["buddyList","api","webrtc","contacts",function(n,i,o,a){var r=["$scope","$element","$attrs",function(t,r){t.layout.buddylist=!1,t.layout.buddylistAutoHide=!0;var s=!1,c=function(){s&&!t.peer?(t.layout.buddylist=!0,t.layout.buddylistAutoHide=!1):t.layout.buddylistAutoHide||(t.layout.buddylist=!1,t.layout.buddylistAutoHide=!0)};o.e.on("done",function(){t.$apply(c)}),t.$on("room.joined",function(){s=!0,c()}),t.$on("room.left",function(){s=!1,l.onClosed(),c()}),t.doCall=function(e){o.doCall(e)},t.doChat=function(e){t.$emit("startchat",e,{autofocus:!0,restore:!0})},t.doContactRequest=function(e){t.$emit("requestcontact",e,{restore:!0})},t.doContactRemove=function(e){a.remove(e)};var l=t.buddylist=n.buddylist(r,t,{}),d=e.bind(l.onJoined,l),u=e.bind(l.onLeft,l),p=e.bind(l.onStatus,l),f=e.bind(l.onContactAdded,l),h=e.bind(l.onContactRemoved,l),g=e.bind(l.onContactUpdated,l);i.e.on("received.userleftorjoined",function(e,t,n){"Left"===t?u(n):d(n)}),i.e.on("received.users",function(n,i){var o=t.id;e.each(i,function(e){e.Id!==o&&d(e)}),t.$apply()}),i.e.on("received.status",function(e,t){p(t)}),a.e.on("contactadded",function(e,t){f(t)}),a.e.on("contactremoved",function(e,t){h(t)}),a.e.on("contactupdated",function(e,t){g(t)})}],s=function(e,t){var n=t.parent();n.on("mouseenter mouseleave",function(t){"mouseenter"===t.type?e.layout.buddylist=!0:e.layout.buddylistAutoHide&&(e.layout.buddylist=!1),e.$apply()}),a.enabled&&t.addClass("with-contacts")};return{restrict:"E",replace:!0,scope:!0,template:t,controller:r,link:s}}]}),define("text!partials/buddypicturecapture.html",[],function(){return'<div class="buddyPictureCapture">\n	<img class="picture" ng-show="user.buddyPicture" ng-src="{{user.buddyPicture}}" alt="" width="46" height="46" />\n	<div class="collapse showTakePicture" collapse="!showTakePicture">\n		<div class="videoPicture">\n			<div class="videoPictureVideo">\n				<div class="videoFlash"></div>\n				<div class="countdownPicture" ng-show="countdown.num" ng-bind="countdown.num"></div>\n				<video ng-show="!previewPicture" autoplay="autoplay"></video>\n				<canvas class="videoPic hidden"></canvas>\n				<canvas class="videoPrev hidden"></canvas>\n				<img class="preview" ng-class="{previewPicture: previewPicture}" ng-show="previewPicture" ng-src="{{preview}}" alt="" />\n				<a class="btn btn-xs btn-success btn-takePicture" ng-disabled="countingDown || waitingForPermission" ng-show="!previewPicture && !countingDown" ng-click="takePictureCapture()"> {{_(\'Take\')}}</a>\n				<a class="btn btn-xs btn-success btn-retakePicture" ng-disabled="waitingForPermission" ng-show="previewPicture" ng-click="retakePictureCapture()"> {{_(\'Retake\')}}</a>\n			</div>\n		</div>\n		<div>\n			<a class="btn btn-small btn-default" ng-click="cancelPictureCapture()"> {{_(\'Cancel\')}}</a>\n			<a class="btn btn-small btn-primary" ng-disabled="!previewPicture || waitingForPermission" ng-click="usePictureCapture()"> {{_(\'Set as Profile Picture\')}}</a>\n		</div>\n	</div>\n	<buddy-picture-upload></buddy-picture-upload>\n	<a class="btn btn-small btn-primary" ng-show="!showTakePicture && !showUploadPicture" ng-disabled="waitingForPermission" ng-click="startPictureCapture()"> {{_(\'Take picture\')}}</a>\n	<a class="btn btn-small btn-default" ng-show="!showTakePicture && !showUploadPicture" ng-model="showUploadPicture" btn-checkbox>{{_(\'Upload picture\')}}</a>\n	<span ng-show="waitingForPermission">\n		<i class="fa fa-circle-o-notch fa-spin"></i> {{_(\'Waiting for camera\')}}\n	</span>\n</div>\n'}),define("directives/buddypicturecapture",["jquery","underscore","text!partials/buddypicturecapture.html"],function(e,t,n){return["$compile","$window",function(t,i){var o=["$scope","safeApply","$timeout","$q","mediaDevices","userMedia",function(e,t,n,o,a,r){e.captureSize={width:128,height:128},e.showTakePicture=!1,e.waitingForPermission=!1,e.previewPicture=!1,e.countingDown=!1,e.video=null,e.canvasPic=null,e.canvasPrev=null;var s=null,c=3e3,l=3,d=function(t,i){e.countingDown=!0,e.countdown={},e.countdown.num=t;for(var o=function(o){n(function(){e.countdown.num--,0===e.countdown.num&&(e.countingDown=!1)},i/t*o)},a=1;t>=a;a++)o(a)},u=function(t){var n=e.video.videoWidth,i=e.video.videoHeight,o=n/i;o||(console.warn("Unable to compute aspectRat§io",o),o=1.3333333333333333);var a=t.height,r=t.width,s=0,c=0;o>=1?(s=(r-r*o)/2,r*=o):(c=(a-a*(1/o))/2,a*=o),t.getContext("2d").drawImage(e.video,s,c,r,a)},p=function(){u(e.canvasPrev),e.preview=e.canvasPrev.toDataURL("image/jpeg")},f=function(t,i,o){d(i,o),n(function(){e.flash.addClass("flash"),n(function(){e.flash.removeClass("flash")},70),h(t,e.video),p(),e.previewPicture=!0},o)},h=function(e,t){e&&(t.pause(),r.stopUserMediaStream(e),e=null)},g=function(){e.waitingForPermission=!0;var n=!0,r=o.defer();return e.user.settings.cameraId&&(n={optional:[{sourceId:e.user.settings.cameraId}]}),a.getUserMedia({video:n}).then(function(n){e.showTakePicture=!0,s=n,e.waitingForPermission=!1,i.attachMediaStream(e.video,n),t(e),r.resolve(!0)}).catch(function(n){console.error("Failed to get access to local media. Error code was "+n.code),e.waitingForPermission=!1,t(e),r.resolve(!1)}),r.promise};e.startPictureCapture=function(){g(s)},e.cancelPictureCapture=function(){e.showTakePicture=!1,e.previewPicture=!1,h(s,e.video)},e.usePictureCapture=function(){u(e.canvasPic),e.save(),e.cancelPictureCapture()},e.retakePictureCapture=function(){var t=g(s);t.then(function(t){t&&(e.previewPicture=!1,f(s,l,c))})},e.takePictureCapture=function(){f(s,l,c)}}],a=function(t,n,i,o){t.video=n.find("video")[0],t.flash=n.find(".videoFlash"),t.canvasPic=n.find("canvas.videoPic")[0],t.canvasPrev=n.find("canvas.videoPrev")[0],e(t.canvasPic).attr(t.captureSize),t.save=function(){o.$setViewValue(t.canvasPic.toDataURL("image/jpeg"))}};return{scope:!0,restrict:"E",require:"ngModel",replace:!0,template:n,controller:o,link:a}}]}),define("text!partials/buddypictureupload.html",[],function(){return'<div class="buddyPictureUpload collapse" collapse="!showUploadPicture">\n	<div class="showUploadPicture" ng-class="{imgData: imgData}">\n		<span class="chooseUploadPicture">{{_(\'Picture\')}}</span>\n		<span class="loader" ng-if="upload.status !== 100 && upload.status !== 0">\n			<i class="fa fa-circle-o-notch fa-spin fa-2x"></i>\n		</span>\n		<div class="imageUtilites">\n			<div class="moveHorizontal">\n				<i class="fa fa-long-arrow-left"></i>\n				<i class="fa fa-long-arrow-right"></i>\n			</div>\n			<div class="moveVertical">\n				<i class="fa fa-long-arrow-up"></i>\n				<i class="fa fa-long-arrow-down"></i>\n			</div>\n			<div class="resize">\n				<i class="fa fa-plus"></i>\n				<i class="fa fa-minus"></i>\n			</div>\n		</div>\n		<img class="preview" ng-class="{previewUpload: previewUpload}" />\n	</div>\n	<div class="alert alert-warning" ng-if="error.read">{{_(\'The file couldn\\\'t be read.\')}}<button type="button" class="close" ng-click="error.read = null"><span>&times;</span></button></div>\n	<div class="alert alert-warning" ng-if="error.image">{{_(\'The file is not an image.\')}}<button type="button" class="close" ng-click="error.image = null"><span>&times;</span></button></div>\n	<div class="alert alert-warning" ng-if="error.size">{{_(\'The file is too large. Max. %d MB.\', maxUploadMb)}}<button type="button" class="close" ng-click="error.size = null"><span>&times;</span></button></div>\n	<p>\n		<input class="btn btn-success" bfi type="file" title="{{_(\'Select file\')}}" data-filename-placement="outside"/>\n	</p>\n	<p>\n		<a class="btn btn-small btn-default" ng-click="cancelPictureUpload()"> {{_(\'Cancel\')}}</a>\n		<a class="btn btn-small btn-primary" ng-click="usePictureUpload()" ng-disabled="!imgData"> {{_(\'Set as Profile Picture\')}}</a>\n	</p>\n</div>\n'}),define("directives/buddypictureupload",["jquery","underscore","text!partials/buddypictureupload.html"],function(e,t,n){return["$compile",function(){var t=function(e){var t=e.match(/[\-0-9]+/);return t=t?Number(t[0]):0},i=["$scope","safeApply","$timeout","$q","translation",function(n,i){var o=205,a=205;n.maxUploadMb=8;var r=1024*n.maxUploadMb*1024;n.showUploadPicture=!1,n.previewUpload=!1,n.imgData=null,n.error={read:null,image:null,size:null},n.upload={status:0},n.aspectRatio=1;var s=function(){n.upload.status=100},c=function(e){n.prevImage.onload=function(){this.style.cssText=null,n.aspectRatio=this.width/this.height;var e=l(this,{width:o,height:a});this.style.width=e.width+"px",this.style.height=e.height+"px",this.style.top="0px",this.style.left="0px",s(),i(n)},n.prevImage.src=e},l=function(e,t){if(!(e.width||e.height||t.width||t.height))return null;var n=null,i=null;return e.width<e.height?(i=t.width*(e.height/e.width),n=t.width):(i=t.height,n=t.height*(e.width/e.height)),{width:n,height:i}},d=function(e,n){if(!(e.style.width||e.style.height||n.width||n.height))return null;var i={width:t(e.style.width),height:t(e.style.height),top:t(e.style.top),left:t(e.style.left)},r=o/n.width,s=a/n.height,c=i.width/r,l=i.height/s,d=i.left/r,u=i.top/s;return i.width<o&&(d=(o-i.width)/r/2),i.height<a&&(u=(a-i.height)/s/2),{width:c,height:l,x:d,y:u}},u=function(e){var t=n.prevImage,i=d(t,e),o=e.getContext("2d");o.clearRect(0,0,e.width,e.height),o.drawImage(t,i.x,i.y,i.width,i.height)},p=function(){e(".file-input-name").empty(),n.imgData=null,n.prevImage.src="",n.prevImage.style.cssText=null,n.clearInput()};n.cancelPictureUpload=function(){n.showUploadPicture=!1,n.previewUpload=!1,p()},n.usePictureUpload=function(){u(n.canvasPic),n.save(),n.cancelPictureUpload()},n.handlePictureUpload=function(e){var t=e.target.files[0];if(t){var i=function(e){var t=e.loaded/e.total*100;100!==t&&n.$apply(function(){n.upload.status=t})},o=function(e){n.$apply(function(t){t.imgData=e.target.result,c(t.imgData),n.previewUpload=!0})},a=function(e){"NotReadableError"==e.target.error.name&&n.$apply(function(e){e.error.read=!0}),"NotImage"==e.target.error.name&&n.$apply(function(e){e.error.image=!0}),"Size"==e.target.error.name&&n.$apply(function(e){e.error.size=!0})};if(t.type.match(/image/))if(t.size>r)a({target:{error:{name:"Size"}}});else{n.$apply(function(){n.upload.status=5});var s=new FileReader;s.readAsDataURL(t),s.onprogress=i,s.onload=o,s.onerror=a}else a({target:{error:{name:"NotImage"}}})}}}],o=function(e,n){e.prevImage=n.find("img.preview")[0],e.clearInput=function(){n.find("input[type=file]")[0].value=""},n.find("input[type=file]").on("change",e.handlePictureUpload);var i={num:null},o=5,a=function(n){return t(n)/e.aspectRatio+"px"},r=function(e,n){return void 0===n&&(n=o),t(e)+n+"px"},s=function(e,n){return void 0===n&&(n=o),t(e)-n+"px"},c=function(t){e.prevImage.style.top=s(e.prevImage.style.top,t)},l=function(t){e.prevImage.style.top=r(e.prevImage.style.top,t)},d=function(t){e.prevImage.style.left=s(e.prevImage.style.left,t)},u=function(t){e.prevImage.style.left=r(e.prevImage.style.left,t)},p=function(){e.prevImage.style.width=r(e.prevImage.style.width),e.prevImage.style.height=a(e.prevImage.style.width),d(1),c(2)},f=function(){e.prevImage.style.width=s(e.prevImage.style.width),e.prevImage.style.height=a(e.prevImage.style.width),u(1),l(2)},h=function(e){e.data.intervalNum.num||!e.data.action?(clearInterval(e.data.intervalNum.num),e.data.intervalNum.num=null):e.data.intervalNum.num=setInterval(function(){e.data.action()},50)};n.find(".fa-long-arrow-up").on("mousedown",null,{intervalNum:i,action:l},h),n.find(".fa-long-arrow-down").on("mousedown",null,{intervalNum:i,action:c},h),n.find(".fa-long-arrow-up").on("mouseup",null,{intervalNum:i},h),n.find(".fa-long-arrow-down").on("mouseup",null,{intervalNum:i},h),n.find(".fa-long-arrow-left").on("mousedown",null,{intervalNum:i,action:d},h),n.find(".fa-long-arrow-right").on("mousedown",null,{intervalNum:i,action:u},h),n.find(".fa-long-arrow-left").on("mouseup",null,{intervalNum:i},h),n.find(".fa-long-arrow-right").on("mouseup",null,{intervalNum:i},h),n.find(".fa-plus").on("mousedown",null,{intervalNum:i,action:p},h),n.find(".fa-minus").on("mousedown",null,{intervalNum:i,action:f},h),n.find(".fa-plus").on("mouseup",null,{intervalNum:i},h),n.find(".fa-minus").on("mouseup",null,{intervalNum:i},h)};return{scope:!1,restrict:"E",require:"^buddyPictureCapture",replace:!0,template:n,controller:i,link:o}}]}),define("text!partials/settings.html",[],function(){return'<div>\n  <nav class="navbar navbar-default navbar-static-top">\n    <div class="container-fluid">\n      <div>\n        <a class="navbar-brand">{{_(\'Settings\')}}</a>\n      </div>\n      <div class="navbar-right">\n          <button ng-click="layout.settings=false" type="button" class="btn btn-primary navbar-btn">{{_(\'OK\')}}</button>\n      </div>\n    </div>\n  </nav>\n<div class="settings nicescroll">\n  <div class="version">{{version}}</div>\n  <div ng-form="settingsform" class="form-horizontal" on-enter="saveSettings(user)" on-escape="cancelSettings()"\n    <fieldset>\n\n      <settings-account ng-controller="UsersettingsController as usersettings">\n        <legend>{{_(\'Profile\')}}</legend>\n        <div class="form-group profile-yourname">\n          <label class="col-xs-4 control-label">{{_(\'Your name\')}}</label>\n          <div class="col-xs-8">\n            <input type="text" class="form-control" ng-model="user.displayName" placeholder="{{_(\'Name\')}}" />\n          </div>\n        </div>\n        <div class="form-group profile-yourpicture">\n          <label class="col-xs-4 control-label">{{_(\'Your picture\')}}</label>\n            <div class="col-xs-8">\n                <buddy-picture-capture ng-model="user.buddyPicture"></buddy-picture-capture>\n            </div>\n        </div>\n        <div class="form-group profile-statusmessage">\n          <label class="col-xs-4 control-label">{{_(\'Status message\')}}</label>\n          <div class="col-xs-8">\n            <input type="text" class="form-control" ng-model="user.message" placeholder="{{_(\'What\\\'s on your mind?\')}}" />\n          </div>\n        </div>\n        <div class="form-group profile-publicnotice">\n          <label class="col-xs-4 control-label"></label>\n          <div class="col-xs-8">\n            <p class="help-block">{{_(\'Your picture, name and status message identify yourself in calls, chats and rooms.\')}}</p>\n          </div>\n        </div>\n        <div ng-if="(withUsers && withUsersRegistration) || userid">\n          <div class="form-group profile-yourid">\n            <label class="col-xs-4 control-label">{{_(\'Your ID\')}}</label>\n            <div ng-switch="withUsersMode">\n              <form ng-switch-when="certificate" class="col-xs-8" target="users_registration_certificate_iframe">\n                <div ng-if="!userid">\n                  <keygen class="hidden" name="pubkey"/>\n                  <label ng-if="!userid && withUsersRegistration && usersettings.registerUserid">\n                    <button class="btn btn-small btn-primary" ng-click="usersettings.registerUserid($event)">{{_(\'Register\')}}</button>\n                  </label>\n                  <iframe class="hidden" name="users_registration_certificate_iframe"></iframe>\n                </div>\n                <div ng-if="userid">\n                  <p class="form-control-static well well-sm">{{userid|displayUserid}}</p>\n                  <p class-"help-block">{{_(\'Authenticated by certificate. To log out you have to remove your certificate from the browser.\')}}</p>\n                </div>\n              </form>\n              <div ng-switch-default class="col-xs-8">\n                <div ng-if="!userid && withUsersRegistration">\n                  <label ng-if="usersettings.loginUserid">\n                    <button class="btn btn-small btn-primary btn-sign-in" ng-click="usersettings.loginUserid()">{{_(\'Sign in\')}}</button>\n                  </label>\n                  <label ng-if="usersettings.registerUserid">\n                    <button class="btn btn-small btn-info btn-create-account" ng-click="usersettings.registerUserid($event)">{{_(\'Create an account\')}}</button>\n                  </label>\n                </div>\n                <p class="form-control-static well well-sm" ng-if="userid">{{userid|displayUserid}}</p>\n                <label ng-if="userid && withUsersForget && usersettings.forgetUserid">\n                  <button class="btn btn-small btn-default btn-sign-out" ng-click="usersettings.forgetUserid()">{{_(\'Sign out\')}}</button>\n                </label>\n                <label ng-if="userid && usersettings.accountUserid">\n                  <button class="btn btn-small btn-info btn-manage-account" ng-click="usersettings.accountUserid()">{{_(\'Manage account\')}}</button>\n                </label>\n              </div>\n            </div>\n          </div>\n        </div>\n      </settings-account>\n      <settings-media ng-show="mediaSources.supported || supported.constraints.audioVideo">\n        <legend>{{_(\'Media\')}}</legend>\n        <div ng-show="mediaSources.supported">\n          <div class="form-group">\n            <label class="col-xs-4 control-label">{{_(\'Microphone\')}}</label>\n            <div class="col-xs-8">\n              <select class="form-control" ng-model="user.settings.microphoneId" ng-options="mic.id as mic.label for mic in mediaSources.audio"></select>\n            </div>\n          </div>\n          <div class="form-group">\n            <label class="col-xs-4 control-label">{{_(\'Camera\')}}</label>\n            <div class="col-xs-8">\n              <select class="form-control" ng-model="user.settings.cameraId" ng-options="vid.id as vid.label for vid in mediaSources.video"></select>\n            </div>\n          </div>\n        </div>\n        <div ng-show="supported.constraints.audioVideo" class="form-group">\n          <label class="col-xs-4 control-label">{{_(\'Video quality\')}}</label>\n          <div class="col-xs-8">\n            <div class="btn-group">\n              <button type="button" class="btn btn-default" ng-model="user.settings.videoQuality" btn-radio="\'low\'">{{_(\'Low\')}}</button>\n              <button type="button" class="btn btn-default" ng-model="user.settings.videoQuality" btn-radio="\'high\'">{{_(\'High\')}}</button>\n              <button ng-if="supported.constraints.hdVideo" type="button" class="btn btn-default" ng-model="user.settings.videoQuality" btn-radio="\'hd\'">{{_(\'HD\')}}</button>\n              <button ng-if="supported.constraints.hdVideo" type="button" class="btn btn-default" ng-model="user.settings.videoQuality" btn-radio="\'fullhd\'">{{_(\'Full HD\')}}</button>\n            </div>\n          </div>\n        </div>\n      </settings-media>\n      <settings-settings>\n        <legend>{{_(\'General\')}}</legend>\n        <div class="form-group">\n          <label class="col-xs-4 control-label">{{_(\'Language\')}}</label>\n          <div class="col-xs-8">\n            <select class="form-control" ng-model="user.settings.language" ng-options="l.code as l.name for l in availableLanguages | orderBy:\'code\'"></select>\n            <span class="help-block">{{_(\'Language changes become active on reload.\')}}</span>\n          </div>\n        </div>\n        <div class="form-group">\n          <label class="col-xs-4 control-label">{{_(\'Default room\')}}</label>\n          <div class="col-xs-8">\n            <input type="text" class="form-control" ng-model="user.settings.defaultRoom" placeholder="{{_(\'Main\')}}" />\n            <span class="help-block">{{_(\'Set alternative room to join at start.\')}}</span>\n          </div>\n        </div>\n        <legend>{{_(\'Notifications\')}}</legend>\n        <div class="form-group" ng-show="desktopNotify.supported">\n          <label class="col-xs-4 control-label">{{_(\'Desktop notification\')}}</label>\n          <div class="col-xs-8">\n            <span ng-switch="desktopNotify.level">\n              <a ng-switch-when="default" class="btn btn-small btn-success" ng-click="requestDesktopNotifyPermission()">{{_(\'Enable\')}}</a>\n              <p class="form-control-static text-error" ng-switch-when="denied"><i class="fa fa-exclamation-triangle"></i>{{_(\'Denied - check your browser settings\')}}</p>\n              <p class="form-control-static text-success" ng-switch-when="granted"><i class="fa fa-ok"></i>{{_(\'Allowed\')}}</p>\n            </span>\n          </div>\n        </div>\n        <div class="form-group">\n          <label class="col-xs-4 control-label"><input type="checkbox" ng-model="user.settings.sound.incomingMessages"/></label>\n          <div class="col-xs-8">\n            <div class="form-control-static">{{_(\'Sounds for incoming messages\')}}</div>\n          </div>\n        </div>\n        <div class="form-group">\n          <label class="col-xs-4 control-label"><input type="checkbox" ng-model="user.settings.sound.incomingCall"/></label>\n          <div class="col-xs-8">\n            <div class="form-control-static">{{_(\'Ring on incoming calls\')}}</div>\n          </div>\n        </div>\n        <div class="form-group">\n          <label class="col-xs-4 control-label"><input type="checkbox" ng-model="user.settings.sound.roomJoinLeave"/></label>\n          <div class="col-xs-8">\n            <div class="form-control-static">{{_(\'Sounds for users in current room\')}}</div>\n          </div>\n        </div>\n      </settings-settings>\n\n      <settings-extra settings-extra></settings-extra>\n\n      <settings-advanced class="collapse" collapse="showAdvancedSettings">\n\n        <legend>{{_(\'Advanced settings\')}}</legend>\n\n        <div>\n\n          <div class="form-group" ng-show="supported.constraints.renderToAssociatedSink">\n            <label class="col-xs-4 control-label">{{_(\'Play audio on same device as selected microphone\')}}</label>\n            <div class="col-xs-8">\n              <div class="checkbox">\n               <label>\n                  <input type="checkbox" ng-model="user.settings.audioRenderToAssociatedSkin"/>&nbsp;\n               </label>\n              </div>\n            </div>\n          </div>\n\n          <div ng-show="user.settings.experimental.enabled">\n\n            <div class="form-group" ng-show="supported.constraints.chrome">\n              <label class="col-xs-4 control-label">{{_(\'Experimental AEC\')}}</label>\n              <div class="col-xs-8">\n                <div class="checkbox">\n                 <label>\n                    <input type="checkbox" ng-model="user.settings.experimental.audioEchoCancellation2"/>&nbsp;\n                 </label>\n                </div>\n              </div>\n            </div>\n\n            <div class="form-group" ng-show="supported.constraints.chrome">\n              <label class="col-xs-4 control-label">{{_(\'Experimental AGC\')}}</label>\n              <div class="col-xs-8">\n                <div class="checkbox">\n                 <label>\n                    <input type="checkbox" ng-model="user.settings.experimental.audioAutoGainControl2"/>&nbsp;\n                 </label>\n                </div>\n              </div>\n            </div>\n\n            <div class="form-group" ng-show="supported.constraints.chrome">\n              <label class="col-xs-4 control-label">{{_(\'Experimental noise suppression\')}}</label>\n              <div class="col-xs-8">\n                <div class="checkbox">\n                 <label>\n                    <input type="checkbox" ng-model="user.settings.experimental.audioNoiseSuppression2"/>&nbsp;\n                 </label>\n                </div>\n              </div>\n            </div>\n\n          </div>\n\n          <div class="form-group" ng-show="supported.constraints.audioVideo">\n            <label class="col-xs-4 control-label">{{_(\'Max video frame rate\')}}</label>\n            <div class="col-xs-8">\n              <div class="btn-group">\n                <button type="button" class="btn btn-default" ng-model="user.settings.maxFrameRate" btn-radio="8">8</button>\n                <button type="button" class="btn btn-default" ng-model="user.settings.maxFrameRate" btn-radio="12">12</button>\n                <button type="button" class="btn btn-default" ng-model="user.settings.maxFrameRate" btn-radio="20">20</button>\n                <button type="button" class="btn btn-default" ng-model="user.settings.maxFrameRate" btn-radio="30">30</button>\n                <button type="button" class="btn btn-default" ng-model="user.settings.maxFrameRate" btn-radio="\'auto\'">{{_(\'auto\')}}</button>\n              </div>\n            </div>\n          </div>\n\n          <div class="form-group" ng-show="supported.constraints.chrome">\n            <label class="col-xs-4 control-label">{{_(\'Send stereo audio\')}}</label>\n            <div class="col-xs-8">\n              <div class="checkbox">\n               <label>\n                  <input type="checkbox" ng-model="user.settings.sendStereo"/>&nbsp;\n               </label>\n              </div>\n              <span class="help-block">{{_(\'Sending stereo audio disables echo cancellation. Enable only if you have stereo input.\')}}</span>\n            </div>\n          </div>\n\n          <div class="form-group" ng-show="supported.constraints.chrome">\n            <label class="col-xs-4 control-label">{{_(\'Detect CPU over use\')}}</label>\n            <div class="col-xs-8">\n              <div class="checkbox">\n               <label>\n                  <input type="checkbox" ng-model="user.settings.videoCpuOveruseDetection"/>&nbsp;\n               </label>\n               <span class="help-block">{{_(\'Automatically reduces video quality as needed.\')}}</span>\n              </div>\n            </div>\n          </div>\n\n          <div ng-show="user.settings.experimental.enabled">\n\n            <div class="form-group" ng-show="supported.constraints.chrome">\n              <label class="col-xs-4 control-label">{{_(\'Optimize for high resolution video\')}}</label>\n              <div class="col-xs-8">\n                <div class="checkbox">\n                 <label>\n                    <input type="checkbox" ng-model="user.settings.experimental.videoLeakyBucket"/>&nbsp;\n                 </label>\n                </div>\n              </div>\n            </div>\n\n            <div class="form-group" ng-show="supported.constraints.chrome">\n              <label class="col-xs-4 control-label">{{_(\'Reduce video noise\')}}</label>\n              <div class="col-xs-8">\n                <div class="checkbox">\n                 <label>\n                    <input type="checkbox" ng-model="user.settings.experimental.videoNoiseReduction"/>&nbsp;\n                 </label>\n                </div>\n              </div>\n            </div>\n\n          </div>\n\n          <div class="form-group" ng-show="supported.constraints.chrome">\n            <label class="col-xs-4 control-label">{{_(\'Enable experiments\')}}</label>\n            <div class="col-xs-8">\n              <div class="checkbox">\n               <label>\n                  <input type="checkbox" ng-model="user.settings.experimental.enabled"/>&nbsp;\n               </label>\n              </div>\n            </div>\n          </div>\n\n        </div>\n\n        <settings-advanced-extra settings-advanced-extra></settings-advanced-extra>\n\n      </settings-advanced>\n\n      <hr/>\n\n      <div class="form-group">\n        <div class="col-xs-4 control-label"></div>\n        <div class="col-xs-8">\n          <a ng-click="showAdvancedSettings = !showAdvancedSettings"><span ng-show="showAdvancedSettings">{{_(\'Show advanced settings\')}}</span><span ng-hide="showAdvancedSettings">{{_(\'Hide advanced settings\')}}</span></a>\n        </div>\n      </div>\n\n      <hr/>\n\n      <div class="form-group">\n        <div class="col-xs-8 col-xs-offset-4">\n          <div class="checkbox">\n            <label>\n               <input type="checkbox" ng-model="rememberSettings"> {{_(\'Remember settings\')}}\n            </label>\n            <p class="text-warning" ng-show="userid &&!rememberSettings && loadedUserlogin"><strong>{{_(\'Your ID will still be kept - press the log out button above to delete the ID.\')}}</strong></p>\n          </div>\n        </div>\n      </div>\n\n    </fieldset>\n  </div>\n</div>\n</div>'}),define("directives/settings",["jquery","underscore","text!partials/settings.html"],function(e,t,n){var i={tiny:{maxWidth:80,maxHeight:45},low:{maxWidth:320,maxHeight:180},high:{maxWidth:640,maxHeight:360},hd:{minWidth:1280,minHeight:720,mandatory:{minWidth:640,minHeight:360}},fullhd:{minWidth:1920,minHeight:1080,mandatory:{minWidth:1080,minHeight:720}}};return["$compile","mediaStream",function(o,a){var r=["$scope","desktopNotify","mediaSources","safeApply","availableLanguages","translation","localStorage","userSettingsData","constraints","appData","$timeout",function(n,o,r,s,c,l,d,u,p,f,h){n.layout.settings=!1,n.showAdvancedSettings=!0,n.autoshowSettings=!0,n.rememberSettings=!0,n.desktopNotify=o,n.mediaSources=r,n.availableLanguages=[{code:"",name:l._("Use browser language")}],n.withUsers=a.config.UsersEnabled,n.withUsersRegistration=a.config.UsersAllowRegistration,n.withUsersMode=a.config.UsersMode,t.each(c,function(e,t){n.availableLanguages.push({code:t,name:e})}),e(window).on("unload",function(){n.layout.settings&&n.saveSettings()}),n.saveSettings=function(){var e=n.settingsform;if(e.$valid&&e.$dirty){var t=n.user;n.update(t),n.rememberSettings?(u.save(t),d.setItem("mediastream-language",t.settings.language||"")):(u.clear(),d.removeItem("mediastream-language"),d.removeItem("mediastream-access-code")),e.$setPristine()}n.layout.settings=!1},n.cancelSettings=function(){var e=n.settingsform;n.reset(),e.$dirty&&e.$setPristine(),n.layout.settings=!1},n.requestDesktopNotifyPermission=function(){n.desktopNotify.requestPermission(function(){s(n)})},n.checkDefaultMediaSources=function(){n.master.settings.microphoneId&&!n.mediaSources.hasAudioId(n.master.settings.microphoneId)&&(n.master.settings.microphoneId=null),n.master.settings.cameraId&&!n.mediaSources.hasVideoId(n.master.settings.cameraId)&&(n.master.settings.cameraId=null)},n.$watch("layout.settings",function(e,t){e?(n.desktopNotify.refresh(),n.mediaSources.refresh(function(e,t){s(n,function(){n.user.settings.microphoneId&&!n.mediaSources.hasAudioId(n.user.settings.microphoneId)&&(n.user.settings.microphoneId=null),n.user.settings.cameraId&&!n.mediaSources.hasVideoId(n.user.settings.cameraId)&&(n.user.settings.cameraId=null),!n.user.settings.microphoneId&&e.length>0&&(n.user.settings.microphoneId=e[0].id),!n.user.settings.cameraId&&t.length>0&&(n.user.settings.cameraId=t[0].id)}),n.refreshWebrtcSettings()})):!e&&t&&n.saveSettings()}),n.maybeShowSettings=function(){n.autoshowSettings&&a.connector.connected&&!f.authorizing()&&(n.autoshowSettings=!1,n.loadedUser||(n.layout.settings=!0))},n.$on("room.joined",function(){h(n.maybeShowSettings)}),f.e.on("authenticationChanged",function(){n.autoshowSettings=!0,h(n.maybeShowSettings)}),p.e.on("refresh",function(e,o){var a=n.master.settings;if(function(){var e=o.defer();r.refresh(function(){n.checkDefaultMediaSources(),a.microphoneId&&o.add("audio","sourceId",a.microphoneId),a.cameraId&&o.add("video","sourceId",a.cameraId),r.hasAudio()||(o.disable("audio"),console.info("Disabled audio input as no audio source was found.")),r.hasVideo()||(o.disable("video"),console.info("Disabled video input as no video source was found.")),e.resolve("complete")
})}(),p.supported.chrome&&(o.add("pc","googCpuOveruseDetection",a.videoCpuOveruseDetection&&!0),a.experimental.enabled&&(o.add("audio","googEchoCancellation",!0),o.add("audio","googEchoCancellation2",a.experimental.audioEchoCancellation2&&!0),o.add("audio","googAutoGainControl",!0),o.add("audio","googAutoGainControl2",a.experimental.audioAutoGainControl2&&!0),o.add("audio","googNoiseSuppression",!0),o.add("audio","googNoiseSuppression2",a.experimental.audioNoiseSuppression2&&!0),o.add("audio","googHighpassFilter",!0),o.add("audio","googTypingNoiseDetection",a.experimental.audioTypingNoiseDetection&&!0)),p.supported.renderToAssociatedSink&&(o.add("audio","googDucking",!0),o.add("audio","chromeRenderToAssociatedSink",a.audioRenderToAssociatedSkin&&!0)),a.experimental.enabled&&(o.add(["video","screensharing"],"googLeakyBucket",a.experimental.videoLeakyBucket&&!0),o.add(["video","screensharing"],"googNoiseReduction",a.experimental.videoNoiseReduction&&!0))),p.supported.audioVideo){var s=i[a.videoQuality];if(s){var c=s.mandatory;t.forEach(s,function(e,t){"mandatory"!==t&&o.add("video",t,e,c?!1:!0)}),c&&t.forEach(c,function(e,t){o.add("video",t,e,!0)})}a.maxFrameRate&&"auto"!=a.maxFrameRate&&o.add("video","maxFrameRate",parseInt(a.maxFrameRate,10),!0),a.sendStereo&&o.add("audio","echoCancellation",!1)}})}];return{scope:!0,restrict:"E",replace:!0,template:n,controller:r}}]}),define("text!partials/chat.html",[],function(){return'<div class="chatcontainer" ng-class="{showchatlist: !currentRoomActive && layout.chat}">\n	<div class="chatpane"></div>\n	<div class="chatlist">\n		<div class="chat visible active">\n			<div class="chatheader"><div class="chatstatusicon" ng-click="activateRoom(currentRoom.id, true)"><i class="fa fa-angle-right"></i> <i class="fa fa fa-comments-o"></i></div><div class="chatheadertitle"><span>{{_("Chat sessions")}}</span></div> <div class="ctrl"><i ng-show="layout.chatMaximized" ng-click="toggleMax()" class="fa fa-compress"></i></div></div>\n			<div class="chatbody">\n				<div class="list-group nicescroll">\n					<a ng-repeat="room in getVisibleRooms()" ng-click="activateRoom(room.id, true)" class="list-group-item" ng-class="{newmessage: room.pending, disabled: !room.enabled}">\n						<span class="badge" ng-show="room.pending">{{room.pending}}</span>\n                        <span ng-if="room.id !== \'\'">{{room.id|displayName}}</span>\n                        <span ng-if="room.id === \'\'">{{_("Room chat")}} {{currentRoomName}}</span>\n						<button ng-if="room.id !== \'\'" class="btn btn-sm btn-default" ng-click="hideRoom(room.id)">\n							<i class="fa fa-trash-o"></i>\n						</button>\n					</a>\n				</div>\n			</div>\n		</div>\n	</div>\n</div>\n'}),define("text!partials/chatroom.html",[],function(){return'<div ng-controller="ChatroomController" class="chat room-{{index}}" ng-class="{\'newmessage\': newmessage, \'visible\': visible, \'chat-p2p\': \'p2pstate\', \'with_pictures\': isgroupchat, \'active\': active}">\n    <div class="chatheader"><div class="chatstatusicon" ng-click="deactivateRoom()"><i class="fa fa-angle-left"></i> <i class="fa fa fa-comments-o"></i></div><div class="chatheadertitle"><span ng-show="p2pstate" class="fa fa-exchange" title="{{_(\'Peer to peer\')}}"/><span>{{settings.title}} {{id|displayName}}</span></div> <div class="ctrl"><i ng-hide="layout.chatMaximized" ng-click="toggleMax()" class="fa fa-expand"></i><i ng-show="layout.chatMaximized" ng-click="toggleMax()" class="fa fa-compress"></i><!--<i title="{{_(\'Close chat\')}}" ng-click="hide()" class="fa fa-times"></i>--></div></div>\n    <div class="chatmenu">\n        <div class="btn-group">\n            <button ng-if="!isgroupchat" class="btn btn-sm btn-default" title="{{_(\'Start video call\')}}" ng-click="doCall()"><i class="fa fa-phone fa-fw"></i></button>\n            <button class="btn btn-sm btn-default btn-fileupload" title="{{_(\'Upload files\')}}"><i class="fa fa-upload fa-fw"></i></button>\n            <button class="btn btn-sm btn-default btn-locationshare" title="{{_(\'Share my location\')}}" ng-click="shareGeolocation()"><i class="fa fa-location-arrow fa-fw"></i></button>\n        </div>\n        <div class="btn-group pull-right">\n            <button class="btn btn-sm btn-default" title="{{_(\'Clear chat\')}}" ng-click="doClear()"><i class="fa fa-eraser fa-fw"></i></button>\n        </div>\n    </div>\n    <div class="chatbody">\n        <div class="outputbox">\n            <div class="output nicescroll"></div>\n        </div>\n        <div class="chatbodybottom">\n            <div class="typinghint" ng-switch on="peerIsTyping">\n                <span ng-switch-when="start"><i class="fa fa-pencil"></i> {{id|displayName}} {{_(\'is typing...\')}}</span>\n                <span ng-switch-when="stop"><i class="fa fa-pencil"></i> {{id|displayName}} {{_(\'has stopped typing...\')}}</span>\n            </div>\n            <div class="inputbox">\n                <div>\n                    <textarea class="input nicescroll form-control" maxlength="{{maxMessageSize}}" ng-disabled="!(enabled)" on-enter="submit()" ng-model="input" placeholder="{{_(\'Type here to chat...\')}}"/>\n                </div>\n                <a ng-disabled="!(enabled)" ng-click="submit()" title="{{_(\'Send\')}}" class="btn btn-small btn-info fa fa-play"></a>\n            </div>\n        </div>\n    </div>\n</div>\n'}),define("directives/chat",["jquery","underscore","text!partials/chat.html","text!partials/chatroom.html"],function(e,t,n,i){return["$compile","safeDisplayName","mediaStream","safeApply","desktopNotify","translation","playSound","fileUpload","randomGen","buddyData","appData","$timeout","geolocation",function(o,a,r,s,c,l,d,u,p,f,h,g,m){var v=a,b="",y=2e5,w=["$scope","$element","$attrs",function(e){e.layout.chat=!1,e.layout.chatMaximized=!1;var n=this,i=n.rooms={};n.visibleRooms=[],n.group=b,n.get=function(e){return n.rooms[e]},e.currentRoom=null,e.currentRoomActive=!1,e.maxMessageSize=y,e.getVisibleRooms=function(){for(var e=[],t=0;t<n.visibleRooms.length;t++){var o=i[n.visibleRooms[t]];o&&e.push(o)}return e},r.api.e.on("received.chat",function(t,o,a,c,l){var d=o;if(d===r.api.id)d=a;else if(d!==n.group&&a!==r.api.id)return void console.log("Received chat message for invalid room",d,o,a);var u=!!c.Message,p=i[d];if(!p){if(!u)return;e.$emit("startchat",a,{restore:u}),p=i[a]}u&&a!==r.api.id&&(p.newmessage=!0,p.peerIsTyping="no",p.p2p(!!l),p.firstmessage&&e.showRoom(p.id,null,{restore:u}),p.enabled||(p.enabled=!0)),s(p),p.$broadcast("received",a,c)}),r.api.e.on("received.userleftorjoined",function(e,n,o){var a=i[o.Id];if(a)switch(n){case"Left":"soft"!==o.Status&&(a.enabled=!1,s(a));break;case"Joined":a.enabled||(a.enabled=!0,t.delay(function(){s(a)},1e3))}}),e.$parent.$on("startchat",function(t,n,i){n===b?e.showGroupRoom(null,i):e.showRoom(n,{title:l._("Chat with")},i)}),e.$parent.$on("requestcontact",function(t,n,i){if(n!==b){var o=h.get();if(!o.userid)return void console.log("You need to log in to add contacts.");var a=f.get(n);if(!a||!a.session||!a.session.Userid||o.userid===a.session.Userid)return void console.log("This contact cannot be added.");var r=e.showRoom(n,{title:l._("Chat with")},i);r.sendChatServer(n,"Contact request",{ContactRequest:{Id:p.random({hex:!0})}})}})}],k=function(){var n=o(i);return function(i,o,a,b){var w=o.find(".chatpane");i.showGroupRoom=function(t,n){var o=e.extend({title:l._("Room chat"),group:!0},t);return i.showRoom(b.group,o,n)},i.hideGroupRoom=function(){return i.hideRoom(b.group)},i.showRoom=function(o,a,g){var k=e.extend({},g),x=b.rooms[o],$=b.visibleRooms.length;return x?(k.restore&&(x.visible||(b.visibleRooms.push(o),x.index=$,x.visible=!0),x.enabled||(x.enabled=!0)),k.autofocus&&x.visible&&x.$broadcast("focus")):(console.log("Create new chatroom",[o]),a.group?b.visibleRooms.unshift(o):b.visibleRooms.push(o),x=b.rooms[o]=i.$new(),l.inject(x),x.id=o,x.isgroupchat=!!a.group,x.index=$,x.settings=a,x.visible=!1,x.newmessage=!1,x.enabled=!0,x.peerIsTyping="no",x.firstmessage=!0,x.p2pstate=!1,x.active=!1,x.pending=0,x.isgroupchat||f.push(o),x.hide=function(){i.hideRoom(o)},x.kill=function(){x.isgroupchat||f.pop(o),i.killRoom(o)},x.seen=function(){x.pending=0,i.$emit("chatseen",x.id),x.newmessage&&(x.newmessage=!1,x.$broadcast("seen"))},x.deactivate=function(){i.deactivateRoom()},x.toggleMax=function(){i.toggleMax()},x.sendChat=function(e,t,n,i,o){if(t&&t.length>y)return i;var a=r.webrtc.findTargetCall(e);return a&&a.peerconnection&&a.peerconnection.datachannelReady?(x.p2p(!0),x.sendChatPeer2Peer(a,e,t,n,i,o)):(x.p2p(!1),x.sendChatServer(e,t,n,i,o))},x.sendChatPeer2Peer=function(e,n,i,o,a,s){return i&&!a&&(a=p.random({hex:!0})),t.delay(function(){r.api.apply("sendChat",{send:function(t,n){return s||r.api.received({Type:n.Type,Data:n,From:r.api.id,To:e.id}),e.peerconnection.send(n)}})(n,i,o,a)},100),a},x.sendChatServer=function(e,n,i,o,a){return n&&!o&&(o=p.random({hex:!0})),t.delay(function(){r.api.send2("sendChat",function(t,n){a||r.api.received({Type:n.Type,Data:n,From:r.api.id,To:e})})(e,n,i,o)},100),o},x.p2p=function(e){e!==x.p2pstate&&(x.p2pstate=e,x.$broadcast("p2p",e))},x.doCall=function(){r.webrtc.doCall(x.id)},x.shareGeolocation=function(){m.getCurrentPosition(function(e){var t={accuracy:e.coords.accuracy||null,latitude:e.coords.latitude||null,longitude:e.coords.longitude||null,altitude:e.coords.altitude||null,altitudeAccuracy:e.coords.altitudeAccuracy||null};console.log("Sending geo location",t,e),x.sendChat(x.id,"Geolocation",{Geolocation:t})},function(e){console.error("Failed to receive geolocation",e)})},x.doClear=function(){x.$broadcast("clear")},x.$on("submit",function(e,t){x.seen();var n=x.sendChat(e.targetScope.id,t);e.targetScope.$broadcast("received",null,{Type:"Message",Status:{State:"sent",Mid:n}})}),x.$on("submitseen",function(e,t){x.sendChat(e.targetScope.id,null,{SeenMids:t},null,!0)}),x.$on("submitreceived",function(e,t){x.sendChat(e.targetScope.id,null,{State:"delivered",Mid:t},null,!0)}),x.$on("typing",function(e,t){if("local"===t.who){{e.targetScope.id}x.seen(),x.isgroupchat||x.sendChat(e.targetScope.id,null,{Typing:t.status})}else x.peerIsTyping=t.status;s(x)}),x.$on("incoming",function(e,t,n,o){if(n!==o&&(x.pending++,i.$emit("chatincoming",x.id)),x.firstmessage||!c.windowHasFocus){{e.targetScope.id}x.isgroupchat||n===o||(d.play("chatmessage"),c.notify(l._("Message from ")+v(n),t),h.e.triggerHandler("uiNotification",["chatmessage",{from:n,message:t,first:x.firstmessage}])),x.firstmessage=!1}else x.isgroupchat||n===o||h.e.triggerHandler("uiNotification",["chatmessage",{from:n,message:t,first:x.firstmessage}])}),x.$watch("enabled",function(e,t){if(e!==t){var n;n=e?"resumed":"left",x.$broadcast("received",x.id,{Type:"LeftOrJoined",LeftOrJoined:n})}}),n(x,function(n,o){w.append(n),o.element=n,o.visible=!0,k.autofocus&&t.defer(function(){o.$broadcast("focus")});var a=function(n){t.each(n,function(t){var n=e.extend({id:t.id},t.info);console.log("Advertising file",t,n),o.sendChat(x.id,"File",{FileInfo:n})})},r="file_"+i.id,s=u.bindDrop(r,n,t.bind(function(e){console.log("File dragged",e),a(e)},this)),c=u.bindClick(r,e(".btn-fileupload",n),t.bind(function(e){console.log("Click found files",e),a(e)},this));s.namespace=c.namespace=function(){return r+"_"+i.myid}})),k.noactivate||i.activateRoom(x.id,!0),k.restore&&!k.noenable&&(i.layout.chat||(i.layout.chat=!0)),s(x),x},i.hideRoom=function(e){var n=b.rooms[e];if(!n)return void console.log("hideRoom called for unknown room",e);var o=(n.element,n.index);b.visibleRooms.splice(o,1),n.visible=!1,n.firstmessage=!0,t.each(b.visibleRooms,function(e,t){var n=b.rooms[e];n.index=t}),i.currentRoom===n&&(i.currentRoom=null,i.currentRoomActive=!1),b.visibleRooms.length||(i.layout.chat=!1)},i.killRoom=function(e){i.hideRoom(e);var t=b.rooms[e];t&&(delete b.rooms[e],g(function(){t.$destroy()},0))},i.toggleMax=function(){i.layout.chatMaximized=!i.layout.chatMaximized},i.activateRoom=function(e,t){var n=b.rooms[e];if(n){var o=!!i.layout.chat,a=!1;i.currentRoom==n?(n.active=t,i.currentRoomActive=!0,o&&(a=!0)):(i.currentRoom&&(i.currentRoom.active=!1,o&&(a=!0)),t&&(i.currentRoom=n,i.currentRoomActive=!0),n.active=t),a&&w.toggleClass("flip")}},i.deactivateRoom=function(){i.currentRoomActive=!1},i.$watch("layout.chat",function(e){e||w.removeClass("flip"),i.layout.chatMaximized=!1}),i.$on("room.updated",function(t,n){var o=i.showGroupRoom(null,{restore:!0,noenable:!0,noactivate:!0});if(i.currentRoomName!=n.Name){var a=e("<span>").text(l._("You are now in room %s ...",n.Name));o.$broadcast("display",null,e("<i>").append(a)),i.currentRoomName=n.Name}}),i.$on("room.left",function(){i.hideGroupRoom(),i.currentRoomName=null})}};return{restrict:"E",replace:!0,scope:!0,template:n,controller:w,compile:k}}]}),define("text!partials/audiovideo.html",[],function(){return'<div class="audiovideo" ng-class="{\'cameraMute\': cameraMute, \'microphoneMute\': microphoneMute}">\n  <div class="audiovideoBase">\n    <div class="localContainer">\n      <div class="localVideos">\n        <video class="localVideo" autoplay="autoplay" muted="true"></video>\n        <div class="onlyaudio"><i class="fa fa-eye-slash"></i></div>\n        <div class="overlayLogo"></div>\n      </div>\n    </div>\n    <div class="remoteContainer">\n      <div class="remoteVideos nicescroll"></div>\n      <div class="miniContainer" ng-class="{talking: talking}">\n        <video class="miniVideo" autoplay="autoplay" muted="true"></video>\n        <div class="onlyaudio"><i class="fa fa-eye-slash"></i></div>\n      </div>\n    </div>\n  </div>\n  <div class="overlayActions">\n    <button class="btn btn-link renderer-democrazy" title="{{_(\'Standard view\')}}" ng-click="setRenderer(\'democrazy\')"><i class="fa fa-table"></i></button>\n    <button class="btn btn-link renderer-onepeople" title="{{_(\'Large view\')}}" ng-click="setRenderer(\'onepeople\')"><i class="fa fa-plus-square" ></i></button>\n    <button class="btn btn-link renderer-conferencekiosk" title="{{_(\'Kiosk view\')}}" ng-click="setRenderer(\'conferencekiosk\')"><i class="fa fa-user"></i></button>\n    <button class="btn btn-link renderer-auditorium" title="{{_(\'Auditorium\')}}" ng-click="setRenderer(\'auditorium\')"><i class="fa fa-male"></i><span class="fa"></span></button>\n  </div>\n</div>'}),define("text!partials/audiovideopeer.html",[],function(){return'<div class="remoteVideo" ng-class="{\'dummy\': dummy, \'withvideo\': withvideo, \'onlyaudioVideo\': onlyaudio, \'talking\': peersTalking[peerid]}">\n	<video autoplay="autoplay"></video>\n	<div class="peerLabel">{{peerid|displayName}}</div>\n	<div class="peerActions">\n		<a title="{{_(\'Start chat\')}}" ng-click="doChat()" class="btn btn-default"><i class="fa fa-comments-o"></i></a>\n	</div>\n	<div class="onlyaudio"><i class="fa fa-eye-slash"></i></div>\n	<div class="overlayLogo"></div>\n</div>'}),define("directives/audiovideo",["jquery","underscore","text!partials/audiovideo.html","text!partials/audiovideopeer.html","bigscreen","webrtc.adapter"],function(e,t,n,i,o){return["$window","$compile","$filter","mediaStream","safeApply","desktopNotify","buddyData","videoWaiter","videoLayout","animationFrame","$timeout","dummyStream",function(a,r,s,c,l,d,u,p,f,h,g,m){var v=r(i),b=["$scope","$element","$attrs",function(n,i){var r={},s={},d=function(e,t){var n=t.id+"-"+e.id;return n};return n.container=i[0],n.layoutparent=i.parent(),n.remoteVideos=i.find(".remoteVideos")[0],n.localVideos=i.find(".localVideos")[0],n.localVideo=i.find(".localVideo")[0],n.miniVideo=i.find(".miniVideo")[0],n.mini=i.find(".miniContainer")[0],n.hasUsermedia=!1,n.isActive=!1,n.haveStreams=!1,n.peersTalking={},n.rendererName=n.defaultRendererName="democrazy",n.addRemoteStream=function(t,i){var o=d(t,i);if(console.log("New stream",o),r.hasOwnProperty(o))return void console.warn("Cowardly refusing to add stream id twice",o);var c,f;if(s.hasOwnProperty(i.id)){if(m.is(t))return;if(c=s[i.id],c.dummy){var h=d(c.dummy,i);return f=r[h],void(f?(f.dummy=null,delete r[h],r[o]=f,l(f,function(e){console.log("Replacing dummy with stream",o),e.attachStream(t)})):console.warn("Scope marked as dummy but target stream not found",h))}}else c=n.$new(),s[i.id]=c,c.streams=0,console.log("Created call scope",o);f=c.$new(),c.streams++;var b=f.peerid=i.id;u.push(b),f.unattached=!0,f.withvideo=!1,f.onlyaudio=!1,f.destroyed=!1,f.$on("active",function(){console.log("Stream scope is now active",o,b)}),f.$on("$destroy",function(){f.destroyed||(console.log("Destroyed scope for stream",o,b),f.destroyed=!0,c.streams--,c.streams<1&&(c.$destroy(),delete s[b],console.log("Destroyed scope for call",b,o)))}),console.log("Created stream scope",o),m.is(t)&&(c.dummy=t),r[o]=f,v(f,function(o,r){o.data("peerid",r.peerid),r.element=o,r.attachStream=function(e){if(m.is(e))return r.withvideo=!1,r.onlyaudio=!0,void g(function(){r.$emit("active",i),n.redraw()});var t=o.find("video")[0];a.attachMediaStream(t,e),p.wait(t,e,function(e){return r.destroyed?void console.log("Abort wait for video on destroyed scope."):(e?r.$apply(function(e){e.withvideo=!0,e.onlyaudio=!1}):(console.info("Incoming stream has no video tracks."),r.$apply(function(e){e.withvideo=!1,e.onlyaudio=!0})),r.$emit("active",i),void n.redraw())},function(){return r.destroyed?void console.log("No longer wait for video on destroyed scope."):(console.warn("We did not receive video data for remote stream",i,e,t),r.$emit("active",i),void n.redraw())}),r.dummy=null,r.unattached=!1},r.doChat=function(){n.$emit("startchat",i.id,{autofocus:!0,restore:!0})},r.attachStream(t),e(n.remoteVideos).append(o)})},n.removeRemoteStream=function(e,t){var i=d(e,t);console.log("Stream removed",i);var o=r[i];o&&(u.pop(t.id),delete r[i],o.element&&o.element.remove(),o.$destroy(),n.redraw())},c.api.e.on("received.talking",function(e,t,i,o){n.$apply(function(e){e.peersTalking[i]=!!o})}),n.$on("active",function(){n.isActive||(n.isActive=!0,n.remoteVideos.style.opacity=1,i.addClass("active"),t.delay(function(){n.localVideos.style.opacity=0,n.localVideo.style.opacity=0,n.localVideo.src=""},500),t.delay(function(){e(n.mini).addClass("visible")},1e3))}),n.toggleFullscreen=function(){o.enabled&&(n.isActive||n.hasUsermedia)&&o.toggle(n.layoutparent[0],function(){n.layoutparent.addClass("fullscreen")},function(){n.layoutparent.removeClass("fullscreen")})},c.webrtc.e.on("usermedia",function(e,t){if(t&&t.started)if(n.haveStreams)t.attachMediaStream(n.miniVideo),n.redraw();else{n.hasUsermedia=!0,t.attachMediaStream(n.localVideo);var i=0,o=function(){n.hasUsermedia&&!n.isActive&&(n.localVideo.videoWidth>0?(console.log("Local video size: ",n.localVideo.videoWidth,n.localVideo.videoHeight),n.localVideo.style.opacity=1,n.redraw()):(i++,100>i?setTimeout(o,100):console.warn("Timeout while waiting for local video.")))};o()}}),c.webrtc.e.on("done",function(){n.$apply(function(){n.hasUsermedia=!1,n.isActive=!1,n.peersTalking={},o.enabled&&o.exit(),t.delay(function(){n.isActive||(n.localVideo.src="",n.miniVideo.src="",e(n.remoteVideos).children(".remoteVideo").remove())},1500),e(n.mini).removeClass("visible"),n.localVideos.style.opacity=1,n.localVideo.style.opacity=0,n.remoteVideos.style.opacity=0,i.removeClass("active"),t.each(r,function(e,t){e.$destroy(),delete r[t]}),n.rendererName=n.defaultRendererName,n.haveStreams=!1})}),c.webrtc.e.on("streamadded",function(e,t,i){console.log("Remote stream added.",t,i),n.haveStreams||(a.reattachMediaStream(n.miniVideo,n.localVideo),n.haveStreams=!0),null===t&&(t=new m),n.addRemoteStream(t,i)}),c.webrtc.e.on("streamremoved",function(e,t,i){console.log("Remote stream removed.",t,i),n.removeRemoteStream(t,i)}),c.webrtc.e.on("statechange",function(e,t,i){if(n.haveStreams)switch(t){case"new":case"checking":case"connected":case"completed":case"failed":n.addRemoteStream(new m,i)}}),{streams:r}}],y=function(){return function(n,i,o,r){i.on("doubletap dblclick",t.debounce(n.toggleFullscreen,100,!0));var s=null,c=function(){return null!==s?s:n.rendererName},l=function(e){s="classroom"===e?"classroom":"smally"};n.setRenderer=function(e){n.rendererName=e,s&&s!==e&&l(e)};var d=!1;n.redraw=function(){d=!0};var u=function(){var e,t={width:n.layoutparent.width(),height:n.layoutparent.height()};e=t.width<1||t.height<1?"invisible":c();var i=f.update(e,t,n,r);i&&(d=!0)};e(a).on("resize",n.redraw),n.$on("mainresize",function(e,i){i?l(n.rendererName):s&&(s=null),t.defer(n.redraw)}),n.redraw(),n.$watch("rendererName",function(){t.defer(n.redraw)});var p=function(){d&&(d=!1,u())};h.register(p)}};return{restrict:"E",replace:!0,scope:!0,template:n,controller:b,compile:y}}]}),define("text!partials/usability.html",[],function(){return'<div class="help fadetogglecontainer" ng-hide="peer">\n    <div class="animate-show" ng-hide="layout.settings">\n        <div class="fadetogglecontainer" ng-switch="usabilityInfo">\n          <div ng-switch-when="checking"><i class="fa fa-refresh fa-spin fa-4x pull-right"></i>{{_("Checking camera and microphone access.")}}</div>\n          <div ng-switch-when="usermedia"><i><i class="fa fa-hand-o-up fa-4x pull-right"></i>{{_("Please allow access to your camera and microphone.")}}</i></div>\n          <div ng-switch-when="denied">{{_("Camera / microphone access required.")}}</i></div>\n        </div>\n        <div ng-show="usabilityInfo==\'denied\'" class="help-subline">\n            <p><i>{{_("Please check your browser settings and allow camera and microphone access for this site.")}}</i></p>\n            <p><a ng-click="testMediaAccess()" class="btn btn-primary">{{_("Retry")}}</a> <a ng-click="continueConnect(true)" class="btn btn-default">{{_("Skip check")}}</a></p>\n            <p style="font-size:0.7em" ng-show="isChrome"><i><a rel="external" target="_blank" href="https://support.google.com/chrome/answer/2693767">{{_("Click here for help (Google Chrome).")}}</a></i></p>\n        </div>\n    </div>\n    <div class="animate-show" ng-show="layout.settings">\n        <i style="padding-right:140px">{{_("Please set your user details and settings.")}}<p class="help-subline"></p></i>\n    </div>\n</div>\n'}),define("directives/usability",["jquery","underscore","text!partials/usability.html"],function(e,t,n){var i="1";return[function(){var e=["$scope","webrtc","safeApply","$timeout","localStorage","continueConnector",function(e,t,n,o,a,r){var s=!0,c=!1,l=this;l.setInfo=function(t){e.usabilityInfo=t},l.setInfo("waiting");var d=r.defer();e.continueConnect=function(t){n(e,function(){s=!1,t?(a.setItem("mediastream-mediacheck",i),console.log("Continue with connect after media check ..."),d.resolve(),l.setInfo("ok"),c=!0):l.setInfo("denied")})},e.testMediaAccess=function(){var n=a.getItem("mediastream-mediacheck");n!==i&&e.isChrome?t.testMediaAccess(e.continueConnect):e.continueConnect(!0)},e.retry=function(){l.setInfo("usermedia"),e.testMediaAccess()},e.$watch("connect",function(){e.connect&&(console.log("Checking for media access ..."),l.setInfo("checking"),o(function(){s&&n(e,function(){l.setInfo("usermedia")})},500),e.testMediaAccess())}),e.$on("room.joined",function(){c&&l.setInfo("ok")}),e.$on("room.left",function(){c&&l.setInfo("ok")})}];return{restrict:"E",replace:!0,template:n,controller:e}}]}),define("directives/audiolevel",["jquery","underscore"],function(e,t){return["$window","webrtc","safeApply","animationFrame",function(e,n,i,o){var a=5,r=20,s=12,c=1.4,l=4,d={},u=null;n.e.on("usermedia",function(e,t){console.log("Audio level user media changed",t),u=t});var p=["$scope","$element","$attrs",function(p,f){p.talking=!1,this.active=!1;var h=f[0],g=0;this.update=t.bind(function(){(this.active||g>0)&&(u&&u.audioLevel?(g=Math.round(100*u.audioLevel),a>g&&(g=0)):g=0,h.style.width=g+"%")},this),o.register(this.update),this.audioActivityHistory=[],this.audioActivityMeter=0,this.meter=t.bind(function(){var e;if(this.active&&u){var o=Math.round(100*u.audioLevel);a>o?o=0:o*=c,this.audioActivityHistory.push(o),this.audioActivityHistory.length>l&&this.audioActivityHistory.shift(),this.audioActivityMeter=this.audioActivityHistory.reduce(function(e,t){return e+t})/this.audioActivityHistory.length,e=p.talking?this.audioActivityMeter>s?!0:!1:this.audioActivityMeter>r?!0:!1}else this.audioActivityHistory=[],this.audioActivityMeter=0,e=!1;e!==p.talking&&i(p,function(){p.talking=e});var f={};n.callForEachCall(t.bind(function(t){if(t.peerconnection&&t.peerconnection.datachannelReady){var n=!1;e?(d[t.id]||(n=!0),f[t.id]=e):!e&&d[t.id]&&(n=!0),n&&t.peerconnection.send({Type:"Talking",Talking:e})}},this)),d=f},this),this.meter(),this.meterInterval=null,this.check=function(){!p.peer||p.microphoneMute||this.active?p.peer&&!p.microphoneMute||!this.active||(this.active=!1,t.defer(t.bind(function(){e.clearInterval(this.meterInterval),this.meterInterval=null,this.meter()},this))):(this.active=!0,t.defer(t.bind(function(){this.meter(),this.update(),this.meterInterval=e.setInterval(this.meter,150)},this)))},p.$watch("peer",t.bind(this.check,this)),p.$watch("microphoneMute",t.bind(this.check,this))}];return{restrict:"CE",controller:p}}]}),define("directives/fileinfo",["jquery","underscore","moment"],function(e,t,n){return["fileData","fileUpload","fileDownload","mediaStream","$window","alertify","translation",function(e,i,o,a,r,s,c){var l=["$scope","$element","$attrs",function(l,d){var u=this;console.log("file-info",l,d),l.complete=!1,l.downloader=!1,l.downloadcomplete=!1,l.downloading=!1,l.downloadspeed=!1,l.uploading=!1,l.uploader=!1,l.cancelled=!1,l.error=!1,l.progress=0,l.progressDownload=0,l.bytesPerSecond=0,l.eta="",l.url=null;var p=d.find(".file-info-size > div"),f=p[0],h=p[1];l.$watch("progress",function(){f.style.width=l.progress+"%"}),l.$watch("progressDownload",function(){h.style.width=l.progressDownload+"%"}),l.$watch("error",function(){});var g=0,m=null,v=l.info.id,b=[],y=[],w=null;u.bytesPerSecond=function(){if(l.downloadcomplete||l.cancelled||l.error)return r.clearInterval(w),void l.$apply(function(){l.downloadspeed=!1,l.eta=""});var e=0;b.length&&(e=t.reduce(b,function(e,t){return e+t},0),b=[]),y.push(e),y.length>3&&y.shift();var i=l.info.size-l.info.size*(l.progress/100);l.$apply(function(e){if(e.bytesPerSecond=t.reduce(y,function(e,t){return e+t},0)/y.length,e.downloader&&(e.bytesPerSecond||e.eta))if(e.bytesPerSecond>0){var o=i/e.bytesPerSecond;e.eta=n.duration(o,"seconds").humanize()}else e.eta="";!e.downloadspeed&&e.bytesPerSecond>0?e.downloadspeed=!0:e.downloader||0!==e.bytesPerSecond||(e.downloadspeed=!1)})},l.reset=function(){g=0,b=[],y=[],r.clearInterval(w),w=null,l.complete=!1,l.downloading=!1,l.downloadcomplete=!1,l.downloadspeed=!1,l.progress=0,l.progressDownload=0,l.bytesPerSecond=0,l.eta="",l.error=!1,l.url=null},l.download=function(){return o.supported?(l.error&&l.downloading&&l.reset(),console.log("Download",l.info,l),void(l.complete||l.downloading?l.url?r.open(l.url,"_blank"):console.error("Download of already completed files not implemented yet."):(l.downloading=!0,l.cancelled=!1,w=r.setInterval(u.bytesPerSecond,1e3),l.$emit("download",l.from,l.info.id)))):void s.dialog.alert(c._("Your browser does not support file transfer."))},l.cancel=function(){console.log("Download cancel",l.downloading,l),l.cancelled=!0,l.downloading&&l.$emit("cancelDownload"),l.uploader&&(console.log("Removing upload handler"),m&&(a.tokens.off(v,m),l.uploader=!1),l.$emit("cancelUpload")),l.reset()},l.$on("downloadedWritten",function(e,t){e.stopPropagation(),l.cancelled||(l.progress=Math.ceil(t/(l.info.chunks-1)*100),t>=l.info.chunks-1&&(l.progress=100))}),l.$on("downloadedChunk",function(e,t,n){e.stopPropagation(),l.cancelled||(b.push(n),l.progressDownload=Math.ceil(g/(l.info.chunks-1)*100),g++)}),l.$on("writeComplete",function(e,t){e.stopPropagation(),l.complete=!0,l.url=t,l.progress=100}),l.$on("downloadComplete",function(e){e.stopPropagation(),l.downloadcomplete=!0,l.progressDownload=100}),l.$on("uploadedChunk",function(e,t,n){e.stopPropagation(),l.cancelled||b.push(n)});var k=e.getFile(l.info.id);if(k){l.uploader=!0,console.log("File-info has file on create",k);var x=i.startUpload(l,l.info.id);m=a.tokens.on(v,function(e,t,n,i,o,a,r,s){x.handleRequest(l,s,i)},"xfer"),w=r.setInterval(u.bytesPerSecond,1e3)}else l.downloader=!0,m=a.tokens.on(v,function(e,t,n,i,a,r,s,c){o.handleRequest(l,c,i)},"xfer")}];return{scope:!0,restrict:"EAC",controller:l,replace:!1}}]}),define("text!partials/screenshare.html",[],function(){return'<div class="screenshare" ng-class="{remotesize: !fitScreen}">\n	<div class="screensharepane nicescroll"></div>\n	<div class="overlaybar form-horizontal" ng-class="{notvisible: hideOptionsBar}">\n		<a class="overlaybar-button" ng-model="hideOptionsBar" btn-checkbox btn-checkbox btn-checkbox-true="0" btn-checkbox-false="1" title="{{_(\'Screen sharing options\')}}"><i class="fa fa-cogs"></i></a>\n		<form class="overlaybar-content form-group">\n			<div class="checkbox">\n		        <label class="control-label pull-left">\n		          <input type="checkbox" ng-model="fitScreen"> {{_(\'Fit screen.\')}}\n		        </label>\n	      	</div>\n		</form>\n	</div>\n</div>\n'}),define("text!partials/screensharepeer.html",[],function(){return'<div class="remotescreen">\n	<video autoplay="autoplay"></video>\n</div>'}),define("directives/screenshare",["jquery","underscore","text!partials/screenshare.html","text!partials/screensharepeer.html","bigscreen","webrtc.adapter"],function(e,t,n,i,o){return["$window","mediaStream","$compile","safeApply","videoWaiter","$timeout","alertify","translation","screensharing",function(a,r,s,c,l,d,u,p,f){var h=s(i),g=["$scope","$element","$attrs",function(e,n){var i=0,s={},g=n.find(".screensharepane");e.layout.screenshare=!1,e.usermedia=null,e.connected=!1,e.hideOptionsBar=!0,e.fitScreen=!0;var m=function(e,t,n,i,o,a,r,s){if(console.log("Screen share answer message",t,i,o),"string"==typeof i){if(2===i.charCodeAt(0))return;var c;try{c=JSON.parse(i)}catch(l){return console.warn("Invalid JSON received from screen share channel.",i),void s.close()}switch(c.m){case"bye":s.close();break;default:console.log("Unknown screen share control request",c.m,c)}}else console.warn("Unkown data type received -> ignored",typeof i,[i]),s.close()};r.api.e.on("received.screenshare",function(t,n,i,o,a){if(!a)return void console.warn("Received screensharing info without p2p. This should not happen!");var s=o.id,l=r.tokens.on(s,m,"screenshare");r.webrtc.doSubscribeScreenshare(i,s,{created:function(t){t.e.on("remoteStreamAdded",function(n,i){i&&e.$apply(function(e){e.addRemoteStream(i,t)})}),t.e.on("remoteStreamRemoved",function(n,i){c(e,function(e){e.removeRemoteStream(i,t)})})},connected:function(t){console.log("PeerScreenshare connected",t),e.$apply(function(e){e.connected=!0})},closed:function(t){console.log("PeerScreenshare closed",t),c(e,function(e){e.removeRemoteStream(null,t),e.connected=!1}),r.tokens.off(s,l),l=null}})}),e.addRemoteStream=function(t,n){e.$emit("mainview","screenshare",!0);var i=e.$new(!0),o=i.peerid=n.id;h(i,function(e,i){g.append(e),i.element=e;var r=e.find("video")[0];a.attachMediaStream(r,t),l.wait(r,t,function(){console.log("Screensharing size: ",r.videoWidth,r.videoHeight)},function(){console.warn("We did not receive screen sharing video data",n,t,r)}),s[o]=i})},e.removeRemoteStream=function(n,i){var o=s[i.id];o&&(delete s[i.id],o.element&&o.element.remove(),o.$destroy()),t.isEmpty(s)&&e.$emit("mainview","screenshare",!1)},e.doScreenshare=function(){e.layout.screenshare&&e.stopScreenshare(),e.layout.screenshare=!0,f.getScreen().then(function(t){t?e.startScreenshare(t):e.stopScreenshare()},function(t){console.log("Screen sharing request returned error",t),u.dialog.alert(p._("Failed to start screen sharing (%s).",t)),e.stopScreenshare()})},e.startScreenshare=function(n){var o,s=r.webrtc.doScreenshare(n),l={},f=[],h=function(e,t){l.hasOwnProperty(t.id)||(l[t.id]=!0,t.e.one("closed",function(e,t){delete l[t.id],console.log("Removed closed call from screen sharing.",t.id)}),r.api.apply("sendScreenshare",{send:function(e,n){return t.peerconnection.send(n)
}})(t.from,e))};s.e.one("mediasuccess",function(n,a){e.$apply(function(e){e.usermedia=a;var n="screenshare_"+e.id+"_"+i++,s=function(e,t,i){switch(t){case"completed":case"connected":h(n,i)}};o=r.tokens.create(n,function(e,t,n,i,o,r,s,c){console.log("Screen share create",t,i,o,c),f.push(c),a.addToPeerConnection(c.peerconnection)},"screenshare"),r.webrtc.callForEachCall(function(e){h(n,e)}),r.webrtc.e.on("statechange",s),a.e.one("stopped",function(){r.tokens.off(n,o),r.webrtc.e.off("statechange",s),o=null,t.each(f,function(e){e.send({m:"bye"}),d(function(){e.close()},0)}),l={},f=[],c(e,function(e){e.stopScreenshare()})})})}),s.e.one("mediaerror",function(t,n,i){if(e.$apply(function(e){e.stopScreenshare()}),i&&i.name)switch(i.name){case"PermissionDeniedError":case"InvalidStateError":u.dialog.alert(a.webrtcDetectedVersion>=32&&a.webrtcDetectedVersion<37?p._("Permission to start screen sharing was denied. Make sure to have enabled screen sharing access for your browser. Copy chrome://flags/#enable-usermedia-screen-capture and open it with your browser and enable the flag on top. Then restart the browser and you are ready to go."):p._("Permission to start screen sharing was denied."));break;default:u.dialog.alert(p._("Failed to start screen sharing (%s).",i.name))}})},e.stopScreenshare=function(){e.usermedia&&(e.usermedia.stop(),e.usermedia=null,console.log("Screen share stopped.")),e.layout.screenshare&&(f.cancelGetScreen(),e.layout.screenshare=!1)},e.toggleFullscreen=function(e){o.enabled&&o.toggle(e?e:g[0])},r.webrtc.e.on("done",function(){e.$apply(e.stopScreenshare)}),e.$watch("layout.screenshare",function(t,n){t&&!n?e.doScreenshare():!t&&n&&e.stopScreenshare()}),e.$watch("layout.main",function(t){t&&"screenshare"!==t&&e.stopScreenshare()})}],m=function(){return function(n,i){e(i).on("dblclick",".remotescreen",t.debounce(function(e){n.toggleFullscreen(e.delegateTarget)},100,!0))}};return{restrict:"E",replace:!0,scope:!0,template:n,controller:g,compile:m}}]}),define("text!partials/roombar.html",[],function(){return'<div class="roombar overlaybar form-horizontal" ng-class="{notvisible: !layout.roombar}">\n	<a class="overlaybar-button" ng-model="layout.roombar" btn-checkbox btn-checkbox-true="true" btn-checkbox-false="false" title="{{_(\'Change room\')}}"><i class="fa fa-pencil-square-o"></i></a>\n	<form name="roombarform" class="overlaybar-content form-group">\n		<label class="pull-left control-label hidden-xs">{{_(\'Room\')}}</label>\n		<div class="pull-left">\n			<span ng-if="currentRoomName"><a class="btn btn-danger btn-sm" title="{{_(\'Leave room\')}}" ng-click="exit()"><i class="fa fa-sign-out"></i></a></span>\n		</div>\n		<div class="pull-left">\n			<div class="input-group">\n				<input class="form-control input-sm" ng-model="newRoomName" ng-maxlength="30" on-enter="save()" type="text" placeholder="{{_(\'Main\')}}"></input><span class="input-group-btn"><a class="btn btn-default btn-sm" title="{{_(\'Change room\')}}" ng-disabled="roombarform.$invalid" ng-click="save()"><i class="fa fa-sign-in"></i></a></span>\n			</div>\n		</div>\n		<div class="pull-left">\n			<social-share/>\n		</div>\n	</form>\n	<label class="control-label overlaybar-overlay" title="{{_(\'Current room\')}}">{{currentRoomName}}</label>\n</div>\n'}),define("directives/roombar",["underscore","angular","text!partials/roombar.html"],function(e,t,n){return["$window","rooms","$timeout","safeApply",function(e,t,i,o){var a=function(e,n){var a=function(){e.currentRoomName=null,e.newRoomName=""};e.save=function(){if(!e.roombarform.$invalid){var n=t.joinByName(e.newRoomName);n!==e.currentRoomName?e.roombarform.$setPristine():(e.newRoomName=n,e.roombarform.$setPristine())}},e.exit=function(){e.newRoomName="",e.save()},e.$on("room.updated",function(t,n){o(e,function(e){e.currentRoomName=e.newRoomName=n.Name,e.currentRoomName&&!e.peer&&(e.layout.roombar=!0)})}),e.$on("room.left",function(){o(e,a)}),e.$watch("newRoomName",function(t){t===e.currentRoomName&&e.roombarform.$setPristine()}),e.$watch("layout.roombar",function(){i(function(){n.find("input").focus()})}),e.$watch("peer",function(t){e.layout.roombar=!t}),a()};return{restrict:"E",replace:!0,scope:!0,template:n,link:a}}]}),define("text!partials/socialshare.html",[],function(){return'<div class="socialshare btn-group" ng-show="roomlink">\n	<a title="{{_(\'Room link\')}}" target="_blank" rel="external" href="{{roomlink}}" class="btn btn-link btn-sm" data-nw="link"><i class="fa fa-link fa-lg link"></i></a>\n	<a title="{{_(\'Invite by Email\')}}" class="btn btn-link btn-sm" data-nw="email"><i class="fa fa-envelope fa-lg email"></i></a>\n	<a title="{{_(\'Invite with Facebook\')}}" class="btn btn-link btn-sm" data-nw="facebook"><i class="fa fa-facebook fa-lg facebook"></i></a>\n	<a title="{{_(\'Invite with Twitter\')}}" class="btn btn-link btn-sm" data-nw="twitter"><i class="fa fa-twitter fa-lg twitter"></i></a>\n	<a title="{{_(\'Invite with Google Plus\')}}" class="btn btn-link btn-sm" data-nw="google"><i class="fa fa-google-plus fa-lg google"></i></a>\n	<a title="{{_(\'Invite with XING\')}}" class="btn btn-link btn-sm" data-nw="xing"><i class="fa fa-xing fa-lg xing"></i></a>\n</div>'}),define("directives/socialshare",["text!partials/socialshare.html"],function(e){var t={email:"mailto:?subject=_TEXT_%20_URL_",facebook:"https://www.facebook.com/sharer.php?u=_URL_&t=_TEXT_",twitter:"https://twitter.com/share?url=_URL_&text=_TEXT_&via=_SITE_",google:"https://plus.google.com/share?url=_URL_",xing:"https://www.xing.com/app/user?op=share;url=_URL_"};return["$window","translation","rooms","alertify",function(n,i,o,a){var r=n.encodeURIComponent(n.document.title),s=function(e,o){var a=t[e];return a&&(a=a.replace(/_URL_/,n.encodeURIComponent(o)).replace(/_TEXT_/,n.encodeURIComponent(i._("Meet with me here:"))).replace(/_SITE_/,r)),a};return{scope:!0,restrict:"E",template:e,replace:!0,link:function(e,t){e.$on("room.updated",function(t,n){e.roomlink=o.link(n)}),e.$on("room.left",function(){e.roomlink=null}),t.find("a").on("click",function(t){t.preventDefault();var o=t.currentTarget.getAttribute("data-nw"),r=s(o,e.roomlink);r?"email"===o?e.manualReloadApp(r):n.open(r,"social_"+o,"menubar=no,toolbar=no,resizable=yes,width=600,height=600,scrollbars=yes"):"link"===o&&a.dialog.notify(i._("Room link"),'<a href="'+e.roomlink+'" rel="external" target="_blank">'+e.roomlink+"</a>")})}}}]}),define("text!partials/page.html",[],function(){return'<div id="page" class="ng-cloak">\n	<div ng-if="page" ng-include="page"></div>\n	<div ng-hide="page" id="help">\n		<usability/>\n	</div>\n</div>'}),define("text!partials/page/welcome.html",[],function(){return'<div welcome ng-form="welcome" class="welcome container-fluid" ng-show="!peer" ng-controller="UsersettingsController as usersettings">\n	<div class="welcome-logo"></div>\n	<div ng-if="canJoinRooms()" class="welcome-container">\n		<h1>{{_("Enter a room name")}}</h1>\n		<div class="form-group welcome-input" ng-class="{\'has-error\': welcome.$invalid, \'has-success\': welcome.$valid && roomdata.name}">\n			<input type="text" class="form-control roomdata-link-input input-lg" ng-model="roomdataInput.name" ng-maxlength="30" on-enter="joinRoomByName(roomdata.name)" placeholder="{{roomdata.placeholder}}">\n			<div class="welcome-input-buttons">\n				<a ng-show="roomdata.last" class="fa fa-refresh" title="{{_(\'Random room name\')}}" ng-click="randomRoom()"></a>\n				<button class="btn btn-success btn-roomcreate" title="{{_(\'Enter room\')}}" type="button" ng-disabled="!roomdata.link || welcome.$invalid" ng-click="joinRoomByName(roomdata.name)"><i class="fa fa-sign-in"></i></button>\n			</div>\n			<welcome-form-extra></welcome-form-extra>\n		</div>\n		<p class="room-link small"><span><i class="fa fa-link" title="{{_(\'Room link\')}}"></i> <a ng-show="roomdata.name" href="{{roomdata.link}}" ng-click="joinRoomByName(roomdata.name);$event.preventDefault()">{{roomdata.link}}</a></span></p>\n		<p ng-show="welcome.$invalid" class="welcome-error text-danger">This room name can not be used. Please choose another name.</p>\n		<div class="welcome-login" ng-hide="canCreateRooms()">\n			<p class="h4">{{_("Enter the name of an existing room. You can create new rooms when you are signed in.")}}</p>\n			<button ng-if="!myuserid && usersettings.loginUserid" type="button" class="btn btn-primary" ng-click="usersettings.loginUserid()">{{_(\'Sign in\')}}</button>\n		</div>\n		<welcome-extra></welcome-extra>\n		<p class="rooms-history" ng-show="roomsHistory.length">\n			<span>{{_("Room history")}}</span>\n			<br/>\n			<a ng-repeat="room in roomsHistory" ng-click="joinRoomByName(room)"><span class="label label-default">{{room}}</span></a>\n		</p>\n	</div>\n	<div ng-if="!canJoinRooms()" class="welcome-container">\n		<div class="welcome-login">\n			<p class="h4">{{_("Please sign in.")}}</p>\n			<button ng-if="!myuserid && usersettings.loginUserid" type="button" class="btn btn-primary" ng-click="usersettings.loginUserid()">{{_(\'Sign in\')}}</button>\n		</div>\n	</div>\n</div>'}),define("directives/page",["text!partials/page.html","text!partials/page/welcome.html"],function(e,t){return["$templateCache","$timeout","rooms",function(n,i){n.put("page/welcome.html",t);var o=function(e){e.$on("room.joined",function(){e.page=null}),e.$on("room.random",function(){e.layout.roombar=!1,i(function(){e.page="page/welcome.html"})})};return{restrict:"E",replace:!0,template:e,link:o}}]}),define("directives/contactrequest",["jquery","underscore"],function(e){return["translation","buddyData","contacts",function(t,n,i){var o=["$scope","$element","$attrs",function(t){t.state="request",t.doAccept=function(){t.state="accepted",t.doContact(!0)},t.doReject=function(){t.state="rejected",t.doContact(!1)},t.doContact=function(e){var n=t.request;n.Success=!!e,t.sendChatServer(t.id,"Contact request answer",{ContactRequest:n})},t.addContact=function(e,t){i.add(e,t)};var o=t.request;if(o.Success&&o.Userid&&o.Token){var a=n.lookup(t.id),r={};a&&e.extend(r,a.status),t.addContact(o,r)}}];return{scope:!0,restrict:"EAC",controller:o,replace:!1}}]}),define("text!partials/defaultdialog.html",[],function(){return'<div>\n	<div class="modal-header"><button type="button" class="close" ng-click="$close()">×</button><h3 class="modal-title" ng-bind-html="header"></h3></div>\n	<div class="modal-body" ng-transclude></div>\n	<div class="modal-footer"><button type="button" class="btn btn-default" ng-click="$close()">{{_("Close")}}</button></div>\n</div>\n'}),define("directives/defaultdialog",["text!partials/defaultdialog.html"],function(e){return[function(){return{restrict:"AC",replace:!0,transclude:!0,template:e}}]}),define("directives/pdfcanvas",["require","underscore","jquery"],function(e,t,n){return["$window","$compile","$http","translation","safeApply","restURL","sandbox",function(e,i,o,a,r,s,c){var l=["$scope","$element","$attrs",function(i,l){var d,u=n(l),p=s.sandbox("pdfcanvas"),f=c.createSandbox(u,null,p,"allow-scripts",null,{allowfullscreen:!0,mozallowfullscreen:!0,webkitallowfullscreen:!0});f.e.on("message",function(e,t){var n=t.data,o=n[n.type]||{};switch(n.type){case"ready":break;case"pdfjs.loading":i.$apply(function(e){e.$emit("presentationLoading",o.source)});break;case"pdfjs.loaded":d._pdfLoaded(o.source,o.doc);break;case"pdfjs.loadError":d._pdfLoadError(o.source,o.error);break;case"pdfjs.pageLoaded":d._pageLoaded(o.page);break;case"pdfjs.pageLoadError":d._pageLoadError(o.page,o.error);break;case"pdfjs.renderingPage":i.$apply(function(e){e.$emit("presentationPageRendering",o.page)});break;case"pdfjs.pageRendered":d._pageRendered(o.page);break;case"pdfjs.pageRenderError":d._pageRenderError(o.page,o.error);break;case"pdfjs.keyUp":i.$apply(function(e){e.$emit("keyUp",o.key)});break;default:console.log("Unknown message received",t)}});var h=function(e){this.scope=e,this.doc=null,this.currentPageNumber=null,this.pendingPageNumber=null,this.url=null};h.prototype.close=function(){f.postMessage("closeFile",{close:!0}),this.url&&(URL.revokeObjectURL(this.url),this.url=null),this.pendingPageNumber=null,this.currentPageNumber=-1,this.maxPageNumber=-1},h.prototype.open=function(e){this.scope.$emit("presentationOpening",e),e.open(t.bind(function(e){if(console.log("Loading PDF from",e),this.close(),"string"==typeof e)return void this._openFile(e);var n=e.file||e;if("undefined"!=typeof URL&&URL.createObjectURL)this.url=URL.createObjectURL(n),this._openFile(this.url);else{var i=new FileReader;i.onload=t.bind(function(e){var t=e.target.result,n=new Uint8Array(t);this._openFile(n)},this),i.readAsArrayBuffer(n)}},this))},h.prototype._pdfLoaded=function(e,n){this.scope.$apply(t.bind(function(t){this.doc=n,this.maxPageNumber=n.numPages,this.currentPageNumber=-1,t.$emit("presentationLoaded",e,n)},this))},h.prototype._pdfLoadError=function(e,n){var i;switch(n){case"InvalidPDFException":i=a._("Could not load PDF: Please make sure to select a PDF document.");break;case"MissingPDFException":i=a._("Could not load PDF: Missing PDF file.");break;default:i=n?a._("An error occurred while loading the PDF (%s).",n):a._("An unknown error occurred while loading the PDF.")}this.scope.$apply(t.bind(function(t){t.$emit("presentationLoadError",e,i)},this))},h.prototype._openFile=function(e){return"string"==typeof e?void o.get(e,{responseType:"arraybuffer"}).then(t.bind(function(e){this._openFile(e.data)},this),t.bind(function(t){this._pdfLoadError(e,t)},this)):(console.log("Opening file",e),void f.postMessage("openFile",{source:e}))},h.prototype._pageLoaded=function(e){this.scope.$apply(t.bind(function(t){t.$emit("presentationPageLoaded",e)},this))},h.prototype._pageLoadError=function(e,n){var i;i=n?a._("An error occurred while loading the PDF page (%s).",n):a._("An unknown error occurred while loading the PDF page."),this.scope.$apply(t.bind(function(t){t.$emit("presentationPageLoadError",e,i)},this))},h.prototype._showPage=function(e){e!==this.currentPageNumber&&(console.log("Showing page",e,"/",this.maxPageNumber),this.currentPageNumber=e,this.scope.$emit("presentationPageLoading",e),f.postMessage("loadPage",{page:e}))},h.prototype._pageRendered=function(e){this.scope.$apply(t.bind(function(){this.scope.$emit("presentationPageRendered",e,this.maxPageNumber),this.showQueuedPage()},this))},h.prototype._pageRenderError=function(e,n){var i;i=n?a._("An error occurred while rendering the PDF page (%s).",n):a._("An unknown error occurred while rendering the PDF page."),this.scope.$apply(t.bind(function(t){t.$emit("presentationPageRenderError",e,this.maxPageNumber,i)},this))},h.prototype.redrawPage=function(){f.postMessage("redrawPage",{redraw:!0})},h.prototype.showPage=function(e){e>=1&&e<=this.maxPageNumber&&(this.doc?this._showPage(e):this.pendingPageNumber=e)},h.prototype.showQueuedPage=function(){null!==this.pendingPageNumber&&(this._showPage(this.pendingPageNumber),this.pendingPageNumber=null)},d=new h(i),i.$watch("currentPresentation",function(e,t){e?r(i,function(){d.open(e)}):(t&&t.close(),d.close())}),i.$on("$destroy",function(){d.close(),d=null,f.destroy()}),i.$watch("currentPageNumber",function(e,t){e!==t&&d.showPage(e)}),n(e).on("resize",function(){i.$apply(function(){d.redrawPage()})})}];return{restrict:"E",replace:!0,template:'<div class="canvasContainer"></div>',controller:l}}]}),define("directives/odfcanvas",["require","underscore","jquery"],function(e,t,n){return["$window","$compile","$http","translation","safeApply","restURL","sandbox",function(e,i,o,a,r,s,c){var l="presentation",d=["$scope","$element","$attrs",function(i,a){var d,u=n(a),p=s.sandbox("odfcanvas"),f=c.createSandbox(u,null,p,"allow-scripts",null,{allowfullscreen:!0,mozallowfullscreen:!0,webkitallowfullscreen:!0});f.e.on("message",function(e,t){var n=t.data,o=n[n.type]||{};switch(n.type){case"ready":break;case"webodf.loading":i.$apply(function(e){e.$emit("presentationLoading",o.source),u.hide()});break;case"webodf.loaded":d._odfLoaded(o.url,o.type,o.numPages);break;case"webodf.keyUp":i.$apply(function(e){e.$emit("keyUp",o.key)});break;default:console.log("Unknown message received",t)}});var h=function(e,t){this.scope=e,this.container=t,this.doc=null,this.maxPageNumber=-1,this.currentPageNumber=-1,this.pendingPageNumber=null};h.prototype.close=function(){f.postMessage("closeFile",{close:!0}),this.maxPageNumber=-1,this.currentPageNumber=-1,this.pendingPageNumber=null,this.doc=null},h.prototype.open=function(e){this.scope.$emit("presentationOpening",e),e.open(t.bind(function(e){if(console.log("Loading ODF from",e),this.close(),"string"==typeof e)return void this._openFile(e);var n=e.file||e;if("undefined"!=typeof URL&&URL.createObjectURL)this.url=URL.createObjectURL(n),this._openFile(this.url);else{var i=new FileReader;i.onload=t.bind(function(e){var t=e.target.result,n=new Uint8Array(t);this._openFile(n)},this),i.readAsArrayBuffer(n)}},this))},h.prototype._odfLoaded=function(e,n,i){this.scope.$apply(t.bind(function(t){switch(this.document_type=n,n){case l:this.container.addClass("showonepage");break;default:this.container.removeClass("showonepage")}this.maxPageNumber=i,this.currentPageNumber=-1,this.doc={numPages:this.maxPageNumber},t.$emit("presentationLoaded",e,this.doc),null!==this.pendingPageNumber&&(this._showPage(this.pendingPageNumber),this.pendingPageNumber=null)},this))},h.prototype._openFile=function(e){return"string"==typeof e?void o.get(e,{responseType:"arraybuffer"}).then(t.bind(function(e){this._openFile(e.data)},this)):(console.log("Opening file",e),void f.postMessage("openFile",{source:e}))},h.prototype._showPage=function(e){e!==this.currentPageNumber&&(console.log("Showing page",e,"/",this.maxPageNumber),this.scope.$emit("presentationPageLoading",e),this.scope.$emit("presentationPageLoaded",e,null),t.defer(t.bind(function(){this.scope.$apply(t.bind(function(){-1===this.currentPageNumber&&(this.container.show(),this.redrawPage()),this.currentPageNumber=e,f.postMessage("showPage",{page:e}),this.scope.$emit("presentationPageRendering",e),this.scope.$emit("presentationPageRendered",e,this.maxPageNumber)},this))},this)))},h.prototype.redrawPage=function(){f.postMessage("redrawPage",{redraw:!0})},h.prototype.showPage=function(e){e>=1&&e<=this.maxPageNumber&&(this.doc?this._showPage(e):this.pendingPageNumber=e)},d=new h(i,u),i.$watch("currentPresentation",function(e,t){e?r(i,function(){d.open(e)}):(t&&t.close(),d.close())}),i.$on("$destroy",function(){d.close(),d=null,f.destroy()}),i.$watch("currentPageNumber",function(e,t){e!==t&&d.showPage(e)}),n(e).on("resize",function(){i.$apply(function(){d.redrawPage()})})}];return{restrict:"E",replace:!0,template:'<div class="canvasContainer odfcontainer"></div>',controller:d}}]}),define("text!partials/presentation.html",[],function(){return'<div class="presentation">\n	<div class="presentationpane nicescroll">\n		<div class="welcome container-fluid" ng-show="loading || (!currentPresentation && activeDownloads.length)">\n			<h1>{{_(\'Loading presentation ...\')}}</h1>\n			<div class="progress" ng-repeat="download in activeDownloads | orderBy: \'sortkey\'">\n				<span class="download-info">{{download.info.name}} ({{download.info.size|humanizeFilesize}} / {{download.progress}}%)</span>\n				<div class="progress-bar progress-bar-success" ng-style="{\'width\': download.progress+\'%\'}"></div>\n			</div>\n		</div>\n		<div class="welcome container-fluid" ng-hide="currentPresentation || loading">\n			<h1>{{_(\'Please upload a document\')}}</h1>\n			<div>\n				<p>{{_(\'Documents are shared with everyone in this call. The supported file types are PDF and OpenDocument files.\')}}</p>\n				<p><button class="btn btn-lg btn-primary">{{_(\'Upload\')}}</button></p>\n				<p>{{_(\'You can drag files here too.\')}}</p>\n			</div>\n		</div>\n		<div class="canvasContainer" ng-if="currentPresentation" ng-hide="loading" ng-switch="currentPresentation.type">\n			<pdfcanvas ng-switch-when="pdf" />\n			<odfcanvas ng-switch-when="odf" />\n		</div>\n	</div>\n	<div class="overlaybar form-horizontal" ng-class="{notvisible: hideControlsBar}">\n		<a class="overlaybar-button" ng-model="hideControlsBar" btn-checkbox btn-checkbox btn-checkbox-true="0" btn-checkbox-false="1" title="{{_(\'Presentation controls\')}}"><i class="fa fa-cogs"></i></a>\n		<div class="overlaybar-content">\n			<div class="pagecontrol" ng-show="currentPresentation || availablePresentations.length">\n				<div class="clearfix" ng-show="currentPresentation && maxPageNumber &gt; 1">\n					<a class="overlaybar-button btn-prev" ng-click="prevPage()" ng-show="currentPageNumber &gt; 1" title="{{_(\'Prev\')}}"><i class="fa fa-backward"></i></a>\n					<div class="pageinfo center-block"><input class="form-control input-sm" type="number" ng-model="currentPageNumber" /> / {{ maxPageNumber }}</div>\n					<a class="overlaybar-button btn-next" ng-click="nextPage()" ng-show="currentPageNumber &lt; maxPageNumber" title="{{_(\'Next\')}}"><i class="fa fa-forward"></i></a>\n				</div>\n			</div>\n			<div class="presentations nicescroll" ng-show="availablePresentations.length">\n				<div class="thumbnail">\n					<div class="fa filetype fa-plus"></div>\n					<div class="caption">\n						<button class="btn btn-primary">{{_(\'Upload\')}}</button>\n					</div>\n				</div>\n				<div class="thumbnail" ng-repeat="presentation in availablePresentations | orderBy : \'sortkey\'"\n									   ng-class="{\'presentable\': presentation.presentable}"\n									   ng-click="selectPresentation(presentation)"\n									   title="{{ presentation.info.name }}">\n					<div class="fa active fa-check" ng-show="presentation === currentPresentation"></div>\n					<div class="fa notavailable fa-ban" ng-show="presentation !== currentPresentation && !presentation.presentable"></div>\n					<a class="btn btn-primary presentation-action download" ng-show="presentation.uploaded || !presentation.downloading" ng-click="downloadPresentation(presentation, $event)"><i class="fa fa-download fa-lg"></i></a>\n					<a class="btn btn-danger presentation-action delete" ng-show="presentation.uploaded" ng-click="deletePresentation(presentation, $event)"><i class="fa fa-trash-o fa-lg"></i></a>\n					<div class="fa filetype fa-file-pdf-o"></div>\n					<div class="caption">\n						<span class="name">{{ presentation.info.name }}</span><br>\n						<span ng-show="!presentation.downloading" class="size">{{ presentation.info.size|humanizeFilesize }}</span>\n						<div ng-show="presentation.downloading" class="progress">\n							<span class="download-info">{{presentation.info.size|humanizeFilesize}} / {{presentation.progress}}%</span>\n							<div class="progress-bar progress-bar-success" ng-style="{\'width\': presentation.progress+\'%\'}"></div>\n						</div>\n					</div>\n				</div>\n			</div>\n		</div>\n	</div>\n</div>\n'}),define("directives/presentation",["jquery","underscore","text!partials/presentation.html","bigscreen"],function(e,t,n,i){return["$window","mediaStream","fileUpload","fileDownload","alertify","translation","randomGen","fileData",function(o,a,r,s,c,l,d,u){var p={"application/pdf":"pdf","application/vnd.oasis.opendocument.text":"odf","application/vnd.oasis.opendocument.spreadsheet":"odf","application/vnd.oasis.opendocument.presentation":"odf","application/vnd.oasis.opendocument.graphics":"odf","application/vnd.oasis.opendocument.chart":"odf","application/vnd.oasis.opendocument.formula":"odf","application/vnd.oasis.opendocument.image":"odf","application/vnd.oasis.opendocument.text-master":"odf"},f=function(t,n,i){this.e=e({}),t&&(this.scope=t.$new(),this.scope.info=n),this.info=n,n&&(this.sortkey=(n.name||"").toLowerCase(),this.type=p[n.type]||"unknown"),this.token=i,this.fileid=null,this.file=null,this.handler=null,this.session=null,this.url=null};f.prototype.stop=function(){this.handler&&(a.tokens.off(this.token,this.handler),this.handler=null)},f.prototype.clear=function(){this.fileid&&(u.purgeFile(this.fileid),this.fileid=null),this.file=null,this.e.off()};var h=function(e,n,i,o){f.call(this,e,n,i),this.owner=o,this.progress=0,this.presentable=!1,this.downloading=!0,this.uploaded=!1,this.openCallback=null,this.scope.$on("downloadedChunk",t.bind(function(e,t,n,i,o){var a=Math.ceil(i/o*100);this.progress=a},this)),this.scope.$on("downloadComplete",t.bind(function(e){e.stopPropagation(),this.progress=100},this)),this.scope.$on("writeComplete",t.bind(function(e,t,n){if(e.stopPropagation(),this.fileid=n.id,this.file=n.file,this.url=t,this.downloading=!1,this.e.triggerHandler("available",[this,t,n]),this.stop(),this.openCallback){var i=this.openCallback;this.openCallback=null,this.open(i)}},this))};h.prototype=new f,h.prototype.constructor=h,h.prototype.open=function(e){return this.downloading?(console.log("Presentation download not finished yet, not showing",this),void(this.openCallback=e)):this.url&&0===this.url.indexOf("blob:")?void e(this.url):void(this.file.hasOwnProperty("writer")?e(this.file):this.file.file(function(t){e(t)}))},h.prototype.browserOpen=function(e){return e=e||"_blank",this.downloading?void console.log("Presentation download not finished yet, not opening",this):void o.open(this.url,e)},h.prototype.close=function(){this.openCallback=null},h.prototype.start=function(){this.handler=a.tokens.on(this.token,t.bind(function(e,t,n,i,o,a,r,c){s.handleRequest(this.scope,c,i)},this),"xfer"),this.session=s.startDownload(this.scope,this.owner,this.token)},h.prototype.stop=function(){f.prototype.stop.call(this),this.session&&(this.session.cancel(),this.session=null)},h.prototype.clear=function(){this.stop(),this.scope&&(this.scope.$emit("cancelDownload"),this.scope.$destroy(),this.scope=null),this.openCallback=null,f.prototype.clear.call(this)};var g=function(e,t,n){f.call(this,e,t.info,n),this.file=t,this.presentable=!0,this.uploaded=!0,this.fileid=n};g.prototype=new f,g.prototype.constructor=g,g.prototype.open=function(e){e(this.file)},g.prototype.browserOpen=function(e){e=e||"_blank",this.url||(this.url=URL.createObjectURL(this.file.file)),o.open(this.url,e)},g.prototype.close=function(){},g.prototype.start=function(){this.session=r.startUpload(this.scope,this.token),this.handler=a.tokens.on(this.token,t.bind(function(e,t,n,i,o,a,r,s){this.session.handleRequest(this.scope,s,i)},this),"xfer")},g.prototype.stop=function(){f.prototype.stop.call(this)},g.prototype.clear=function(){this.stop(),this.close(),this.scope&&(this.scope.$emit("cancelUpload"),this.scope.$destroy(),this.scope=null),this.url&&(URL.revokeObjectURL(this.url),this.url=null),this.session=null,f.prototype.clear.call(this)};var m=["$scope","$element","$attrs",function(n,o){var s=0,d=o.find(".presentationpane");n.layout.presentation=!1,n.hideControlsBar=!0,n.currentPageNumber=-1,n.maxPageNumber=-1,n.pendingPageRequest=null,n.presentationLoaded=!1,n.currentPresentation=null,n.currentPage=null,n.receivedPage=null,n.loading=!1,n.activeDownloads=[],n.availablePresentations=[],n.getPresentation=function(e){var i=t.find(n.availablePresentations,function(t){return t.token===e});return i||null},n.resetProperties=function(){n.currentPageNumber=-1,n.maxPageNumber=-1,n.pendingPageRequest=null,n.presentationLoaded=!1,n.currentPresentation=null,n.currentPage=null,n.receivedPage=null,n.loading=!1},n.$on("presentationOpening",function(){n.loading=!0}),n.$on("presentationLoaded",function(e,t,i){n.maxPageNumber=i.numPages,n.currentPresentation&&n.currentPresentation.presentable?n.currentPageNumber=1:null!==n.pendingPageRequest&&(n.currentPageNumber=n.pendingPageRequest,n.pendingPageRequest=null),n.presentationLoaded=!0}),n.$on("presentationLoadError",function(e,t,i){n.loading=!1,c.dialog.alert(i)});var u=function(e,i){var o=e.id,a=n.getPresentation(o);if(a)return void console.log("Found existing presentation",a);var r=t.find(n.activeDownloads,function(e){return e.token===o});return r?void console.log("Still downloading presentation",r):(r=new h(n,e,o,i),r.e.one("available",function(e,i){var o=t.indexOf(n.activeDownloads,i);-1!==o&&n.activeDownloads.splice(o,1)}),n.activeDownloads.push(r),n.availablePresentations.push(r),void r.start())},f=function(e){var t=e.info.id,i=n.getPresentation(t);if(i)return console.log("Already uploaded presentation",i),i;var o=new g(n,e,t);return n.availablePresentations.push(o),o.start(),o};a.api.e.on("received.presentation",function(e,i,o,a,r){if(!r)return void console.warn("Received presentation info without p2p. This should not happen!");if(a.Type)switch(a.Type){case"FileInfo":console.log("Received presentation file request",a),n.$apply(function(){u(a.FileInfo,o)});break;case"Delete":console.log("Received presentation delete request",a),n.$apply(function(e){var n=a.Delete,i=t.find(e.availablePresentations,function(e){return!e.uploaded&&e.token===n});i&&e.deletePresentation(i)});break;case"Show":console.log("Received presentation show request",a),n.$apply(function(e){e.layout.presentation||(e.resetProperties(),e.layout.presentation=!0)});break;case"Hide":console.log("Received presentation hide request",a),n.$apply(function(e){e.layout.presentation=!1});break;case"Select":console.log("Received presentation select request",a),n.$apply(function(e){var n=a.Select,i=t.find(e.availablePresentations,function(e){return!e.uploaded&&e.token===n});i?e.doSelectPresentation(i):console.log("No presentation found for token",n)});break;case"Page":n.$apply(function(e){e.receivedPage=a.Page,e.presentationLoaded?(console.log("Received presentation page request",a),e.currentPageNumber=a.Page):(console.log("Queuing presentation page request, not loaded yet",a),e.pendingPageRequest=a.Page)});break;default:console.log("Received unknown presentation event",a)}});var m={},v=[],b=null,y=null,w=function(e,t,n){a.api.apply("sendPresentation",{send:function(t,n){return e.peerconnection.datachannelReady?e.peerconnection.send(n):e.e.one("dataReady",function(){e.peerconnection.send(n)})}})(e.id,t,n)},k=function(e,i){m.hasOwnProperty(i.id)||(m[i.id]=!0,w(i,e,{Type:"Show",Show:!0}),t.each(n.availablePresentations,function(t){t.uploaded&&w(i,e,{Type:"FileInfo",FileInfo:t.info})}),n.currentPresentation&&n.currentPresentation.uploaded&&(w(i,e,{Type:"Select",Select:n.currentPresentation.token}),null!==n.currentPage&&w(i,e,{Type:"Page",Page:n.currentPage})))},x=function(e,i,o){switch(i){case"completed":case"connected":k(b,o);break;case"closed":delete m[o.id],t.isEmpty(m)&&(console.log("All peers disconnected, stopping presentation"),n.$apply(function(e){e.hidePresentation()}))}};n.$on("presentationPageLoading",function(e,t){return n.loading=!1,n.currentPageNumber=t,n.receivedPage===t?void(n.receivedPage=null):(n.currentPage=t,void a.webrtc.callForEachCall(function(e){w(e,b,{Type:"Page",Page:t})}))}),n.$on("presentationPageLoadError",function(e,t,i){n.loading=!1,c.dialog.alert(i)}),n.$on("presentationPageRenderError",function(e,t,i,o){n.loading=!1,c.dialog.alert(o)}),n.advertiseFile=function(e){console.log("Advertising file",e);var t=e.info;a.webrtc.callForEachCall(function(e){w(e,b,{Type:"FileInfo",FileInfo:t})});var i=f(e);n.currentPresentation||n.selectPresentation(i)};var $=function(e){var i=[];t.each(e,function(e){return p.hasOwnProperty(e.info.type)?void(null!==i&&i.push(e)):(console.log("Not sharing file",e),c.dialog.alert(l._("Only PDF documents and OpenDocument files can be shared at this time.")),void(i=null))}),n.$apply(function(e){t.each(i,function(t){t.info.hasOwnProperty("id")||(t.info.id=t.id),e.advertiseFile(t)})})},C="file_"+n.id,S=r.bindDrop(C,o,function(e){console.log("Files dragged",e),$(e)});S.namespace=function(){return C+"_"+n.myid};var P=r.bindClick(C,o.find(".welcome button")[0],function(e){console.log("Files selected",e),$(e)});P.namespace=function(){return C+"_"+n.myid};var T=r.bindClick(C,o.find(".thumbnail button")[0],function(e){console.log("Files selected",e),$(e)});T.namespace=function(){return C+"_"+n.myid},n.showPresentation=function(){console.log("Presentation active"),n.layout.presentation=!0,n.$emit("mainview","presentation",!0),b&&a.tokens.off(b,y),b="presentation_"+n.id+"_"+s++,y=a.tokens.create(b,function(e,t,n,i,o,a,r,s){console.log("Presentation create",t,i,o,s),v.push(s)
},"presentation"),a.webrtc.callForEachCall(function(e){k(b,e)}),a.webrtc.e.on("statechange",x)},n.hidePresentation=function(){console.log("Presentation disabled"),b&&(a.webrtc.callForEachCall(function(e){w(e,b,{Type:"Hide",Hide:!0})}),a.tokens.off(b,y),b=null),n.resetProperties(),n.layout.presentation=!1,m={},n.$emit("mainview","presentation",!1),a.webrtc.e.off("statechange",x)},n.selectPresentation=function(e){if(e.presentable){if(n.currentPresentation===e)return void(n.currentPageNumber=1);a.webrtc.callForEachCall(function(t){w(t,b,{Type:"Select",Select:e.token})}),n.doSelectPresentation(e)}},n.doSelectPresentation=function(e){console.log("Selected",e),n.resetProperties(),n.currentPresentation=e},n.deletePresentation=function(e,i){i&&i.preventDefault();var o=t.indexOf(n.availablePresentations,e);-1!==o&&n.availablePresentations.splice(o,1),e.uploaded&&a.webrtc.callForEachCall(function(t){w(t,b,{Type:"Delete",Delete:e.token})}),n.currentPresentation===e&&(n.currentPresentation=null,n.resetProperties()),e.clear()},n.downloadPresentation=function(e,t){t&&t.preventDefault(),e.browserOpen()},n.toggleFullscreen=function(e){i.enabled&&i.toggle(e?e:d[0])},n.prevPage=function(){n.currentPageNumber>1&&(n.currentPageNumber-=1)},n.nextPage=function(){n.currentPageNumber<n.maxPageNumber&&(n.currentPageNumber+=1)},a.webrtc.e.on("done",function(){n.$apply(function(){t.each(n.availablePresentations,function(e){e.clear()}),n.availablePresentations=[],n.activeDownloads=[]})}),n.$on("keyUp",function(e,t){switch(t){case 37:n.prevPage();break;case 39:case 32:n.nextPage()}}),e(document).on("keyup",function(t){n.layout.presentation&&(e(t.target).is("input,textarea,select")||(n.$apply(function(e){e.$emit("keyUp",t.keyCode)}),t.preventDefault()))}),n.$watch("layout.presentation",function(e,t){e&&!t?n.showPresentation():!e&&t&&n.hidePresentation()}),n.$watch("layout.main",function(e){e&&"presentation"!==e&&n.hidePresentation()})}],v=function(){return function(n,i){e(i).on("dblclick",".canvasContainer",t.debounce(function(e){n.toggleFullscreen(e.delegateTarget)},100,!0))}};return{restrict:"E",replace:!0,scope:!0,template:n,controller:m,compile:v}}]}),define("text!partials/youtubevideo.html",[],function(){return'<div class="youtubevideo">\n	<div class="youtubevideopane nicescroll">\n		<form class="container-fluid form" role="form">\n\n			<div class="welcome container-fluid" ng-show="!playbackActive && youtubeAPIReady">\n				<h1>{{_(\'Share a YouTube video\')}}</h1>\n				<div class="welcome-container">\n					<p>{{_("Videos play simultaneously for everyone in this call.")}}</p>\n					<div class="form-group welcome-input">\n						<input type="text" class="form-control input-lg" ng-model="youtubeurl" placeholder="{{_(\'YouTube URL\')}}">\n						<div class="welcome-input-buttons">\n					  		<button class="btn btn-primary" type="button" ng-disabled="!youtubeurl" ng-click="shareVideo(youtubeurl)">{{_("Share")}}</button>\n						</div>\n					</div>\n				</div>\n			</div>\n\n			<div class="welcome container-fluid" ng-show="!youtubeAPIReady">\n				<h1>{{_(\'Share a YouTube video\')}}</h1>\n				<div class="welcome-container">\n					<div>\n					  <p>{{_("Could not load YouTube player API, please check your network / firewall settings.")}}</p>\n					  <p ng-if="currentVideoUrl">{{_(\'Currently playing\')}}<br><a href="{{ currentVideoUrl }}" rel="external" target="_blank">{{ currentVideoUrl }}</a></p>\n					  <p class="form-group welcome-input">\n						<button class="btn btn-primary btn-lg" type="button" ng-click="loadYouTubeAPI()">{{_("Retry")}}</button>\n					  </p>\n					</div>\n				</div>\n			</div>\n\n			<div ng-show="playbackActive">\n				<div class="row youtubecontainer">\n					<div class="embed-responsive embed-responsive-16by9 youtubeplayercontainer"></div>\n					<div class="youtubeplayerinfo">\n						<div>{{_(\'Currently playing\')}}<br><a href="{{ currentVideoUrl }}" rel="external" target="_blank">{{ currentVideoUrl }}</a></div>\n					</div>\n					<div class="click-container" ng-show="!isPublisher">\n						<div class="volumecontrol">\n							<button class="btn volume-button" ng-class="{\'active\': volumebarVisible}" ng-click="volumebarVisible=!volumebarVisible"><i class="fa fa-volume-up" ng-class="{\'fa-volume-up\': volume &gt;= 60, \'fa-volume-down\': volume &lt; 60}"></i></button>\n							<div ng-show="volumebarVisible" class="volumebar">\n								<input type="range" class="bar" min="0" max="100" step="1" ng-model="volume" />\n							</div>\n						</div>\n					</div>\n				</div>\n			</div>\n		</form>\n	</div>\n\n	<div class="overlaybar form-horizontal" ng-if="youtubeAPIReady" ng-class="{notvisible: hideControlsBar}">\n		<a class="overlaybar-button" ng-model="hideControlsBar" btn-checkbox btn-checkbox btn-checkbox-true="0" btn-checkbox-false="1" title="{{_(\'YouTube controls\')}}"><i class="fa fa-cogs"></i></a>\n		<div class="overlaybar-content">\n			<form class="container-fluid" role="form">\n				<div class="form-group">\n					<label>{{_(\'YouTube video to share\')}}</label>\n					<div class="overlaybar-input">\n						<input type="text" class="form-control input-lg" ng-disabled="!youtubeAPIReady" ng-model="youtubeurl" required placeholder="{{_(\'YouTube URL\')}}">\n						<div class="overlaybar-buttons">\n							<button type="button" class="btn btn-primary" ng-click="shareVideo(youtubeurl)" ng-disabled="youtubeurl === \'\'">{{_(\'Share\')}}</button>\n						</div>\n					</div>\n				</div>\n			</form>\n		</div>\n	</div>\n</div>\n'}),define("directives/youtubevideo",["require","jquery","underscore","moment","text!partials/youtubevideo.html","bigscreen"],function(e,t,n,i,o,a){return["$window","$document","mediaStream","alertify","translation","safeApply","appData","$q","restURL","sandbox","$http",function(e,r,s,c,l,d,u,p,f,h,g){var m="//www.youtube.com/iframe_api",v=p.defer(),b=v.promise,y=function(e,t){this.sandbox=e,this.state=-1,this.position=0,this.lastPositionUpdate=null,this.sandbox.postMessage("loadPlayer",t)};y.prototype.destroy=function(){this.sandbox.postMessage("destroyPlayer",{destroy:!0})},y.prototype.loadVideoById=function(e,t){var n={id:e};"undefined"!=typeof t&&(n.position=t),this.sandbox.postMessage("loadVideo",n)},y.prototype.playVideo=function(){this.sandbox.postMessage("playVideo",{play:!0})},y.prototype.pauseVideo=function(){this.sandbox.postMessage("pauseVideo",{pause:!0})},y.prototype.stopVideo=function(){this.sandbox.postMessage("stopVideo",{stop:!0})},y.prototype.seekTo=function(e,t){var n={position:e};"undefined"!=typeof t&&(n.allowSeekAhead=t),this.sandbox.postMessage("seekTo",n)},y.prototype.setVolume=function(e){this.sandbox.postMessage("setVolume",{volume:e})},y.prototype.setCurrentTime=function(e){this.position=e,this.lastPositionUpdate=i()},y.prototype.getCurrentTime=function(){if(!this.lastPositionUpdate)return this.position;var e=i(),t=e.diff(this.lastPositionUpdate,"seconds",!0);return this.position+t},y.prototype.setPlayerState=function(e){this.state=e},y.prototype.getPlayerState=function(){return this.state};var w=["$scope","$element","$attrs",function(i,o){var r=null,p=null,w=null,k=null,x=null,$=null,C=function(n,a){$&&n&&($.destroy(),$=null),$||($=h.createSandbox(t(".youtubeplayercontainer",o)[0],a,null,"allow-scripts allow-same-origin","youtubeplayer"),$.e.on("message",function(t,n){var o=n.data,a=o[o.type]||{};switch(o.type){case"ready":$.postMessage("loadApi",{url:e.location.protocol+m});break;case"youtube.apiReady":i.$apply(function(){console.log("YouTube IFrame ready"),v.resolve()});break;case"youtube.error":i.$apply(function(e){console.log("YouTube error",a),e.$emit("youtube.error",a.msgid)});break;case"youtube.playerReady":i.$apply(function(){p.resolve()});break;case"youtube.volume":i.$apply(function(e){e.volume=a.volume});break;case"youtube.event":i.$apply(function(e){console.log("State change",a),r&&r.setPlayerState(a.state),e.$emit(a.event,a.position)});break;case"youtube.position":r&&r.setCurrentTime(a.position);break;default:console.log("Unknown message received",n)}}))};i.$on("$destroy",function(){r&&(r.destroy(),r=null),$&&($.destroy(),$=null)}),i.isPublisher=null,i.playbackActive=!1,i.hideControlsBar=!0,i.currentVideoUrl=null,i.currentVideoId=null,i.youtubeurl="",i.youtubeAPIReady=!1,i.volumebarVisible=!0,i.volume=null,b.then(function(){d(i,function(e){e.youtubeAPIReady=!0})});var S=function(e){if(!e)return null;var t=/^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\?))\??v?=?([^#\&\?]*).*/,n=e.match(t);return n&&11==n[7].length?n[7]:null};i.$on("youtube.playing",function(e,t){return 2===x?(x=null,void r.pauseVideo()):void(w&&(w=!1,s.webrtc.callForEachCall(function(e){U(e,M,{Type:"Resume",Resume:{position:t}})})))}),i.$on("youtube.buffering",function(){2===x&&(x=null,r.pauseVideo())}),i.$on("youtube.paused",function(e,t){i.isPublisher&&M&&(w||(w=!0,s.webrtc.callForEachCall(function(e){U(e,M,{Type:"Pause",Pause:{position:t}})})))}),i.$on("youtube.ended",function(){}),i.$on("youtube.seeked",function(e,t){i.isPublisher&&M&&s.webrtc.callForEachCall(function(e){U(e,M,{Type:"Seek",Seek:{position:t}})})}),i.$on("youtube.error",function(e,t){var n;switch(t){case"loadScriptFailed":n=l._("Could not load YouTube player API, please check your network / firewall settings.");break;case"invalidParameter":n=l._("The request contains an invalid parameter value. Please check the URL of the video you want to share and try again.");break;case"htmlPlayerError":n=l._("The requested content cannot be played in an HTML5 player or another error related to the HTML5 player has occurred. Please try again later.");break;case"videoNotFound":n=l._("The video requested was not found. Please check the URL of the video you want to share and try again.");break;case"notAllowedEmbedded":n=l._("The owner of the requested video does not allow it to be played in embedded players.");break;default:n=t?l._("An unknown error occurred while playing back the video (%s). Please try again later.",t):l._("An unknown error occurred while playing back the video. Please try again later.")}r&&(r.destroy(),r=null),c.dialog.alert(n)});var P=function(e,t,n){p.done(function(){if(i.playbackActive=!0,w=null,k){var o=.001*(new Date-k);k=null,t?t+=o:t=o}x=n,t?r.loadVideoById(e,t):r.loadVideoById(e)})},T=function(n){r&&i.isPublisher!==n&&(r.destroy(),r=null,p=null),p||(p=t.Deferred()),b.then(function(){if(!r){var t=e.location.protocol+"//"+e.location.host;r=new y($,{height:"390",width:"640",playerVars:{enablejsapi:"1",hl:u.language||"en",autohide:"1",rel:"0",showinfo:"0",playsinline:"1",controls:n?"2":"0",disablekb:n?"0":"1",origin:t}}),d(i,function(e){e.playbackActive=!0,e.isPublisher=n})}})};i.shareVideo=function(e){var t=S(e);return t?(s.webrtc.callForEachCall(function(n){U(n,M,{Type:"Play",Play:{url:e,id:t}})}),T(!0),i.youtubeurl="",i.currentVideoUrl=e,i.currentVideoId=t,void P(t)):void c.dialog.alert(l._("Unknown URL format. Please make sure to enter a valid YouTube URL."))},s.api.e.on("received.youtubevideo",function(e,t,n,o,a){if(!a)return void console.warn("Received YouTubeVideo info without p2p. This should not happen!");if(o.Type)switch(o.Type){case"Show":console.log("Received YouTubeVideo show request",o),i.$apply(function(e){e.layout.youtubevideo=!0});break;case"Hide":console.log("Received YouTubeVideo hide request",o),i.$apply(function(e){e.layout.youtubevideo=!1});break;case"Play":console.log("Received YouTubeVideo play request",o),k=new Date,i.$apply(function(e){e.currentVideoUrl=o.Play.url,T(!1),p.done(function(){d(e,function(e){e.currentVideoUrl=o.Play.url,e.currentVideoId=o.Play.id,P(o.Play.id,o.Play.position,o.Play.state)})})});break;case"Pause":console.log("Received YouTubeVideo pause request",o),i.$apply(function(){r&&(r.pauseVideo(),o.Pause.position&&r.seekTo(o.Pause.position,!0))});break;case"Resume":console.log("Received YouTubeVideo resume request",o),i.$apply(function(){r&&(o.Resume.position&&r.seekTo(o.Resume.position,!0),r.playVideo())});break;case"Seek":console.log("Received YouTubeVideo seek request",o),i.$apply(function(){r&&r.seekTo(o.Seek.position)});break;default:console.log("Received unknown YouTubeVideo event",o)}});var _={},D=[],R=0,M=null,A=null,U=function(e,t,n){s.api.apply("sendYouTubeVideo",{send:function(t,n){return e.peerconnection.datachannelReady?e.peerconnection.send(n):e.e.one("dataReady",function(){e.peerconnection.send(n)})}})(e.id,t,n)},E=function(e,t){if(!_.hasOwnProperty(t.id)&&(_[t.id]=!0,U(t,e,{Type:"Show",Show:!0}),i.isPublisher&&i.currentVideoUrl)){var n={url:i.currentVideoUrl,id:i.currentVideoId};r&&(n.position=r.getCurrentTime(),n.state=r.getPlayerState()),U(t,e,{Type:"Play",Play:n})}},I=function(e,t,o){switch(t){case"completed":case"connected":E(M,o);break;case"closed":delete _[o.id],n.isEmpty(_)&&(console.log("All peers disconnected, stopping youtubevideo"),i.$apply(function(e){e.hideYouTubeVideo()}))}};i.loadYouTubeAPI=function(e){var t=f.sandbox("youtubevideo"),n=/<base href=.*>/i;g.get(t).success(function(t){var i='<base href="'+f.createAbsoluteUrl("")+'">';t=t.replace(n,i),C(!e,t)})},i.showYouTubeVideo=function(){i.loadYouTubeAPI(!0),i.layout.youtubevideo=!0,i.$emit("mainview","youtubevideo",!0),M&&s.tokens.off(M,A),M="youtubevideo_"+i.id+"_"+R++,A=s.tokens.create(M,function(e,t,n,i,o,a,r,s){console.log("YouTubeVideo create",t,i,o,s),D.push(s)},"youtubevideo"),s.webrtc.callForEachCall(function(e){E(M,e)}),s.webrtc.e.on("statechange",I)},i.hideYouTubeVideo=function(){i.$emit("mainview","youtubevideo",!1),i.layout.youtubevideo=!1,M&&(s.webrtc.callForEachCall(function(e){U(e,M,{Type:"Hide",Hide:!0})}),s.tokens.off(M,A),M=null),r&&(r.destroy(),r=null),i.isPublisher=null,i.playbackActive=!1,i.currentVideoUrl=null,i.currentVideoId=null,_={},p=null,x=null,s.webrtc.e.off("statechange",I)},i.$watch("layout.youtubevideo",function(e,t){e&&!t?i.showYouTubeVideo():!e&&t&&i.hideYouTubeVideo()}),i.$watch("layout.main",function(e){e&&"youtubevideo"!==e&&i.hideYouTubeVideo()}),i.$watch("volume",function(e,t){t!==e&&r&&!i.isPublisher&&null!==e&&r.setVolume(e)}),i.toggleFullscreen=function(e){a.enabled&&a.toggle(e,function(){t(e).addClass("fullscreen")},function(){t(e).removeClass("fullscreen")})}}],k=function(){return function(e,i){t(i).find(".youtubecontainer").on("dblclick",n.debounce(function(t){e.toggleFullscreen(t.delegateTarget)},100,!0))}};return{restrict:"E",replace:!0,scope:!0,template:o,controller:w,compile:k}}]}),function(e){e.fn.bootstrapFileInput=function(){this.each(function(t,n){var i=e(n);if("undefined"==typeof i.attr("data-bfi-disabled")){var o="Browse";"undefined"!=typeof i.attr("title")&&(o=i.attr("title"));var a="";i.attr("class")&&(a=" "+i.attr("class")),i.wrap('<a class="file-input-wrapper btn btn-default '+a+'"></a>').parent().prepend(e("<span></span>").html(o))}}).promise().done(function(){e(".file-input-wrapper").mousemove(function(t){var n,i,o,a,r,s,c,l;i=e(this),n=i.find("input"),o=i.offset().left,a=i.offset().top,r=n.width(),s=n.height(),c=t.pageX,l=t.pageY,moveInputX=c-o-r+20,moveInputY=l-a-s/2,n.css({left:moveInputX,top:moveInputY})}),e("body").on("change",".file-input-wrapper input[type=file]",function(){var t;t=e(this).val(),e(this).parent().next(".file-input-name").remove(),t=e(this).prop("files")&&e(this).prop("files").length>1?e(this)[0].files.length+" files":t.substring(t.lastIndexOf("\\")+1,t.length);var n=e(this).data("filename-placement")||"outside";"inside"===n?(e(this).siblings("span").html(t),e(this).attr("title",t)):"outside"===n?e(this).parent().after('<span class="file-input-name">'+t+"</span>"):console.log("Error in bootstrap-file-input plugin : unknown placement ["+n+"] for selected filename")})})};var t="<style>.file-input-wrapper { overflow: hidden; position: relative; cursor: pointer; z-index: 1; }.file-input-wrapper input[type=file], .file-input-wrapper input[type=file]:focus, .file-input-wrapper input[type=file]:hover { position: absolute; top: 0; left: 0; cursor: pointer; opacity: 0; filter: alpha(opacity=0); z-index: 99; outline: 0; }.file-input-name { margin-left: 8px; }</style>";e("link[rel=stylesheet]").eq(0).before(t)}(jQuery),define("bootstrap-file-input",["jquery"],function(e){return function(){var t;return t||e.$}}(this)),define("directives/bfi",["bootstrap-file-input"],function(){return["$timeout",function(e){return{restrict:"A",link:function(t,n){e(function(){n.bootstrapFileInput()})}}}]}),define("directives/title",[],function(){return[function(){var e=function(e,t){var n=t.text(),i=function(e){t.text(e?e+" - "+n:n)};e.$on("room.updated",function(e,t){i(t.Name)}),e.$on("room.left",function(){i()})};return{restrict:"E",replace:!1,link:e}}]}),define("directives/welcome",[],function(){return["rooms","$timeout","mediaStream","translation",function(e,t,n,i){function o(n,o){var a=i._("Room name");n.randomRoom=e.randomRoom,n.canCreateRooms=e.canCreateRooms,n.canJoinRooms=e.canJoinRooms,n.joinRoomByName=function(t){n.welcome.$invalid||t&&e.joinByName(t)};var r=e.getRandomRoom(),s=!0;r?(n.roomdata={name:r.name,placeholder:r.name?r.name:a},s=!1):n.roomdata={placeholder:a},n.roomdataInput={name:""},n.$watch("roomdata.name",function(t){n.roomdata.link=e.link({Name:t})},!0),n.$watch("roomdataInput.name",function(e){""===e?s?n.randomRoom():s=!0:n.roomdata.name=e}),n.$on("room.random",function(e,t){n.roomdata={name:t.name,last:t.name,placeholder:t.name?t.name:a},n.roomdataInput.name=""}),t(function(){o.find(".roomdata-link-input:visible:enabled:first").focus()})}return{restrict:"EA",link:o}}]}),define("text!partials/menu.html",[],function(){return'<span>\n	<button ng-if="withModule(\'youtube\')" title="{{_(\'Share a YouTube video\')}}" class="btn aenablebtn btn-youtubevideo" ng-show="status==\'connected\' || status==\'conference\' || layout.youtubevideo" ng-model="layout.youtubevideo" btn-checkbox><i class="fa fa-youtube"></i></button>\n	<button ng-if="withModule(\'presentation\')" title="{{_(\'Share a file as presentation\')}}" class="btn aenablebtn btn-presentation" ng-show="status==\'connected\' || status==\'conference\' || layout.presentation" ng-model="layout.presentation" btn-checkbox><i class="fa fa-folder-open-o"></i></button>\n	<button ng-if="withModule(\'screensharing\')" title="{{_(\'Share your screen\')}}" class="btn aenablebtn btn-screenshare" ng-disabled="!supported.screensharing" ng-show="status==\'connected\' || status==\'conference\' || layout.screenshare" ng-model="layout.screenshare" btn-checkbox><i class="fa fa-desktop"></i></button>\n	<button title="{{_(\'Chat\')}}" class="btn btn-chat" ng-class="{messagesunseen: chatMessagesUnseen>0}" ng-model="layout.chat" btn-checkbox btn-checkbox-true="true" btn-checkbox-false="false"><i class="fa fa-comments-o"></i><span class="badge" ng-show="chatMessagesUnseen" ng-bind="chatMessagesUnseen"></span></button>\n	<button ng-if="withModule(\'contacts\')" ng-show="myid && myuserid" title="{{_(\'Contacts\')}}" class="btn btn-contacts" ng-click="openContactsManager()"><i class="fa fa-sitemap"></i></button>\n	<button title="{{_(\'Mute microphone\')}}" class="btn btn-mutemicrophone amutebtn" ng-model="microphoneMute" btn-checkbox btn-checkbox-true="true" btn-checkbox-false="false"><i class="fa"></i></button>\n	<button title="{{_(\'Turn camera off\')}}" class="btn btn-mutecamera amutebtn" ng-model="cameraMute" btn-checkbox btn-checkbox-true="true" btn-checkbox-false="false"><i class="fa"></i></button>\n	<button title="{{_(\'Settings\')}}" class="btn btn-settings" ng-model="layout.settings" btn-checkbox btn-checkbox-true="true" btn-checkbox-false="false"><i class="fa fa-cog"></i></button>\n</span>'}),define("directives/menu",["text!partials/menu.html"],function(e){return["modules",function(t){var n=function(e){e.withModule=t.withModule};return{restrict:"E",replace:!0,template:e,link:n}}]}),define("text!partials/ui.html",[],function(){return'<div class="ui">\n	<page></page>\n	<div id="bar" class="navbar navbar-default navbar-fixed-top bar">\n		<div class="container-fluid">\n			<div class="navbar-header">\n				<button type="button" class="navbar-toggle collapsed" ng-click="isCollapsed = !isCollapsed">\n					<span class="icon-bar"></span>\n					<span class="icon-bar"></span>\n					<span class="icon-bar"></span>\n				</button>\n				<div class="navbar-brand left">\n					<span ui-logo class="logo"><span class="desc"><a target="_blank" href="https://github.com/strukturag/spreed-webrtc">WebRTC</a></span></span>\n				</div>\n			</div>\n			<div class="navbar-collapse collapse" collapse="isCollapsed">\n				<ul class="nav navbar-nav navbar-right right">\n					<li class="ng-cloak">\n						<menu></menu>\n					</li>\n				</ul>\n			</div>\n		</div>\n		<div class="callbar middle">\n			<status-message></status-message>\n		</div>\n	</div>\n	<div id="roombar" class="ng-cloak">\n		<room-bar/>\n	</div>\n	<div id="audiolevel" class="ng-cloak">\n		<div class="audio-level" title="{{_(\'Your audio level\')}}"></div>\n	</div>\n	<div id="audiovideo" class="ng-cloak" ng-show="peer">\n		<audio-video/>\n	</div>\n	<div id="screenshare" class="ng-cloak mainview">\n		<screenshare/>\n	</div>\n	<div id="presentation" class="ng-cloak mainview">\n		<presentation/>\n	</div>\n	<div id="youtubevideo" class="ng-cloak mainview">\n		<youtubevideo/>\n	</div>\n	<div class="ng-cloak" id="rightslide">\n		<div class="rightslidepane">\n			<div id="buddylist"><buddy-list/></div>\n			<div id="chat"><chat/></div>\n		</div>\n	</div>\n	<div class="ng-cloak" id="settings" ng-class="{show: layout.settings}"><settings/></div>\n</chat>'}),define("directives/ui",["text!partials/ui.html"],function(e){return[function(){return{restrict:"E",replace:!0,scope:!1,controller:"UiController",template:e}}]}),define("directives/directives",["underscore","directives/onenter","directives/onescape","directives/statusmessage","directives/buddylist","directives/buddypicturecapture","directives/buddypictureupload","directives/settings","directives/chat","directives/audiovideo","directives/usability","directives/audiolevel","directives/fileinfo","directives/screenshare","directives/roombar","directives/socialshare","directives/page","directives/contactrequest","directives/defaultdialog","directives/pdfcanvas","directives/odfcanvas","directives/presentation","directives/youtubevideo","directives/bfi","directives/title","directives/welcome","directives/menu","directives/ui"],function(e,t,n,i,o,a,r,s,c,l,d,u,p,f,h,g,m,v,b,y,w,k,x,$,C,S,P,T){var _={onEnter:t,onEscape:n,statusMessage:i,buddyList:o,buddyPictureCapture:a,buddyPictureUpload:r,settings:s,chat:c,audioVideo:l,usability:d,audioLevel:u,fileInfo:p,screenshare:f,roomBar:h,socialShare:g,page:m,contactRequest:v,defaultDialog:b,pdfcanvas:y,odfcanvas:w,presentation:k,youtubevideo:x,bfi:$,title:C,welcome:S,menu:P,ui:T},D=function(t){e.each(_,function(e,n){t.directive(n,e)})};return{initialize:D}}),define("filters/displayname",[],function(){return["buddyData","appData","translation",function(e,t,n){var i="",o={count:1},a=n._("User"),r=n._("Someone"),s=n._("Me");return function(n,c){if(n===i)return"";var l=e.lookup(n,!1,!0);if(l)return l.display.displayName?l.display.displayName:a+" "+l.buddyIndex;var d=t.get();if(d&&n===d.id)return c?s:d.master.displayName?d.master.displayName:s;var u=o[n];return u||(u=r+" "+o.count++,o[n]=u),u}}]}),define("filters/buddyimagesrc",["underscore"],function(e){var t=function(e){return URL.createObjectURL(e)},n=function(e){return URL.revokeObjectURL(e)};return["buddyData","buddyPicture","appData",function(i,o,a){var r={},s=function(e,t){delete r[e],n(t)};return window.setInterval(function(){e.each(r,function(e,t){i.get(t)||s(t,e)})},5e3),function(e,n){if("undefined"==typeof n){var c=i.lookup(e,!1,!0);c&&(n=c.display)}if(n){if(n.buddyPictureLocalUrl)return n.buddyPictureLocalUrl;if(n.buddyPicture){var l=r[e];if(l&&s(e,l),o.update(n),n.buddyPictureLocalUrl)return n.buddyPictureLocalUrl;if(l=n.buddyPicture,0===l.indexOf("data:")){var d=o.toBlob(l);return l=n.buddyPictureLocalUrl=r[e]=t(d)}return null}}else{var u=a.get();if(u&&e===u.id&&u.master.buddyPicture)return u.master.buddyPicture}return""}}]}),define("filters/displayconference",[],function(){return["safeDisplayName","translation",function(e,t){return function(n){return n&&0!==n.length?1===n.length?" "+t._("and %s",e(n[0])):" "+t._("and %d others",n.length):""}}]}),define("filters/displayuserid",[],function(){return[function(){return function(e){return e}}]}),define("filters/displaynameforsession",["jquery"],function(e){return["$filter",function(t){return function(n,i){return""!==e.trim(n)?n:t("displayName")(i)}}]}),define("filters/formatbase1000",[],function(){return[function(){var e=2,t=2,n=1,i=0;return function(o,a,r){o=Number(o),r=Number(r);var s=function(e){var t=o.toString().search(/\./);return e+=-1===t?o.toString().length:t,e>21&&(e=21),o.toPrecision(e)},c=function(){return isNaN(r)?o>=100?i:100>o&&o>=10?n:10>o&&o>=1?t:e:r};return a?o>=1e3?(o/=1e3,s(c())+"k"+a):1>o&&o>=.01?(o*=100,s(c())+"c"+a):.01>o?(o*=1e3,s(c())+"m"+a):s(c())+a:s(c())}}]}),define("filters/filters",["underscore","filters/displayname","filters/buddyimagesrc","filters/displayconference","filters/displayuserid","filters/displaynameforsession","filters/formatbase1000"],function(e,t,n,i,o,a,r){var s={displayName:t,buddyImageSrc:n,displayConference:i,displayUserid:o,displayNameForSession:a,formatBase1000:r},c=function(t){e.each(s,function(e,n){t.filter(n,e)})};return{initialize:c}}),define("controllers/uicontroller",["jquery","underscore","bigscreen","moment","sjcl","modernizr","webrtc.adapter"],function(e,t,n,i,o,a){return["$scope","$rootScope","$element","$window","$timeout","safeDisplayName","safeApply","mediaStream","appData","playSound","desktopNotify","alertify","toastr","translation","fileDownload","localStorage","screensharing","localStatus","dialogs","rooms","constraints",function(o,r,s,c,l,d,u,p,f,h,g,m,v,b,y,w,k,x,$,C,S){m.dialog.registerCustom({baseType:"notify",type:"webrtcUnsupported",message:b._("Your browser does not support WebRTC. No calls possible.")}),e(c).on("beforeunload",function(){return!f.flags.manualUnload&&o.peer?b._("Close this window and disconnect?"):void 0}),e(c).on("unload",function(){p.webrtc.doHangup("unload"),p.api.connector&&(p.api.connector.disabled=!0)}),e("#bar .logo").on("doubletap dblclick",t.debounce(function(){n.enabled&&n.toggle(e("body").get(0))},100,!0)),c.showCiphers=function(){var e=function(e){return JSON.stringify(e,null,2)},t=function(t){var n={};for(var i in t)if(t.hasOwnProperty(i)){var o=t[i],a=null;if("googCandidatePair"!==o.type)continue;if(!o.googActiveConnection)continue;if(a=t[o.googChannelId],a&&!n[a.id]){n[a.id]=!0,console.info("Connected channel",e(a));var r=t[a.localCertificateId],s=t[a.remoteCertificateId];console.info("Local  certificate",e(r)),console.info("Remote certificate",e(s))}}};p.webrtc.callForEachCall(function(e){e.peerconnection&&e.peerconnection.pc&&e.peerconnection.pc.getStats(null,function(e){t(e)},function(e){console.log("Failed to retrieve stats report",e)})})},h.initialize({urls:["sounds/sprite1.ogg","sounds/sprite1.mp3"],sprite:{connect1:[0,5179],end1:[12892,6199],entry1:[8387,3e3],leaving1:[5228,2126],message1:[19140,816],question1:[20006,3313],ringtone1:[7403,935],whistle1:[11437,1405]}},null,{ring:"whistle1",joined:"entry1",left:"leaving1",end:"end1",dial:"ringtone1",connect:"connect1",prompt:"question1",chatmessage:"message1"});var P=d;!function(){var e=p.config.StunURIs||[];S.stun(e)}(),o.isChrome="chrome"===c.webrtcDetectedBrowser,o.webrtcDetectedBrowser=c.webrtcDetectedBrowser,o.webrtcDetectedVersion=c.webrtcDetectedVersion,o.supported={screensharing:k.supported,constraints:S.supported},o.status="initializing",o.id=o.myid=null,o.userid=o.myuserid=null,o.suserid=null,o.peer=null,o.dialing=null,o.conference=null,o.conferencePeers=[],o.incoming=null,o.microphoneMute=!1,o.cameraMute=!1,o.layout={main:null},o.chatMessagesUnseen=0,o.autoAccept=null,o.isCollapsed=!0,o.usermedia=null,o.setStatus=function(e){o.$emit("status",e)},o.getStatus=function(){return o.status},o.updateStatus=function(e){var t={displayName:o.master.displayName||null,buddyPicture:o.master.buddyPicture||null,message:o.master.message||null};e&&x.clear(),x.update(t)},o.refreshWebrtcSettings=function(){S.refresh(o.master.settings).then(function(){var e=o.usermedia;e&&e.renegotiation&&e.started&&e.doGetUserMediaWithConstraints(p.webrtc.settings.mediaConstraints)})},o.refreshWebrtcSettings(),o.refreshSoundSettings=function(){var e=o.master.settings.sound;h.disable("chatmessage",!e.incomingMessages),h.disable("ring",!e.incomingCall);var t=o.peer?!1:e.roomJoinLeave;h.disable("joined",!t),h.disable("left",!t)},o.refreshSoundSettings();var T=null,_=null;o.updateAutoAccept=function(e,t){return e?(console.log("Auto accept requested",e),o.autoAccept=e,l.cancel(_),_=l(function(){o.autoAccept=null,console.warn("Auto accept expired!"),u(o)},2e3),void 0):o.autoAccept&&o.autoAccept===t?(o.autoAccept=null,l.cancel(_),console.log("Auto accept success",t),t):null},o.toggleBuddylist=function(){var e=null;return function(t,n){t||n?(e=o.layout.buddylist,o.layout.buddylist=!!t):o.layout.buddylist=e}}(),o.openContactsManager=function(){var e=null;return function(){return e&&e.dismiss("open"),e=$.create("/contactsmanager/main.html","ContactsmanagerController",{header:b._("Contacts Manager")},{wc:"contactsmanager"}),e.result.finally(function(){e=null}),e}}(),o.$watch("cameraMute",function(e){p.webrtc.setVideoMute(e)}),o.$watch("microphoneMute",function(e){p.webrtc.setAudioMute(e)}),o.$watch("peer",function(e,t){e&&!t?o.refreshSoundSettings():!e&&t&&o.refreshSoundSettings()});var D,R,M=h.interval("ring",null,4e3),A=h.interval("dial",null,4e3),U=!1,E=!1;p.api.e.on("received.self",function(e,n){if(l.cancel(R),u(o,function(e){e.id=e.myid=n.Id,e.userid=e.myuserid=n.Userid?n.Userid:null,e.suserid=n.Suserid?n.Suserid:null}),S.turn(n.Turn),S.stun(n.Stun),o.refreshWebrtcSettings(),n.Version!==p.version&&(console.info("Server was upgraded. Reload required."),E||(E=!0,t.delay(function(){m.dialog.confirm(b._("Restart required to apply updates. Click ok to restart now."),function(){o.manualReloadApp()},function(){E=!1})},300))),!n.Userid&&p.config.UsersEnabled){var i=p.users.load();null!==i?(o.loadedUserlogin=!0,console.log("Trying to authorize with stored credentials ..."),p.users.authorize(i,function(e){console.info("Retrieved nonce - authenticating as user:",e.userid),p.api.requestAuthentication(e.userid,e.nonce),delete e.nonce},function(e,t){console.error("Failed to authorize session",t,e),p.users.forget()})):o.loadedUserlogin=!1}if(n.Turn.ttl&&(R=l(function(){console.log("Ttl reached - sending refresh request."),p.api.sendSelf()},n.Turn.ttl/100*90*1e3)),f.flags.resurrect){var a=f.flags.resurrect;f.flags.resurrect=null,l(function(){a.id===o.id&&(console.log("Using resurrection shrine",a),o.setStatus(a.status))},0)}if(f.e.triggerHandler("selfReceived",[n]),n.Userid)f.authorizing(!1,n.Userid);else if(f.authorizing()){var r=function(){return function(e,t,n){t||(f.e.off("authorizing",r),r=null,n||o.loadUserSettings())}}();f.e.on("authorizing",r)}else o.loadUserSettings();C.inDefaultRoom()&&o.master.settings.defaultRoom&&(console.log("Selecting default room from settings:",[o.master.settings.defaultRoom]),C.joinByName(o.master.settings.defaultRoom,!0))}),p.webrtc.e.on("peercall",function(e,t){l.cancel(T),T=null,U=t&&null===t.from?!0:!1,M.stop(),D&&D.close(),u(o,function(e){e.peer=t?t.id:null})}),p.webrtc.e.on("peerconference",function(e,t){u(o,function(e){e.conference=t?t.id:null,e.conferencePeers=t?t.peerIds():[]})}),p.webrtc.e.on("offer",function(e,t){return u(o,function(e){e.incoming=t}),o.updateAutoAccept(null,t)?void p.webrtc.doAccept():(M.start(),D=g.notify(b._("Incoming call"),b._("from")+" "+P(t),{timeout:null}),o.$emit("status","ringing"),T=l(function(){console.log("Pickup timeout reached."),p.webrtc.doHangup("pickuptimeout"),o.$emit("notification","incomingpickuptimeout",{reason:"pickuptimeout",from:t})},3e4),void f.e.triggerHandler("uiNotification",["incoming",{from:t}]))
}),p.webrtc.e.on("error",function(e,t,n){switch(n){case"failed_getusermedia":t=b._("Failed to access camera/microphone.");break;case"failed_peerconnection_setup":case"failed_peerconnection":t=b._("Failed to establish peer connection.")}t||(t=n),t||(t=b._("We are sorry but something went wrong. Boo boo.")),m.dialog.alert(b._("Oops")+"<br/>"+t)}),p.webrtc.e.on("usermedia",function(e,t){u(o,function(e){e.usermedia=t})}),f.flags.autoreconnect=!0,f.flags.autoreconnectDelay=0;var I=function(){if(f.flags.connected&&f.flags.autoreconnect)if(null===f.flags.resurrect&&(f.flags.resurrect={status:o.getStatus(),id:o.id},console.log("Stored data at the resurrection shrine",f.flags.resurrect)),f.flags.reconnecting)console.warn("Already reconnecting ...");else{var e=f.flags.autoreconnectDelay;1e4>e&&(f.flags.autoreconnectDelay+=500),f.flags.reconnecting=!0,t.delay(function(){f.flags.autoreconnect&&(console.log("Requesting to reconnect ..."),p.reconnect()),f.flags.reconnecting=!1},e),o.setStatus("reconnecting")}else o.setStatus("closed")};o.$on("room.joined",function(){o.updateStatus(!0)}),p.connector.e.on("open error close",function(e){switch(l.cancel(R),o.userid=o.suserid=null,e.type){case"open":f.flags.connected=!0,f.flags.autoreconnectDelay=0,o.updateStatus(!0),o.setStatus("waiting");break;case"error":f.flags.connected?I():o.setStatus(e.type);break;case"close":I()}}),p.webrtc.e.on("waitforusermedia connecting",function(e,t){var n=e.type;u(o,function(e){e.dialing=t?t.id:null,e.setStatus(n)})}),p.webrtc.e.on("statechange",function(e,t,n){switch(console.info("P2P state changed",t,n.id),t){case"completed":case"connected":o.setStatus(o.conference?"conference":"connected");break;case"failed":p.webrtc.doHangup("failed",n.id),m.dialog.alert(b._("Peer connection failed. Check your settings."))}}),c.setInterval(function(){p.api.heartbeat(5e3,11500)},1e3),o.$on("active",function(e,t){console.info("Video state active (assuming connected)",t.id),o.setStatus(o.conference?"conference":"connected"),l(function(){o.peer&&(o.layout.buddylist=!1,o.layout.buddylistAutoHide=!0)},1e3)}),o.$on("mainview",function(e,t,n){console.info("Main view update",t,n);var i=!1,a=o.layout;a.main!==t||n?n&&(a.main=t,i=!0):(a.main=null,i=!0),i&&o.$broadcast("mainresize",a.main)}),o.$watch("userid",function(e,t){var n;e&&(n=o.suserid,console.info("Session is now authenticated:",e,n)),e!==t&&(f.e.triggerHandler("authenticationChanged",[e,n]),o.loadUserSettings())}),o.$watch("layout",function(){var e=function(e,t){return e+t.charAt(0).toUpperCase()+t.slice(1)};return function(n,i){t.each(n,function(t,n){if("main"!==n){var i=e("with",n);t?s.addClass(i):s.removeClass(i)}}),i.main!==n.main&&(i.main&&s.removeClass(e("main",i.main)),n.main&&s.addClass(e("main",n.main))),o.$broadcast("mainresize",n.main)}}(),!0),p.webrtc.e.on("done",function(){p.connector.connected&&o.setStatus("waiting")}),p.webrtc.e.on("busy",function(e,t){console.log("Incoming call - sent busy.",t),o.$emit("notification","incomingbusy",{reason:"busy",from:t})}),p.webrtc.e.on("bye",function(e,t,n){switch(t){case"busy":console.log("User is busy",t,n),o.$emit("notification","busy",{reason:t,from:n});break;case"reject":console.log("User rejected",t,n),o.$emit("notification","reject",{reason:t,from:n});break;case"pickuptimeout":console.log("User did not pick up",t,n),o.$emit("notification","pickuptimeout",{reason:t,from:n});break;case"error":console.log("User cannot accept call because of error"),m.dialog.alert(b._("Oops")+"<br/>"+b._("User hung up because of error."));break;case"abort":console.log("Remote call was aborted before we did pick up"),o.$emit("notification","abortbeforepickup",{reason:t,from:n})}}),o.$on("status",function(e,n){"connecting"===n&&U?A.start():A.stop(),u(o,function(){var e=o.status;o.status=n,"connected"===e&&"waiting"===n?t.delay(h.play,100,"end"):"connecting"===e&&"connected"===n&&h.play("connect")}),f.e.triggerHandler("mainStatus",[n])}),o.$on("notification",function(e,t,n){var o=null;switch(t){case"busy":o=P(n.from)+b._(" is busy. Try again later.");break;case"reject":o=P(n.from)+b._(" rejected your call.");break;case"pickuptimeout":o=P(n.from)+b._(" does not pick up.");break;case"incomingbusy":v.info(i().format("lll"),P(n.from)+b._(" tried to call you"));break;case"abortbeforepickup":case"incomingpickuptimeout":v.info(i().format("lll"),P(n.from)+b._(" called you"))}o&&(h.play("question"),m.dialog.alert(o)),f.e.triggerHandler("uiNotification",[t,n])}),o.$on("download",function(e,t,n){var i=e.targetScope;y.startDownload(i,t,n)});var N={};o.$on("chatincoming",function(e,t){var n=N[t]||0;n++,N[t]=n,o.chatMessagesUnseen++}),o.$on("chatseen",function(e,t){var n=N[t]||0;delete N[t],o.chatMessagesUnseen=o.chatMessagesUnseen-n}),t.defer(function(){return c.webrtcDetectedVersion&&"edge"!==c.webrtcDetectedBrowser?!a.websockets||c.webrtcDetectedVersion<c.webrtcMinimumVersion?(m.dialog.alert(b._("Your browser is not supported. Please upgrade to a current version.")),void o.setStatus("unsupported")):p.config.Renegotiation&&"firefox"===c.webrtcDetectedBrowser&&c.webrtcDetectedVersion<38?void console.warn("Renegotiation enabled -> currently not compatible with Firefox."):void 0:void m.dialog.custom("webrtcUnsupported")})}]}),define("controllers/statusmessagecontroller",[],function(){return["$scope","mediaStream",function(e,t){e.doHangup=function(){t.webrtc.doHangup()},e.doAbort=function(){t.webrtc.doHangup("abort",e.dialing)},e.doReconnect=function(){t.connector.reconnect()},e.doAccept=function(){t.webrtc.doAccept()},e.doReject=function(){t.webrtc.doHangup("reject")}}]}),define("text!partials/fileinfo.html",[],function(){return'<div class="file-info" ng-class="{\'downloading\': downloading, \'uploader\': uploader, \'downloader\': downloader}">\n	<div class="file-info-bg"><i class="fa" ng-class="{\'fa-arrow-circle-o-down\':downloader, \'fa-arrow-circle-o-up\':uploader}"></i></div>\n	<div class="hovercontrol">\n		<div class="anim">\n			<div ng-show="downloader">\n				<i title="{{_(\'File sharing\')}}" class="fa fa-file-o fa-4x"></i>\n			</div>\n			<div ng-show="uploader"><i title="{{_(\'File sharing\')}}" class="fa fa-file-o fa-4x"></i></div>\n			<div ng-show="!uploader && !downloader">\n				<i title="{{_(\'File is no longer available\')}}" class="fa fa-ban-circle fa-4x text-error"></i>\n			</div>\n		</div>\n		<div class="actions" ng-show="uploader || downloader">\n			<a ng-hide="downloading || uploader || error" class="btn btn-small btn-primary" ng-click="download()">{{_(\'Download\')}}</a>\n			<a href="{{url}}" download="{{info.name}}" ng-show="complete" class="btn btn-small btn-success">{{_(\'Open\')}}</a>\n			<a ng-show="downloading && !complete && !error" class="btn btn-small btn-danger" ng-click="cancel()">{{_(\'Cancel\')}}</a>\n			<a ng-show="uploader" class="btn btn-small btn-danger" ng-click="cancel()">{{_(\'Unshare\')}}</a>\n			<a ng-show="error" class="btn btn-small btn-danger" ng-click="download()">{{_(\'Retry\')}}</a>\n		</div>\n	</div>\n	<div class="file-info-name">{{info.name}}</div>\n	<div class="file-info-size" ng-class="{\'progress\': downloader}">\n		<span>{{info.size|humanizeFilesize}} <span ng-show="downloading">/ {{progress}}%</span></span>\n		<div class="progress-bar progress-bar-success download"></div>\n		<div class="progress-bar progress-bar-success"></div>\n	</div>\n	<div ng-show="downloadspeed || error" class="file-info-speed" ng-class="{\'text-error\': error}">\n		<span ng-show="downloadspeed">{{bytesPerSecond|humanizeFilesize}}/s<span ng-show="eta"> <span class="fa fa-flag-checkered"></span> {{eta}}</span></span>\n		<span ng-show="error">{{_("Download failed.")}}</span>\n	</div>\n</div>'}),define("text!partials/contactrequest.html",[],function(){return'<div class="contact-request">\n	<div ng-if="!fromself && request.Userid && !request.Success && request.Token">\n		<div ng-switch="state">\n			<div ng-switch-when="request">\n				<button ng-click="doAccept()" class="btn btn-success btn-sm">{{_(\'Accept\')}}</button>\n				<button ng-click="doReject()" class="btn btn-danger btn-sm">{{_(\'Reject\')}}</button>\n			</div>\n		</div>\n	</div>\n</div>'}),define("text!partials/geolocation.html",[],function(){return'<div class="geolocation">\n	<div><i class="fa fa-location-arrow"></i> <a rel="external" href="https://maps.google.com/maps?q={{info.latitude}},{{info.longitude}}">{{info.latitude|number:6}}&ordm; {{info.longitude|number:6}}&ordm; &plusmn;{{info.accuracy|formatBase1000:\'m\'}}</a></div>\n</div>\n'}),define("text!partials/picturehover.html",[],function(){return'<div class="buddyInfoActions">\n    <div class="btn-group">\n        <button class="btn btn-lg btn-primary" ng-click="doCall()" title="Start video call">\n            <i class="fa fa-phone"></i>\n        </button>\n        <button class="btn btn-lg btn-primary" ng-click="startChat()" title="Start chat">\n            <i class="fa fa-comments-o"></i>\n        </button>\n    </div>\n</div>\n\n'}),define("controllers/chatroomcontroller",["jquery","underscore","moment","text!partials/fileinfo.html","text!partials/contactrequest.html","text!partials/geolocation.html","text!partials/picturehover.html"],function(e,t,n,i,o,a,r){return["$scope","$element","$window","safeMessage","safeDisplayName","$compile","$filter","translation","mediaStream",function(s,c,l,d,u,p,f,h,g){s.outputElement=c.find(".output"),s.inputElement=c.find(".input"),s.bodyElement=c.find(".chatbody"),s.menuElement=c.find(".chatmenu");var m=null,v=null,b=null,y=null,w=!1,k=null,x=null,$=!1;s.bodyElement.on("mouseover mouseenter touchstart",t.debounce(function(){s.$parent.seen(),s.$apply()},100));var C=u,S=f("buddyImageSrc"),P=p(i),T=p(o),_=p(a),D=p(r),R={r:{},pending:[],register:function(e,t,n,i){if(t){if(R.r.hasOwnProperty(t))return void console.warn("Duplicate chat message registration.",t,e,n);var o=R.r[t]={element:e,status:n};o.status&&e.addClass(o.status),i&&(R.pending.push(t),s.$emit("submitreceived",t))}},update:function(e,t){var n=R.r[e];n&&n.status!==t&&t&&(n.status&&n.element.removeClass(n.status),n.status=t,n.element.addClass(n.status),("received"===t||"read"===t)&&delete R.r[e])},seen:function(){var e=R.pending;e.length&&(R.pending=[],s.$emit("submitseen",e),t.each(e,function(e){R.update(e,"read")}))}},M=function(e,t,n){if(t.picture&&!n){var i=s.$new();i.startChat=function(){s.$emit("startchat",e,{autofocus:!0,restore:!0})},i.doCall=function(){g.webrtc.doCall(e)},D(i,function(e){t.picture.append(e)}),t.extra_css+="with_hoverimage "}},A=function(t,n,i){if(s.isgroupchat){n.title=e("<strong>"),n.title.html(C(t,!0)),n.extra_css+="with_name ";var o=S(t);n.picture=e('<div class="buddyPicture"><i class="fa fa-user fa-3x"/><img/></div>'),o&&n.picture.find("img").attr("src",o),M(t,n,i)}};c.on("click",function(t){var n=e(t.target);if(n.is("a")){var i=n.attr("href");i&&!n.attr("download")&&null===i.match(/mailto:/gi)&&(t.preventDefault(),l.open(n.attr("href"),"_blank"))}}),s.$watch("input",function(e){s.$parent.seen(),l.clearTimeout(k),e&&(w||(w=!0,s.$emit("typing",{who:"local",status:"start"})),k=l.setTimeout(function(){w=!1,s.$emit("typing",{who:"local",status:"stop"})},4e3))}),s.reset=function(){s.input="",w=!1,l.clearTimeout(k)},s.focus=function(){s.inputElement.focus()},s.submit=function(){var e=s.input;e&&($=!0,s.$emit("submit",s.input),s.reset(),s.focus())},s.canScroll=function(){var e=s.outputElement[0];return!(e.clientHeight-20<e.scrollHeight)||!$&&e.clientHeight+20<e.scrollHeight-e.scrollTop?!1:($=!1,function(){e.scrollTop=e.scrollHeight})},s.display=function(t,n,i,o,a){var r,c,l=this.canScroll();return b=null,i||(i=""),(t||o||a)&&(r=e('<div class="message '+i+'"></div>'),o&&r.prepend(o),a&&r.prepend(a),b=e("<ul>").appendTo(r),e.trim(t)&&(c=e("<li>").html(t),c.prepend('<div class="timestamp-space">'),c.appendTo(b))),n&&(r?r.append(n):s.outputElement.append(n),r&&b&&(b=e("<ul>").appendTo(r))),r&&s.outputElement.append(r),l&&l(),c},s.$on("display",function(e,t,n){s.display(t,n)}),s.append=function(t,n){if(b){var i=this.canScroll(),o=e("<li>");if(o.html(t),b.append(o),n){var a=b.parent();a.append(n),b=e("<ul>"),a.append(b)}return i&&i(),o}},s.showtime=function(t,i,o){var a;a=t?n(t):n(),i||(i="LLL");var r=a.format(i);return o&&r===o?r:(s.display(null,e("<i>"+r+"</i>")),t||(m=null),r)},s.showdate=function(e){v=s.showtime(e,"LL",v)},s.showmessage=function(t,i,o,a){var r=s.$parent.$parent.id,c=[];o&&(c.push(o),s.$emit("incoming",o,t,r));var l=m!==t,d=t===r,u={extra_css:"",title:null,picture:null};l&&(m=t,s.showdate(i),A(t,u,d));var p=c.join(" ");if(!l){var f=this.append(p,a);if(f)return f;A()}if(u.extra_css+=d?"is_self":"is_remote",i){var h=e('<div class="timestamp"/>');h.text(n(i).format("H:mm")),a=a?a.add(h):h}return s.display(p,a,u.extra_css,u.title,u.picture)},s.$on("seen",function(){R.seen()}),s.$on("clear",function(){R.seen(),m=null,v=null,b=null,s.outputElement.empty()}),s.$on("p2p",function(t,n){var i;i=h._(n?"Peer to peer chat active.":"Peer to peer chat is now off."),s.display(null,e("<i class='p2p'><span class='icon-exchange'></span> "+i+"</i>"))}),s.$on("focus",function(){s.focus()}),s.$on("received",function(n,i,o){var a=s.$parent.$parent.id,r=o.Mid||null;switch(o.Type){case"LeftOrJoined":s.showtime(new Date),"left"===o.LeftOrJoined?s.display(null,e("<i>"+C(i)+h._(" is now offline.")+"</i>")):s.display(null,e("<i>"+C(i)+h._(" is now online.")+"</i>"));break;case"Log":s.showtime(new Date),s.display(null,o.Log);break;default:var c,u=null,p=null,f=i===a,g=!1,v=null,b=o.Time;b||(b=new Date),o.Status&&(!r&&o.Status.Mid&&(r=o.Status.Mid),o.Status.Typing&&!f&&(l.clearTimeout(x),s.$emit("typing",{who:"peer",status:o.Status.Typing}),"stop"===o.Status.Typing&&(x=l.setTimeout(function(){s.$emit("typing",{who:"peer",status:"no"})},2e4))),r&&o.Status.State&&R.update(r,o.Status.State),o.Status.SeenMids&&t.each(o.Status.SeenMids,function(e){R.update(e,"received")}),o.Status.FileInfo&&(c=s.$new(),c.info=o.Status.FileInfo,c.from=i,P(c,function(e){var t=h._(f?"You share file:":"Incoming file:");v=s.showmessage(i,b,t,e)}),g=!0),o.Status.Geolocation&&(c=s.$new(),c.info=o.Status.Geolocation,c.from=i,_(c,function(e){var t=h._(f?"You shared your location:":"Location received:");v=s.showmessage(i,b,t,e)}),g=!0),o.Status.ContactRequest&&(c=s.$new(),c.request=o.Status.ContactRequest,c.fromself=f,T(c,function(e,t){var n;n=h._(f?t.request.Userid?t.request.Success?"You accepted the contact request.":"You rejected the contact request.":"You sent a contact request.":t.request.Success?"Your contact request was accepted.":t.request.Token?"Incoming contact request.":"Your contact request was rejected."),v=s.showmessage(i,b,n,e)}),g=!0),null===u&&null===p&&(g=!0)),o.Message||null!==u||null!==p||(g=!0),g||(null===u&&null===p&&o.Message&&"string"==typeof o.Message&&(u=d(o.Message)),v=s.showmessage(i,b,u,p)),v&&r&&!s.isgroupchat&&R.register(v,r,f?"sending":"unread",!f)}l.clearTimeout(y),y=l.setTimeout(function(){m=null},61e3)})}]}),define("controllers/usersettingscontroller",[],function(){return["$scope","$element","mediaStream","safeApply","$window",function(e,t,n,i,o){e.withUsersForget=!0,this.registerUserid=function(t){var o=function(t){console.info("Created new userid:",t.userid),n.users.store(t),e.loadedUserlogin=!0,i(e),n.api.requestAuthentication(t.userid,t.nonce),delete t.nonce},a=null;t&&t.target&&(a=t.target.form),console.log("No userid - creating one ..."),n.users.register(a,function(e){e.nonce?o(e):n.users.authorize(e,o,function(e,t){console.error("Failed to get nonce after create",t,e)})},function(e,t){console.error("Failed to create userid",t,e)})},this.forgetUserid=function(){n.users.forget(),n.webrtc.doHangup("forgetUserid"),o.setTimeout(function(){n.connector.forgetAndReconnect()},0)}}]}),define("controllers/contactsmanagercontroller",[],function(){return["$scope","$modalInstance","contactData","data","contacts","dialogs","translation","mediaStream","buddyData",function(e,t,n,i,o,a,r,s,c){var l=function(e){var t=null,n=c.lookup(e,!1,!1);return n&&(t=n.session.get()),t&&t.Id?t.Id:null};e.header=i.header,e.contacts=[],e.openContactsManagerEdit=function(e){return a.create("/contactsmanager/edit.html","ContactsmanagereditController",{header:r._("Edit Contact"),contact:e},{wc:"contactsmanager contactsmanageredit"})};var d=function(){e.contacts=n.getAll()};d(),o.e.on("contactadded",function(){d()}),o.e.on("contactupdated",function(){d()}),o.e.on("contactremoved",function(){d()}),e.doCall=function(e){s.webrtc.doCall(l(e.Userid)),t.close()},e.startChat=function(n){e.$emit("startchat",l(n.Userid),{autofocus:!0,restore:!0}),t.close()}}]}),define("controllers/contactsmanagereditcontroller",[],function(){return["$scope","$modalInstance","data","contacts","buddyData",function(e,t,n,i,o){e.header=n.header,e.contact=n.contact?n.contact:null,e.buddySyncable=!1;var a=null,r=function(e){i.update(e)};if(e.contact){a=e.contact.Status.displayName;var s=o.lookup(e.contact.Userid,!1,!1);if(s){var c=s.session.get();e.buddySyncable=c&&c.Type?!0:!1}}e.removeContact=function(){i.remove(e.contact.Userid),t.close()},e.syncContactInfo=function(){var t=o.lookup(e.contact.Userid,!1,!1);if(t){var n=t.session.get();e.contact.Status.displayName=n.Status.displayName}},e.save=function(){r(e.contact),t.close()},e.cancel=function(){e.contact.Status.displayName=a,t.dismiss()}}]}),define("controllers/appcontroller",["jquery","angular","underscore"],function(e,t,n){return["$scope","$window","appData","userSettingsData","$timeout",function(i,o,a,r,s){e(o).on("dragover dragenter drop",function(e){e.preventDefault()}),a.set(i),i.authorizing=!1,i.roomsHistory=[],i.defaults={displayName:null,buddyPicture:null,message:null,settings:{videoQuality:"high",sendStereo:!1,maxFrameRate:20,defaultRoom:"",language:"",audioRenderToAssociatedSkin:!0,videoCpuOveruseDetection:!0,experimental:{enabled:!1,audioEchoCancellation2:!0,audioAutoGainControl2:!0,audioNoiseSuppression2:!0,audioTypingNoiseDetection:!0,videoLeakyBucket:!0,videoNoiseReduction:!1},sound:{incomingMessages:!0,incomingCall:!0,roomJoinLeave:!1}}},i.master=t.copy(i.defaults),i.update=function(e){i.master=t.copy(e),a.flags.connected&&i.updateStatus(),i.refreshWebrtcSettings(),i.refreshSoundSettings()},i.reset=function(){i.user=t.copy(i.master)},i.loadUserSettings=function(){i.master=t.copy(i.defaults);var n=r.load();n?(i.user=e.extend(!0,{},i.master,n),i.user.settings=e.extend(!0,{},i.user.settings,i.master.settings,i.user.settings),i.update(i.user),i.loadedUser=n.displayName&&!0):i.loadedUser=!1,i.roomsHistory=[],a.e.triggerHandler("userSettingsLoaded",[i.loadedUser,i.user]),i.reset()},i.manualReloadApp=function(e){a.flags.manualUnload=!0,e?(o.location.href=e,s(function(){a.flags.manualUnload=!1},0)):o.location.reload(!0)},i.$on("room.joined",function(e,t){t&&(n.pull(i.roomsHistory,t),i.roomsHistory.unshift(t),i.roomsHistory.length>15&&(i.roomsHistory=i.roomsHistory.splice(0,15)))}),a.e.on("authorizing",function(e,t){i.authorizing=!!t}),i.reset()}]}),define("controllers/controllers",["underscore","controllers/uicontroller","controllers/statusmessagecontroller","controllers/chatroomcontroller","controllers/usersettingscontroller","controllers/contactsmanagercontroller","controllers/contactsmanagereditcontroller","controllers/appcontroller"],function(e,t,n,i,o,a,r,s){var c={UiController:t,StatusmessageController:n,ChatroomController:i,UsersettingsController:o,ContactsmanagerController:a,ContactsmanagereditController:r,AppController:s},l=function(t){e.each(c,function(e,n){t.controller(n,e)})};return{initialize:l}}),define("translation/languages",[],function(){return{en:"English","zh-tw":"繁體中文",de:"Deutsch",ko:"한국어","zh-cn":"中文（简体）",ja:"日本語"}}),angular.module("ui.bootstrap",["ui.bootstrap.tpls","ui.bootstrap.transition","ui.bootstrap.collapse","ui.bootstrap.accordion","ui.bootstrap.alert","ui.bootstrap.bindHtml","ui.bootstrap.buttons","ui.bootstrap.carousel","ui.bootstrap.dateparser","ui.bootstrap.position","ui.bootstrap.datepicker","ui.bootstrap.dropdown","ui.bootstrap.modal","ui.bootstrap.pagination","ui.bootstrap.tooltip","ui.bootstrap.popover","ui.bootstrap.progressbar","ui.bootstrap.rating","ui.bootstrap.tabs","ui.bootstrap.timepicker","ui.bootstrap.typeahead"]),angular.module("ui.bootstrap.tpls",["template/accordion/accordion-group.html","template/accordion/accordion.html","template/alert/alert.html","template/carousel/carousel.html","template/carousel/slide.html","template/datepicker/datepicker.html","template/datepicker/day.html","template/datepicker/month.html","template/datepicker/popup.html","template/datepicker/year.html","template/modal/backdrop.html","template/modal/window.html","template/pagination/pager.html","template/pagination/pagination.html","template/tooltip/tooltip-html-unsafe-popup.html","template/tooltip/tooltip-popup.html","template/popover/popover.html","template/progressbar/bar.html","template/progressbar/progress.html","template/progressbar/progressbar.html","template/rating/rating.html","template/tabs/tab.html","template/tabs/tabset.html","template/timepicker/timepicker.html","template/typeahead/typeahead-match.html","template/typeahead/typeahead-popup.html"]),angular.module("ui.bootstrap.transition",[]).factory("$transition",["$q","$timeout","$rootScope",function(e,t,n){function i(e){for(var t in e)if(void 0!==a.style[t])return e[t]}var o=function(i,a,r){r=r||{};var s=e.defer(),c=o[r.animation?"animationEndEventName":"transitionEndEventName"],l=function(){n.$apply(function(){i.unbind(c,l),s.resolve(i)})};return c&&i.bind(c,l),t(function(){angular.isString(a)?i.addClass(a):angular.isFunction(a)?a(i):angular.isObject(a)&&i.css(a),c||s.resolve(i)}),s.promise.cancel=function(){c&&i.unbind(c,l),s.reject("Transition cancelled")},s.promise},a=document.createElement("trans"),r={WebkitTransition:"webkitTransitionEnd",MozTransition:"transitionend",OTransition:"oTransitionEnd",transition:"transitionend"},s={WebkitTransition:"webkitAnimationEnd",MozTransition:"animationend",OTransition:"oAnimationEnd",transition:"animationend"};return o.transitionEndEventName=i(r),o.animationEndEventName=i(s),o}]),angular.module("ui.bootstrap.collapse",["ui.bootstrap.transition"]).directive("collapse",["$transition",function(e){return{link:function(t,n,i){function o(t){function i(){l===o&&(l=void 0)}var o=e(n,t);return l&&l.cancel(),l=o,o.then(i,i),o}function a(){d?(d=!1,r()):(n.removeClass("collapse").addClass("collapsing"),o({height:n[0].scrollHeight+"px"}).then(r))}function r(){n.removeClass("collapsing"),n.addClass("collapse in"),n.css({height:"auto"})}function s(){d?(d=!1,c(),n.css({height:0})):(n.css({height:n[0].scrollHeight+"px"}),n[0].offsetWidth,n.removeClass("collapse in").addClass("collapsing"),o({height:0}).then(c))}function c(){n.removeClass("collapsing"),n.addClass("collapse")}var l,d=!0;t.$watch(i.collapse,function(e){e?s():a()})}}}]),angular.module("ui.bootstrap.accordion",["ui.bootstrap.collapse"]).constant("accordionConfig",{closeOthers:!0}).controller("AccordionController",["$scope","$attrs","accordionConfig",function(e,t,n){this.groups=[],this.closeOthers=function(i){var o=angular.isDefined(t.closeOthers)?e.$eval(t.closeOthers):n.closeOthers;o&&angular.forEach(this.groups,function(e){e!==i&&(e.isOpen=!1)})},this.addGroup=function(e){var t=this;this.groups.push(e),e.$on("$destroy",function(){t.removeGroup(e)})},this.removeGroup=function(e){var t=this.groups.indexOf(e);-1!==t&&this.groups.splice(t,1)}}]).directive("accordion",function(){return{restrict:"EA",controller:"AccordionController",transclude:!0,replace:!1,templateUrl:"template/accordion/accordion.html"}}).directive("accordionGroup",function(){return{require:"^accordion",restrict:"EA",transclude:!0,replace:!0,templateUrl:"template/accordion/accordion-group.html",scope:{heading:"@",isOpen:"=?",isDisabled:"=?"},controller:function(){this.setHeading=function(e){this.heading=e}},link:function(e,t,n,i){i.addGroup(e),e.$watch("isOpen",function(t){t&&i.closeOthers(e)}),e.toggleOpen=function(){e.isDisabled||(e.isOpen=!e.isOpen)}}}}).directive("accordionHeading",function(){return{restrict:"EA",transclude:!0,template:"",replace:!0,require:"^accordionGroup",link:function(e,t,n,i,o){i.setHeading(o(e,function(){}))}}}).directive("accordionTransclude",function(){return{require:"^accordionGroup",link:function(e,t,n,i){e.$watch(function(){return i[n.accordionTransclude]},function(e){e&&(t.html(""),t.append(e))})}}}),angular.module("ui.bootstrap.alert",[]).controller("AlertController",["$scope","$attrs",function(e,t){e.closeable="close"in t}]).directive("alert",function(){return{restrict:"EA",controller:"AlertController",templateUrl:"template/alert/alert.html",transclude:!0,replace:!0,scope:{type:"@",close:"&"}}}),angular.module("ui.bootstrap.bindHtml",[]).directive("bindHtmlUnsafe",function(){return function(e,t,n){t.addClass("ng-binding").data("$binding",n.bindHtmlUnsafe),e.$watch(n.bindHtmlUnsafe,function(e){t.html(e||"")})}}),angular.module("ui.bootstrap.buttons",[]).constant("buttonConfig",{activeClass:"active",toggleEvent:"click"}).controller("ButtonsController",["buttonConfig",function(e){this.activeClass=e.activeClass||"active",this.toggleEvent=e.toggleEvent||"click"}]).directive("btnRadio",function(){return{require:["btnRadio","ngModel"],controller:"ButtonsController",link:function(e,t,n,i){var o=i[0],a=i[1];a.$render=function(){t.toggleClass(o.activeClass,angular.equals(a.$modelValue,e.$eval(n.btnRadio)))},t.bind(o.toggleEvent,function(){var i=t.hasClass(o.activeClass);(!i||angular.isDefined(n.uncheckable))&&e.$apply(function(){a.$setViewValue(i?null:e.$eval(n.btnRadio)),a.$render()})})}}}).directive("btnCheckbox",function(){return{require:["btnCheckbox","ngModel"],controller:"ButtonsController",link:function(e,t,n,i){function o(){return r(n.btnCheckboxTrue,!0)}function a(){return r(n.btnCheckboxFalse,!1)}function r(t,n){var i=e.$eval(t);return angular.isDefined(i)?i:n}var s=i[0],c=i[1];c.$render=function(){t.toggleClass(s.activeClass,angular.equals(c.$modelValue,o()))},t.bind(s.toggleEvent,function(){e.$apply(function(){c.$setViewValue(t.hasClass(s.activeClass)?a():o()),c.$render()})})}}}),angular.module("ui.bootstrap.carousel",["ui.bootstrap.transition"]).controller("CarouselController",["$scope","$timeout","$transition",function(e,t,n){function i(){o();var n=+e.interval;!isNaN(n)&&n>=0&&(r=t(a,n))}function o(){r&&(t.cancel(r),r=null)}function a(){s?(e.next(),i()):e.pause()}var r,s,c=this,l=c.slides=e.slides=[],d=-1;c.currentSlide=null;var u=!1;c.select=e.select=function(o,a){function r(){u||(c.currentSlide&&angular.isString(a)&&!e.noTransition&&o.$element?(o.$element.addClass(a),o.$element[0].offsetWidth,angular.forEach(l,function(e){angular.extend(e,{direction:"",entering:!1,leaving:!1,active:!1})}),angular.extend(o,{direction:a,active:!0,entering:!0}),angular.extend(c.currentSlide||{},{direction:a,leaving:!0}),e.$currentTransition=n(o.$element,{}),function(t,n){e.$currentTransition.then(function(){s(t,n)},function(){s(t,n)})}(o,c.currentSlide)):s(o,c.currentSlide),c.currentSlide=o,d=p,i())}function s(t,n){angular.extend(t,{direction:"",active:!0,leaving:!1,entering:!1}),angular.extend(n||{},{direction:"",active:!1,leaving:!1,entering:!1}),e.$currentTransition=null}var p=l.indexOf(o);void 0===a&&(a=p>d?"next":"prev"),o&&o!==c.currentSlide&&(e.$currentTransition?(e.$currentTransition.cancel(),t(r)):r())},e.$on("$destroy",function(){u=!0}),c.indexOfSlide=function(e){return l.indexOf(e)},e.next=function(){var t=(d+1)%l.length;return e.$currentTransition?void 0:c.select(l[t],"next")},e.prev=function(){var t=0>d-1?l.length-1:d-1;return e.$currentTransition?void 0:c.select(l[t],"prev")},e.isActive=function(e){return c.currentSlide===e},e.$watch("interval",i),e.$on("$destroy",o),e.play=function(){s||(s=!0,i())},e.pause=function(){e.noPause||(s=!1,o())},c.addSlide=function(t,n){t.$element=n,l.push(t),1===l.length||t.active?(c.select(l[l.length-1]),1==l.length&&e.play()):t.active=!1},c.removeSlide=function(e){var t=l.indexOf(e);l.splice(t,1),l.length>0&&e.active?c.select(t>=l.length?l[t-1]:l[t]):d>t&&d--}}]).directive("carousel",[function(){return{restrict:"EA",transclude:!0,replace:!0,controller:"CarouselController",require:"carousel",templateUrl:"template/carousel/carousel.html",scope:{interval:"=",noTransition:"=",noPause:"="}}}]).directive("slide",function(){return{require:"^carousel",restrict:"EA",transclude:!0,replace:!0,templateUrl:"template/carousel/slide.html",scope:{active:"=?"},link:function(e,t,n,i){i.addSlide(e,t),e.$on("$destroy",function(){i.removeSlide(e)}),e.$watch("active",function(t){t&&i.select(e)})}}}),angular.module("ui.bootstrap.dateparser",[]).service("dateParser",["$locale","orderByFilter",function(e,t){function n(e,t,n){return 1===t&&n>28?29===n&&(e%4===0&&e%100!==0||e%400===0):3===t||5===t||8===t||10===t?31>n:!0}this.parsers={};var i={yyyy:{regex:"\\d{4}",apply:function(e){this.year=+e}},yy:{regex:"\\d{2}",apply:function(e){this.year=+e+2e3}},y:{regex:"\\d{1,4}",apply:function(e){this.year=+e}},MMMM:{regex:e.DATETIME_FORMATS.MONTH.join("|"),apply:function(t){this.month=e.DATETIME_FORMATS.MONTH.indexOf(t)}},MMM:{regex:e.DATETIME_FORMATS.SHORTMONTH.join("|"),apply:function(t){this.month=e.DATETIME_FORMATS.SHORTMONTH.indexOf(t)}},MM:{regex:"0[1-9]|1[0-2]",apply:function(e){this.month=e-1}},M:{regex:"[1-9]|1[0-2]",apply:function(e){this.month=e-1}},dd:{regex:"[0-2][0-9]{1}|3[0-1]{1}",apply:function(e){this.date=+e}},d:{regex:"[1-2]?[0-9]{1}|3[0-1]{1}",apply:function(e){this.date=+e}},EEEE:{regex:e.DATETIME_FORMATS.DAY.join("|")},EEE:{regex:e.DATETIME_FORMATS.SHORTDAY.join("|")}};this.createParser=function(e){var n=[],o=e.split("");return angular.forEach(i,function(t,i){var a=e.indexOf(i);if(a>-1){e=e.split(""),o[a]="("+t.regex+")",e[a]="$";for(var r=a+1,s=a+i.length;s>r;r++)o[r]="",e[r]="$";e=e.join(""),n.push({index:a,apply:t.apply})}}),{regex:new RegExp("^"+o.join("")+"$"),map:t(n,"index")}},this.parse=function(t,i){if(!angular.isString(t))return t;i=e.DATETIME_FORMATS[i]||i,this.parsers[i]||(this.parsers[i]=this.createParser(i));var o=this.parsers[i],a=o.regex,r=o.map,s=t.match(a);if(s&&s.length){for(var c,l={year:1900,month:0,date:1,hours:0},d=1,u=s.length;u>d;d++){var p=r[d-1];p.apply&&p.apply.call(l,s[d])}return n(l.year,l.month,l.date)&&(c=new Date(l.year,l.month,l.date,l.hours)),c}}}]),angular.module("ui.bootstrap.position",[]).factory("$position",["$document","$window",function(e,t){function n(e,n){return e.currentStyle?e.currentStyle[n]:t.getComputedStyle?t.getComputedStyle(e)[n]:e.style[n]}function i(e){return"static"===(n(e,"position")||"static")}var o=function(t){for(var n=e[0],o=t.offsetParent||n;o&&o!==n&&i(o);)o=o.offsetParent;return o||n};return{position:function(t){var n=this.offset(t),i={top:0,left:0},a=o(t[0]);a!=e[0]&&(i=this.offset(angular.element(a)),i.top+=a.clientTop-a.scrollTop,i.left+=a.clientLeft-a.scrollLeft);var r=t[0].getBoundingClientRect();return{width:r.width||t.prop("offsetWidth"),height:r.height||t.prop("offsetHeight"),top:n.top-i.top,left:n.left-i.left}},offset:function(n){var i=n[0].getBoundingClientRect();return{width:i.width||n.prop("offsetWidth"),height:i.height||n.prop("offsetHeight"),top:i.top+(t.pageYOffset||e[0].documentElement.scrollTop),left:i.left+(t.pageXOffset||e[0].documentElement.scrollLeft)}},positionElements:function(e,t,n,i){var o,a,r,s,c=n.split("-"),l=c[0],d=c[1]||"center";o=i?this.offset(e):this.position(e),a=t.prop("offsetWidth"),r=t.prop("offsetHeight");var u={center:function(){return o.left+o.width/2-a/2},left:function(){return o.left},right:function(){return o.left+o.width}},p={center:function(){return o.top+o.height/2-r/2},top:function(){return o.top},bottom:function(){return o.top+o.height}};switch(l){case"right":s={top:p[d](),left:u[l]()};break;case"left":s={top:p[d](),left:o.left-a};break;case"bottom":s={top:p[l](),left:u[d]()};break;default:s={top:o.top-r,left:u[d]()}}return s}}}]),angular.module("ui.bootstrap.datepicker",["ui.bootstrap.dateparser","ui.bootstrap.position"]).constant("datepickerConfig",{formatDay:"dd",formatMonth:"MMMM",formatYear:"yyyy",formatDayHeader:"EEE",formatDayTitle:"MMMM yyyy",formatMonthTitle:"yyyy",datepickerMode:"day",minMode:"day",maxMode:"year",showWeeks:!0,startingDay:0,yearRange:20,minDate:null,maxDate:null}).controller("DatepickerController",["$scope","$attrs","$parse","$interpolate","$timeout","$log","dateFilter","datepickerConfig",function(e,t,n,i,o,a,r,s){var c=this,l={$setViewValue:angular.noop};
this.modes=["day","month","year"],angular.forEach(["formatDay","formatMonth","formatYear","formatDayHeader","formatDayTitle","formatMonthTitle","minMode","maxMode","showWeeks","startingDay","yearRange"],function(n,o){c[n]=angular.isDefined(t[n])?8>o?i(t[n])(e.$parent):e.$parent.$eval(t[n]):s[n]}),angular.forEach(["minDate","maxDate"],function(i){t[i]?e.$parent.$watch(n(t[i]),function(e){c[i]=e?new Date(e):null,c.refreshView()}):c[i]=s[i]?new Date(s[i]):null}),e.datepickerMode=e.datepickerMode||s.datepickerMode,e.uniqueId="datepicker-"+e.$id+"-"+Math.floor(1e4*Math.random()),this.activeDate=angular.isDefined(t.initDate)?e.$parent.$eval(t.initDate):new Date,e.isActive=function(t){return 0===c.compare(t.date,c.activeDate)?(e.activeDateId=t.uid,!0):!1},this.init=function(e){l=e,l.$render=function(){c.render()}},this.render=function(){if(l.$modelValue){var e=new Date(l.$modelValue),t=!isNaN(e);t?this.activeDate=e:a.error('Datepicker directive: "ng-model" value must be a Date object, a number of milliseconds since 01.01.1970 or a string representing an RFC2822 or ISO 8601 date.'),l.$setValidity("date",t)}this.refreshView()},this.refreshView=function(){if(this.element){this._refreshView();var e=l.$modelValue?new Date(l.$modelValue):null;l.$setValidity("date-disabled",!e||this.element&&!this.isDisabled(e))}},this.createDateObject=function(e,t){var n=l.$modelValue?new Date(l.$modelValue):null;return{date:e,label:r(e,t),selected:n&&0===this.compare(e,n),disabled:this.isDisabled(e),current:0===this.compare(e,new Date)}},this.isDisabled=function(n){return this.minDate&&this.compare(n,this.minDate)<0||this.maxDate&&this.compare(n,this.maxDate)>0||t.dateDisabled&&e.dateDisabled({date:n,mode:e.datepickerMode})},this.split=function(e,t){for(var n=[];e.length>0;)n.push(e.splice(0,t));return n},e.select=function(t){if(e.datepickerMode===c.minMode){var n=l.$modelValue?new Date(l.$modelValue):new Date(0,0,0,0,0,0,0);n.setFullYear(t.getFullYear(),t.getMonth(),t.getDate()),l.$setViewValue(n),l.$render()}else c.activeDate=t,e.datepickerMode=c.modes[c.modes.indexOf(e.datepickerMode)-1]},e.move=function(e){var t=c.activeDate.getFullYear()+e*(c.step.years||0),n=c.activeDate.getMonth()+e*(c.step.months||0);c.activeDate.setFullYear(t,n,1),c.refreshView()},e.toggleMode=function(t){t=t||1,e.datepickerMode===c.maxMode&&1===t||e.datepickerMode===c.minMode&&-1===t||(e.datepickerMode=c.modes[c.modes.indexOf(e.datepickerMode)+t])},e.keys={13:"enter",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down"};var d=function(){o(function(){c.element[0].focus()},0,!1)};e.$on("datepicker.focus",d),e.keydown=function(t){var n=e.keys[t.which];if(n&&!t.shiftKey&&!t.altKey)if(t.preventDefault(),t.stopPropagation(),"enter"===n||"space"===n){if(c.isDisabled(c.activeDate))return;e.select(c.activeDate),d()}else!t.ctrlKey||"up"!==n&&"down"!==n?(c.handleKeyDown(n,t),c.refreshView()):(e.toggleMode("up"===n?1:-1),d())}}]).directive("datepicker",function(){return{restrict:"EA",replace:!0,templateUrl:"template/datepicker/datepicker.html",scope:{datepickerMode:"=?",dateDisabled:"&"},require:["datepicker","?^ngModel"],controller:"DatepickerController",link:function(e,t,n,i){var o=i[0],a=i[1];a&&o.init(a)}}}).directive("daypicker",["dateFilter",function(e){return{restrict:"EA",replace:!0,templateUrl:"template/datepicker/day.html",require:"^datepicker",link:function(t,n,i,o){function a(e,t){return 1!==t||e%4!==0||e%100===0&&e%400!==0?c[t]:29}function r(e,t){var n=new Array(t),i=new Date(e),o=0;for(i.setHours(12);t>o;)n[o++]=new Date(i),i.setDate(i.getDate()+1);return n}function s(e){var t=new Date(e);t.setDate(t.getDate()+4-(t.getDay()||7));var n=t.getTime();return t.setMonth(0),t.setDate(1),Math.floor(Math.round((n-t)/864e5)/7)+1}t.showWeeks=o.showWeeks,o.step={months:1},o.element=n;var c=[31,28,31,30,31,30,31,31,30,31,30,31];o._refreshView=function(){var n=o.activeDate.getFullYear(),i=o.activeDate.getMonth(),a=new Date(n,i,1),c=o.startingDay-a.getDay(),l=c>0?7-c:-c,d=new Date(a);l>0&&d.setDate(-l+1);for(var u=r(d,42),p=0;42>p;p++)u[p]=angular.extend(o.createDateObject(u[p],o.formatDay),{secondary:u[p].getMonth()!==i,uid:t.uniqueId+"-"+p});t.labels=new Array(7);for(var f=0;7>f;f++)t.labels[f]={abbr:e(u[f].date,o.formatDayHeader),full:e(u[f].date,"EEEE")};if(t.title=e(o.activeDate,o.formatDayTitle),t.rows=o.split(u,7),t.showWeeks){t.weekNumbers=[];for(var h=s(t.rows[0][0].date),g=t.rows.length;t.weekNumbers.push(h++)<g;);}},o.compare=function(e,t){return new Date(e.getFullYear(),e.getMonth(),e.getDate())-new Date(t.getFullYear(),t.getMonth(),t.getDate())},o.handleKeyDown=function(e){var t=o.activeDate.getDate();if("left"===e)t-=1;else if("up"===e)t-=7;else if("right"===e)t+=1;else if("down"===e)t+=7;else if("pageup"===e||"pagedown"===e){var n=o.activeDate.getMonth()+("pageup"===e?-1:1);o.activeDate.setMonth(n,1),t=Math.min(a(o.activeDate.getFullYear(),o.activeDate.getMonth()),t)}else"home"===e?t=1:"end"===e&&(t=a(o.activeDate.getFullYear(),o.activeDate.getMonth()));o.activeDate.setDate(t)},o.refreshView()}}}]).directive("monthpicker",["dateFilter",function(e){return{restrict:"EA",replace:!0,templateUrl:"template/datepicker/month.html",require:"^datepicker",link:function(t,n,i,o){o.step={years:1},o.element=n,o._refreshView=function(){for(var n=new Array(12),i=o.activeDate.getFullYear(),a=0;12>a;a++)n[a]=angular.extend(o.createDateObject(new Date(i,a,1),o.formatMonth),{uid:t.uniqueId+"-"+a});t.title=e(o.activeDate,o.formatMonthTitle),t.rows=o.split(n,3)},o.compare=function(e,t){return new Date(e.getFullYear(),e.getMonth())-new Date(t.getFullYear(),t.getMonth())},o.handleKeyDown=function(e){var t=o.activeDate.getMonth();if("left"===e)t-=1;else if("up"===e)t-=3;else if("right"===e)t+=1;else if("down"===e)t+=3;else if("pageup"===e||"pagedown"===e){var n=o.activeDate.getFullYear()+("pageup"===e?-1:1);o.activeDate.setFullYear(n)}else"home"===e?t=0:"end"===e&&(t=11);o.activeDate.setMonth(t)},o.refreshView()}}}]).directive("yearpicker",["dateFilter",function(){return{restrict:"EA",replace:!0,templateUrl:"template/datepicker/year.html",require:"^datepicker",link:function(e,t,n,i){function o(e){return parseInt((e-1)/a,10)*a+1}var a=i.yearRange;i.step={years:a},i.element=t,i._refreshView=function(){for(var t=new Array(a),n=0,r=o(i.activeDate.getFullYear());a>n;n++)t[n]=angular.extend(i.createDateObject(new Date(r+n,0,1),i.formatYear),{uid:e.uniqueId+"-"+n});e.title=[t[0].label,t[a-1].label].join(" - "),e.rows=i.split(t,5)},i.compare=function(e,t){return e.getFullYear()-t.getFullYear()},i.handleKeyDown=function(e){var t=i.activeDate.getFullYear();"left"===e?t-=1:"up"===e?t-=5:"right"===e?t+=1:"down"===e?t+=5:"pageup"===e||"pagedown"===e?t+=("pageup"===e?-1:1)*i.step.years:"home"===e?t=o(i.activeDate.getFullYear()):"end"===e&&(t=o(i.activeDate.getFullYear())+a-1),i.activeDate.setFullYear(t)},i.refreshView()}}}]).constant("datepickerPopupConfig",{datepickerPopup:"yyyy-MM-dd",currentText:"Today",clearText:"Clear",closeText:"Done",closeOnDateSelection:!0,appendToBody:!1,showButtonBar:!0}).directive("datepickerPopup",["$compile","$parse","$document","$position","dateFilter","dateParser","datepickerPopupConfig",function(e,t,n,i,o,a,r){return{restrict:"EA",require:"ngModel",scope:{isOpen:"=?",currentText:"@",clearText:"@",closeText:"@",dateDisabled:"&"},link:function(s,c,l,d){function u(e){return e.replace(/([A-Z])/g,function(e){return"-"+e.toLowerCase()})}function p(e){if(e){if(angular.isDate(e)&&!isNaN(e))return d.$setValidity("date",!0),e;if(angular.isString(e)){var t=a.parse(e,f)||new Date(e);return isNaN(t)?void d.$setValidity("date",!1):(d.$setValidity("date",!0),t)}return void d.$setValidity("date",!1)}return d.$setValidity("date",!0),null}var f,h=angular.isDefined(l.closeOnDateSelection)?s.$parent.$eval(l.closeOnDateSelection):r.closeOnDateSelection,g=angular.isDefined(l.datepickerAppendToBody)?s.$parent.$eval(l.datepickerAppendToBody):r.appendToBody;s.showButtonBar=angular.isDefined(l.showButtonBar)?s.$parent.$eval(l.showButtonBar):r.showButtonBar,s.getText=function(e){return s[e+"Text"]||r[e+"Text"]},l.$observe("datepickerPopup",function(e){f=e||r.datepickerPopup,d.$render()});var m=angular.element("<div datepicker-popup-wrap><div datepicker></div></div>");m.attr({"ng-model":"date","ng-change":"dateSelection()"});var v=angular.element(m.children()[0]);l.datepickerOptions&&angular.forEach(s.$parent.$eval(l.datepickerOptions),function(e,t){v.attr(u(t),e)}),angular.forEach(["minDate","maxDate"],function(e){l[e]&&(s.$parent.$watch(t(l[e]),function(t){s[e]=t}),v.attr(u(e),e))}),l.dateDisabled&&v.attr("date-disabled","dateDisabled({ date: date, mode: mode })"),d.$parsers.unshift(p),s.dateSelection=function(e){angular.isDefined(e)&&(s.date=e),d.$setViewValue(s.date),d.$render(),h&&(s.isOpen=!1,c[0].focus())},c.bind("input change keyup",function(){s.$apply(function(){s.date=d.$modelValue})}),d.$render=function(){var e=d.$viewValue?o(d.$viewValue,f):"";c.val(e),s.date=p(d.$modelValue)};var b=function(e){s.isOpen&&e.target!==c[0]&&s.$apply(function(){s.isOpen=!1})},y=function(e){s.keydown(e)};c.bind("keydown",y),s.keydown=function(e){27===e.which?(e.preventDefault(),e.stopPropagation(),s.close()):40!==e.which||s.isOpen||(s.isOpen=!0)},s.$watch("isOpen",function(e){e?(s.$broadcast("datepicker.focus"),s.position=g?i.offset(c):i.position(c),s.position.top=s.position.top+c.prop("offsetHeight"),n.bind("click",b)):n.unbind("click",b)}),s.select=function(e){if("today"===e){var t=new Date;angular.isDate(d.$modelValue)?(e=new Date(d.$modelValue),e.setFullYear(t.getFullYear(),t.getMonth(),t.getDate())):e=new Date(t.setHours(0,0,0,0))}s.dateSelection(e)},s.close=function(){s.isOpen=!1,c[0].focus()};var w=e(m)(s);g?n.find("body").append(w):c.after(w),s.$on("$destroy",function(){w.remove(),c.unbind("keydown",y),n.unbind("click",b)})}}}]).directive("datepickerPopupWrap",function(){return{restrict:"EA",replace:!0,transclude:!0,templateUrl:"template/datepicker/popup.html",link:function(e,t){t.bind("click",function(e){e.preventDefault(),e.stopPropagation()})}}}),angular.module("ui.bootstrap.dropdown",[]).constant("dropdownConfig",{openClass:"open"}).service("dropdownService",["$document",function(e){var t=null;this.open=function(o){t||(e.bind("click",n),e.bind("keydown",i)),t&&t!==o&&(t.isOpen=!1),t=o},this.close=function(o){t===o&&(t=null,e.unbind("click",n),e.unbind("keydown",i))};var n=function(e){e&&e.isDefaultPrevented()||t.$apply(function(){t.isOpen=!1})},i=function(e){27===e.which&&(t.focusToggleElement(),n())}}]).controller("DropdownController",["$scope","$attrs","$parse","dropdownConfig","dropdownService","$animate",function(e,t,n,i,o,a){var r,s=this,c=e.$new(),l=i.openClass,d=angular.noop,u=t.onToggle?n(t.onToggle):angular.noop;this.init=function(i){s.$element=i,t.isOpen&&(r=n(t.isOpen),d=r.assign,e.$watch(r,function(e){c.isOpen=!!e}))},this.toggle=function(e){return c.isOpen=arguments.length?!!e:!c.isOpen},this.isOpen=function(){return c.isOpen},c.focusToggleElement=function(){s.toggleElement&&s.toggleElement[0].focus()},c.$watch("isOpen",function(t,n){a[t?"addClass":"removeClass"](s.$element,l),t?(c.focusToggleElement(),o.open(c)):o.close(c),d(e,t),angular.isDefined(t)&&t!==n&&u(e,{open:!!t})}),e.$on("$locationChangeSuccess",function(){c.isOpen=!1}),e.$on("$destroy",function(){c.$destroy()})}]).directive("dropdown",function(){return{restrict:"CA",controller:"DropdownController",link:function(e,t,n,i){i.init(t)}}}).directive("dropdownToggle",function(){return{restrict:"CA",require:"?^dropdown",link:function(e,t,n,i){if(i){i.toggleElement=t;var o=function(o){o.preventDefault(),t.hasClass("disabled")||n.disabled||e.$apply(function(){i.toggle()})};t.bind("click",o),t.attr({"aria-haspopup":!0,"aria-expanded":!1}),e.$watch(i.isOpen,function(e){t.attr("aria-expanded",!!e)}),e.$on("$destroy",function(){t.unbind("click",o)})}}}}),angular.module("ui.bootstrap.modal",["ui.bootstrap.transition"]).factory("$$stackedMap",function(){return{createNew:function(){var e=[];return{add:function(t,n){e.push({key:t,value:n})},get:function(t){for(var n=0;n<e.length;n++)if(t==e[n].key)return e[n]},keys:function(){for(var t=[],n=0;n<e.length;n++)t.push(e[n].key);return t},top:function(){return e[e.length-1]},remove:function(t){for(var n=-1,i=0;i<e.length;i++)if(t==e[i].key){n=i;break}return e.splice(n,1)[0]},removeTop:function(){return e.splice(e.length-1,1)[0]},length:function(){return e.length}}}}}).directive("modalBackdrop",["$timeout",function(e){return{restrict:"EA",replace:!0,templateUrl:"template/modal/backdrop.html",link:function(t){t.animate=!1,e(function(){t.animate=!0})}}}]).directive("modalWindow",["$modalStack","$timeout",function(e,t){return{restrict:"EA",scope:{index:"@",animate:"="},replace:!0,transclude:!0,templateUrl:function(e,t){return t.templateUrl||"template/modal/window.html"},link:function(n,i,o){i.addClass(o.windowClass||""),n.size=o.size,t(function(){n.animate=!0,i[0].focus()}),n.close=function(t){var n=e.getTop();n&&n.value.backdrop&&"static"!=n.value.backdrop&&t.target===t.currentTarget&&(t.preventDefault(),t.stopPropagation(),e.dismiss(n.key,"backdrop click"))}}}}]).factory("$modalStack",["$transition","$timeout","$document","$compile","$rootScope","$$stackedMap",function(e,t,n,i,o,a){function r(){for(var e=-1,t=f.keys(),n=0;n<t.length;n++)f.get(t[n]).value.backdrop&&(e=n);return e}function s(e){var t=n.find("body").eq(0),i=f.get(e).value;f.remove(e),l(i.modalDomEl,i.modalScope,300,function(){i.modalScope.$destroy(),t.toggleClass(p,f.length()>0),c()})}function c(){if(d&&-1==r()){var e=u;l(d,u,150,function(){e.$destroy(),e=null}),d=void 0,u=void 0}}function l(n,i,o,a){function r(){r.done||(r.done=!0,n.remove(),a&&a())}i.animate=!1;var s=e.transitionEndEventName;if(s){var c=t(r,o);n.bind(s,function(){t.cancel(c),r(),i.$apply()})}else t(r,0)}var d,u,p="modal-open",f=a.createNew(),h={};return o.$watch(r,function(e){u&&(u.index=e)}),n.bind("keydown",function(e){var t;27===e.which&&(t=f.top(),t&&t.value.keyboard&&(e.preventDefault(),o.$apply(function(){h.dismiss(t.key,"escape key press")})))}),h.open=function(e,t){f.add(e,{deferred:t.deferred,modalScope:t.scope,backdrop:t.backdrop,keyboard:t.keyboard});var a=n.find("body").eq(0),s=r();s>=0&&!d&&(u=o.$new(!0),u.index=s,d=i("<div modal-backdrop></div>")(u),a.append(d));var c=angular.element("<div modal-window></div>");c.attr({"template-url":t.windowTemplateUrl,"window-class":t.windowClass,size:t.size,index:f.length()-1,animate:"animate"}).html(t.content);var l=i(c)(t.scope);f.top().value.modalDomEl=l,a.append(l),a.addClass(p)},h.close=function(e,t){var n=f.get(e).value;n&&(n.deferred.resolve(t),s(e))},h.dismiss=function(e,t){var n=f.get(e).value;n&&(n.deferred.reject(t),s(e))},h.dismissAll=function(e){for(var t=this.getTop();t;)this.dismiss(t.key,e),t=this.getTop()},h.getTop=function(){return f.top()},h}]).provider("$modal",function(){var e={options:{backdrop:!0,keyboard:!0},$get:["$injector","$rootScope","$q","$http","$templateCache","$controller","$modalStack",function(t,n,i,o,a,r,s){function c(e){return e.template?i.when(e.template):o.get(e.templateUrl,{cache:a}).then(function(e){return e.data})}function l(e){var n=[];return angular.forEach(e,function(e){(angular.isFunction(e)||angular.isArray(e))&&n.push(i.when(t.invoke(e)))}),n}var d={};return d.open=function(t){var o=i.defer(),a=i.defer(),d={result:o.promise,opened:a.promise,close:function(e){s.close(d,e)},dismiss:function(e){s.dismiss(d,e)}};if(t=angular.extend({},e.options,t),t.resolve=t.resolve||{},!t.template&&!t.templateUrl)throw new Error("One of template or templateUrl options is required.");var u=i.all([c(t)].concat(l(t.resolve)));return u.then(function(e){var i=(t.scope||n).$new();i.$close=d.close,i.$dismiss=d.dismiss;var a,c={},l=1;t.controller&&(c.$scope=i,c.$modalInstance=d,angular.forEach(t.resolve,function(t,n){c[n]=e[l++]}),a=r(t.controller,c)),s.open(d,{scope:i,deferred:o,content:e[0],backdrop:t.backdrop,keyboard:t.keyboard,windowClass:t.windowClass,windowTemplateUrl:t.windowTemplateUrl,size:t.size})},function(e){o.reject(e)}),u.then(function(){a.resolve(!0)},function(){a.reject(!1)}),d},d}]};return e}),angular.module("ui.bootstrap.pagination",[]).controller("PaginationController",["$scope","$attrs","$parse",function(e,t,n){var i=this,o={$setViewValue:angular.noop},a=t.numPages?n(t.numPages).assign:angular.noop;this.init=function(a,r){o=a,this.config=r,o.$render=function(){i.render()},t.itemsPerPage?e.$parent.$watch(n(t.itemsPerPage),function(t){i.itemsPerPage=parseInt(t,10),e.totalPages=i.calculateTotalPages()}):this.itemsPerPage=r.itemsPerPage},this.calculateTotalPages=function(){var t=this.itemsPerPage<1?1:Math.ceil(e.totalItems/this.itemsPerPage);return Math.max(t||0,1)},this.render=function(){e.page=parseInt(o.$viewValue,10)||1},e.selectPage=function(t){e.page!==t&&t>0&&t<=e.totalPages&&(o.$setViewValue(t),o.$render())},e.getText=function(t){return e[t+"Text"]||i.config[t+"Text"]},e.noPrevious=function(){return 1===e.page},e.noNext=function(){return e.page===e.totalPages},e.$watch("totalItems",function(){e.totalPages=i.calculateTotalPages()}),e.$watch("totalPages",function(t){a(e.$parent,t),e.page>t?e.selectPage(t):o.$render()})}]).constant("paginationConfig",{itemsPerPage:10,boundaryLinks:!1,directionLinks:!0,firstText:"First",previousText:"Previous",nextText:"Next",lastText:"Last",rotate:!0}).directive("pagination",["$parse","paginationConfig",function(e,t){return{restrict:"EA",scope:{totalItems:"=",firstText:"@",previousText:"@",nextText:"@",lastText:"@"},require:["pagination","?ngModel"],controller:"PaginationController",templateUrl:"template/pagination/pagination.html",replace:!0,link:function(n,i,o,a){function r(e,t,n){return{number:e,text:t,active:n}}function s(e,t){var n=[],i=1,o=t,a=angular.isDefined(d)&&t>d;a&&(u?(i=Math.max(e-Math.floor(d/2),1),o=i+d-1,o>t&&(o=t,i=o-d+1)):(i=(Math.ceil(e/d)-1)*d+1,o=Math.min(i+d-1,t)));for(var s=i;o>=s;s++){var c=r(s,s,s===e);n.push(c)}if(a&&!u){if(i>1){var l=r(i-1,"...",!1);n.unshift(l)}if(t>o){var p=r(o+1,"...",!1);n.push(p)}}return n}var c=a[0],l=a[1];if(l){var d=angular.isDefined(o.maxSize)?n.$parent.$eval(o.maxSize):t.maxSize,u=angular.isDefined(o.rotate)?n.$parent.$eval(o.rotate):t.rotate;n.boundaryLinks=angular.isDefined(o.boundaryLinks)?n.$parent.$eval(o.boundaryLinks):t.boundaryLinks,n.directionLinks=angular.isDefined(o.directionLinks)?n.$parent.$eval(o.directionLinks):t.directionLinks,c.init(l,t),o.maxSize&&n.$parent.$watch(e(o.maxSize),function(e){d=parseInt(e,10),c.render()});var p=c.render;c.render=function(){p(),n.page>0&&n.page<=n.totalPages&&(n.pages=s(n.page,n.totalPages))}}}}}]).constant("pagerConfig",{itemsPerPage:10,previousText:"« Previous",nextText:"Next »",align:!0}).directive("pager",["pagerConfig",function(e){return{restrict:"EA",scope:{totalItems:"=",previousText:"@",nextText:"@"},require:["pager","?ngModel"],controller:"PaginationController",templateUrl:"template/pagination/pager.html",replace:!0,link:function(t,n,i,o){var a=o[0],r=o[1];r&&(t.align=angular.isDefined(i.align)?t.$parent.$eval(i.align):e.align,a.init(r,e))}}}]),angular.module("ui.bootstrap.tooltip",["ui.bootstrap.position","ui.bootstrap.bindHtml"]).provider("$tooltip",function(){function e(e){var t=/[A-Z]/g,n="-";return e.replace(t,function(e,t){return(t?n:"")+e.toLowerCase()})}var t={placement:"top",animation:!0,popupDelay:0},n={mouseenter:"mouseleave",click:"click",focus:"blur"},i={};this.options=function(e){angular.extend(i,e)},this.setTriggers=function(e){angular.extend(n,e)},this.$get=["$window","$compile","$timeout","$parse","$document","$position","$interpolate",function(o,a,r,s,c,l,d){return function(o,u,p){function f(e){var t=e||h.trigger||p,i=n[t]||t;return{show:t,hide:i}}var h=angular.extend({},t,i),g=e(o),m=d.startSymbol(),v=d.endSymbol(),b="<div "+g+'-popup title="'+m+"tt_title"+v+'" content="'+m+"tt_content"+v+'" placement="'+m+"tt_placement"+v+'" animation="tt_animation" is-open="tt_isOpen"></div>';return{restrict:"EA",scope:!0,compile:function(){var e=a(b);return function(t,n,i){function a(){t.tt_isOpen?p():d()}function d(){(!C||t.$eval(i[u+"Enable"]))&&(t.tt_popupDelay?k||(k=r(g,t.tt_popupDelay,!1),k.then(function(e){e()})):g()())}function p(){t.$apply(function(){m()})}function g(){return k=null,w&&(r.cancel(w),w=null),t.tt_content?(v(),y.css({top:0,left:0,display:"block"}),x?c.find("body").append(y):n.after(y),S(),t.tt_isOpen=!0,t.$digest(),S):angular.noop}function m(){t.tt_isOpen=!1,r.cancel(k),k=null,t.tt_animation?w||(w=r(b,500)):b()}function v(){y&&b(),y=e(t,function(){}),t.$digest()}function b(){w=null,y&&(y.remove(),y=null)}var y,w,k,x=angular.isDefined(h.appendToBody)?h.appendToBody:!1,$=f(void 0),C=angular.isDefined(i[u+"Enable"]),S=function(){var e=l.positionElements(n,y,t.tt_placement,x);e.top+="px",e.left+="px",y.css(e)};t.tt_isOpen=!1,i.$observe(o,function(e){t.tt_content=e,!e&&t.tt_isOpen&&m()}),i.$observe(u+"Title",function(e){t.tt_title=e}),i.$observe(u+"Placement",function(e){t.tt_placement=angular.isDefined(e)?e:h.placement}),i.$observe(u+"PopupDelay",function(e){var n=parseInt(e,10);t.tt_popupDelay=isNaN(n)?h.popupDelay:n});var P=function(){n.unbind($.show,d),n.unbind($.hide,p)};i.$observe(u+"Trigger",function(e){P(),$=f(e),$.show===$.hide?n.bind($.show,a):(n.bind($.show,d),n.bind($.hide,p))});var T=t.$eval(i[u+"Animation"]);t.tt_animation=angular.isDefined(T)?!!T:h.animation,i.$observe(u+"AppendToBody",function(e){x=angular.isDefined(e)?s(e)(t):x}),x&&t.$on("$locationChangeSuccess",function(){t.tt_isOpen&&m()}),t.$on("$destroy",function(){r.cancel(w),r.cancel(k),P(),b()})}}}}}]}).directive("tooltipPopup",function(){return{restrict:"EA",replace:!0,scope:{content:"@",placement:"@",animation:"&",isOpen:"&"},templateUrl:"template/tooltip/tooltip-popup.html"}}).directive("tooltip",["$tooltip",function(e){return e("tooltip","tooltip","mouseenter")}]).directive("tooltipHtmlUnsafePopup",function(){return{restrict:"EA",replace:!0,scope:{content:"@",placement:"@",animation:"&",isOpen:"&"},templateUrl:"template/tooltip/tooltip-html-unsafe-popup.html"}}).directive("tooltipHtmlUnsafe",["$tooltip",function(e){return e("tooltipHtmlUnsafe","tooltip","mouseenter")}]),angular.module("ui.bootstrap.popover",["ui.bootstrap.tooltip"]).directive("popoverPopup",function(){return{restrict:"EA",replace:!0,scope:{title:"@",content:"@",placement:"@",animation:"&",isOpen:"&"},templateUrl:"template/popover/popover.html"}}).directive("popover",["$tooltip",function(e){return e("popover","popover","click")}]),angular.module("ui.bootstrap.progressbar",[]).constant("progressConfig",{animate:!0,max:100}).controller("ProgressController",["$scope","$attrs","progressConfig",function(e,t,n){var i=this,o=angular.isDefined(t.animate)?e.$parent.$eval(t.animate):n.animate;this.bars=[],e.max=angular.isDefined(t.max)?e.$parent.$eval(t.max):n.max,this.addBar=function(t,n){o||n.css({transition:"none"}),this.bars.push(t),t.$watch("value",function(n){t.percent=+(100*n/e.max).toFixed(2)}),t.$on("$destroy",function(){n=null,i.removeBar(t)})},this.removeBar=function(e){this.bars.splice(this.bars.indexOf(e),1)}}]).directive("progress",function(){return{restrict:"EA",replace:!0,transclude:!0,controller:"ProgressController",require:"progress",scope:{},templateUrl:"template/progressbar/progress.html"}}).directive("bar",function(){return{restrict:"EA",replace:!0,transclude:!0,require:"^progress",scope:{value:"=",type:"@"},templateUrl:"template/progressbar/bar.html",link:function(e,t,n,i){i.addBar(e,t)}}}).directive("progressbar",function(){return{restrict:"EA",replace:!0,transclude:!0,controller:"ProgressController",scope:{value:"=",type:"@"},templateUrl:"template/progressbar/progressbar.html",link:function(e,t,n,i){i.addBar(e,angular.element(t.children()[0]))}}}),angular.module("ui.bootstrap.rating",[]).constant("ratingConfig",{max:5,stateOn:null,stateOff:null}).controller("RatingController",["$scope","$attrs","ratingConfig",function(e,t,n){var i={$setViewValue:angular.noop};this.init=function(o){i=o,i.$render=this.render,this.stateOn=angular.isDefined(t.stateOn)?e.$parent.$eval(t.stateOn):n.stateOn,this.stateOff=angular.isDefined(t.stateOff)?e.$parent.$eval(t.stateOff):n.stateOff;var a=angular.isDefined(t.ratingStates)?e.$parent.$eval(t.ratingStates):new Array(angular.isDefined(t.max)?e.$parent.$eval(t.max):n.max);e.range=this.buildTemplateObjects(a)},this.buildTemplateObjects=function(e){for(var t=0,n=e.length;n>t;t++)e[t]=angular.extend({index:t},{stateOn:this.stateOn,stateOff:this.stateOff},e[t]);return e},e.rate=function(t){!e.readonly&&t>=0&&t<=e.range.length&&(i.$setViewValue(t),i.$render())},e.enter=function(t){e.readonly||(e.value=t),e.onHover({value:t})},e.reset=function(){e.value=i.$viewValue,e.onLeave()},e.onKeydown=function(t){/(37|38|39|40)/.test(t.which)&&(t.preventDefault(),t.stopPropagation(),e.rate(e.value+(38===t.which||39===t.which?1:-1)))},this.render=function(){e.value=i.$viewValue}}]).directive("rating",function(){return{restrict:"EA",require:["rating","ngModel"],scope:{readonly:"=?",onHover:"&",onLeave:"&"},controller:"RatingController",templateUrl:"template/rating/rating.html",replace:!0,link:function(e,t,n,i){var o=i[0],a=i[1];a&&o.init(a)}}}),angular.module("ui.bootstrap.tabs",[]).controller("TabsetController",["$scope",function(e){var t=this,n=t.tabs=e.tabs=[];t.select=function(e){angular.forEach(n,function(t){t.active&&t!==e&&(t.active=!1,t.onDeselect())}),e.active=!0,e.onSelect()},t.addTab=function(e){n.push(e),1===n.length?e.active=!0:e.active&&t.select(e)},t.removeTab=function(e){var i=n.indexOf(e);if(e.active&&n.length>1){var o=i==n.length-1?i-1:i+1;t.select(n[o])}n.splice(i,1)}}]).directive("tabset",function(){return{restrict:"EA",transclude:!0,replace:!0,scope:{type:"@"},controller:"TabsetController",templateUrl:"template/tabs/tabset.html",link:function(e,t,n){e.vertical=angular.isDefined(n.vertical)?e.$parent.$eval(n.vertical):!1,e.justified=angular.isDefined(n.justified)?e.$parent.$eval(n.justified):!1}}}).directive("tab",["$parse",function(e){return{require:"^tabset",restrict:"EA",replace:!0,templateUrl:"template/tabs/tab.html",transclude:!0,scope:{active:"=?",heading:"@",onSelect:"&select",onDeselect:"&deselect"},controller:function(){},compile:function(t,n,i){return function(t,n,o,a){t.$watch("active",function(e){e&&a.select(t)}),t.disabled=!1,o.disabled&&t.$parent.$watch(e(o.disabled),function(e){t.disabled=!!e}),t.select=function(){t.disabled||(t.active=!0)},a.addTab(t),t.$on("$destroy",function(){a.removeTab(t)}),t.$transcludeFn=i}}}}]).directive("tabHeadingTransclude",[function(){return{restrict:"A",require:"^tab",link:function(e,t){e.$watch("headingElement",function(e){e&&(t.html(""),t.append(e))})}}}]).directive("tabContentTransclude",function(){function e(e){return e.tagName&&(e.hasAttribute("tab-heading")||e.hasAttribute("data-tab-heading")||"tab-heading"===e.tagName.toLowerCase()||"data-tab-heading"===e.tagName.toLowerCase())}return{restrict:"A",require:"^tabset",link:function(t,n,i){var o=t.$eval(i.tabContentTransclude);o.$transcludeFn(o.$parent,function(t){angular.forEach(t,function(t){e(t)?o.headingElement=t:n.append(t)})})}}}),angular.module("ui.bootstrap.timepicker",[]).constant("timepickerConfig",{hourStep:1,minuteStep:1,showMeridian:!0,meridians:null,readonlyInput:!1,mousewheel:!0}).controller("TimepickerController",["$scope","$attrs","$parse","$log","$locale","timepickerConfig",function(e,t,n,i,o,a){function r(){var t=parseInt(e.hours,10),n=e.showMeridian?t>0&&13>t:t>=0&&24>t;return n?(e.showMeridian&&(12===t&&(t=0),e.meridian===g[1]&&(t+=12)),t):void 0}function s(){var t=parseInt(e.minutes,10);return t>=0&&60>t?t:void 0}function c(e){return angular.isDefined(e)&&e.toString().length<2?"0"+e:e}function l(e){d(),h.$setViewValue(new Date(f)),u(e)}function d(){h.$setValidity("time",!0),e.invalidHours=!1,e.invalidMinutes=!1}function u(t){var n=f.getHours(),i=f.getMinutes();e.showMeridian&&(n=0===n||12===n?12:n%12),e.hours="h"===t?n:c(n),e.minutes="m"===t?i:c(i),e.meridian=f.getHours()<12?g[0]:g[1]}function p(e){var t=new Date(f.getTime()+6e4*e);f.setHours(t.getHours(),t.getMinutes()),l()}var f=new Date,h={$setViewValue:angular.noop},g=angular.isDefined(t.meridians)?e.$parent.$eval(t.meridians):a.meridians||o.DATETIME_FORMATS.AMPMS;this.init=function(n,i){h=n,h.$render=this.render;var o=i.eq(0),r=i.eq(1),s=angular.isDefined(t.mousewheel)?e.$parent.$eval(t.mousewheel):a.mousewheel;s&&this.setupMousewheelEvents(o,r),e.readonlyInput=angular.isDefined(t.readonlyInput)?e.$parent.$eval(t.readonlyInput):a.readonlyInput,this.setupInputEvents(o,r)};var m=a.hourStep;t.hourStep&&e.$parent.$watch(n(t.hourStep),function(e){m=parseInt(e,10)});var v=a.minuteStep;t.minuteStep&&e.$parent.$watch(n(t.minuteStep),function(e){v=parseInt(e,10)}),e.showMeridian=a.showMeridian,t.showMeridian&&e.$parent.$watch(n(t.showMeridian),function(t){if(e.showMeridian=!!t,h.$error.time){var n=r(),i=s();angular.isDefined(n)&&angular.isDefined(i)&&(f.setHours(n),l())}else u()}),this.setupMousewheelEvents=function(t,n){var i=function(e){e.originalEvent&&(e=e.originalEvent);var t=e.wheelDelta?e.wheelDelta:-e.deltaY;return e.detail||t>0};t.bind("mousewheel wheel",function(t){e.$apply(i(t)?e.incrementHours():e.decrementHours()),t.preventDefault()}),n.bind("mousewheel wheel",function(t){e.$apply(i(t)?e.incrementMinutes():e.decrementMinutes()),t.preventDefault()})},this.setupInputEvents=function(t,n){if(e.readonlyInput)return e.updateHours=angular.noop,void(e.updateMinutes=angular.noop);var i=function(t,n){h.$setViewValue(null),h.$setValidity("time",!1),angular.isDefined(t)&&(e.invalidHours=t),angular.isDefined(n)&&(e.invalidMinutes=n)};e.updateHours=function(){var e=r();angular.isDefined(e)?(f.setHours(e),l("h")):i(!0)},t.bind("blur",function(){!e.invalidHours&&e.hours<10&&e.$apply(function(){e.hours=c(e.hours)})}),e.updateMinutes=function(){var e=s();angular.isDefined(e)?(f.setMinutes(e),l("m")):i(void 0,!0)},n.bind("blur",function(){!e.invalidMinutes&&e.minutes<10&&e.$apply(function(){e.minutes=c(e.minutes)})})},this.render=function(){var e=h.$modelValue?new Date(h.$modelValue):null;isNaN(e)?(h.$setValidity("time",!1),i.error('Timepicker directive: "ng-model" value must be a Date object, a number of milliseconds since 01.01.1970 or a string representing an RFC2822 or ISO 8601 date.')):(e&&(f=e),d(),u())},e.incrementHours=function(){p(60*m)},e.decrementHours=function(){p(60*-m)},e.incrementMinutes=function(){p(v)},e.decrementMinutes=function(){p(-v)},e.toggleMeridian=function(){p(720*(f.getHours()<12?1:-1))}}]).directive("timepicker",function(){return{restrict:"EA",require:["timepicker","?^ngModel"],controller:"TimepickerController",replace:!0,scope:{},templateUrl:"template/timepicker/timepicker.html",link:function(e,t,n,i){var o=i[0],a=i[1];a&&o.init(a,t.find("input"))}}}),angular.module("ui.bootstrap.typeahead",["ui.bootstrap.position","ui.bootstrap.bindHtml"]).factory("typeaheadParser",["$parse",function(e){var t=/^\s*(.*?)(?:\s+as\s+(.*?))?\s+for\s+(?:([\$\w][\$\w\d]*))\s+in\s+(.*)$/;return{parse:function(n){var i=n.match(t);if(!i)throw new Error('Expected typeahead specification in form of "_modelValue_ (as _label_)? for _item_ in _collection_" but got "'+n+'".');return{itemName:i[3],source:e(i[4]),viewMapper:e(i[2]||i[1]),modelMapper:e(i[1])}}}}]).directive("typeahead",["$compile","$parse","$q","$timeout","$document","$position","typeaheadParser",function(e,t,n,i,o,a,r){var s=[9,13,27,38,40];return{require:"ngModel",link:function(c,l,d,u){var p,f=c.$eval(d.typeaheadMinLength)||1,h=c.$eval(d.typeaheadWaitMs)||0,g=c.$eval(d.typeaheadEditable)!==!1,m=t(d.typeaheadLoading).assign||angular.noop,v=t(d.typeaheadOnSelect),b=d.typeaheadInputFormatter?t(d.typeaheadInputFormatter):void 0,y=d.typeaheadAppendToBody?c.$eval(d.typeaheadAppendToBody):!1,w=t(d.ngModel).assign,k=r.parse(d.typeahead),x=c.$new();c.$on("$destroy",function(){x.$destroy()});var $="typeahead-"+x.$id+"-"+Math.floor(1e4*Math.random());
l.attr({"aria-autocomplete":"list","aria-expanded":!1,"aria-owns":$});var C=angular.element("<div typeahead-popup></div>");C.attr({id:$,matches:"matches",active:"activeIdx",select:"select(activeIdx)",query:"query",position:"position"}),angular.isDefined(d.typeaheadTemplateUrl)&&C.attr("template-url",d.typeaheadTemplateUrl);var S=function(){x.matches=[],x.activeIdx=-1,l.attr("aria-expanded",!1)},P=function(e){return $+"-option-"+e};x.$watch("activeIdx",function(e){0>e?l.removeAttr("aria-activedescendant"):l.attr("aria-activedescendant",P(e))});var T=function(e){var t={$viewValue:e};m(c,!0),n.when(k.source(c,t)).then(function(n){var i=e===u.$viewValue;if(i&&p)if(n.length>0){x.activeIdx=0,x.matches.length=0;for(var o=0;o<n.length;o++)t[k.itemName]=n[o],x.matches.push({id:P(o),label:k.viewMapper(x,t),model:n[o]});x.query=e,x.position=y?a.offset(l):a.position(l),x.position.top=x.position.top+l.prop("offsetHeight"),l.attr("aria-expanded",!0)}else S();i&&m(c,!1)},function(){S(),m(c,!1)})};S(),x.query=void 0;var _;u.$parsers.unshift(function(e){return p=!0,e&&e.length>=f?h>0?(_&&i.cancel(_),_=i(function(){T(e)},h)):T(e):(m(c,!1),S()),g?e:e?void u.$setValidity("editable",!1):(u.$setValidity("editable",!0),e)}),u.$formatters.push(function(e){var t,n,i={};return b?(i.$model=e,b(c,i)):(i[k.itemName]=e,t=k.viewMapper(c,i),i[k.itemName]=void 0,n=k.viewMapper(c,i),t!==n?t:e)}),x.select=function(e){var t,n,o={};o[k.itemName]=n=x.matches[e].model,t=k.modelMapper(c,o),w(c,t),u.$setValidity("editable",!0),v(c,{$item:n,$model:t,$label:k.viewMapper(c,o)}),S(),i(function(){l[0].focus()},0,!1)},l.bind("keydown",function(e){0!==x.matches.length&&-1!==s.indexOf(e.which)&&(e.preventDefault(),40===e.which?(x.activeIdx=(x.activeIdx+1)%x.matches.length,x.$digest()):38===e.which?(x.activeIdx=(x.activeIdx?x.activeIdx:x.matches.length)-1,x.$digest()):13===e.which||9===e.which?x.$apply(function(){x.select(x.activeIdx)}):27===e.which&&(e.stopPropagation(),S(),x.$digest()))}),l.bind("blur",function(){p=!1});var D=function(e){l[0]!==e.target&&(S(),x.$digest())};o.bind("click",D),c.$on("$destroy",function(){o.unbind("click",D)});var R=e(C)(x);y?o.find("body").append(R):l.after(R)}}}]).directive("typeaheadPopup",function(){return{restrict:"EA",scope:{matches:"=",query:"=",active:"=",position:"=",select:"&"},replace:!0,templateUrl:"template/typeahead/typeahead-popup.html",link:function(e,t,n){e.templateUrl=n.templateUrl,e.isOpen=function(){return e.matches.length>0},e.isActive=function(t){return e.active==t},e.selectActive=function(t){e.active=t},e.selectMatch=function(t){e.select({activeIdx:t})}}}}).directive("typeaheadMatch",["$http","$templateCache","$compile","$parse",function(e,t,n,i){return{restrict:"EA",scope:{index:"=",match:"=",query:"="},link:function(o,a,r){var s=i(r.templateUrl)(o.$parent)||"template/typeahead/typeahead-match.html";e.get(s,{cache:t}).success(function(e){a.replaceWith(n(e.trim())(o))})}}}]).filter("typeaheadHighlight",function(){function e(e){return e.replace(/([.?*+^$[\]\\(){}|-])/g,"\\$1")}return function(t,n){return n?(""+t).replace(new RegExp(e(n),"gi"),"<strong>$&</strong>"):t}}),angular.module("template/accordion/accordion-group.html",[]).run(["$templateCache",function(e){e.put("template/accordion/accordion-group.html",'<div class="panel panel-default">\n  <div class="panel-heading">\n    <h4 class="panel-title">\n      <a class="accordion-toggle" ng-click="toggleOpen()" accordion-transclude="heading"><span ng-class="{\'text-muted\': isDisabled}">{{heading}}</span></a>\n    </h4>\n  </div>\n  <div class="panel-collapse" collapse="!isOpen">\n	  <div class="panel-body" ng-transclude></div>\n  </div>\n</div>')}]),angular.module("template/accordion/accordion.html",[]).run(["$templateCache",function(e){e.put("template/accordion/accordion.html",'<div class="panel-group" ng-transclude></div>')}]),angular.module("template/alert/alert.html",[]).run(["$templateCache",function(e){e.put("template/alert/alert.html",'<div class="alert" ng-class="{\'alert-{{type || \'warning\'}}\': true, \'alert-dismissable\': closeable}" role="alert">\n    <button ng-show="closeable" type="button" class="close" ng-click="close()">\n        <span aria-hidden="true">&times;</span>\n        <span class="sr-only">Close</span>\n    </button>\n    <div ng-transclude></div>\n</div>\n')}]),angular.module("template/carousel/carousel.html",[]).run(["$templateCache",function(e){e.put("template/carousel/carousel.html",'<div ng-mouseenter="pause()" ng-mouseleave="play()" class="carousel" ng-swipe-right="prev()" ng-swipe-left="next()">\n    <ol class="carousel-indicators" ng-show="slides.length > 1">\n        <li ng-repeat="slide in slides track by $index" ng-class="{active: isActive(slide)}" ng-click="select(slide)"></li>\n    </ol>\n    <div class="carousel-inner" ng-transclude></div>\n    <a class="left carousel-control" ng-click="prev()" ng-show="slides.length > 1"><span class="glyphicon glyphicon-chevron-left"></span></a>\n    <a class="right carousel-control" ng-click="next()" ng-show="slides.length > 1"><span class="glyphicon glyphicon-chevron-right"></span></a>\n</div>\n')}]),angular.module("template/carousel/slide.html",[]).run(["$templateCache",function(e){e.put("template/carousel/slide.html","<div ng-class=\"{\n    'active': leaving || (active && !entering),\n    'prev': (next || active) && direction=='prev',\n    'next': (next || active) && direction=='next',\n    'right': direction=='prev',\n    'left': direction=='next'\n  }\" class=\"item text-center\" ng-transclude></div>\n")}]),angular.module("template/datepicker/datepicker.html",[]).run(["$templateCache",function(e){e.put("template/datepicker/datepicker.html",'<div ng-switch="datepickerMode" role="application" ng-keydown="keydown($event)">\n  <daypicker ng-switch-when="day" tabindex="0"></daypicker>\n  <monthpicker ng-switch-when="month" tabindex="0"></monthpicker>\n  <yearpicker ng-switch-when="year" tabindex="0"></yearpicker>\n</div>')}]),angular.module("template/datepicker/day.html",[]).run(["$templateCache",function(e){e.put("template/datepicker/day.html",'<table role="grid" aria-labelledby="{{uniqueId}}-title" aria-activedescendant="{{activeDateId}}">\n  <thead>\n    <tr>\n      <th><button type="button" class="btn btn-default btn-sm pull-left" ng-click="move(-1)" tabindex="-1"><i class="glyphicon glyphicon-chevron-left"></i></button></th>\n      <th colspan="{{5 + showWeeks}}"><button id="{{uniqueId}}-title" role="heading" aria-live="assertive" aria-atomic="true" type="button" class="btn btn-default btn-sm" ng-click="toggleMode()" tabindex="-1" style="width:100%;"><strong>{{title}}</strong></button></th>\n      <th><button type="button" class="btn btn-default btn-sm pull-right" ng-click="move(1)" tabindex="-1"><i class="glyphicon glyphicon-chevron-right"></i></button></th>\n    </tr>\n    <tr>\n      <th ng-show="showWeeks" class="text-center"></th>\n      <th ng-repeat="label in labels track by $index" class="text-center"><small aria-label="{{label.full}}">{{label.abbr}}</small></th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr ng-repeat="row in rows track by $index">\n      <td ng-show="showWeeks" class="text-center h6"><em>{{ weekNumbers[$index] }}</em></td>\n      <td ng-repeat="dt in row track by dt.date" class="text-center" role="gridcell" id="{{dt.uid}}" aria-disabled="{{!!dt.disabled}}">\n        <button type="button" style="width:100%;" class="btn btn-default btn-sm" ng-class="{\'btn-info\': dt.selected, active: isActive(dt)}" ng-click="select(dt.date)" ng-disabled="dt.disabled" tabindex="-1"><span ng-class="{\'text-muted\': dt.secondary, \'text-info\': dt.current}">{{dt.label}}</span></button>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),angular.module("template/datepicker/month.html",[]).run(["$templateCache",function(e){e.put("template/datepicker/month.html",'<table role="grid" aria-labelledby="{{uniqueId}}-title" aria-activedescendant="{{activeDateId}}">\n  <thead>\n    <tr>\n      <th><button type="button" class="btn btn-default btn-sm pull-left" ng-click="move(-1)" tabindex="-1"><i class="glyphicon glyphicon-chevron-left"></i></button></th>\n      <th><button id="{{uniqueId}}-title" role="heading" aria-live="assertive" aria-atomic="true" type="button" class="btn btn-default btn-sm" ng-click="toggleMode()" tabindex="-1" style="width:100%;"><strong>{{title}}</strong></button></th>\n      <th><button type="button" class="btn btn-default btn-sm pull-right" ng-click="move(1)" tabindex="-1"><i class="glyphicon glyphicon-chevron-right"></i></button></th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr ng-repeat="row in rows track by $index">\n      <td ng-repeat="dt in row track by dt.date" class="text-center" role="gridcell" id="{{dt.uid}}" aria-disabled="{{!!dt.disabled}}">\n        <button type="button" style="width:100%;" class="btn btn-default" ng-class="{\'btn-info\': dt.selected, active: isActive(dt)}" ng-click="select(dt.date)" ng-disabled="dt.disabled" tabindex="-1"><span ng-class="{\'text-info\': dt.current}">{{dt.label}}</span></button>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),angular.module("template/datepicker/popup.html",[]).run(["$templateCache",function(e){e.put("template/datepicker/popup.html",'<ul class="dropdown-menu" ng-style="{display: (isOpen && \'block\') || \'none\', top: position.top+\'px\', left: position.left+\'px\'}" ng-keydown="keydown($event)">\n	<li ng-transclude></li>\n	<li ng-if="showButtonBar" style="padding:10px 9px 2px">\n		<span class="btn-group">\n			<button type="button" class="btn btn-sm btn-info" ng-click="select(\'today\')">{{ getText(\'current\') }}</button>\n			<button type="button" class="btn btn-sm btn-danger" ng-click="select(null)">{{ getText(\'clear\') }}</button>\n		</span>\n		<button type="button" class="btn btn-sm btn-success pull-right" ng-click="close()">{{ getText(\'close\') }}</button>\n	</li>\n</ul>\n')}]),angular.module("template/datepicker/year.html",[]).run(["$templateCache",function(e){e.put("template/datepicker/year.html",'<table role="grid" aria-labelledby="{{uniqueId}}-title" aria-activedescendant="{{activeDateId}}">\n  <thead>\n    <tr>\n      <th><button type="button" class="btn btn-default btn-sm pull-left" ng-click="move(-1)" tabindex="-1"><i class="glyphicon glyphicon-chevron-left"></i></button></th>\n      <th colspan="3"><button id="{{uniqueId}}-title" role="heading" aria-live="assertive" aria-atomic="true" type="button" class="btn btn-default btn-sm" ng-click="toggleMode()" tabindex="-1" style="width:100%;"><strong>{{title}}</strong></button></th>\n      <th><button type="button" class="btn btn-default btn-sm pull-right" ng-click="move(1)" tabindex="-1"><i class="glyphicon glyphicon-chevron-right"></i></button></th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr ng-repeat="row in rows track by $index">\n      <td ng-repeat="dt in row track by dt.date" class="text-center" role="gridcell" id="{{dt.uid}}" aria-disabled="{{!!dt.disabled}}">\n        <button type="button" style="width:100%;" class="btn btn-default" ng-class="{\'btn-info\': dt.selected, active: isActive(dt)}" ng-click="select(dt.date)" ng-disabled="dt.disabled" tabindex="-1"><span ng-class="{\'text-info\': dt.current}">{{dt.label}}</span></button>\n      </td>\n    </tr>\n  </tbody>\n</table>\n')}]),angular.module("template/modal/backdrop.html",[]).run(["$templateCache",function(e){e.put("template/modal/backdrop.html",'<div class="modal-backdrop fade"\n     ng-class="{in: animate}"\n     ng-style="{\'z-index\': 1040 + (index && 1 || 0) + index*10}"\n></div>\n')}]),angular.module("template/modal/window.html",[]).run(["$templateCache",function(e){e.put("template/modal/window.html",'<div tabindex="-1" role="dialog" class="modal fade" ng-class="{in: animate}" ng-style="{\'z-index\': 1050 + index*10, display: \'block\'}" ng-click="close($event)">\n    <div class="modal-dialog" ng-class="{\'modal-sm\': size == \'sm\', \'modal-lg\': size == \'lg\'}"><div class="modal-content" ng-transclude></div></div>\n</div>')}]),angular.module("template/pagination/pager.html",[]).run(["$templateCache",function(e){e.put("template/pagination/pager.html",'<ul class="pager">\n  <li ng-class="{disabled: noPrevious(), previous: align}"><a href ng-click="selectPage(page - 1)">{{getText(\'previous\')}}</a></li>\n  <li ng-class="{disabled: noNext(), next: align}"><a href ng-click="selectPage(page + 1)">{{getText(\'next\')}}</a></li>\n</ul>')}]),angular.module("template/pagination/pagination.html",[]).run(["$templateCache",function(e){e.put("template/pagination/pagination.html",'<ul class="pagination">\n  <li ng-if="boundaryLinks" ng-class="{disabled: noPrevious()}"><a href ng-click="selectPage(1)">{{getText(\'first\')}}</a></li>\n  <li ng-if="directionLinks" ng-class="{disabled: noPrevious()}"><a href ng-click="selectPage(page - 1)">{{getText(\'previous\')}}</a></li>\n  <li ng-repeat="page in pages track by $index" ng-class="{active: page.active}"><a href ng-click="selectPage(page.number)">{{page.text}}</a></li>\n  <li ng-if="directionLinks" ng-class="{disabled: noNext()}"><a href ng-click="selectPage(page + 1)">{{getText(\'next\')}}</a></li>\n  <li ng-if="boundaryLinks" ng-class="{disabled: noNext()}"><a href ng-click="selectPage(totalPages)">{{getText(\'last\')}}</a></li>\n</ul>')}]),angular.module("template/tooltip/tooltip-html-unsafe-popup.html",[]).run(["$templateCache",function(e){e.put("template/tooltip/tooltip-html-unsafe-popup.html",'<div class="tooltip {{placement}}" ng-class="{ in: isOpen(), fade: animation() }">\n  <div class="tooltip-arrow"></div>\n  <div class="tooltip-inner" bind-html-unsafe="content"></div>\n</div>\n')}]),angular.module("template/tooltip/tooltip-popup.html",[]).run(["$templateCache",function(e){e.put("template/tooltip/tooltip-popup.html",'<div class="tooltip {{placement}}" ng-class="{ in: isOpen(), fade: animation() }">\n  <div class="tooltip-arrow"></div>\n  <div class="tooltip-inner" ng-bind="content"></div>\n</div>\n')}]),angular.module("template/popover/popover.html",[]).run(["$templateCache",function(e){e.put("template/popover/popover.html",'<div class="popover {{placement}}" ng-class="{ in: isOpen(), fade: animation() }">\n  <div class="arrow"></div>\n\n  <div class="popover-inner">\n      <h3 class="popover-title" ng-bind="title" ng-show="title"></h3>\n      <div class="popover-content" ng-bind="content"></div>\n  </div>\n</div>\n')}]),angular.module("template/progressbar/bar.html",[]).run(["$templateCache",function(e){e.put("template/progressbar/bar.html",'<div class="progress-bar" ng-class="type && \'progress-bar-\' + type" role="progressbar" aria-valuenow="{{value}}" aria-valuemin="0" aria-valuemax="{{max}}" ng-style="{width: percent + \'%\'}" aria-valuetext="{{percent | number:0}}%" ng-transclude></div>')}]),angular.module("template/progressbar/progress.html",[]).run(["$templateCache",function(e){e.put("template/progressbar/progress.html",'<div class="progress" ng-transclude></div>')}]),angular.module("template/progressbar/progressbar.html",[]).run(["$templateCache",function(e){e.put("template/progressbar/progressbar.html",'<div class="progress">\n  <div class="progress-bar" ng-class="type && \'progress-bar-\' + type" role="progressbar" aria-valuenow="{{value}}" aria-valuemin="0" aria-valuemax="{{max}}" ng-style="{width: percent + \'%\'}" aria-valuetext="{{percent | number:0}}%" ng-transclude></div>\n</div>')}]),angular.module("template/rating/rating.html",[]).run(["$templateCache",function(e){e.put("template/rating/rating.html",'<span ng-mouseleave="reset()" ng-keydown="onKeydown($event)" tabindex="0" role="slider" aria-valuemin="0" aria-valuemax="{{range.length}}" aria-valuenow="{{value}}">\n    <i ng-repeat="r in range track by $index" ng-mouseenter="enter($index + 1)" ng-click="rate($index + 1)" class="glyphicon" ng-class="$index < value && (r.stateOn || \'glyphicon-star\') || (r.stateOff || \'glyphicon-star-empty\')">\n        <span class="sr-only">({{ $index < value ? \'*\' : \' \' }})</span>\n    </i>\n</span>')}]),angular.module("template/tabs/tab.html",[]).run(["$templateCache",function(e){e.put("template/tabs/tab.html",'<li ng-class="{active: active, disabled: disabled}">\n  <a ng-click="select()" tab-heading-transclude>{{heading}}</a>\n</li>\n')}]),angular.module("template/tabs/tabset-titles.html",[]).run(["$templateCache",function(e){e.put("template/tabs/tabset-titles.html","<ul class=\"nav {{type && 'nav-' + type}}\" ng-class=\"{'nav-stacked': vertical}\">\n</ul>\n")}]),angular.module("template/tabs/tabset.html",[]).run(["$templateCache",function(e){e.put("template/tabs/tabset.html",'\n<div>\n  <ul class="nav nav-{{type || \'tabs\'}}" ng-class="{\'nav-stacked\': vertical, \'nav-justified\': justified}" ng-transclude></ul>\n  <div class="tab-content">\n    <div class="tab-pane" \n         ng-repeat="tab in tabs" \n         ng-class="{active: tab.active}"\n         tab-content-transclude="tab">\n    </div>\n  </div>\n</div>\n')}]),angular.module("template/timepicker/timepicker.html",[]).run(["$templateCache",function(e){e.put("template/timepicker/timepicker.html",'<table>\n	<tbody>\n		<tr class="text-center">\n			<td><a ng-click="incrementHours()" class="btn btn-link"><span class="glyphicon glyphicon-chevron-up"></span></a></td>\n			<td>&nbsp;</td>\n			<td><a ng-click="incrementMinutes()" class="btn btn-link"><span class="glyphicon glyphicon-chevron-up"></span></a></td>\n			<td ng-show="showMeridian"></td>\n		</tr>\n		<tr>\n			<td style="width:50px;" class="form-group" ng-class="{\'has-error\': invalidHours}">\n				<input type="text" ng-model="hours" ng-change="updateHours()" class="form-control text-center" ng-mousewheel="incrementHours()" ng-readonly="readonlyInput" maxlength="2">\n			</td>\n			<td>:</td>\n			<td style="width:50px;" class="form-group" ng-class="{\'has-error\': invalidMinutes}">\n				<input type="text" ng-model="minutes" ng-change="updateMinutes()" class="form-control text-center" ng-readonly="readonlyInput" maxlength="2">\n			</td>\n			<td ng-show="showMeridian"><button type="button" class="btn btn-default text-center" ng-click="toggleMeridian()">{{meridian}}</button></td>\n		</tr>\n		<tr class="text-center">\n			<td><a ng-click="decrementHours()" class="btn btn-link"><span class="glyphicon glyphicon-chevron-down"></span></a></td>\n			<td>&nbsp;</td>\n			<td><a ng-click="decrementMinutes()" class="btn btn-link"><span class="glyphicon glyphicon-chevron-down"></span></a></td>\n			<td ng-show="showMeridian"></td>\n		</tr>\n	</tbody>\n</table>\n')}]),angular.module("template/typeahead/typeahead-match.html",[]).run(["$templateCache",function(e){e.put("template/typeahead/typeahead-match.html",'<a tabindex="-1" bind-html-unsafe="match.label | typeaheadHighlight:query"></a>')}]),angular.module("template/typeahead/typeahead-popup.html",[]).run(["$templateCache",function(e){e.put("template/typeahead/typeahead-popup.html",'<ul class="dropdown-menu" ng-if="isOpen()" ng-style="{top: position.top+\'px\', left: position.left+\'px\'}" style="display: block;" role="listbox" aria-hidden="{{!isOpen()}}">\n    <li ng-repeat="match in matches track by $index" ng-class="{active: isActive($index) }" ng-mouseenter="selectActive($index)" ng-click="selectMatch($index)" role="option" id="{{match.id}}">\n        <div typeahead-match index="$index" match="match" query="query" template-url="templateUrl"></div>\n    </li>\n</ul>')}]),define("ui-bootstrap",["angular"],function(){}),function(e,t,n){function i(e){var n=[];return c(n,t.noop).chars(e),n.join("")}function o(e){var t={};e=e.split(",");var n;for(n=0;n<e.length;n++)t[e[n]]=!0;return t}function a(e,n){function i(e,i,a,s){if(i=t.lowercase(i),x[i])for(;b.last()&&$[b.last()];)o("",b.last());k[i]&&b.last()==i&&o("",i),(s=w[i]||!!s)||b.push(i);var c={};a.replace(p,function(e,t,n,i,o){c[t]=r(n||i||o||"")}),n.start&&n.start(i,c,s)}function o(e,i){var o,a=0;if(i=t.lowercase(i))for(a=b.length-1;a>=0&&b[a]!=i;a--);if(a>=0){for(o=b.length-1;o>=a;o--)n.end&&n.end(b[o]);b.length=a}}"string"!=typeof e&&(e=null===e||"undefined"==typeof e?"":""+e);var a,s,c,b=[],y=e;for(b.last=function(){return b[b.length-1]};e;){if(c="",s=!0,b.last()&&C[b.last()]?(e=e.replace(RegExp("(.*)<\\s*\\/\\s*"+b.last()+"[^>]*>","i"),function(e,t){return t=t.replace(g,"$1").replace(v,"$1"),n.chars&&n.chars(r(t)),""}),o("",b.last())):(0===e.indexOf("<!--")?(a=e.indexOf("--",4),a>=0&&e.lastIndexOf("-->",a)===a&&(n.comment&&n.comment(e.substring(4,a)),e=e.substring(a+3),s=!1)):m.test(e)?(a=e.match(m))&&(e=e.replace(a[0],""),s=!1):h.test(e)?(a=e.match(u))&&(e=e.substring(a[0].length),a[0].replace(u,o),s=!1):f.test(e)&&((a=e.match(d))?(a[4]&&(e=e.substring(a[0].length),a[0].replace(d,i)),s=!1):(c+="<",e=e.substring(1))),s&&(a=e.indexOf("<"),c+=0>a?e:e.substring(0,a),e=0>a?"":e.substring(a),n.chars&&n.chars(r(c)))),e==y)throw l("badparse",e);y=e}o()}function r(e){if(!e)return"";var t=D.exec(e);e=t[1];var n=t[3];return(t=t[2])&&(_.innerHTML=t.replace(/</g,"&lt;"),t="textContent"in _?_.textContent:_.innerText),e+t+n}function s(e){return e.replace(/&/g,"&amp;").replace(b,function(e){var t=e.charCodeAt(0);return e=e.charCodeAt(1),"&#"+(1024*(t-55296)+(e-56320)+65536)+";"}).replace(y,function(e){return"&#"+e.charCodeAt(0)+";"}).replace(/</g,"&lt;").replace(/>/g,"&gt;")}function c(e,n){var i=!1,o=t.bind(e,e.push);return{start:function(e,a,r){e=t.lowercase(e),!i&&C[e]&&(i=e),i||!0!==S[e]||(o("<"),o(e),t.forEach(a,function(i,a){var r=t.lowercase(a),c="img"===e&&"src"===r||"background"===r;!0!==T[r]||!0===P[r]&&!n(i,c)||(o(" "),o(a),o('="'),o(s(i)),o('"'))}),o(r?"/>":">"))},end:function(e){e=t.lowercase(e),i||!0!==S[e]||(o("</"),o(e),o(">")),e==i&&(i=!1)},chars:function(e){i||o(s(e))}}}var l=t.$$minErr("$sanitize"),d=/^<((?:[a-zA-Z])[\w:-]*)((?:\s+[\w:-]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)\s*(>?)/,u=/^<\/\s*([\w:-]+)[^>]*>/,p=/([\w:-]+)(?:\s*=\s*(?:(?:"((?:[^"])*)")|(?:'((?:[^'])*)')|([^>\s]+)))?/g,f=/^</,h=/^<\//,g=/\x3c!--(.*?)--\x3e/g,m=/<!DOCTYPE([^>]*?)>/i,v=/<!\[CDATA\[(.*?)]]\x3e/g,b=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g,y=/([^\#-~| |!])/g,w=o("area,br,col,hr,img,wbr");e=o("colgroup,dd,dt,li,p,tbody,td,tfoot,th,thead,tr"),n=o("rp,rt");var k=t.extend({},n,e),x=t.extend({},e,o("address,article,aside,blockquote,caption,center,del,dir,div,dl,figure,figcaption,footer,h1,h2,h3,h4,h5,h6,header,hgroup,hr,ins,map,menu,nav,ol,pre,script,section,table,ul")),$=t.extend({},n,o("a,abbr,acronym,b,bdi,bdo,big,br,cite,code,del,dfn,em,font,i,img,ins,kbd,label,map,mark,q,ruby,rp,rt,s,samp,small,span,strike,strong,sub,sup,time,tt,u,var")),C=o("script,style"),S=t.extend({},w,x,$,k),P=o("background,cite,href,longdesc,src,usemap"),T=t.extend({},P,o("abbr,align,alt,axis,bgcolor,border,cellpadding,cellspacing,class,clear,color,cols,colspan,compact,coords,dir,face,headers,height,hreflang,hspace,ismap,lang,language,nohref,nowrap,rel,rev,rows,rowspan,rules,scope,scrolling,shape,size,span,start,summary,target,title,type,valign,value,vspace,width")),_=document.createElement("pre"),D=/^(\s*)([\s\S]*?)(\s*)$/;t.module("ngSanitize",[]).provider("$sanitize",function(){this.$get=["$$sanitizeUri",function(e){return function(t){var n=[];return a(t,c(n,function(t,n){return!/^unsafe/.test(e(t,n))})),n.join("")}}]}),t.module("ngSanitize").filter("linky",["$sanitize",function(e){var n=/((ftp|https?):\/\/|(mailto:)?[A-Za-z0-9._%+-]+@)\S*[^\s.;,(){}<>"]/,o=/^mailto:/;return function(a,r){function s(e){e&&f.push(i(e))}function c(e,n){f.push("<a "),t.isDefined(r)&&(f.push('target="'),f.push(r),f.push('" ')),f.push('href="'),f.push(e),f.push('">'),s(n),f.push("</a>")}if(!a)return a;for(var l,d,u,p=a,f=[];l=p.match(n);)d=l[0],l[2]==l[3]&&(d="mailto:"+d),u=l.index,s(p.substr(0,u)),c(d,l[0].replace(o,"")),p=p.substring(u+l[0].length);return s(p),e(f.join(""))}}])}(window,window.angular),define("angular-sanitize",["angular"],function(e){return function(){var t;return t||e.angular}}(this)),function(e,t,n){t.module("ngAnimate",["ng"]).directive("ngAnimateChildren",function(){return function(e,n,i){i=i.ngAnimateChildren,t.isString(i)&&0===i.length?n.data("$$ngAnimateChildren",!0):e.$watch(i,function(e){n.data("$$ngAnimateChildren",!!e)})}}).factory("$$animateReflow",["$$rAF","$document",function(e){return function(t){return e(function(){t()})}}]).config(["$provide","$animateProvider",function(i,o){function a(e){for(var t=0;t<e.length;t++){var n=e[t];if(n.nodeType==d)return n}}function r(e){return t.element(a(e))}var s=t.noop,c=t.forEach,l=o.$$selectors,d=1,u="$$ngAnimateState",p="$$ngAnimateChildren",f="ng-animate",h={running:!0};i.decorator("$animate",["$delegate","$injector","$sniffer","$rootElement","$$asyncCallback","$rootScope","$document",function(e,n,i,d,g,m){function v(e){var t=e.data(u)||{};t.running=!0,e.data(u,t)}function b(e){if(e){var t=[],o={};e=e.substr(1).split("."),(i.transitions||i.animations)&&t.push(n.get(l[""]));for(var a=0;a<e.length;a++){var r=e[a],s=l[r];s&&!o[r]&&(t.push(n.get(s)),o[r]=!0)}return t}}function y(e,n,i){function o(e,t){var n=e[t],i=e["before"+t.charAt(0).toUpperCase()+t.substr(1)];return n||i?("leave"==t&&(i=n,n=null),w.push({event:t,fn:n}),m.push({event:t,fn:i}),!0):void 0}function a(t,n,o){var a=[];c(t,function(e){e.fn&&a.push(e)});var r=0;c(a,function(t,c){var u=function(){e:{if(n){if((n[c]||s)(),++r<a.length)break e;n=null}o()}};switch(t.event){case"setClass":n.push(t.fn(e,l,d,u));break;case"addClass":n.push(t.fn(e,l||i,u));break;case"removeClass":n.push(t.fn(e,d||i,u));break;default:n.push(t.fn(e,u))}}),n&&0===n.length&&o()}var r=e[0];if(r){var l,d,u="setClass"==n,p=u||"addClass"==n||"removeClass"==n;t.isArray(i)&&(l=i[0],d=i[1],i=l+" "+d);var f=e.attr("class")+" "+i;if(P(f)){var h=s,g=[],m=[],v=s,y=[],w=[],f=(" "+f).replace(/\s+/g,".");return c(b(f),function(e){!o(e,n)&&u&&(o(e,"addClass"),o(e,"removeClass"))}),{node:r,event:n,className:i,isClassBased:p,isSetClassOperation:u,before:function(e){h=e,a(m,g,function(){h=s,e()})},after:function(e){v=e,a(w,y,function(){v=s,e()})},cancel:function(){g&&(c(g,function(e){(e||s)(!0)}),h(!0)),y&&(c(y,function(e){(e||s)(!0)}),v(!0))}}}}}function w(e,n,i,o,a,r,s){function l(t){var o="$animate:"+t;w&&w[o]&&0<w[o].length&&g(function(){i.triggerHandler(o,{event:e,className:n})})}function d(){l("before")}function p(){l("after")}function h(){l("close"),s&&g(function(){s()})}function m(){m.hasBeenRun||(m.hasBeenRun=!0,r())}function v(){if(!v.hasBeenRun){v.hasBeenRun=!0;var t=i.data(u);t&&(b&&b.isClassBased?x(i,n):(g(function(){var t=i.data(u)||{};D==t.index&&x(i,n,e)}),i.data(u,t))),h()}}var b=y(i,e,n);if(b){n=b.className;var w=t.element._data(b.node),w=w&&w.events;o||(o=a?a.parent():i.parent());var k=i.data(u)||{};a=k.active||{};var S,P=k.totalActive||0,T=k.last;if(b.isClassBased&&(S=k.running||k.disabled||T&&!T.isClassBased),S||$(i,o))m(),d(),p(),v();else{if(o=!1,P>0){if(S=[],b.isClassBased)"setClass"==T.event?(S.push(T),x(i,n)):a[n]&&(_=a[n],_.event==e?o=!0:(S.push(_),x(i,n)));else if("leave"==e&&a["ng-leave"])o=!0;else{for(var _ in a)S.push(a[_]),x(i,_);a={},P=0}0<S.length&&c(S,function(e){e.cancel()})}if(!b.isClassBased||b.isSetClassOperation||o||(o="addClass"==e==i.hasClass(n)),o)m(),d(),p(),h();else{"leave"==e&&i.one("$destroy",function(e){e=t.element(this);var n=e.data(u);n&&(n=n.active["ng-leave"])&&(n.cancel(),x(e,"ng-leave"))}),i.addClass(f);var D=C++;P++,a[n]=b,i.data(u,{last:b,active:a,index:D,totalActive:P}),d(),b.before(function(t){var o=i.data(u);t=t||!o||!o.active[n]||b.isClassBased&&o.active[n].event!=e,m(),!0===t?v():(p(),b.after(v))})}}}else m(),d(),p(),v()}function k(e){(e=a(e))&&(e=t.isFunction(e.getElementsByClassName)?e.getElementsByClassName(f):e.querySelectorAll("."+f),c(e,function(e){e=t.element(e),(e=e.data(u))&&e.active&&c(e.active,function(e){e.cancel()})}))}function x(e,t){if(a(e)==a(d))h.disabled||(h.running=!1,h.structural=!1);else if(t){var n=e.data(u)||{},i=!0===t;!i&&n.active&&n.active[t]&&(n.totalActive--,delete n.active[t]),(i||!n.totalActive)&&(e.removeClass(f),e.removeData(u))}}function $(e,n){if(h.disabled)return!0;if(a(e)==a(d))return h.running;var i,o,r;do{if(0===n.length)break;var s=a(n)==a(d),c=s?h:n.data(u)||{};if(c.disabled)return!0;s&&(r=!0),!1!==i&&(s=n.data(p),t.isDefined(s)&&(i=s)),o=o||c.running||c.last&&!c.last.isClassBased}while(n=n.parent());return!r||!i&&o}var C=0;d.data(u,h),m.$$postDigest(function(){m.$$postDigest(function(){h.running=!1})});var S=o.classNameFilter(),P=S?function(e){return S.test(e)}:function(){return!0};return{enter:function(n,i,o,a){n=t.element(n),i=i&&t.element(i),o=o&&t.element(o),v(n),e.enter(n,i,o),m.$$postDigest(function(){n=r(n),w("enter","ng-enter",n,i,o,s,a)})},leave:function(n,i){n=t.element(n),k(n),v(n),m.$$postDigest(function(){w("leave","ng-leave",r(n),null,null,function(){e.leave(n)},i)})},move:function(n,i,o,a){n=t.element(n),i=i&&t.element(i),o=o&&t.element(o),k(n),v(n),e.move(n,i,o),m.$$postDigest(function(){n=r(n),w("move","ng-move",n,i,o,s,a)})},addClass:function(n,i,o){n=t.element(n),n=r(n),w("addClass",i,n,null,null,function(){e.addClass(n,i)},o)},removeClass:function(n,i,o){n=t.element(n),n=r(n),w("removeClass",i,n,null,null,function(){e.removeClass(n,i)},o)},setClass:function(n,i,o,a){n=t.element(n),n=r(n),w("setClass",[i,o],n,null,null,function(){e.setClass(n,i,o)},a)},enabled:function(e,t){switch(arguments.length){case 2:if(e)x(t);else{var n=t.data(u)||{};n.disabled=!0,t.data(u,n)}break;case 1:h.disabled=!e;break;default:e=!h.disabled}return!!e}}}]),o.register("",["$window","$sniffer","$timeout","$$animateReflow",function(i,o,r,l){function u(){E||(E=l(function(){X=[],E=null,z={}}))}function p(e,t){E&&E(),X.push(t),E=l(function(){c(X,function(e){e()}),X=[],E=null,z={}})}function f(e,n){var i=a(e);e=t.element(i),J.push(e),i=Date.now()+n,G>=i||(r.cancel(W),G=i,W=r(function(){h(J),J=[]},n,!1))}function h(e){c(e,function(e){(e=e.data(F))&&(e.closeAnimationFn||s)()})}function g(e,t){var n=t?z[t]:null;if(!n){var o,a,r,s,l=0,u=0,p=0,f=0;c(e,function(e){if(e.nodeType==d){e=i.getComputedStyle(e)||{},r=e[D+I],l=Math.max(m(r),l),s=e[D+N],o=e[D+O],u=Math.max(m(o),u),a=e[M+O],f=Math.max(m(a),f);var t=m(e[M+I]);t>0&&(t*=parseInt(e[M+H],10)||1),p=Math.max(t,p)}}),n={total:0,transitionPropertyStyle:s,transitionDurationStyle:r,transitionDelayStyle:o,transitionDelay:u,transitionDuration:l,animationDelayStyle:a,animationDelay:f,animationDuration:p},t&&(z[t]=n)}return n}function m(e){var n=0;return e=t.isString(e)?e.split(/\s*,\s*/):[],c(e,function(e){n=Math.max(parseFloat(e)||0,n)}),n}function v(e){var t=e.parent(),n=t.data(V);return n||(t.data(V,++Y),n=Y),n+"-"+a(e).getAttribute("class")}function b(e,t,n,i){var o=v(t),r=o+" "+n,c=z[r]?++z[r].total:0,l={};if(c>0){var d=n+"-stagger",l=o+" "+d;(o=!z[l])&&t.addClass(d),l=g(t,l),o&&t.removeClass(d)}i=i||function(e){return e()},t.addClass(n);var d=t.data(F)||{},u=i(function(){return g(t,r)});return i=u.transitionDuration,o=u.animationDuration,0===i&&0===o?(t.removeClass(n),!1):(t.data(F,{running:d.running||0,itemIndex:c,stagger:l,timings:u,closeAnimationFn:s}),e=0<d.running||"setClass"==e,i>0&&y(t,n,e),o>0&&0<l.animationDelay&&0===l.animationDuration&&(a(t).style[M]="none 0s"),!0)}function y(e,t,n){"ng-enter"!=t&&"ng-move"!=t&&"ng-leave"!=t&&n?e.addClass(q):a(e).style[D+N]="none"}function w(e){var t=D+N,n=a(e);n.style[t]&&0<n.style[t].length&&(n.style[t]=""),e.removeClass(q)}function k(e){var t=M;e=a(e),e.style[t]&&0<e.style[t].length&&(e.style[t]="")}function x(e,t,n,i){function o(e){t.off(b,r),t.removeClass(l),T(t,n),e=a(t);for(var i in w)e.style.removeProperty(w[i])}function r(e){e.stopPropagation();var t=e.originalEvent||e;e=t.$manualTimeStamp||t.timeStamp||Date.now(),t=parseFloat(t.elapsedTime.toFixed(j)),Math.max(e-v,0)>=m&&t>=h&&i()}var s=a(t);if(e=t.data(F),-1!=s.getAttribute("class").indexOf(n)&&e){var l="";c(n.split(" "),function(e,t){l+=(t>0?" ":"")+e+"-active"});var d=e.stagger,u=e.timings,p=e.itemIndex,h=Math.max(u.transitionDuration,u.animationDuration),g=Math.max(u.transitionDelay,u.animationDelay),m=g*B,v=Date.now(),b=A+" "+R,y="",w=[];
if(0<u.transitionDuration){var k=u.transitionPropertyStyle;-1==k.indexOf("all")&&(y+=U+"transition-property: "+k+";",y+=U+"transition-duration: "+u.transitionDurationStyle+";",w.push(U+"transition-property"),w.push(U+"transition-duration"))}return p>0&&(0<d.transitionDelay&&0===d.transitionDuration&&(y+=U+"transition-delay: "+$(u.transitionDelayStyle,d.transitionDelay,p)+"; ",w.push(U+"transition-delay")),0<d.animationDelay&&0===d.animationDuration&&(y+=U+"animation-delay: "+$(u.animationDelayStyle,d.animationDelay,p)+"; ",w.push(U+"animation-delay"))),0<w.length&&(u=s.getAttribute("style")||"",s.setAttribute("style",u+"; "+y)),t.on(b,r),t.addClass(l),e.closeAnimationFn=function(){o(),i()},s=(p*(Math.max(d.animationDelay,d.transitionDelay)||0)+(g+h)*L)*B,e.running++,f(t,s),o}i()}function $(e,t,n){var i="";return c(e.split(","),function(e,o){i+=(o>0?",":"")+(n*t+parseInt(e,10))+"s"}),i}function C(e,t,n,i){return b(e,t,n,i)?function(e){e&&T(t,n)}:void 0}function S(e,t,n,i){return t.data(F)?x(e,t,n,i):(T(t,n),void i())}function P(e,t,n,i){var o=C(e,t,n);if(o){var a=o;return p(t,function(){w(t,n),k(t),a=S(e,t,n,i)}),function(e){(a||s)(e)}}u(),i()}function T(e,t){e.removeClass(t);var n=e.data(F);n&&(n.running&&n.running--,n.running&&0!==n.running||e.removeData(F))}function _(e,n){var i="";return e=t.isArray(e)?e:e.split(/\s+/),c(e,function(e,t){e&&0<e.length&&(i+=(t>0?" ":"")+e+n)}),i}var D,R,M,A,U="";e.ontransitionend===n&&e.onwebkittransitionend!==n?(U="-webkit-",D="WebkitTransition",R="webkitTransitionEnd transitionend"):(D="transition",R="transitionend"),e.onanimationend===n&&e.onwebkitanimationend!==n?(U="-webkit-",M="WebkitAnimation",A="webkitAnimationEnd animationend"):(M="animation",A="animationend");var E,I="Duration",N="Property",O="Delay",H="IterationCount",V="$$ngAnimateKey",F="$$ngAnimateCSS3Data",q="ng-animate-block-transitions",j=3,L=1.5,B=1e3,z={},Y=0,X=[],W=null,G=0,J=[];return{enter:function(e,t){return P("enter",e,"ng-enter",t)},leave:function(e,t){return P("leave",e,"ng-leave",t)},move:function(e,t){return P("move",e,"ng-move",t)},beforeSetClass:function(e,t,n,i){var o=_(n,"-remove")+" "+_(t,"-add"),a=C("setClass",e,o,function(i){var o=e.attr("class");return e.removeClass(n),e.addClass(t),i=i(),e.attr("class",o),i});return a?(p(e,function(){w(e,o),k(e),i()}),a):(u(),void i())},beforeAddClass:function(e,t,n){var i=C("addClass",e,_(t,"-add"),function(n){return e.addClass(t),n=n(),e.removeClass(t),n});return i?(p(e,function(){w(e,t),k(e),n()}),i):(u(),void n())},setClass:function(e,t,n,i){return n=_(n,"-remove"),t=_(t,"-add"),S("setClass",e,n+" "+t,i)},addClass:function(e,t,n){return S("addClass",e,_(t,"-add"),n)},beforeRemoveClass:function(e,t,n){var i=C("removeClass",e,_(t,"-remove"),function(n){var i=e.attr("class");return e.removeClass(t),n=n(),e.attr("class",i),n});return i?(p(e,function(){w(e,t),k(e),n()}),i):void n()},removeClass:function(e,t,n){return S("removeClass",e,_(t,"-remove"),n)}}}])}])}(window,window.angular),define("angular-animate",["angular"],function(e){return function(){var t;return t||e.angular}}(this)),function(e,t,n){var i=t.module("ngHumanize",[]);i.filter("humanizeDate",function(){return function(e,t){return n.date(t,e)}}),i.filter("humanizeNumber",function(){return function(e,t,i,o){return n.numberFormat(e,t,i,o)}}),i.filter("humanizeNaturalDay",function(){return function(e,t){return n.naturalDay(e,t)}}),i.filter("humanizeRelativeTime",function(){return function(e){return n.relativeTime(e)}}),i.filter("humanizeOrdinal",function(){return function(e){return n.ordinal(e)}}),i.filter("humanizeFilesize",function(){return function(e,t,i,o,a){return n.filesize(e,t,i,o,a)}}),i.filter("humanizeLinebreaks",function(){return function(e){return n.linebreaks(e)}}),i.filter("humanizeNl2br",function(){return function(e){return n.nl2br(e)}}),i.filter("humanizeTruncatechars",function(){return function(e,t){return n.truncatechars(e,t)}}),i.filter("humanizeTruncatewords",function(){return function(e,t){return n.truncatewords(e,t)}})}(window,window.angular,window.humanize),define("angular-humanize",["angular","humanize"],function(e){return function(){var t;return t||e.angular}}(this)),function(e,t){function n(e,n,i){return{restrict:"ECA",terminal:!0,priority:400,transclude:"element",link:function(o,a,r,s,c){function l(){f&&(f.remove(),f=null),u&&(u.$destroy(),u=null),p&&(i.leave(p,function(){f=null}),f=p,p=null)}function d(){var r=e.current&&e.current.locals;if(t.isDefined(r&&r.$template)){var r=o.$new(),s=e.current;p=c(r,function(e){i.enter(e,null,p||a,function(){!t.isDefined(h)||h&&!o.$eval(h)||n()}),l()}),u=s.scope=r,u.$emit("$viewContentLoaded"),u.$eval(g)}else l()}var u,p,f,h=r.autoscroll,g=r.onload||"";o.$on("$routeChangeSuccess",d),d()}}}function i(e,t,n){return{restrict:"ECA",priority:-400,link:function(i,o){var a=n.current,r=a.locals;o.html(r.$template);var s=e(o.contents());a.controller&&(r.$scope=i,r=t(a.controller,r),a.controllerAs&&(i[a.controllerAs]=r),o.data("$ngControllerController",r),o.children().data("$ngControllerController",r)),s(i)}}}e=t.module("ngRoute",["ng"]).provider("$route",function(){function e(e,n){return t.extend(new(t.extend(function(){},{prototype:e})),n)}function n(e,t){var n=t.caseInsensitiveMatch,i={originalPath:e,regexp:e},o=i.keys=[];return e=e.replace(/([().])/g,"\\$1").replace(/(\/)?:(\w+)([\?\*])?/g,function(e,t,n,i){return e="?"===i?i:null,i="*"===i?i:null,o.push({name:n,optional:!!e}),t=t||"",""+(e?"":t)+"(?:"+(e?t:"")+(i&&"(.+?)"||"([^/]+)")+(e||"")+")"+(e||"")}).replace(/([\/$\*])/g,"\\$1"),i.regexp=RegExp("^"+e+"$",n?"i":""),i}var i={};this.when=function(e,o){if(i[e]=t.extend({reloadOnSearch:!0},o,e&&n(e,o)),e){var a="/"==e[e.length-1]?e.substr(0,e.length-1):e+"/";i[a]=t.extend({redirectTo:e},n(a,o))}return this},this.otherwise=function(e){return this.when(null,e),this},this.$get=["$rootScope","$location","$routeParams","$q","$injector","$http","$templateCache","$sce",function(n,o,a,r,s,c,l,d){function u(){var e=p(),i=g.current;e&&i&&e.$$route===i.$$route&&t.equals(e.pathParams,i.pathParams)&&!e.reloadOnSearch&&!h?(i.params=e.params,t.copy(i.params,a),n.$broadcast("$routeUpdate",i)):(e||i)&&(h=!1,n.$broadcast("$routeChangeStart",e,i),(g.current=e)&&e.redirectTo&&(t.isString(e.redirectTo)?o.path(f(e.redirectTo,e.params)).search(e.params).replace():o.url(e.redirectTo(e.pathParams,o.path(),o.search())).replace()),r.when(e).then(function(){if(e){var n,i,o=t.extend({},e.resolve);return t.forEach(o,function(e,n){o[n]=t.isString(e)?s.get(e):s.invoke(e)}),t.isDefined(n=e.template)?t.isFunction(n)&&(n=n(e.params)):t.isDefined(i=e.templateUrl)&&(t.isFunction(i)&&(i=i(e.params)),i=d.getTrustedResourceUrl(i),t.isDefined(i)&&(e.loadedTemplateUrl=i,n=c.get(i,{cache:l}).then(function(e){return e.data}))),t.isDefined(n)&&(o.$template=n),r.all(o)}}).then(function(o){e==g.current&&(e&&(e.locals=o,t.copy(e.params,a)),n.$broadcast("$routeChangeSuccess",e,i))},function(t){e==g.current&&n.$broadcast("$routeChangeError",e,i,t)}))}function p(){var n,a;return t.forEach(i,function(i){var r;if(r=!a){var s=o.path();r=i.keys;var c={};if(i.regexp)if(s=i.regexp.exec(s)){for(var l=1,d=s.length;d>l;++l){var u=r[l-1],p=s[l];u&&p&&(c[u.name]=p)}r=c}else r=null;else r=null;r=n=r}r&&(a=e(i,{params:t.extend({},o.search(),n),pathParams:n}),a.$$route=i)}),a||i[null]&&e(i[null],{params:{},pathParams:{}})}function f(e,n){var i=[];return t.forEach((e||"").split(":"),function(e,t){if(0===t)i.push(e);else{var o=e.match(/(\w+)(.*)/),a=o[1];i.push(n[a]),i.push(o[2]||""),delete n[a]}}),i.join("")}var h=!1,g={routes:i,reload:function(){h=!0,n.$evalAsync(u)}};return n.$on("$locationChangeSuccess",u),g}]}),e.provider("$routeParams",function(){this.$get=function(){return{}}}),e.directive("ngView",n),e.directive("ngView",i),n.$inject=["$route","$anchorScroll","$animate"],i.$inject=["$compile","$controller","$route"]}(window,window.angular),define("angular-route",function(){}),function(e){function t(){var e=s();e!==c&&(c=e,u.trigger("orientationchange"))}function n(t,n,i,o){var a=i.type;i.type=n,e.event.dispatch.call(t,i,o),i.type=a}e.attrFn=e.attrFn||{};var i=navigator.userAgent.toLowerCase(),o=i.indexOf("chrome")>-1&&(i.indexOf("windows")>-1||i.indexOf("macintosh")>-1||i.indexOf("linux")>-1)&&i.indexOf("mobile")<0&&i.indexOf("nexus")<0,a={tap_pixel_range:5,swipe_h_threshold:50,swipe_v_threshold:50,taphold_threshold:750,doubletap_int:500,touch_capable:"ontouchstart"in document.documentElement&&!o,orientation_support:"orientation"in window&&"onorientationchange"in window,startevent:"ontouchstart"in document.documentElement&&!o?"touchstart":"mousedown",endevent:"ontouchstart"in document.documentElement&&!o?"touchend":"mouseup",moveevent:"ontouchstart"in document.documentElement&&!o?"touchmove":"mousemove",tapevent:"ontouchstart"in document.documentElement&&!o?"tap":"click",scrollevent:"ontouchstart"in document.documentElement&&!o?"touchmove":"scroll",hold_timer:null,tap_timer:null};e.isTouchCapable=function(){return a.touch_capable},e.getStartEvent=function(){return a.startevent},e.getEndEvent=function(){return a.endevent},e.getMoveEvent=function(){return a.moveevent},e.getTapEvent=function(){return a.tapevent},e.getScrollEvent=function(){return a.scrollevent},e.each(["tapstart","tapend","tap","singletap","doubletap","taphold","swipe","swipeup","swiperight","swipedown","swipeleft","swipeend","scrollstart","scrollend","orientationchange"],function(t,n){e.fn[n]=function(e){return e?this.on(n,e):this.trigger(n)},e.attrFn[n]=!0}),e.event.special.tapstart={setup:function(){var t=this,i=e(t);i.on(a.startevent,function(e){if(i.data("callee",arguments.callee),e.which&&1!==e.which)return!1;var o=e.originalEvent,r={position:{x:a.touch_capable?o.touches[0].screenX:e.screenX,y:a.touch_capable?o.touches[0].screenY:e.screenY},offset:{x:a.touch_capable?o.touches[0].pageX-o.touches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?o.touches[0].pageY-o.touches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target};return n(t,"tapstart",e,r),!0})},remove:function(){e(this).off(a.startevent,e(this).data.callee)}},e.event.special.tapmove={setup:function(){var t=this,i=e(t);i.on(a.moveevent,function(e){i.data("callee",arguments.callee);var o=e.originalEvent,r={position:{x:a.touch_capable?o.touches[0].screenX:e.screenX,y:a.touch_capable?o.touches[0].screenY:e.screenY},offset:{x:a.touch_capable?o.touches[0].pageX-o.touches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?o.touches[0].pageY-o.touches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target};return n(t,"tapmove",e,r),!0})},remove:function(){e(this).off(a.moveevent,e(this).data.callee)}},e.event.special.tapend={setup:function(){var t=this,i=e(t);i.on(a.endevent,function(e){i.data("callee",arguments.callee);var o=e.originalEvent,r={position:{x:a.touch_capable?o.changedTouches[0].screenX:e.screenX,y:a.touch_capable?o.changedTouches[0].screenY:e.screenY},offset:{x:a.touch_capable?o.changedTouches[0].pageX-o.changedTouches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?o.changedTouches[0].pageY-o.changedTouches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target};return n(t,"tapend",e,r),!0})},remove:function(){e(this).off(a.endevent,e(this).data.callee)}},e.event.special.taphold={setup:function(){var t,i=this,o=e(i),r={x:0,y:0};o.on(a.startevent,function(e){if(e.which&&1!==e.which)return!1;o.data("tapheld",!1),t=e.target;var s=e.originalEvent,c=(new Date).getTime(),l={x:a.touch_capable?s.touches[0].screenX:e.screenX,y:a.touch_capable?s.touches[0].screenY:e.screenY},d={x:a.touch_capable?s.touches[0].pageX-s.touches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?s.touches[0].pageY-s.touches[0].target.offsetTop:e.offsetY};return r.x=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageX:e.pageX,r.y=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageY:e.pageY,a.hold_timer=window.setTimeout(function(){var u=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageX:e.pageX,p=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageY:e.pageY;if(e.target==t&&r.x==u&&r.y==p){o.data("tapheld",!0);var f=(new Date).getTime(),h={x:a.touch_capable?s.touches[0].screenX:e.screenX,y:a.touch_capable?s.touches[0].screenY:e.screenY},g={x:a.touch_capable?s.touches[0].pageX-s.touches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?s.touches[0].pageY-s.touches[0].target.offsetTop:e.offsetY};duration=f-c;var m={startTime:c,endTime:f,startPosition:l,startOffset:d,endPosition:h,endOffset:g,duration:duration,target:e.target};o.data("callee1",arguments.callee),n(i,"taphold",e,m)}},a.taphold_threshold),!0}).on(a.endevent,function(){o.data("callee2",arguments.callee),o.data("tapheld",!1),window.clearTimeout(a.hold_timer)})},remove:function(){e(this).off(a.startevent,e(this).data.callee1).off(a.endevent,e(this).data.callee2)}},e.event.special.doubletap={setup:function(){var t,i,o,r,s=this,c=e(s);c.on(a.startevent,function(e){return e.which&&1!==e.which?!1:c.data("lastTouch")?void 0:(c.data("doubletapped",!1),t=e.target,c.data("callee1",arguments.callee),r=e.originalEvent,o={position:{x:a.touch_capable?r.touches[0].screenX:e.screenX,y:a.touch_capable?r.touches[0].screenY:e.screenY},offset:{x:a.touch_capable?r.touches[0].pageX-r.touches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?r.touches[0].pageY-r.touches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target},!0)}).on(a.endevent,function(e){var r=(new Date).getTime(),l=c.data("lastTouch")||r+1,d=r-l;if(window.clearTimeout(i),c.data("callee2",arguments.callee),d<a.doubletap_int&&d>0&&e.target==t&&d>100){c.data("doubletapped",!0),window.clearTimeout(a.tap_timer);var u={position:{x:a.touch_capable?e.originalEvent.changedTouches[0].screenX:e.screenX,y:a.touch_capable?e.originalEvent.changedTouches[0].screenY:e.screenY},offset:{x:a.touch_capable?e.originalEvent.changedTouches[0].pageX-e.originalEvent.changedTouches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?e.originalEvent.changedTouches[0].pageY-e.originalEvent.changedTouches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target},p={firstTap:o,secondTap:u,interval:u.time-o.time};n(s,"doubletap",e,p)}else c.data("lastTouch",r),i=window.setTimeout(function(){window.clearTimeout(i)},a.doubletap_int,[e]);c.data("lastTouch",r)})},remove:function(){e(this).off(a.startevent,e(this).data.callee1).off(a.endevent,e(this).data.callee2)}},e.event.special.singletap={setup:function(){var t=this,i=e(t),o=null,r=null,s={x:0,y:0};i.on(a.startevent,function(e){return e.which&&1!==e.which?!1:(r=(new Date).getTime(),o=e.target,i.data("callee1",arguments.callee),s.x=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageX:e.pageX,s.y=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageY:e.pageY,!0)}).on(a.endevent,function(e){i.data("callee2",arguments.callee),e.target==o&&(end_pos_x=e.originalEvent.changedTouches?e.originalEvent.changedTouches[0].pageX:e.pageX,end_pos_y=e.originalEvent.changedTouches?e.originalEvent.changedTouches[0].pageY:e.pageY,a.tap_timer=window.setTimeout(function(){if(!i.data("doubletapped")&&!i.data("tapheld")&&s.x==end_pos_x&&s.y==end_pos_y){var o=e.originalEvent,c={position:{x:a.touch_capable?o.changedTouches[0].screenX:e.screenX,y:a.touch_capable?o.changedTouches[0].screenY:e.screenY},offset:{x:a.touch_capable?o.changedTouches[0].pageX-o.changedTouches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?o.changedTouches[0].pageY-o.changedTouches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target};c.time-r<a.taphold_threshold&&n(t,"singletap",e,c)}},a.doubletap_int))})},remove:function(){e(this).off(a.startevent,e(this).data.callee1).off(a.endevent,e(this).data.callee2)}},e.event.special.tap={setup:function(){var t,i=this,o=e(i),r=!1,s=null,c={x:0,y:0};o.on(a.startevent,function(e){return o.data("callee1",arguments.callee),e.which&&1!==e.which?!1:(r=!0,c.x=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageX:e.pageX,c.y=e.originalEvent.targetTouches?e.originalEvent.targetTouches[0].pageY:e.pageY,t=(new Date).getTime(),s=e.target,!0)}).on(a.endevent,function(e){o.data("callee2",arguments.callee);var l=e.originalEvent.targetTouches?e.originalEvent.changedTouches[0].pageX:e.pageX,d=e.originalEvent.targetTouches?e.originalEvent.changedTouches[0].pageY:e.pageY;if(diff_x=c.x-l,diff_y=c.y-d,s==e.target&&r&&(new Date).getTime()-t<a.taphold_threshold&&(c.x==l&&c.y==d||diff_x>=-a.tap_pixel_range&&diff_x<=a.tap_pixel_range&&diff_y>=-a.tap_pixel_range&&diff_y<=a.tap_pixel_range)){var u=e.originalEvent,p={position:{x:a.touch_capable?u.changedTouches[0].screenX:e.screenX,y:a.touch_capable?u.changedTouches[0].screenY:e.screenY},offset:{x:a.touch_capable?u.changedTouches[0].pageX-u.changedTouches[0].target.offsetLeft:e.offsetX,y:a.touch_capable?u.changedTouches[0].pageY-u.changedTouches[0].target.offsetTop:e.offsetY},time:(new Date).getTime(),target:e.target};n(i,"tap",e,p)}})},remove:function(){e(this).off(a.startevent,e(this).data.callee1).off(a.endevent,e(this).data.callee2)}},e.event.special.swipe={setup:function(){function t(t){s=e(t.target),s.data("callee1",arguments.callee),d.x=t.originalEvent.targetTouches?t.originalEvent.targetTouches[0].pageX:t.pageX,d.y=t.originalEvent.targetTouches?t.originalEvent.targetTouches[0].pageY:t.pageY,u.x=d.x,u.y=d.y,c=!0;var n=t.originalEvent;o={position:{x:a.touch_capable?n.touches[0].screenX:t.screenX,y:a.touch_capable?n.touches[0].screenY:t.screenY},offset:{x:a.touch_capable?n.touches[0].pageX-n.touches[0].target.offsetLeft:t.offsetX,y:a.touch_capable?n.touches[0].pageY-n.touches[0].target.offsetTop:t.offsetY},time:(new Date).getTime(),target:t.target};for(var i=new Date;new Date-i<100;);}function n(t){s=e(t.target),s.data("callee2",arguments.callee),u.x=t.originalEvent.targetTouches?t.originalEvent.targetTouches[0].pageX:t.pageX,u.y=t.originalEvent.targetTouches?t.originalEvent.targetTouches[0].pageY:t.pageY,window.clearTimeout(a.hold_timer);var n,i=s.data("xthreshold"),r=s.data("ythreshold"),p="undefined"!=typeof i&&i!==!1&&parseInt(i)?parseInt(i):a.swipe_h_threshold,f="undefined"!=typeof r&&r!==!1&&parseInt(r)?parseInt(r):a.swipe_v_threshold;if(d.y>u.y&&d.y-u.y>f&&(n="swipeup"),d.x<u.x&&u.x-d.x>p&&(n="swiperight"),d.y<u.y&&u.y-d.y>f&&(n="swipedown"),d.x>u.x&&d.x-u.x>p&&(n="swipeleft"),void 0!=n&&c){d.x=0,d.y=0,u.x=0,u.y=0,c=!1;var h=t.originalEvent;endEvnt={position:{x:a.touch_capable?h.touches[0].screenX:t.screenX,y:a.touch_capable?h.touches[0].screenY:t.screenY},offset:{x:a.touch_capable?h.touches[0].pageX-h.touches[0].target.offsetLeft:t.offsetX,y:a.touch_capable?h.touches[0].pageY-h.touches[0].target.offsetTop:t.offsetY},time:(new Date).getTime(),target:t.target};var g=Math.abs(o.position.x-endEvnt.position.x),m=Math.abs(o.position.y-endEvnt.position.y),v={startEvnt:o,endEvnt:endEvnt,direction:n.replace("swipe",""),xAmount:g,yAmount:m,duration:endEvnt.time-o.time};l=!0,s.trigger("swipe",v).trigger(n,v)}}function i(t){s=e(t.target);var n="";if(s.data("callee3",arguments.callee),l){var i=s.data("xthreshold"),r=s.data("ythreshold"),d="undefined"!=typeof i&&i!==!1&&parseInt(i)?parseInt(i):a.swipe_h_threshold,u="undefined"!=typeof r&&r!==!1&&parseInt(r)?parseInt(r):a.swipe_v_threshold,p=t.originalEvent;endEvnt={position:{x:a.touch_capable?p.changedTouches[0].screenX:t.screenX,y:a.touch_capable?p.changedTouches[0].screenY:t.screenY},offset:{x:a.touch_capable?p.changedTouches[0].pageX-p.changedTouches[0].target.offsetLeft:t.offsetX,y:a.touch_capable?p.changedTouches[0].pageY-p.changedTouches[0].target.offsetTop:t.offsetY},time:(new Date).getTime(),target:t.target},o.position.y>endEvnt.position.y&&o.position.y-endEvnt.position.y>u&&(n="swipeup"),o.position.x<endEvnt.position.x&&endEvnt.position.x-o.position.x>d&&(n="swiperight"),o.position.y<endEvnt.position.y&&endEvnt.position.y-o.position.y>u&&(n="swipedown"),o.position.x>endEvnt.position.x&&o.position.x-endEvnt.position.x>d&&(n="swipeleft");var f=Math.abs(o.position.x-endEvnt.position.x),h=Math.abs(o.position.y-endEvnt.position.y),g={startEvnt:o,endEvnt:endEvnt,direction:n.replace("swipe",""),xAmount:f,yAmount:h,duration:endEvnt.time-o.time};s.trigger("swipeend",g)}c=!1,l=!1}var o,r=this,s=e(r),c=!1,l=!1,d={x:0,y:0},u={x:0,y:0};s.on(a.startevent,t),s.on(a.moveevent,n),s.on(a.endevent,i)},remove:function(){e(this).off(a.startevent,e(this).data.callee1).off(a.moveevent,e(this).data.callee2).off(a.endevent,e(this).data.callee3)}},e.event.special.scrollstart={setup:function(){function t(e,t){i=t,n(r,i?"scrollstart":"scrollend",e)}var i,o,r=this,s=e(r);s.on(a.scrollevent,function(e){s.data("callee",arguments.callee),i||t(e,!0),clearTimeout(o),o=setTimeout(function(){t(e,!1)},50)})},remove:function(){e(this).off(a.scrollevent,e(this).data.callee)}};var r,s,c,l,d,u=e(window),p={0:!0,180:!0};if(a.orientation_support){var f=window.innerWidth||e(window).width(),h=window.innerHeight||e(window).height(),g=50;l=f>h&&f-h>g,d=p[window.orientation],(l&&d||!l&&!d)&&(p={"-90":!0,90:!0})}e.event.special.orientationchange=r={setup:function(){return a.orientation_support?!1:(c=s(),u.on("throttledresize",t),!0)},teardown:function(){return a.orientation_support?!1:(u.off("throttledresize",t),!0)},add:function(e){var t=e.handler;e.handler=function(e){return e.orientation=s(),t.apply(this,arguments)}}},e.event.special.orientationchange.orientation=s=function(){var e=!0,t=document.documentElement;return e=a.orientation_support?p[window.orientation]:t&&t.clientWidth/t.clientHeight<1.1,e?"portrait":"landscape"},e.event.special.throttledresize={setup:function(){e(this).on("resize",w)},teardown:function(){e(this).off("resize",w)}};var m,v,b,y=250,w=function(){v=(new Date).getTime(),b=v-k,b>=y?(k=v,e(this).trigger("throttledresize")):(m&&window.clearTimeout(m),m=window.setTimeout(t,y-b))},k=0;e.each({scrollend:"scrollstart",swipeup:"swipe",swiperight:"swipe",swipedown:"swipe",swipeleft:"swipe",swipeend:"swipe"},function(t,n){e.event.special[t]={setup:function(){e(this).on(n,e.noop)}}})}(jQuery),define("mobile-events",["jquery"],function(e){return function(){var t;return t||e.$}}(this)),define("app",["require","jquery","underscore","angular","modernizr","moment","services/services","directives/directives","filters/filters","controllers/controllers","translation/languages","ui-bootstrap","angular-sanitize","angular-animate","angular-humanize","angular-route","mobile-events"],function(e,t,n,i,o,a,r,s,c,l,d){var u=function(){return function(e){if(""===e)return{};for(var t={},n=0;n<e.length;++n){var i=e[n].split("=");2==i.length&&(t[i[0]]=window.decodeURIComponent(i[1].replace(/\+/g," ")))}return t}(window.location.search.substr(1).split("&"))}(),p={},f=function(e,t){this.data={locale_data:{}},this.lang=this.default_lang=e,this.getHTTP=t.$http.get};f.prototype.language=function(){return this.lang},f.prototype.default_language=function(){return this.default_lang},f.prototype.add=function(e,t){var i;if(t&&t.locale_data){i=t.locale_data[e];var o,a=0;for(var r in i)if(i.hasOwnProperty(r)&&(o=i[r],o.constructor===Array&&null===o[0]?o.shift():a++,a>1))break}var s=this.data.locale_data[e];s||(s=this.data.locale_data[e]={"":{domain:e,plural_forms:"nplurals=2; plural=(n != 1);"}}),n.extend(s,i)},f.prototype.load=function(e,t){var n=this;return this.getHTTP(t).success(function(t){n.add(e,t)}).error(function(t,i){console.warn("Failed to load translation data: "+i),n.add(e,null)})},f.prototype.get=function(){return this.data};var h=function(e,t){var o=t.translationData=new f("en",t),a=["ui.bootstrap","ngSanitize","ngAnimate","ngHumanize","ngRoute"];e&&e.length&&n.each(e,function(e){a.push(e)});var u=i.module("app",a);return r.initialize(u),s.initialize(u),c.initialize(u),l.initialize(u),u.config(["$compileProvider","$locationProvider","$routeProvider",function(e,t,n){e.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|tel|file|filesystem|blob):/),e.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|filesystem|blob):|data:image\//),n.when("/:room*",{}),t.html5Mode(!0)}]),u.run(["$rootScope","$timeout","mediaStream","translation","continueConnector",function(e,t,n,i,o){i.inject(e),console.log("Initializing ...");var a=o.defer();n.initialize(e,i),t(function(){console.log("Initializing complete."),a.resolve()},0)}]),u.constant("availableLanguages",d),u.provider("translationData",function(){this.add=n.bind(o.add,o),this.load=n.bind(o.load,o),this.language=n.bind(o.language,o),this.default_language=n.bind(o.default_language,o),this.$get=[function(){return o.get()}]}),u.directive("spreedWebrtc",[function(){return{restrict:"A",scope:!1,controller:"AppController"}}]),u.directive("uiLogo",["globalContext",function(e){return{restrict:"A",link:function(t,n,i){i.$set("title",e.Cfg.Title||"")}}}]),u},g=1.1,m=function(t,i){var r=i.$q.defer(),s=JSON.parse(document.getElementById("globalcontext").innerHTML);s.Cfg.Version||(s.Cfg.Version="unknown"),t.constant("globalContext",s);var c=function(){var e="en",t=[],i=function(e){t.push(e),-1!=e.indexOf("-")&&t.push(e.split("-")[0])};if(o.localstorage){var a=localStorage.getItem("mediastream-language");a&&"undefined"!==a&&t.push(a)}var r=u.lang;r&&i(r),n.each(s.Languages,i);for(var c=0;c<t.length;c++)if(d.hasOwnProperty(t[c])){e=t[c];break}var l=document.getElementsByTagName("html")[0];return l.setAttribute("lang",e),e}();console.info("Selected language: "+c),i.translationData.lang=c;var l="messages";if(c===i.translationData.default_lang)i.translationData.add(l,null),r.resolve();else{var p=e.toUrl("translation/"+l+"-"+c+".json");i.translationData.load(l,p).then(function(){r.resolve()},function(){r.resolve()})}return a.lang(c),r.promise};return{create:h,initialize:m,query:u,config:p,apiversion:g}});